<?php
class APBDLicAPI {
		
		private $module;
		private $isNoSerialize = false;
		private $api_messages=null;
		function __construct( APBDLicenseSettings &$module ) {
			$this->module = $module;
			$this->api_messages=get_option('elite_api_msg',[]);
		}
		
		function __( $string, $parameter = NULL, $_ = NULL ) {
			$args = func_get_args();
			
			return call_user_func_array( "sprintf", $args );
		}
		
		/**
		 * @param $id
		 * param default $default
		 * @param mixed ...$params
		 *
		 * @return mixed|string
		 */
		public function GetAPIMessage($id,...$params) {
			if(!empty($params[0])) {
				$msg = &$params[0];
			}else{
				return '';
			}
			if(!empty($this->api_messages[$id])){
				$msg= $this->api_messages[$id];
			}
			if(count($params)>1){
				return call_user_func_array("sprintf",array_merge($params));
			}
			return $msg;
		}
		function isOk() {
			return true;
		}
		
		function routes() {
			$licensor = $this->module->GetOption( "api_end_point", "licensor" );
			register_rest_route( $licensor, '/license/add', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "add_license" ],
				'permission_callback' => '__return_true'
			) );
			
			
			register_rest_route( $licensor, '/license/edit', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "edit_license" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/refund', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "refund_license" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/change-status-by-extra', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "change_status_license_extra_param" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/view', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/view_with_product_client', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license_with_product_client" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/view_activate_sites', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "get_license_domains" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/view_with_of_client', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license_of_product_client" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/remove_domain_by_email', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "remove_domain_by_email" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/remove_domain', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "remove_domain" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/active/(?P<id>\d+)', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "show_get_msg" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/active/(?P<id>\d+)', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "active_product" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/deactive/(?P<id>\d+)', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "deactive_product" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/deactive/(?P<id>\d+)', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "show_get_msg" ],
				'permission_callback' => '__return_true'
			) );
			
			//'/product/update(?:/(?P<id>\d+))?(?:/(?P<vesrion>\d+))?'
			register_rest_route( $licensor, '/product/update/(?P<id>\d+)(?:/(?P<license>[a-zA-Z0-9\-]+))?(?:/(?P<version>[a-z0-9.]+))?', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "update_product" ],
				'permission_callback' => '__return_true'
			) );
			
			register_rest_route( $licensor, '/product/change-log/(?P<id>\d+)?(?:/(?P<type>[a-zA-Z0-9]+))?', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "product_changelog" ],
				'permission_callback' => '__return_true'
			) );
			
			//product
			register_rest_route( $licensor, '/hello', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "api_hello" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/hello(?:/(?P<check>[a-zA-Z0-9]))?', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "api_get_hello" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/add', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "add_product" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/edit', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "edit_product" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/view', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_product" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/view-all', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_product_list" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/view-all-with-license-type', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_product_with_license" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/product/download/(?P<id>\d+)/(?P<nc>[a-zA-Z0-9]+)', array(
				'methods'             => 'GET',
				'callback'            => [ $this, "product_download" ],
				'permission_callback' => '__return_true'
			) );
			//client
			register_rest_route( $licensor, '/client/add', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "add_client" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/client/edit', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "edit_client" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/client/view', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_client" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/client/view-all', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_client_list" ],
				'permission_callback' => '__return_true'
			) );
			
			register_rest_route( $licensor, '/license-type/view-all', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license_type_list" ],
				'permission_callback' => '__return_true'
			) );
			
			register_rest_route( $licensor, '/license/view-all-by-email', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license_list_by_email" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/license/view-all', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "view_license_list_with_product_client" ],
				'permission_callback' => '__return_true'
			) );
			//FastSpring Web hooks
			register_rest_route( $licensor, '/fastspring/license/add', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "add_fastspring_license" ],
				'permission_callback' => '__return_true'
			) );
			register_rest_route( $licensor, '/fastspring/web-hook', array(
				'methods'             => 'POST',
				'callback'            => [ $this, "fastspring_web_hook" ],
				'permission_callback' => '__return_true'
			) );
			
		
			do_action( $this->module->getHookActionStr( "register-rest-api" ), $licensor );
		}
		
		function show_get_msg() {
			echo "GET404";
			die;
		}
		
		function fastspring_hash_check( $input_string ) {
			if ( empty( $input_string ) ) {
				return false;
			}
			$markets = APBDLicIntegration::getMarkets();
			$secret  = "";
			if ( ! empty( $markets ) ) {
				foreach ( $markets as $market ) {
					if ( $market instanceof FastSpringIntegrator ) {
						$secret = $market->GetOption( "web_hook_secret" );
						break;
					}
				}
			}
			$serverSignature = ! empty( $_SERVER['HTTP_X_FS_SIGNATURE'] ) ? $_SERVER['HTTP_X_FS_SIGNATURE'] : ( ! empty( $_SERVER['X_FS_SIGNATURE'] ) ? $_SERVER['X_FS_SIGNATURE'] : "" );
			if ( ! empty( $serverSignature ) || ! empty( $secret ) ) {
				$hash = base64_encode( hash_hmac( 'sha256', $input_string, $secret, true ) );
				if ( ! empty( $serverSignature ) && $hash == $serverSignature ) {
					return true;
				}
			} else {
				return true;
			}
			
			return false;
		}
		
		private function fastspring_set_subscription( $event, &$subscription_id, &$deactivationDate, &$hook_license ) {
			if ( in_array( $event->type, [ 'subscription.charge.completed' ] ) ) {
				$subscription_id  = $event->data->subscription->id;
				$deactivationDate = $event->data->subscription->nextChargeDateInSeconds;
				$hook_license     = $this->fastspring_get_license_key_from_fulfillments( $event->data->subscription->fulfillments );
			} elseif ( in_array( $event->type, [ 'subscription.canceled' ] ) ) {
				$subscription_id  = $event->data->subscription;
				$deactivationDate = $event->data->deactivationDateInSeconds;
				$hook_license     = $this->fastspring_get_license_key_from_fulfillments( $event->data->fulfillments );
			} elseif ( in_array( $event->type, [ 'subscription.activated', 'subscription.updated' ] ) ) {
				$subscription_id  = $event->data->subscription;
				$deactivationDate = $event->data->nextChargeDateInSeconds;
				$hook_license     = $this->fastspring_get_license_key_from_fulfillments( $event->data->fulfillments );
			} elseif ( in_array( $event->type, [ 'subscription.deactivated' ] ) ) {
				$subscription_id  = $event->data->subscription;
				$deactivationDate = $event->data->changedInSeconds;
				$hook_license     = $this->fastspring_get_license_key_from_fulfillments( $event->data->fulfillments );
			}
		}
		
		private function fastspring_update_subscription( $event_type, $subscription_id, $deactivationDate, $hook_license = '' ) {
			if ( ! empty( $subscription_id ) ) {
				$postiveEvents           = [
					'subscription.charge.completed',
					'subscription.activated',
					'order.completed',
					'subscription.updated'
				];
				$nagativeEvents          = [
					'subscription.canceled'
				];
				$directDeactivatesEvents = [
					'subscription.deactivated'
				];
				$directReturnEvents      = [
					'return.created'
				];
				
				$licenseObje = NULL;
				if ( ! empty( $hook_license ) ) {
					$licenseObje = Mapbd_license::FindBy( 'purchase_key', $hook_license );
					if ( ! empty( $licenseObje ) ) {
						if ( ! empty( $subscription_id ) && $licenseObje->extra_param != $subscription_id ) {
							//update license extra param
							$ul = new Mapbd_license();
							$ul->extra_param( $subscription_id );
							$ul->SetWhereUpdate( "id", $licenseObje->id );
							if ( $ul->Update() ) {
								$licenseObje->extra_param = $subscription_id;
							}
						}
					}
				}
				if ( empty( $licenseObje ) ) {
					$licenseObje = Mapbd_license::FindBy( 'extra_param', $subscription_id );
				}
				if ( ! empty( $licenseObje ) ) {
					if ( in_array( $event_type, $postiveEvents ) ) {
						$licenseDate = strtotime( $licenseObje->expiry_time );
						if ( $licenseDate < $deactivationDate ) {
							$upObject = new Mapbd_license();
							$upObject->expiry_time( date( 'Y-m-d H:i:s', $deactivationDate ) );
							if ( in_array( $licenseObje->status, [ 'I', 'R' ] ) ) {
								$upObject->status( 'W' );
							}
							$upObject->support_end_time( date( 'Y-m-d H:i:s', $deactivationDate ) );
							
							$upObject->SetWhereUpdate( "id", $licenseObje->id );
							if ( $upObject->Update() ) {
								echo "License Expiry update successfully";
								exit;
							} else {
								echo "License Expiry update fail";
								exit;
							}
						} else {
							echo "License Expiry is already greater or equal of this request";
							exit;
						}
						
						
					} elseif ( in_array( $event_type, $nagativeEvents ) ) {
						$upObject    = new Mapbd_license();
						$licenseDate = strtotime( $licenseObje->expiry_time );
						if ( $licenseDate > $deactivationDate ) {
							$upObject->expiry_time( date( 'Y-m-d H:i:s', $deactivationDate ) );
							$upObject->SetWhereUpdate( "id", $licenseObje->id );
							if ( $upObject->Update() ) {
								Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObje );
								echo "License inactivated successfully";
								exit;
							} else {
								echo "License inactivate fail";
								exit;
							}
						}
					} elseif ( in_array( $event_type, $directDeactivatesEvents ) ) {
						$this->AddTestLog( "I am here, need to update with status" );
						$upObject    = new Mapbd_license();
						$licenseDate = strtotime( $licenseObje->expiry_time );
						
						if ( empty( $licenseObje->expiry_time ) || $licenseDate > $deactivationDate ) {
							$upObject->expiry_time( date( 'Y-m-d H:i:s', $deactivationDate ) );
						}
						if ( ! in_array( $licenseObje->status, [ 'I', 'R' ] ) ) {
							$upObject->status( 'I' );
						}
						$upObject->SetWhereUpdate( "id", $licenseObje->id );
						if ( $upObject->IsSetDataForSaveUpdate() && $upObject->Update() ) {
							Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObje );
							echo "License inactivated successfully";
							exit;
						} else {
							echo "License inactivate fail";
							exit;
						}
					} elseif ( in_array( $event_type, $directReturnEvents ) ) {
						
						//it has been handled by other method named fastSpringItemRefundProcess
						$this->AddTestLog( "I am here, need to process return" );
						$this->UpdateLicenseForRefund( $licenseObje, $deactivationDate );
					}
				}
			}
		}
		
		private function fastspring_get_license_key_from_fulfillments( $fulfillments ) {
			$item_hook_license = "";
			if ( ! empty( $fulfillments ) ) {
				foreach ( $fulfillments as $fulfillment_ary ) {
					foreach ( $fulfillment_ary as $fulfillment ) {
						if ( ! empty( $fulfillment->license ) ) {
							$item_hook_license = $fulfillment->license;
							break;
						}
					}
					if ( ! empty( $item_hook_license ) ) {
						break;
					}
				}
			}
			
			return $item_hook_license;
		}
		
		private function fastspring_process_event( $event ) {
			$event_type = $event->type;
			if ( in_array( $event->type, [ 'order.completed' ] ) ) {
				$items =& $event->data->items;
				foreach ( $items as &$item ) {
					$subscription_id   = $item->subscription->id;
					$deactivationDate  = $item->subscription->nextChargeDateInSeconds;
					$item_hook_license = $this->fastspring_get_license_key_from_fulfillments( $item->fulfillments );
					$this->fastspring_update_subscription( $event_type, $subscription_id, $deactivationDate, $item_hook_license );
				}
			} elseif ( in_array( $event->type, [ 'return.created' ] ) ) {
				$itemList = $this->getFastspringRefundItemsInfo( $event );
				if ( ! empty( $itemList ) && is_array( $itemList ) ) {
					foreach ( $itemList as $item ) {
						$this->AddTestLog( $item );
						$this->fastSpringItemReturnProcess( $item );
					}
				}
			} else {
				$subscription_id  = "";
				$deactivationDate = "";
				$hook_license     = "";
				$this->fastspring_set_subscription( $event, $subscription_id, $deactivationDate, $hook_license );
				$this->fastspring_update_subscription( $event_type, $subscription_id, $deactivationDate, $hook_license );
			}
			
		}
		
		function fastSpringItemReturnProcess( $item ) {
			{
				$licenseObje = NULL;
				if ( ! empty( $item->license_code ) ) {
					$licenseObje = Mapbd_license::FindBy( 'purchase_key', $item->license_code );
					if ( ! empty( $licenseObje ) ) {
						if ( ! empty( $item->subscription_id ) && $licenseObje->extra_param != $item->subscription_id ) {
							//update license extra param
							$ul = new Mapbd_license();
							$ul->extra_param( $item->subscription_id );
							$ul->SetWhereUpdate( "id", $licenseObje->id );
							if ( $ul->Update() ) {
								$licenseObje->extra_param = $item->subscription_id;
							}
						}
					}
				}
				if ( empty( $licenseObje ) && ! empty( $item->subscription_id ) ) {
					$licenseObje = Mapbd_license::FindBy( 'extra_param', $item->subscription_id );
				} elseif ( empty( $licenseObje ) && ! empty( $item->order_id ) ) {
					$licenseObje = Mapbd_license::FindBy( 'extra_param', $item->order_id );
					if ( ! empty( $licenseObje ) ) {
						if ( ! empty( $item->subscription_id ) && $licenseObje->extra_param != $item->subscription_id ) {
							//update license extra param
							$ul = new Mapbd_license();
							$ul->extra_param( $item->subscription_id );
							$ul->SetWhereUpdate( "id", $licenseObje->id );
							if ( $ul->Update() ) {
								$licenseObje->extra_param = $item->subscription_id;
							}
						}
					}
				}
				$this->UpdateLicenseForRefund( $licenseObje, $item->changedInSeconds );
			}
		}
		
		/**
		 * @param Mapbd_license $licenseObje
		 * @param $deactivationDate
		 *
		 * @return false
		 */
		private function UpdateLicenseForRefund( $licenseObje, $deactivationDate ) {
			if ( empty( $licenseObje ) ) {
				$this->AddTestLog( "Not order found" );
				
				return false;
			}
			if ( $licenseObje instanceof Mapbd_license ) {
				$this->AddTestLog( "Start process refund" );
				$upObject    = new Mapbd_license();
				$licenseDate = strtotime( $licenseObje->expiry_time );
				if ( empty( $licenseObje->expiry_time ) || $licenseDate > $deactivationDate ) {
					$upObject->expiry_time( date( 'Y-m-d H:i:s', $deactivationDate ) );
				}
				$upObject->status( 'R' );
				$upObject->SetWhereUpdate( "id", $licenseObje->id );
				if ( $upObject->IsSetDataForSaveUpdate() && $upObject->Update( true ) ) {
					Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObje );
					echo "License inactivated successfully";
					exit;
				} else {
					echo "License inactivate fail";
					exit;
				}
			} else {
				$this->AddTestLog( "Wrong Object" );
			}
		}
		
		function getFastspringRefundItemsInfo( $event ) {
			$order_id         = $event->data->original->reference;
			$changedInSeconds = $event->data->changedInSeconds;
			$finalResponse    = [];
			foreach ( $event->data->items as $item ) {
				$resp_item                   = new stdClass();
				$resp_item->order_id         = $order_id;
				$resp_item->product_id       = $item->product;
				$resp_item->quantity         = $item->quantity;
				$resp_item->subscription_id  = "";
				$resp_item->license_code     = "";
				$resp_item->changedInSeconds = $changedInSeconds;
				if ( ! empty( $item->subscription->subscription ) ) {
					$resp_item->subscription_id = $item->subscription->subscription;
					$item_hook_license          = &$resp_item->license_code;
					$item_hook_license          = "";
					if ( ! empty( $item->subscription->fulfillments ) ) {
						foreach ( $item->subscription->fulfillments as $fulfillment_ary ) {
							foreach ( $fulfillment_ary as $fulfillment ) {
								if ( ! empty( $fulfillment->license ) ) {
									$item_hook_license = $fulfillment->license;
									break;
								}
							}
							if ( ! empty( $item_hook_license ) ) {
								break;
							}
						}
					}
					
				}
				$finalResponse[] = $resp_item;
			}
			
			return $finalResponse;
		}
		
		function fastspring_web_hook() {
			$input = file_get_contents( 'php://input' );
			if ( $this->fastspring_hash_check( $input ) ) {
				$postData = json_decode( $input );
				if ( ! empty( $postData ) ) {
					if ( ! empty( $postData->events ) && is_array( $postData->events ) ) {
						
						foreach ( $postData->events as $event ) {
							$this->fastspring_process_event( $event );
						}
					} else {
						echo "No events found";
					}
				}
			} else {
				echo "Invalid Signature";
			}
		}
		
		function AddTestLog( $str ) {
			return;
			if ( ! is_string( $str ) ) {
				$str = print_r( $str, true );
			}
		}
		
		function api_get_hello( $data ) {
			$response         = new AppsbdAPIResponse();
			$response->status = true;
			$datares          = new stdClass();
			$isCheck          = ! empty( $data['check'] ) && $data['check'] == "d";
			$isInfo           = ! empty( $data['check'] ) && $data['check'] == "i";
			$isCheck2         = ! empty( $data['check'] ) && $data['check'] == "c";
			
			$datares->pversion      = APBDLicenseSettings::GetModuleInstance()->kernelObject->pluginVersion;
			$datares->response_time = gmdate( "Y-m-d\TH:i:s\Z" );
			if ( $isCheck2 ) {
				$datares->pversion = APBDLicenseSettings::GetModuleInstance()->kernelObject->pluginVersion;
			}
			if ( $isCheck || $isInfo ) {
				$datares->phpv = PHP_VERSION;
				$datares->wpv  = get_bloginfo( 'version' );
			}
			if ( $isCheck ) {
				$datares->db_modified = true;
				APBDLicenseSettings::DoVersionUpdate( $datares->pversion, $datares->pversion, true );
			}
			
			$response->SetResponse( true, "Ping Success", $datares );
			
			return $response;
		}
		
		function api_hello() {
			$response = new AppsbdAPIResponse();
			if ( ! empty( $_POST['api_key'] ) ) {
				$apiKey = $_POST['api_key'];
				$apiObj = Mapbd_apikey::FindBy( "api_key", $apiKey, [ "status" => 'A' ] );
				if ( $apiObj ) {
					$ip = APBD_get_remote_ip();
					if ( ! empty( $apiObj->api_ip ) && $ip != $apiObj->api_ip ) {
						$response->DisplayWithResponse( false, $this->__( "Invalid request IP" ) );
					}
					$permissions = $apiObj->getPropertiesArray( 'id,title,api_key,api_ip,entry_time,status' );
					//$permissions['msg']=$this->GetAPIMessage("m001","Your host (%s) has been automatically blocked for anonymous call","test host");
					$response->DisplayWithResponse( true, "Welcome to Elite Licenser API", $permissions );
				}
			}
			$response->DisplayWithResponse( false, $this->__( "The API key doesn't have this operation's permission" ) );
		}
		
		/**
		 * The getProductUpdateInfo is generated by appsbd
		 *
		 * @param Mapbd_product $product
		 * @param mixed $product_id
		 * @param false $isDontShowDownload
		 * @param false $isSupportExpire
		 *
		 * @return mixed
		 */
		function getProductUpdateInfo( &$product, $product_id, $isDontShowDownload = false, $isSupportExpire = false ) {
			$product_update = Mapbd_product_update::FindBy( "product_id", $product_id, [ "status" => "A" ] );
			if ( empty( $product_update ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->__( "no update found" ) );
			}
			$obj                  = new APBDUpdateResponse();
			$obj->name            = $product->product_name;
			$obj->slug            = $product->product_base;
			$obj->url             = $product->product_link;
			$obj->new_version     = $product_update->new_version;
			$obj->tested          = $product_update->tested;
			$obj->requires        = $product_update->required_version;
			$obj->last_updated    = $product_update->required_version;
			$obj->downloaded      = 1;
			$obj->is_downloadable = ! $isDontShowDownload;
			$obj->renew_link      = ! empty( $product->renew_link ) ? ( strpos( $product->renew_link, '?' ) === false ? $product->renew_link . "?p=" . $product->id : $product->renew_link . "&p=" . $product->id ) : "";
			if ( $isSupportExpire || $isDontShowDownload ) {
				$obj->update_denied_type = $isDontShowDownload ? "L" : "S";
				$obj->download_link      = "";
			} else {
				$obj->download_link = apply_filters( 'elite-licenser/filter/update-download-link', $product_update->download_link ,$product);
			}
			
			
			$obj->icons['high']   = "";
			$obj->banners['high'] = $product_update->banner_high;
			$obj->AddSection( "description", $product_update->update_des );
			$obj->AddSection( "changelog", $product_update->change_log );
			$aditional_response = $product_update->decodeAdditionalSections();
			foreach ( $aditional_response as $section ) {
				$obj->AddSection( $section['name'], $section['data'] );
			}
			$obj  = apply_filters( $this->module->getHookActionStr( "update-response" ), $obj );
			return $obj;
		}
		
		private function getDomainFromUserAgent() {
			if ( ! empty( $_SERVER['HTTP_USER_AGENT'] ) ) {
				preg_match_all( '/\b(?:(?:https?|ftp|file):\/\/|www\.|ftp\.)[-A-Z0-9+&@#\/%=~_|$?!:,.]*[A-Z0-9+&@#\/%=~_|$]/i', $_SERVER['HTTP_USER_AGENT'], $result, PREG_PATTERN_ORDER );
				if ( ! empty( $result[0][0] ) ) {
					
					$url = trim( $result[0][0] );
					if ( filter_var( $url, FILTER_VALIDATE_URL ) ) {
						return $url;
					}
				}
			}
			
			return "";
		}
		
		private function update_license_version( &$licObj, $version ) {
			if ( ! empty( $version ) ) {
				if ( version_compare( $licObj->current_version, $version, "<" ) ) {
					$uobj = new Mapbd_license();
					$uobj->current_version( $version );
					$uobj->SetWhereUpdate( "id", $licObj->id );
					if ( @$uobj->Update() ) {
					
					}
				}
				if ( $licObj->max_domain > 1 ) {
					$url = $this->getDomainFromUserAgent();
					$url = APBD_CleanDomainName( $url );
					if ( ! empty( $url ) ) {
						$ip               = APBD_get_remote_ip();
						$activated_domain = Mapbd_useddomain::FindBy( "purchase_key", $licObj->purchase_key, [ 'used_domain' => $url ] );
						if ( ! empty( $activated_domain ) && $activated_domain->server_ip == $ip && $activated_domain->product_id == $licObj->product_id ) {
							if ( version_compare( $activated_domain->version, $version, "<" ) ) {
								$uv = new Mapbd_useddomain();
								$uv->version( $version );
								$uv->SetWhereUpdate( "id", $activated_domain->id );
								if ( @$uv->Update() ) {
								
								}
							}
						}
						
					}
				}
			}
		}
		
		function update_product( $data ) {
			if ( empty( $data['id'] ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->__( "Product doesn't found" ) );
			}
			$product_id       = $data['id'];
			$isCheckingExpiry = false;
			$isCheckingSupportExpiry = false;
			
			$productObj = Mapbd_product::FindBy( "id", $product_id, [ 'status' => 'A' ] );
			if ( empty( $productObj ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->__( "invalid product" ) );
			} else {
				$isCheckingExpiry = $productObj->is_check_lic_on_update == "Y";
				$isCheckingSupportExpiry = $productObj->is_check_sup_on_update == "Y";
				if ( $productObj->is_enc_up_res == 'Y' ) {
					AppsbdAPIEncryptResponse::setEncKey( $productObj->enc_key );
				}
				
			}
			
			$licenseCode = isset( $data['license'] ) ? $data['license'] : "";
			if ( ! empty( $licenseCode ) ) {
				$licObj = Mapbd_license::FindBy( "purchase_key", $licenseCode );
				if ( ! empty( $licObj ) ) {
					if(in_array($licObj->status,['R','I'])){
						$obj = $this->getProductUpdateInfo( $productObj, $product_id, true );
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "License inactivated" ), $obj );
						return;
					}
					//version update
					if ( ! empty( $data['version'] ) ) {
						$this->update_license_version( $licObj, $data['version'] );
					}
					
				}
			}
			//check license expiry.
			if ( $isCheckingExpiry ) {
				//need to check license and expiry
				if ( ! empty( $licenseCode ) ) {
					if ( ! empty($licObj) ) {
						if ( $licObj->product_id == $product_id ) {
							if ( $licObj->has_expiry == "Y") {
								$nowtime = time();
								if (  $nowtime > strtotime( $licObj->expiry_time )  ) {
									$obj = $this->getProductUpdateInfo( $productObj, $product_id, true );
									AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "License expired" ), $obj );
									return;
								}
							}
						}
					}else{
						$obj = $this->getProductUpdateInfo( $productObj, $product_id, true );
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "Invalid license info" ), $obj );
						return;
					}
				}
			}
			
			//check license support.
			if($isCheckingSupportExpiry){
				if ( !empty($licObj) && $licObj->has_support == "Y" ) {
					$nowtime = time();
					if (  $nowtime > strtotime( $licObj->support_end_time ) ) {
						//check filter
						$oldTime = strtotime( $licObj->support_end_time );
						$licObj  = apply_filters( $this->module->getHookActionStr( "expire-filter" ), $licObj );
						if ( $oldTime < strtotime( $licObj->support_end_time ) ) {
							do_action( $this->module->getHookActionStr( "update-expire-time" ), $licObj );
						}
					}
					if ( $nowtime > strtotime( $licObj->support_end_time )) {
						$obj = $this->getProductUpdateInfo( $productObj, $product_id,false,true );
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "Support expired" ), $obj );
						return;
					}
				}else{
					if(empty($licObj) || $licObj->has_support != "U"){
						$obj = $this->getProductUpdateInfo( $productObj, $product_id, false, true );
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "Support expired" ), $obj );
						return;
					}
				}
			}
			$obj = $this->getProductUpdateInfo( $productObj, $product_id );
			AppsbdAPIEncryptResponse::DirectDisplay( true, $this->__( "product found" ), $obj );
		}
		function product_changelog( $data ) {
			
			$type=strtolower(!empty( $data['type'] )?$data['type']:"html");
			if ( empty( $data['id'] ) ) {
				$this->process_change_log_type('no change log found',$type);
			}
			$product_id       = $data['id'];
			$productUpdate=Mapbd_product_update::FindBy("product_id",$product_id,['status'=>'A']);
			if(!empty($productUpdate->change_log)){
				$this->process_change_log_type($productUpdate->change_log,$type);
			}else{
				$this->process_change_log_type('no change log found',$type);
			}
		}
		function process_change_log_type($change_log,$type=''){
			if($type=="html"){
				header('Content-Type: text/html; charset=UTF-8');
				echo $change_log;
			}elseif($type=="text" || $type=="txt"){
				header('Content-Type: text/plain; charset=UTF-8');
				$change_log=str_replace('</p>',"</p>\n",$change_log);
				$change_log=str_replace('</li>',"</li>\n",$change_log);
				$change_log=str_replace('</ol>',"</ol>\n",$change_log);
				$change_log=preg_replace('/<br\s?\/?>/ius',"\n",$change_log);
				echo strip_tags($change_log);
			}elseif($type=="json"){
				$changeObj=new stdClass();
				$changeObj->change_log=$change_log;
				wp_send_json($changeObj);
			}
		}
		
		function valid_api_key( $type = "" ) {
			$api_key=APBD_PostValue("api_key","");
			return apply_filters('elite-licenser/api-key/verify',true,$api_key,$type);
		}
		
		function add_fastspring_license() {
			$this->valid_api_key( "add_license" );
			$postData                = [];
			$postData['client_name'] = APBD_PostValue( "client_name", NULL );
			if ( empty( $postData['client_name'] ) ) {
				$postData['client_name'] = APBD_PostValue( "name", "" );
			}
			$postData['client_email'] = APBD_PostValue( "client_email", "" );
			if ( empty( $postData['client_email'] ) ) {
				$postData['client_email'] = APBD_PostValue( "email", "" );
			}
			$postData['client_country']  = APBD_PostValue( "client_country" );
			$postData['client_company']  = APBD_PostValue( "client_company" );
			$postData['product_id']      = APBD_PostValue( "product_id" );
			$postData['product_base']    = APBD_PostValue( "product_base" );
			$postData['license_type_id'] = APBD_PostValue( "license_id" );
			$postData['market']          = APBD_PostValue( "market", "" );
			
			
			// need to check subscribe id
			// if exists then update the subscription time
			//
			$subscription = APBD_PostValue( "subscription", NULL );
			if ( ! empty( $subscription ) ) {
				$postData['extra_param'] = $subscription;
				$license_list            = Mapbd_license::FindAllBy( "extra_param", $subscription );
				
				if ( ! empty( $license_list ) && is_array( $license_list ) ) {
					$response = "";
					foreach ( $license_list as $licenseObj ) {
						if ( ! empty( $licenseObj->purchase_key ) ) {
							$response .= $licenseObj->purchase_key . "\n";
						}
					}
					if ( ! empty( $response ) ) {
						echo $response;
						exit;
					}
				}
				
			} else {
				$postData['extra_param'] = APBD_PostValue( "extra_param", "" );
				if ( empty( $postData['extra_param'] ) ) {
					$postData['extra_param'] = APBD_PostValue( "reference", "" );
				}
			}
			
			$postData['qty'] = APBD_PostValue( "qty", NULL );
			if ( empty( $postData['qty'] ) ) {
				$postData['qty'] = APBD_PostValue( "quantity", 1 );
			}
			
			
			$postData['return_license_only'] = 1;
			$postData['seperator']           = "\n";
			$this->add_license_data( $postData );
			
		}
		
		function add_license() {
			$this->valid_api_key( "add_license" );
			$postData                = [];
			$postData['client_name'] = APBD_PostValue( "client_name", NULL );
			if ( empty( $postData['client_name'] ) ) {
				$postData['client_name'] = APBD_PostValue( "name", "" );
			}
			$postData['client_email'] = APBD_PostValue( "client_email" );
			if ( empty( $postData['client_email'] ) ) {
				$postData['client_email'] = APBD_PostValue( "email" );
			}
			$postData['client_country']  = APBD_PostValue( "client_country" );
			$postData['client_company']  = APBD_PostValue( "client_company" );
			$postData['product_id']      = APBD_PostValue( "product_id" );
			$postData['product_base']    = APBD_PostValue( "product_base" );
			$postData['license_type_id'] = APBD_PostValue( "license_id" );
			$postData['market']          = APBD_PostValue( "market", "" );
			
			
			// need to check subscribe id
			// if exists then update the subscription time
			//
			$subscription = APBD_PostValue( "subscription", NULL );
			if ( ! empty( $subscription ) ) {
				$postData['extra_param'] = $subscription;
			} else {
				$postData['extra_param'] = APBD_PostValue( "extra_param", "" );
				if ( empty( $postData ) ) {
					$postData['extra_param'] = APBD_PostValue( "reference", "" );
				}
			}
			
			$postData['qty'] = APBD_PostValue( "qty", NULL );
			if ( empty( $postData['qty'] ) ) {
				$postData['qty'] = APBD_PostValue( "quantity", 1 );
			}
			
			
			$postData['return_license_only'] = APBD_PostValue( "return_license_only", 0 );
			$postData['seperator']           = APBD_PostValue( "sep", "" );
			$this->add_license_data( $postData );
			
		}
		
		function add_license_data( $licenseData = [] ) {
			do_action('elite-licenser/license/add',$licenseData);
		}
		
		function edit_license() {
			$this->valid_api_key( "edit_license" );
			
			$isOk         = true;
			$response     = new AppsbdAPIResponse();
			$client_name  = APBD_PostValue( "client_name" );
			$client_email = APBD_PostValue( "client_email" );
			if ( empty( $client_email ) ) {
				$client_email = APBD_PostValue( "email" );
			}
			$license_code     = APBD_PostValue( "license_code" );
			$max_domain       = APBD_PostValue( "max_domain" );
			$has_expiry       = APBD_PostValue( "has_expiry" );
			$expiry_time      = APBD_PostValue( "expiry_time" );
			$has_support      = APBD_PostValue( "has_support" );
			$support_end_time = APBD_PostValue( "support_end_time" );
			$status           = APBD_PostValue( "status" );
			if ( empty( $license_code ) ) {
				$response->DisplayWithResponse( false, "License code is empty" );
			}
			$licenseObj = Mapbd_license::FindBy( "purchase_key", $license_code );
			if ( empty( $licenseObj ) ) {
				$response->DisplayWithResponse( false, "License information is invalid" );
			}
			
			$arrayOldData = $licenseObj->getPropertiesArray();
			$postedArray  = [];
			foreach ( [ 'max_domain', 'has_expiry', 'expiry_time', 'has_support', 'support_end_time', 'status' ] as $prop ) {
				$value = APBD_PostValue( $prop, NULL );
				if ( ! empty( $value ) || $value . "-_" !== "-_" ) {
					$postedArray[ $prop ] = $value;
				}
			}
			if ( empty( $postedArray ) || count( $postedArray ) == 0 ) {
				$response->DisplayWithResponse( false, "No valid data set found for update" );
			}
			$updateObject = new Mapbd_license();
			$updateObject->SetFromArrayWithOldData( $postedArray, $arrayOldData );
			if ( ! $updateObject->IsSetDataForSaveUpdate() ) {
				$response->DisplayWithResponse( false, "No change for update" );
			}
			$updateObject->SetWhereUpdate( "purchase_key", $license_code );
			if ( $updateObject->Update() ) {
				if($status=='R'){
					$licenseObj->status="R";
					Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObj );
				}
				$response->DisplayWithResponse( true, "Licnese code successfully updated" );
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
		}
		function refund_license() {
			$this->valid_api_key( "edit_license" );
			$response     = new AppsbdAPIResponse();
			$license_code     = APBD_PostValue( "license_code" );
			$status           = APBD_PostValue( "status","R" );
			
			if(empty($license_code)){
				$extraParam=APBD_PostValue( "extra_param","" );
				
			}
			
			if ( empty( $license_code ) ) {
				$response->DisplayWithResponse( false, "License code is empty" );
			}
			$licenseObj = Mapbd_license::FindBy( "purchase_key", $license_code );
			if ( empty( $licenseObj ) ) {
				$response->DisplayWithResponse( false, "License information is invalid" );
			}
			if($licenseObj->status==$status){
				$response->DisplayWithResponse( true, "License code already in refunded status" );
				return;
			}
			
			$updateObject = new Mapbd_license();
			$updateObject->status($status);
			$updateObject->SetWhereUpdate( "purchase_key", $license_code );
			if ( $updateObject->Update() ) {
				if($status=='R'){
					$licenseObj->status="R";
					Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObj );
				}
				$response->DisplayWithResponse( true, "License code successfully refunded" );
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
		}
		function change_status_license_extra_param() {
			$this->valid_api_key( "edit_license" );
			$response = new AppsbdAPIResponse();
			
			$status          = APBD_PostValue( "status", "R" );
			$extraParam      = sanitize_text_field( APBD_PostValue( "extra_param", "" ) );
			$extraParamField = sanitize_text_field( APBD_PostValue( "p_fld", "extra_param" ) );
			
			if ( empty( $extraParam ) ) {
				$response->DisplayWithResponse( false, "Param data is empty" );
			}
			$obj      = new Mapbd_license();
			$licenses = $obj->SelectAll( '', '', '', '', '', $extraParamField, $extraParam );
			
			if ( empty( $licenses ) ) {
				$response->DisplayWithResponse( false, "No license found with the request param" );
			}
			$is_updated=true;
			$msg='';
			foreach ( $licenses as $licenseObj ) {
				if ( $licenseObj->status != $status ) {
					$updateObject = new Mapbd_license();
					$updateObject->status( $status );
					$updateObject->SetWhereUpdate( "id", $licenseObj->id );
					if ( $updateObject->Update() ) {
						if ( $status == 'R' ) {
							$licenseObj->status = "R";
							Mapbd_license::RemoveALlDomainByLicenseObject( $licenseObj );
						}
					} else {
						$is_updated=false;
						$msg.=APBD_GetMsg_API();
					}
				}
			}
			$response->DisplayWithResponse( $is_updated, $msg);
		}
		function view_license() {
			$this->valid_api_key( "view_license" );
			$response     = new AppsbdAPIResponse();
			$license_code = APBD_PostValue( "license_code" );
			$licenseObj   = Mapbd_license::FindBy( "purchase_key", $license_code );
			
			if ( empty( $licenseObj ) ) {
				$licenseObj = apply_filters( $this->module->getHookActionStr( "check-license" ), $licenseObj, $license_code );
				//$response->DisplayWithResponse( false, "test" );
			}
			
			if ( empty( $licenseObj ) ) {
				//$licenseObj = APBDLicIntegration::CheckIntegratedLicense( $postData ); //not possible cause product is not exists
				$response->DisplayWithResponse( false, "License information is invalid" );
			}
			$this->set_unlimited_max_domain($licenseObj);
			$arrayOldData = $licenseObj->getPropertiesArray();
			
			foreach (
				[
					'user_domain',
					'server_ip',
					'current_version',
					'request_counter',
					'request_delay_time'
				] as $prop
			) {
				if ( isset( $arrayOldData[ $prop ] ) ) {
					unset( $arrayOldData[ $prop ] );
				}
			}
			$arrayOldData['market_description']        = $licenseObj->GetPropertyRawOptions( 'market' );
			$arrayOldData['status_description']        = $licenseObj->GetPropertyRawOptions( 'status' );
			$arrayOldData['active_domains']            = [];
			$arrayOldData['approval_required_domains'] = [];
			$product                                   = Mapbd_product::FindBy( "id", $licenseObj->product_id );
			$arrayOldData['product_name']              = $product->product_name;
			if ( $licenseObj->max_domain > 1 ) {
				$obj = new Mapbd_useddomain();
				$obj->product_id( $licenseObj->product_id );
				$obj->purchase_key( $licenseObj->purchase_key );
				$obj->status( "in ('A','W')", true );
				$domains = $obj->SelectAll();
				foreach ( $domains as $domain ) {
					if ( $domain->status == "A" ) {
						$arrayOldData['active_domains'][] = $domain->full_domain;
					} elseif ( $domain->status == "W" ) {
						$arrayOldData['approval_required_domains'][] = $domain->full_domain;
					}
					
				}
			} else {
				
				if ( ! empty( $licenseObj->user_domain ) ) {
					$arrayOldData['active_domains'][] = $licenseObj->user_domain;
				}
			}
			$response->DisplayWithResponse( true, "License Information found", (object) $arrayOldData );
			
		}
		function set_unlimited_max_domain(&$licenseObj){
			if(!empty($licenseObj->is_unlimited) && $licenseObj->is_unlimited=='Y'){
				$licenseObj->max_domain='∞';
			}
		}
		function view_license_with_product_client() {
			$this->valid_api_key( "view_license" );
			$response     = new AppsbdAPIResponse();
			$license_code = APBD_PostValue( "license_code" );
			$email_address = APBD_PostValue( "email" ,"");
		
			$license_id = APBD_PostValue( "id" ,"");
			$extraParam=[];
			if(!empty($email_address)){
				$client=Mapbd_client::FindBy("email",$email_address);
				if(!empty($client->id)) {
					$extraParam['client_id'] = $client->id;
				}else{
					$extraParam['client_id'] = 0;
				}
			}
			if(!empty($license_id)){
				$extraParam['id']=$license_id;
			}
			$is_all_info=APBD_PostValue("all_info",'N')=='Y';
			
		
			$licenseObj   = Mapbd_license::FindBy( "purchase_key", $license_code,$extraParam);
			if ( empty( $licenseObj ) ) {
				$licenseObj=apply_filters(APBDLicIntegration::GetModuleInstance()->getHookActionStr("check-license-key"),$licenseObj,$license_code);
				if(empty($licenseObj)) {
					$response->DisplayWithResponse( false, "License information is invalid" );
				}
			}
			$this->set_unlimited_max_domain($licenseObj);
			$arrayOldData = $licenseObj->getPropertiesArray();
			
			foreach (
				[
					'user_domain',
					'server_ip',
					'current_version',
					'request_counter',
					'request_delay_time'
				] as $prop
			) {
				if ( isset( $arrayOldData[ $prop ] ) ) {
					unset( $arrayOldData[ $prop ] );
				}
			}
			$arrayOldData['market_description']        = $licenseObj->GetPropertyRawOptions( 'market' );
			$arrayOldData['status_description']        = $licenseObj->GetPropertyRawOptions( 'status' );
			$arrayOldData['active_domains']            = [];
			$arrayOldData['approval_required_domains'] = [];
			
			$domains=$this->get_domains_by_license($licenseObj,$is_all_info);
			$arrayOldData['active_domains']=$domains['active_domains'];
			$arrayOldData['approval_required_domains']=$domains['approval_required_domains'];
			$arrayOldData['client_obj'] = Mapbd_client::FindBy( "id", $licenseObj->client_id );
			if ( isset( $arrayOldData['client_obj']->settedPropertyforLog ) ) {
				unset( $arrayOldData['client_obj']->settedPropertyforLog );
			}
			$arrayOldData['product_obj'] = Mapbd_product::FindBy( "id", $licenseObj->product_id );
			if ( isset( $arrayOldData['product_obj']->enc_key ) ) {
				unset( $arrayOldData['product_obj']->enc_key );
			}
			if ( isset( $arrayOldData['product_obj']->settedPropertyforLog ) ) {
				unset( $arrayOldData['product_obj']->settedPropertyforLog );
			}
			$response->DisplayWithResponse( true, "License Information found", (object) $arrayOldData );
			
		}
		
		function get_license_domains() {
			$this->valid_api_key( "view_license" );
			$response     = new AppsbdAPIResponse();
			$license_code = APBD_PostValue( "license_code" );
			$email_address = APBD_PostValue( "email" ,"");
			$license_id = APBD_PostValue( "id" ,"");
			$extraParam=[];
			if(!empty($email_address)){
				$client=Mapbd_client::FindBy("email",$email_address);
				if(!empty($client->id)) {
					$extraParam['client_id'] = $client->id;
				}else{
					$extraParam['client_id'] = 0;
				}
			}
			if(!empty($license_id)){
				$extraParam['id']=$license_id;
			}
			$licenseObj   = Mapbd_license::FindBy( "purchase_key", $license_code,$extraParam);
			if ( empty( $licenseObj ) ) {
				$licenseObj=apply_filters(APBDLicIntegration::GetModuleInstance()->getHookActionStr("check-license-key"),$licenseObj,$license_code);
				if(empty($licenseObj)) {
					$response->DisplayWithResponse( false, "License information is invalid" );
				}
			}
			$domains=$this->get_domains_by_license($licenseObj,true);
			$arrayOldData=array_merge($domains['approval_required_domains'],$domains['active_domains']);
			$response->DisplayWithResponse( true, "License Information found", $arrayOldData );
		}
		/**
		 * The get domains by license is generated by appsbd
		 *
		 * @param Mapbd_license $licenseObj
		 * @param false $is_all_info
		 *
		 * @return array
		 */
		function get_domains_by_license($licenseObj,$is_all_info=false){
			$arrayOldData=[];
			$arrayOldData['active_domains']=[];
			$arrayOldData['approval_required_domains']=[];
			if (  $licenseObj->max_domain > 1 ) {
				$obj = new Mapbd_useddomain();
				$obj->product_id( $licenseObj->product_id );
				$obj->purchase_key( $licenseObj->purchase_key );
				$obj->status( "in ('A','W')", true );
				$domains = $obj->SelectAll();
				foreach ( $domains as $domain ) {
					if ( $is_all_info ) {
						$domain_info=new stdClass();
						$domain_info->full_domain=$domain->full_domain;
						$domain_info->domain=$domain->used_domain;
						$domain_info->server_ip=$domain->server_ip;;
						$domain_info->version=$domain->version;
						$domain_info->active_time=$domain->entry_time;
						$domain_info->status=$domain->status;
					} else {
						$domain_info = $domain->full_domain;
					}
					if ( $domain->status == "A" ) {
						$arrayOldData['active_domains'][] = $domain_info;
					} elseif ( $domain->status == "W" ) {
						$domain_info->status='Z';
						$arrayOldData['approval_required_domains'][] = $domain_info;
					}
					
				}
			} else {
				
				if ( ! empty( $licenseObj->user_domain ) ) {
					if ( $is_all_info ) {
						$domain_info=new stdClass();
						$domain_info->full_domain=$licenseObj->user_domain;
						$domain_info->domain=str_replace(['http://','https://'],"",$licenseObj->user_domain);
						$domain_info->server_ip=$licenseObj->server_ip;;
						$domain_info->version=$licenseObj->current_version;
						$domain_info->active_time=$licenseObj->active_time;
						$domain_info->status=$licenseObj->status;
					} else {
						$domain_info = $licenseObj->user_domain;
					}
					$arrayOldData['active_domains'][] = $domain_info;
				}
			}
			return $arrayOldData;
		}
		function view_license_of_product_client() {
			$this->valid_api_key( "view_license" );
			$response    = new AppsbdAPIResponse();
			$client_id   = APBD_PostValue( "client_id" );
			$licenseObjs = Mapbd_license::FindAllBy( "client_id", $client_id );
			if ( empty( $licenseObjs ) ) {
				$response->DisplayWithResponse( false, "No license found for this client" );
			}
			$lobj                            = new Mapbd_license();
			$responseObj                     = new stdClass();
			$responseObj->market_description = $lobj->GetPropertyRawOptions( 'market' );
			$responseObj->status_description = $lobj->GetPropertyRawOptions( 'status' );
			$responseObj->license_list       = [];
			$products                        = Mapbd_product::FetchAllKeyValue( "id", "product_name" );
			
			foreach ( $licenseObjs as $licenseObj ) {
				
				$arrayOldData = (array) $licenseObj;
				foreach (
					[
						'user_domain',
						'server_ip',
						'current_version',
						'request_counter',
						'request_delay_time'
					] as $prop
				) {
					if ( isset( $arrayOldData[ $prop ] ) ) {
						unset( $arrayOldData[ $prop ] );
					}
				}
				$arrayOldData['product_name']              = ! empty( $products[ $licenseObj->product_id ] ) ? $products[ $licenseObj->product_id ] : "";
				$arrayOldData['active_domains']            = [];
				$arrayOldData['approval_required_domains'] = [];
				if ( $licenseObj->max_domain > 1 ) {
					$obj = new Mapbd_useddomain();
					$obj->product_id( $licenseObj->product_id );
					$obj->purchase_key( $licenseObj->purchase_key );
					$obj->status( "in ('A','W')", true );
					$domains = $obj->SelectAll();
					foreach ( $domains as $domain ) {
						if ( $domain->status == "A" ) {
							$arrayOldData['active_domains'][] = $domain->full_domain;
						} elseif ( $domain->status == "W" ) {
							$arrayOldData['approval_required_domains'][] = $domain->full_domain;
						}
						
					}
				} else {
					
					if ( ! empty( $licenseObj->user_domain ) ) {
						$arrayOldData['active_domains'][] = $licenseObj->user_domain;
					}
				}
				$responseObj->license_list[] = $arrayOldData;
			}
			$response->DisplayWithResponse( true, "License Information found", $responseObj );
			
		}
		
		function remove_domain() {
			$this->valid_api_key( "edit_license" );
			$response     = new AppsbdAPIResponse();
			$license_code = APBD_PostValue( "license_code" );
			$domain       = APBD_PostValue( "domain" );
			
			if ( empty( $license_code ) ) {
				$response->DisplayWithResponse( false, "License code is empty" );
			}
			$licenseObj = Mapbd_license::FindBy( "purchase_key", $license_code );
			if ( empty( $licenseObj ) ) {
				$response->DisplayWithResponse( false, "License information is invalid" );
			} else {
				$this->removeLicenseDomainByLicenseObject( $response, $domain, $licenseObj );
			}
			
			
		}
		
		function remove_domain_by_email() {
			$this->valid_api_key( "edit_license" );
			$response     = new AppsbdAPIResponse();
			$license_code = APBD_PostValue( "license_code" );
			$license_id   = APBD_PostValue( "license_id" );
			$domain       = APBD_PostValue( "domain" );
			$email        = APBD_PostValue( "email" );
			
			if ( empty( $license_code ) && empty( $license_id ) ) {
				$response->DisplayWithResponse( false, "License code is empty" );
			}
			if ( empty( $email ) ) {
				$response->DisplayWithResponse( false, "email is empty" );
			}
			$client = Mapbd_client::FindBy( "email", $email );
			if ( ! empty( $client ) ) {
				if ( ! empty( $license_id ) ) {
					$licenseObj = Mapbd_license::FindBy( "id", $license_id, [ "client_id" => $client->id ] );
				} elseif ( ! empty( $license_code ) ) {
					$licenseObj = Mapbd_license::FindBy( "purchase_key", $license_code, [ "client_id" => $client->id ] );
				}
				if ( empty( $licenseObj ) ) {
					$response->DisplayWithResponse( false, "License information is invalid" );
				}
				
				$this->removeLicenseDomainByLicenseObject( $response, $domain, $licenseObj );
				
			} else {
				$response->DisplayWithResponse( false, "No client found with this email address" );
			}
			
		}
		
		/**
		 * @param AppsbdAPIResponse $response
		 * @param $domain
		 * @param $licenseObj
		 */
		private function removeLicenseDomainByLicenseObject( &$response, $domain, $licenseObj ) {
			$domain = APBD_CleanDomainName( $domain );
			if ( empty( $domain ) ) {
				$response->DisplayWithResponse( false, "Domain is required" );
				
				return;
			}
			if ( $licenseObj->max_domain > 1 ) {
				//multi domain
				$used_domain = Mapbd_useddomain::FindBy( "purchase_key", $licenseObj->purchase_key, [
					"used_domain" => $domain,
					"product_id"  => $licenseObj->product_id
				] );
				if ( ! empty( $used_domain ) ) {
					if ( Mapbd_useddomain::DeleteByID( $used_domain->id ) ) {
						$product = Mapbd_product::FindBy( "id", $licenseObj->product_id );
						if ( ! empty( $product ) ) {
							Mapbd_license::RemoveLicenseFromDomain( $licenseObj->product_id, $product->enc_key, $used_domain->full_domain );
						}
						$response->DisplayWithResponse( true, "Domain successfully removed" );
					}else{
						$response->DisplayWithResponse( false, "Domain delete failed" );
					}
				} else {
					$response->DisplayWithResponse( false, "No domain found for remove" );
				}
			} else {
				//single domain
				$serverDomain = APBD_CleanDomainName( $licenseObj->user_domain );
				if ( $serverDomain == $domain ) {
					$product = Mapbd_product::FindBy( "id", $licenseObj->product_id );
					$up      = new Mapbd_license();
					$up->status( "W" );
					$up->user_domain('');
					$up->SetWhereUpdate( "id", $licenseObj->id );
					if ( $licenseObj->status == "W" || $up->Update() ) {
						Mapbd_license::RemoveLicenseFromDomain( $licenseObj->product_id, $product->enc_key, $licenseObj->user_domain );
						$response->DisplayWithResponse( true, "Domain successfully removed" );
					}else{
						$response->DisplayWithResponse( false, "Can't update" );
					}
					
				} else {
					$response->DisplayWithResponse( false, "Request domain does not match with registered domain " );
				}
			}
		}
		
		//products
		function add_product() {
			$this->valid_api_key( "add_product" );
			//$this->APPSBDLoadDatabaseModel( "Mapbd_client" );
			
			$isOk     = true;
			$response = new AppsbdAPIResponse();
			
			//check product limit
			$mp           = new Mapbd_product();
			$totalProduct = $mp->CountALL();
			$limit        = APBDLic::GetProductCount();
			if ( $limit != "U" && $totalProduct >= $limit ) {
				$response->DisplayWithResponse( false, "Produce limit exceeds" );
			}
			
			
			//now we are inserting license
			$productObj = new Mapbd_product();
			if ( $productObj->SetFromPostData( true ) ) {
				if ( $productObj->Save() ) {
					$response->DisplayWithResponse( true, "Successfully added", $productObj->getPropertiesArray( "entry_date" ) );
					
				} else {
					$response->DisplayWithResponse( false, APBD_GetMsg_API() );
				}
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
			
		}
		
		function edit_product() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "edit_product" );
			$product_id = APBD_PostValue( "product_id" );
			if ( empty( $product_id ) ) {
				$response->DisplayWithResponse( false, "Product id missing" );
			}
			$productObj = Mapbd_product::FindBy( "id", $product_id );
			if ( empty( $productObj ) ) {
				$response->DisplayWithResponse( false, "Product information is invalid" );
			}
			
			$arrayOldData = $productObj->getPropertiesArray();
			$postedArray  = [];
			foreach ( [ 'product_name', 'status' ] as $prop ) {
				$value = APBD_PostValue( $prop, NULL );
				if ( ! empty( $value ) || $value . "-_" !== "-_" ) {
					$postedArray[ $prop ] = $value;
				}
			}
			if ( empty( $postedArray ) || count( $postedArray ) == 0 ) {
				$response->DisplayWithResponse( false, "No valid data set found for update" );
			}
			$updateObject = new Mapbd_product();
			$updateObject->SetFromArrayWithOldData( $postedArray, $arrayOldData );
			if ( ! $updateObject->IsSetDataForSaveUpdate() ) {
				$response->DisplayWithResponse( false, "No change for update" );
			}
			$updateObject->SetWhereUpdate( "id", $product_id );
			
			if ( $updateObject->Update() ) {
				$response->DisplayWithResponse( true, "Product updated successfully" );
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
		}
		
		function view_product() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_product" );
			$param = APBD_PostValue( "product_id" );
			
			$mainobj = Mapbd_product::FindBy( "id", $param );
			
			if ( empty( $mainobj ) ) {
				$response->DisplayWithResponse( false, "License information is invalid" );
			}
			
			$arrayOldData = $mainobj->getPropertiesArray();
			
			foreach ( [ 'enc_key' ] as $prop ) {
				if ( isset( $arrayOldData[ $prop ] ) ) {
					unset( $arrayOldData[ $prop ] );
				}
			}
			$arrayOldData['status_description'] = $mainobj->GetPropertyRawOptions( 'status' );
			$response->DisplayWithResponse( true, "License Information found", (object) $arrayOldData );
			
		}
		
		function view_product_list() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_product" );
			$limit = APBD_PostValue( "limit", 10 );
			if ( empty( $limit ) ) {
				$limit = "";
			}
			$page = APBD_PostValue( "page", 1 );
			if ( ! empty( $limit ) ) {
				$limitStart = ( $limit * $page ) - $limit;
			} else {
				$limitStart = 0;
			}
			
			$status = APBD_PostValue( "status", NULL );
			
			$p = new Mapbd_product();
			if ( ! empty( $status ) ) {
				$p->status( $status );
			}
			$totalProduct           = $p->CountALL();
			$products               = $p->SelectAll( "id,product_base,product_name,entry_date,status", "", "", $limit, $limitStart );
			$pResponse              = new stdClass();
			$pResponse->limit       = $limit;
			$pResponse->currentPage = $page;
			if ( empty( $limit ) ) {
				$limit = 1;
			}
			$pResponse->totalPage    = ceil( $totalProduct / $limit );
			$pResponse->totalProduct = (int) $totalProduct;
			$pResponse->products     = $products;
			$response->DisplayWithResponse( true, "", $pResponse );
		}
		
		function view_product_with_license() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_product" );
			$limit      = APBD_PostValue( "limit", 10 );
			$page       = APBD_PostValue( "page", 1 );
			$limitStart = ( $limit * $page ) - $limit;
			$status     = APBD_PostValue( "status", NULL );
			
			/*$p=new Mapbd_product();
			if(!empty($status)){
				$p->status($status);
			}
			$totalProduct=$p->CountALL();
			$products = $p->SelectAll("id,product_base,product_name,entry_date,status","","",$limit,$limitStart);
			$allProductTypes=Mapbd_license_type::FindAllByKeyValue("status","A","id","license_title");
			foreach ($products as &$product){
				$product->product_licenses=[];
				$productlicenses=Mapbd_product_license::FindAllBy("product_id",$product->id);
				foreach ($productlicenses as $pl){
					if(isset($allProductTypes[$pl->license_id])) {
						$product->product_licenses[ $pl->license_id ]=$allProductTypes[$pl->license_id];
					}
				}
				
			}*/
			$products         = Mapbd_product::GetProductWithLicenseType( $status, $limit, $limitStart, $totalProduct );
			$pResponse        = new stdClass();
			$pResponse->limit = $limit;
			if ( empty( $limit ) ) {
				$limit = 1;
			}
			$pResponse->currentPage  = $page;
			$pResponse->totalPage    = ceil( $totalProduct / $limit );
			$pResponse->totalProduct = (int) $totalProduct;
			$pResponse->products     = $products;
			$response->DisplayWithResponse( true, "", $pResponse );
		}
		
		function product_download($data) {
			$product_id = $data['id'];
			$nonce      = $data['nc'];
			$ip         = APBD_get_remote_ip();
			if ( wp_verify_nonce( $nonce, $product_id . '-' . $ip ) ) {
				$product_update = Mapbd_product_update::FindBy( "product_id", $product_id, [ "status" => "A" ] );
				$site_url       = content_url();
				if ( strpos( $product_update->download_link, $site_url ) !== false ) {
					$real_path = realpath( WP_CONTENT_DIR . substr( $product_update->download_link, strlen( $site_url ) ) );
					if ( is_file( $real_path ) ) {
						$fileName = basename( $real_path );
						header( 'Pragma: public' );
						header( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
						header( "Expires: 0" );
						header( "Content-Type: application/zip" );
						header( "Content-Disposition:attachment; filename={$fileName}" );
						header( "Content-Type: application/force-download" );
						header( "Content-Transfer-Encoding: binary" );
						readfile( "$real_path" );
						exit();
					}
				}
			}
			
			header( "HTTP/1.1 401 Unauthorized" );
			wp_die( 'forbidden' );
			die;
		}
		//Clients
		function add_client() {
			$this->valid_api_key( "add_client" );
			//$this->APPSBDLoadDatabaseModel( "Mapbd_client" );
			$isOk     = true;
			$response = new AppsbdAPIResponse();
			
			//now we are inserting license
			$productObj = new Mapbd_client();
			if ( $productObj->SetFromPostData( true ) ) {
				if ( $productObj->Save() ) {
					$response->DisplayWithResponse( true, "Successfully added", $productObj->getPropertiesArray( "entry_time,username" ) );
					
				} else {
					$response->DisplayWithResponse( false, APBD_GetMsg_API() );
				}
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
			
		}
		
		function edit_client() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "edit_client" );
			$mainparam = APBD_PostValue( "client_id" );
			if ( empty( $mainparam ) ) {
				$response->DisplayWithResponse( false, "Client id missing" );
			}
			$mainObject = Mapbd_client::FindBy( "id", $mainparam );
			if ( empty( $mainObject ) ) {
				$response->DisplayWithResponse( false, "Client information is invalid" );
			}
			
			$arrayOldData = $mainObject->getPropertiesArray();
			$postedArray  = [];
			foreach ( [ 'name', 'country', 'company', 'status' ] as $prop ) {
				$value = APBD_PostValue( $prop, NULL );
				if ( ! empty( $value ) || $value . "-_" !== "-_" ) {
					$postedArray[ $prop ] = $value;
				}
			}
			if ( empty( $postedArray ) || count( $postedArray ) == 0 ) {
				$response->DisplayWithResponse( false, "No valid data set found for update" );
			}
			$updateObject = new Mapbd_client();
			$updateObject->SetFromArrayWithOldData( $postedArray, $arrayOldData );
			if ( ! $updateObject->IsSetDataForSaveUpdate() ) {
				$response->DisplayWithResponse( false, "No change for update" );
			}
			$updateObject->SetWhereUpdate( "id", $mainparam );
			
			if ( $updateObject->Update() ) {
				$response->DisplayWithResponse( true, "Client updated successfully" );
			} else {
				$response->DisplayWithResponse( false, APBD_GetMsg_API() );
			}
		}
		
		function view_client() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_client" );
			$emailaddress = APBD_PostValue( "email" );
			$mainparam    = APBD_PostValue( "client_id" );
			if ( empty( $mainparam ) && empty( $emailaddress ) ) {
				$response->DisplayWithResponse( false, "Client id or email is missing" );
			}
			if ( ! empty( $emailaddress ) ) {
				$mainobj = Mapbd_client::FindBy( "email", $emailaddress );
				
			} else {
				$mainobj = Mapbd_client::FindBy( "id", $mainparam );
				
			}
			if ( empty( $mainobj ) ) {
				$response->DisplayWithResponse( false, "Client information is invalid" );
			}
			
			$arrayOldData = $mainobj->getPropertiesArray( 'username' );
			
			/*foreach ([] as $prop){
				if(isset($arrayOldData[$prop])){
					unset($arrayOldData[$prop]);
				}
			}*/
			$arrayOldData['status_description'] = $mainobj->GetPropertyRawOptions( 'status' );
			$response->DisplayWithResponse( true, "Client Information found", (object) $arrayOldData );
			
		}
		
		function view_client_list() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_client" );
			$limit      = APBD_PostValue( "limit", 10 );
			$page       = APBD_PostValue( "page", 1 );
			$limitStart = ( $limit * $page ) - $limit;
			$status     = APBD_PostValue( "status", NULL );
			
			$p = new Mapbd_client();
			if ( ! empty( $status ) ) {
				$p->status( $status );
			}
			$totalProduct = $p->CountALL();
			$products     = $p->SelectAll( "id,name,email,country,company,entry_time,status", "", "", $limit, $limitStart );
			
			
			$pResponse        = new stdClass();
			$pResponse->limit = $limit;
			if ( empty( $limit ) ) {
				$limit = 1;
			}
			$pResponse->currentPage  = $page;
			$pResponse->totalPage    = ceil( $totalProduct / $limit );
			$pResponse->totalProduct = (int) $totalProduct;
			$pResponse->clients      = $products;
			$response->DisplayWithResponse( true, "", $pResponse );
		}
		
		/**
		 * @param Mapbd_license $licenseObj
		 * @param $current_domain
		 * @param string $previous_status
		 *
		 * @return string
		 */
		private function getValidReponseObject( &$licenseObj, $current_domain, $previous_status = 'W' ) {
			$ip = APBD_get_remote_ip();
			Mapbd_ban_host::resetHostIpHost( $ip, $current_domain );
			$responseSuccessObj                   = new stdClass();
			$responseSuccessObj->request_duration = 0;
			$responseSuccessObj->is_valid         = true;
			$responseSuccessObj->license_title    = $licenseObj->license_title;
			$responseSuccessObj->lic_param        = $licenseObj->lictype_param;
			$responseSuccessObj->other_param      = $licenseObj->other_param;
			$responseSuccessObj->market           = $licenseObj->market;
			if ( (int) $licenseObj->request_counter === 0 ) {
				if ( $previous_status == 'W' ) {
					$obj = Mapbd_request_manage::getNextTime( 0, $licenseObj->request_counter );
				} else {
					$obj = Mapbd_request_manage::getNextTime( $licenseObj->request_delay_time, $licenseObj->request_counter );
				}
				if ( $obj->status ) {
					Mapbd_license::updateRequestManageTime( $licenseObj->purchase_key, $licenseObj->product_id, $obj->counter, $obj->duration_in_hour );
				}
				$responseSuccessObj->request_duration = $obj->duration_in_hour;
			} else {
				Mapbd_license::decreaseCounter( $licenseObj->purchase_key, $licenseObj->product_id );
				$responseSuccessObj->request_duration = $licenseObj->request_delay_time;
			}
			$licenseTypeObj                  = new Mapbd_license_type();
			$responseSuccessObj->expire_date = $licenseObj->has_expiry == "Y" ? date( "Y-m-d H:i:s", strtotime( $licenseObj->expiry_time ) ) : "No expiry";
			$responseSuccessObj->support_end = $licenseObj->has_support == "Y" ? date( "Y-m-d H:i:s", strtotime( $licenseObj->support_end_time ) ) : APBD_getTextByKey( $licenseObj->has_support, $licenseTypeObj->GetPropertyRawOptions( "has_support" ) );
			$responseSuccessObj->renew_link  = ! empty( $licenseObj->renew_link ) ? $licenseObj->renew_link : "";
			$responseSuccessObj->domain      = $current_domain;
			
			$responseSuccessObj = apply_filters( $this->module->getHookActionStr( "response-filter" ), $responseSuccessObj, $licenseObj );
			
			$datastring = $this->isNoSerialize ? json_encode( $responseSuccessObj ) : serialize( $responseSuccessObj );
			$datastring = APBDEncryptionLib::getInstance( $current_domain )->encrypt( $datastring );
			
			return $datastring;
		}
		
		function active_product( $data ) {
			
			$content    = file_get_contents( "php://input" );
			$product_id = ! empty( $data['id'] ) ? $data['id'] : 0;
			$enckey     = "";
			$product    = NULL;
			$ip         = APBD_get_remote_ip();
			if ( empty( $product_id ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, "Invalid request param" );
			} else {
				$product = Mapbd_product::FindBy( "id", $product_id );
				if ( $product ) {
					$enckey = $product->enc_key;
					AppsbdAPIEncryptResponse::setEncKey( $product->enc_key );
				} else {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
				}
			}
			
			if ( ! empty( $enckey ) ) {
				$content = APBDEncryptionLib::getInstance( $enckey )->decrypt( $content );
			}
			$postData = json_decode( $content );
			if ( ! empty( $postData->no_php ) ) {
				$this->isNoSerialize = true;
			}
			if ( empty( $postData ) || ( ! is_array( $postData ) && ! is_object( $postData ) ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m003","Invalid license information" ));
			}
			if ( $postData->product_id != $product->id ) {
				Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
			}
			//check IP is ok or not
			if ( empty( $postData->app_version ) ) {
				$postData->app_version = "";
			}
			if ( strlen( $postData->app_version ) > 8 ) {
				$postData->app_version = substr( $postData->app_version, 0, 8 );
			}
			if ( empty( $ip ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
			}
		
			//check filter
			$ob=new stdClass();
			$ob->status=false;
			$ob->msg='';
			$ob->license=null;
			$ob=apply_filters('elite-licenser/filter/check-active-request',$ob,$postData);
			if(!empty($ob->status)){
				if(empty($ob->license)) {
					if ( empty( $postData->product_id ) ) {
						$ob->license = Mapbd_license::FindBy( "product_base_name", $postData->product_base, [ "purchase_key" => $postData->license_key ] );
					} else {
						$ob->license = Mapbd_license::FindBy( "product_id", $postData->product_id, [ "purchase_key" => $postData->license_key ] );
					}
				}
				if(!empty($ob->license) && ($ob->license instanceof Mapbd_license)) {
					$datastring = $this->getValidReponseObject( $ob->license, $postData->domain, 'A' );
					if(empty($ob->msg)){
						$ob->msg=$this->GetAPIMessage( "m008", "License successfully verified" );
					}
					AppsbdAPIEncryptResponse::DirectDisplay( true, $ob->msg, $datastring );
					return;
				}
			}
			if ( Mapbd_ban_host::isBanHost( $ip, $postData->domain ) ) {
				$host = APBD_GetUrlToHost( $postData->domain );
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m001","Your host (%s) has been automatically blocked for anonymous call",$host) );
			}
			if ( empty( $postData->product_id ) && empty( $postData->product_base ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m004","Invalid request, product information missing"));
			}
			if(!empty($ob->license) && ($ob->license instanceof Mapbd_license) && $ob->license->purchase_key==$postData->license_key) {
				$licenseObj = &$ob->license;
			}else {
				if ( empty( $postData->product_id ) ) {
					$licenseObj = Mapbd_license::FindBy( "product_base_name", $postData->product_base, [ "purchase_key" => $postData->license_key ] );
				} else {
					$licenseObj = Mapbd_license::FindBy( "product_id", $postData->product_id, [ "purchase_key" => $postData->license_key ] );
				}
			}
			
			
			if ( ! empty( $licenseObj->client_id ) ) {
				$licenseObj->renew_link = ! empty( $product->renew_link ) ? ( strpos( $product->renew_link, '?' ) === false ? $product->renew_link . "?p=" . $product_id : $product->renew_link . "&p=" . $product_id ) : "";
				$client                 = Mapbd_client::FindBy( "id", $licenseObj->client_id );
				if ( empty( $client ) ) {
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m006","Client has been deleted") );
				} elseif ( $client->status != "A" ) {
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m005","Client has been in inactive status") );
				}
				if ( empty( $client->email ) && ! empty( $postData->email ) ) {
					Mapbd_client::UpdateClientEmail( $client->id, $postData->email );
				}
			}
			
			if ( ! empty( $licenseObj ) ) {
				if(!empty($licenseObj->is_unlimited) && $licenseObj->is_unlimited=='Y'){
					$licenseObj->max_domain=999999;
				}
				//filter need to add
				$licenseObj=apply_filters($this->module->getHookActionStr("before-active-response"),$licenseObj);
				$this->processLicense( $postData, $licenseObj );
				
				return;
			} else {
				// envato license check later
				//$projectObj=Mapbd_product::FindBy("id",$postData->product_id);
				$olicenseObj = APBDLicIntegration::CheckIntegratedLicense( $postData );
				if ( ! empty( $olicenseObj ) ) {
					$olicenseObj=apply_filters($this->module->getHookActionStr("before-active-response"),$olicenseObj);
					if(!empty($licenseObj->is_unlimited) && $licenseObj->is_unlimited=='Y'){
						$licenseObj->max_domain=999999;
					}
					$this->processLicense( $postData, $olicenseObj );
					
					return;
				}
				Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m007","Invalid license code" ) );
				
			}
			
		}
		
		/**
		 * @param array $postData
		 * @param Mapbd_license $licenseObj
		 */
		function processLicense( &$postData, &$licenseObj ) {
			$ip                                   = APBD_get_remote_ip();
			$responseSuccessObj                   = new stdClass();
			$responseSuccessObj->is_valid         = false;
			$responseSuccessObj->request_duration = 0;
			$requestDomain                        = APBD_CleanDomainName( $postData->domain );
			if ( $licenseObj->status == "R" ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m009","Your purchase key has been refunded") );
			} elseif ( strtoupper( $licenseObj->has_expiry ) == "Y" && strtotime( $licenseObj->expiry_time ) < time() ) {
				Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
				if ( ! empty( $licenseObj->renew_link ) ) {
					$renewLink = $licenseObj->renew_link . "&type=l&lic=" . $licenseObj->purchase_key;
					$button    = '<a target="_blank" class="el-green-btn" href="' . $renewLink . '">Click Here To Renew</a>';
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m010","Your purchase key has been expired. ") . $button );
				} else {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m010","Your purchase key has been expired") );
				}
			} elseif ( $licenseObj->status == "I" ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m011","Your purchase key has been temporary inactivated") );
			}
			
			
			if ( (int) $licenseObj->max_domain === 1) { //single domain
				if ( $licenseObj->status == "A" && ! empty( $licenseObj->user_domain ) ) {
					$savedDomain                       = APBD_CleanDomainName( $licenseObj->user_domain );
					$responseSuccessObj->license_title = $licenseObj->license_title;
					if ( $savedDomain == $requestDomain ) {
						//success
						$datastring = $this->getValidReponseObject( $licenseObj, $postData->domain, 'A' );
						AppsbdAPIEncryptResponse::DirectDisplay( true,  $this->GetAPIMessage("m008","License successfully verified").'-' . $postData->domain, $datastring );
					} else {
						if ( $this->isNoSerialize ) {
							AppsbdAPIEncryptResponse::DirectDisplay( false,  $this->GetAPIMessage("m012", "Your key has been installed on another application" ) );
						} else {
							AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m013",  "Your key has been installed on another domain(%s)", $savedDomain ) );
						}
					}
				} elseif ( $licenseObj->status == "W" || $licenseObj->status == "A" && empty( $licenseObj->user_domain ) ) {
					//update
					$uobj = new Mapbd_license();
					$uobj->user_domain( $postData->domain );
					$uobj->server_ip( $ip );
					$uobj->status( 'A' );
					$uobj->current_version( $postData->app_version );
					$uobj->active_time( date('Y-m-d H:i:s') );
					$obj = Mapbd_request_manage::getNextTime( "", $licenseObj->request_counter );
					if ( ! empty( $obj->status ) ) {
						$uobj->request_delay_time( $obj->duration_in_hour );
						$uobj->request_counter( $obj->counter );
					} else {
						$uobj->request_counter( 0 );
					}
					$uobj->SetWhereUpdate( "purchase_key", $licenseObj->purchase_key );
					$uobj->SetWhereUpdate( "product_id", $licenseObj->product_id );
					if ( $uobj->Update() ) {
						$licenseObj->current_version = $postData->app_version;
						if ( ! Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'A', $postData->email ) ) {
						
						}
						$datastring = $this->getValidReponseObject( $licenseObj, $postData->domain, 'W' );
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m008","License successfully verified")."-" . $postData->domain, $datastring );
					}
				} else {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m014","Your purchase key has not been activated") );
				}
			} else {
				//multi license
				if ( $licenseObj->status == "I" ) {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m015","Your key has been inactivated") );
				} elseif ( $licenseObj->status == "R" ) {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m009","Your purchase key has been refunded") );
				} else {
					$this->checkMultiDomain( $licenseObj, $postData );
				}
			}
			//AppsbdAPIEncryptResponse::DirectDisplay( true, "Success", json_decode( $content ) );
			
		}
		
		/**
		 * @param Mapbd_license $licenseObj
		 */
		function checkMultiDomain( &$licenseObj, $postData ) {
			$requestDomain = APBD_CleanDomainName( $postData->domain );
			$ip            = APBD_get_remote_ip();
			$useddomain    = Mapbd_useddomain::FindBy( "product_id", $postData->product_id, [
				"purchase_key" => $postData->license_key,
				"used_domain"  => $requestDomain
			] );
			if ( ! empty( $useddomain ) ) {
				if ( $useddomain->status == "A" ) {
					$datastring = $this->getValidReponseObject( $licenseObj, $postData->domain, 'A' );
					AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m008","License successfully verified")."-" . $postData->domain, $datastring );
				} elseif ( $useddomain->status == "W" ) {
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m017","You license key has been waiting for manual approval, Please contact with license author") );
				}
			} else {
				$vrmsg       = $this->GetAPIMessage("m017","You license key has been waiting for manual approval, Please contact with license author");
				$overmsg     = $this->GetAPIMessage("m018","License quota has been over, you can not add more domain with this license key");
				$totalDomain = Mapbd_useddomain::CountAllByKey( $licenseObj->product_id, $postData->license_key );
				if ( $licenseObj->max_domain > 0 && $totalDomain >= $licenseObj->max_domain ) {
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					AppsbdAPIEncryptResponse::DirectDisplay( false, $overmsg );
				} elseif ( $licenseObj->verification_required > 0 && $licenseObj->verification_required <= $totalDomain ) {
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'W', $postData->email );
					Mapbd_useddomain::Add( $licenseObj->product_id, $licenseObj->purchase_key, $requestDomain, $postData->domain, $ip, $postData->app_version, 'W' );
					Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
					AppsbdAPIEncryptResponse::DirectDisplay( false, $vrmsg );
				} else {
					if ( $licenseObj->status == "W" ) {
						Mapbd_license::updateStatus( $licenseObj->purchase_key, $licenseObj->product_id, "A" );
					}
					Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'A', $postData->email );
					Mapbd_useddomain::Add( $licenseObj->product_id, $licenseObj->purchase_key, $requestDomain, $postData->domain, $ip, $postData->app_version, 'A', $nusedDomain );
					$datastring = $this->getValidReponseObject( $licenseObj, $postData->domain, 'A' );
					AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m008","License successfully verified")."-" . $postData->domain, $datastring );
				}
				
				
			}
		}
		
		function deactive_product( $data ) {
			$product_id = ! empty( $data['id'] ) ? $data['id'] : 0;
			$enckey     = "";
			$product    = NULL;
			if ( empty( $product_id ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
			} else {
				$product = Mapbd_product::FindBy( "id", $product_id );
				if ( $product ) {
					$enckey = $product->enc_key;
					AppsbdAPIEncryptResponse::setEncKey( $product->enc_key );
				} else {
					AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
				}
			}
			$content = file_get_contents( "php://input" );
			if ( ! empty( $enckey ) ) {
				$content = APBDEncryptionLib::getInstance( $enckey )->decrypt( $content );
			}
			$postData = json_decode( $content );
			
			if ( empty( $postData ) || ( ! is_array( $postData ) && ! is_object( $postData ) && ! is_string( $postData->license_key ) ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m003","Invalid license information") );
			}
			//check IP is ok or not
			$ip = APBD_get_remote_ip();
			if ( empty( $ip ) ) {
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m002","Request param is invalid") );
			}
			
			$licenseObj = Mapbd_license::FindBy( "product_id", $postData->product_id, [ "purchase_key" => $postData->license_key ] );
			
			if ( ! empty( $licenseObj ) ) {
				$responseSuccessObj                   = new stdClass();
				$responseSuccessObj->is_valid         = false;
				$responseSuccessObj->request_duration = 0;
				$requestDomain                        = APBD_CleanDomainName( $postData->domain );
				if ( $licenseObj->status == "R" ) {
					AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m002","Your purchase key has been refunded") );
				} elseif ( $licenseObj->status == "I" ) {
					AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m011","Your purchase key has been temporary inactivated") );
				}
				if ( (int) $licenseObj->max_domain === 1 ) { //single domain
					if ( $licenseObj->status == "A" ) {
						$savedDomain                       = APBD_CleanDomainName( $licenseObj->user_domain );
						$responseSuccessObj->license_title = $licenseObj->license_title;
						if ( $savedDomain == $requestDomain ) {
							$uobj = new Mapbd_license();
							$uobj->status( 'W' );
							$uobj->current_version( $postData->app_version );
							$uobj->SetWhereUpdate( "purchase_key", $licenseObj->purchase_key );
							$uobj->SetWhereUpdate( "product_id", $licenseObj->product_id );
							if ( $uobj->Update() ) {
								Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'D', $postData->email );
								AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m019","License deactivated successfully ") );
							} else {
								AppsbdAPIEncryptResponse::DirectDisplay( false, "App can not deactivated  properly, please try again" );
							}
						} else {
							Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'D', $postData->email );
							AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m019","License deactivated successfully") );
						}
					} elseif ( $licenseObj->status == "W" ) {
						Mapbd_domain_log::Add( $licenseObj->purchase_key, $postData->domain, $ip, $postData->app_version, 'D', $postData->email );
						AppsbdAPIEncryptResponse::DirectDisplay( true, "License deactivated successfully" );
						
					} else {
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m020","Your purchase key is in different status, please contact with author") );
					}
				} else {
					$useddomain = Mapbd_useddomain::FindBy( "product_id", $postData->product_id, [
						"purchase_key" => $postData->license_key,
						"used_domain"  => $requestDomain
					] );
					if ( ! empty( $useddomain ) ) {
						if ( Mapbd_useddomain::DeleteByPurchaseKey( $postData->license_key, $requestDomain ) ) {
							AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m019","License deactivated successfully") );
						}
					} else {
						AppsbdAPIEncryptResponse::DirectDisplay( true, $this->GetAPIMessage("m019","License deactivated successfully") );
					}
				}
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m021","You key deactivate process has been failed. Please try again") );
			} else {
				// envato license check later
				//$projectObj=Mapbd_product::FindBy("id",$postData->product_id);
				Mapbd_ban_host::increaseCounter( $ip, $postData->domain );
				AppsbdAPIEncryptResponse::DirectDisplay( false, $this->GetAPIMessage("m003","Invalid license code" ) );
				
			}
			
		}
		
		function view_license_type_list() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_license" );
			$limit      = APBD_PostValue( "limit", 10 );
			$page       = APBD_PostValue( "page", 1 );
			$limitStart = ( $limit * $page ) - $limit;
			$status     = APBD_PostValue( "status", NULL );
			
			$p = new Mapbd_license_type();
			if ( ! empty( $status ) ) {
				$p->status( $status );
			}
			$totalProduct  = $p->CountALL();
			$license_types = $p->SelectAll( "id,license_title,max_domain,has_expiry,days_of_expiry,has_support,days_of_support,status", "", "", $limit, $limitStart );
			
			
			$pResponse        = new stdClass();
			$pResponse->limit = $limit;
			if ( empty( $limit ) ) {
				$limit = 1;
			}
			$pResponse->currentPage   = $page;
			$pResponse->totalPage     = ceil( $totalProduct / $limit );
			$pResponse->totalProduct  = (int) $totalProduct;
			$pResponse->license_types = $license_types;
			$response->DisplayWithResponse( true, "", $pResponse );
		}
		
		function view_license_list_by_email() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_license" );
			$email             = APBD_PostValue( "email", "" );
			$license_id        = APBD_PostValue( "license_id", "" );
			$product_id        = APBD_PostValue( "product_id", "" );
			$is_with_product   = APBD_PostValue( "is_with_product", "N" ) == "Y";
			$is_with_reg_sites = APBD_PostValue( "is_with_site", "N" ) == "Y";
			
			$email = sanitize_email( $email );
			$limit = APBD_PostValue( "limit", 10 );
			
			
			if ( ! empty( $limit ) ) {
				$page       = APBD_PostValue( "page", 1 );
				$limitStart = ( $limit * $page ) - $limit;
				
			} else {
				$limit      = "";
				$limitStart = "";
				$page       = 1;
			}
			$product_list = NULL;
			if ( $is_with_product ) {
				$product_list = Mapbd_product::FetchAllKeyValue( "id", "product_name" );
			}
			if ( ! empty( $email ) ) {
				$client = Mapbd_client::FindBy( "email", $email );
				if ( $client ) {
					$p = new Mapbd_license();
					if ( ! empty( $license_id ) ) {
						$p->license_id( $license_id );
					}
					if ( ! empty( $product_id ) ) {
						$p->product_id( $product_id );
					}
					$p->client_id( $client->id );
					//id,client_id,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status
					$totalProduct = $p->CountALL();
					$licenses     = $p->SelectAll( "", "entry_time", "desc", $limit, $limitStart );
					$newObj       = new Mapbd_license();
					$status_list  = $newObj->GetPropertyRawOptions( 'status' );
					foreach ( $licenses as &$license ) {
						$this->set_unlimited_max_domain($license);
						$license->status = strtoupper( $license->status );
						if ( $is_with_product ) {
							$license->product_name = APBD_getTextByKey( $license->product_id, $product_list );
						}
						$license->status_title = APBD_getTextByKey( $license->status, $status_list );
						
						if ( $is_with_reg_sites ) {
							$license->sites = [];
							if ( $license->max_domain > 1 ) {
								$license->sites = Mapbd_useddomain::FindAllBy( "purchase_key", $license->purchase_key, [
									"product_id" => $license->product_id,
									"status"     => 'A'
								], 'entry_time', 'DESC' );
								if ( ! empty( $license->sites ) ) {
									foreach ( $license->sites as &$site ) {
										$site->status = APBD_getTextByKey( $site->status, $status_list );
										foreach ( [ 'id' ] as $prop ) {
											if ( isset( $site->{$prop} ) ) {
												unset( $site->{$prop} );
											}
										}
									}
								}
							} else {
								if ( $license->status == 'A' ) {
									$ud              = new Mapbd_useddomain();
									$ud->server_ip   = $license->server_ip;
									$ud->used_domain = APBD_CleanDomainName( $license->user_domain );
									$ud->full_domain = $license->user_domain;;
									$ud->status     = $license->status_title;
									$ud->product_id = $license->product_id;;
									$ud->purchase_key = $license->purchase_key;;
									$ud->entry_time   = $license->entry_time;
									$ud->version      = $license->current_version;
									$license->sites[] = $ud;
								}
							}
						}
						
						
						foreach (
							[
								'user_domain',
								'server_ip',
								'current_version',
								'request_counter',
								'request_delay_time'
							] as $prop
						) {
							if ( isset( $license->{$prop} ) ) {
								unset( $license->{$prop} );
							}
						}
						
						
					}
					
					$pResponse              = new stdClass();
					$pResponse->limit       = $limit;
					$pResponse->currentPage = $page;
					if ( ! empty( $limit ) ) {
						$pResponse->totalPage = ceil( $totalProduct / $limit );
					} else {
						$pResponse->totalPage = 1;
					}
					$pResponse->totalLicense = (int) $totalProduct;
					$pResponse->licenses     = $licenses;
					$response->DisplayWithResponse( true, "", $pResponse );
				} else {
					$pResponse               = new stdClass();
					$pResponse->limit        = $limit;
					$pResponse->currentPage  = $page;
					$pResponse->totalPage    = 0;
					$pResponse->totalLicense = 0;
					$pResponse->licenses     = [];
					$response->DisplayWithResponse( true, "client not found", $pResponse );
				}
			} else {
				$response->DisplayWithResponse( false, "email field required" );
			}
		}
		
		function view_license_list_with_product_client() {
			$response = new AppsbdAPIResponse();
			$this->valid_api_key( "view_license" );
		
			$status = APBD_PostValue( "lic_status", '' );
			$limit = (int)APBD_PostValue( "limit", 10 );
			$order_by = APBD_PostValue( "order_by", 'entry_time' );
			$order = APBD_PostValue( "order", 'DESC' );
			$product_id=(int)APBD_PostValue( "product_id", 0 );
			$market=APBD_PostValue( "market", '' );
			$license_id=(int)APBD_PostValue( "license_id", 0 );
			if ( ! empty( $limit ) ) {
				$page       = APBD_PostValue( "page", 1 );
				$limitStart = ( $limit * $page ) - $limit;
				
			} else {
				$limit      = "";
				$limitStart = "";
				$page       = 1;
			}
			$licenseObj=new Mapbd_license();
			if(!empty($status)){
				if(strpos($status,',') !==false){
					$status=explode(',',$status);
					$status="'".implode("','",$status)."'";
					$licenseObj->status( " in ($status)",true );
				}else {
					$licenseObj->status( $status );
				}
			}
			if(!empty($product_id)){
				$licenseObj->product_id($product_id);
			}
			if(!empty($license_id)){
				$licenseObj->license_id($license_id);
			}
			if(!empty($market)){
				$licenseObj->market($market);
			}
			$clientObj=new Mapbd_client();
			$licenseObj->Join($clientObj,"id","client_id");
			$licenseList=$licenseObj->SelectAllGridData('id,purchase_key,client_id,name as client_name,email as client_email,product_id,license_id,entry_time,status',$order_by,$order,$limit,$limitStart);
			if(!empty($licenseList)){
				$pobject=new Mapbd_product();
				$products=$pobject->SelectAllWithIdentity("id",'id,product_name,product_link');
				$license_types=Mapbd_license_type::FetchAllKeyValue("id","license_title");
				$statusList=$licenseObj->GetPropertyRawOptions('status');
				foreach ($licenseList as &$data){
					$data->license_title=APBD_getTextByKey($data->license_id,$license_types);
					$data->product_name=isset($products[$data->product_id])?$products[$data->product_id]->product_name:"";
					$data->product_link=isset($products[$data->product_id])?$products[$data->product_id]->product_link:"";
					$data->entry_time=date("c", strtotime($data->entry_time));
					$data->status=APBD_getTextByKey($data->status,$statusList);
				}
				$response->DisplayWithResponse( true, "License list found", $licenseList );
			}else{
				$response->DisplayWithResponse( false, "No data found", $licenseList );
			}
			
		}
	}