<?php
APBD_LoadCore('AppsbdAjaxConfirmResponse','AppsbdAjaxConfirmResponse',__FILE__);
APBD_LoadCore('AppsbdAjaxDataResponse','AppsbdAjaxDataResponse',__FILE__);
APBD_LoadCore('AppsbdAPIResponse','AppsbdAPIResponse',__FILE__);
APBD_LoadCore('AppsbdAPIEncryptResponse','AppsbdAPIEncryptResponse',__FILE__);
APBD_LoadCore('AppsBDModel','AppsBDModel',__FILE__);
APBD_LoadCore('APPSBDQueryBuilder','APPSBDQueryBuilder',__FILE__);
APBD_LoadCore('AppsBDBaseModule','AppsBDBaseModule',__FILE__);



/**
 * @property AppsBDBaseModule [] moduleList
 */
if(!class_exists("AppsBDKarnel")) {
	abstract class AppsBDKarnel {
		public static $appsbd_globalJS;
		public static $appsbd_globalCss;
		public static $setAppProperies;
		
		public $moduleList = [];
		public $pluginFile;
		public $pluginBaseName;
		private static $appGlobalVar = [];
		private static $_instence = [];
		private static $_instence_base = [];
		public $pluginName;
		public $pluginVersion;
		public $isTabMenu = false;
		protected static $warningMessage;
		protected static $errorMessage = [];
		protected static $infoMessage = [];
		protected static $hiddenFilelds = [];
		protected $isDevelopmode = false;
		private $isLoadJqGrid = false;
		public $pluginIconClass;
		public $_topmenu = [];
		public $_set_action_prefix = "";
		
		public $licenseMessage="";
		public $showMessage=false;
		private $is_module_loaded=false;
		protected $menuTitle;
		/**
		 * @return bool
		 */
		final public function isModuleLoaded() {
			return $this->is_module_loaded;
		}
		
		/**
		 * @param bool $is_module_loaded
		 */
		public function setIsModuleLoaded( $is_module_loaded ) {
			$this->is_module_loaded = $is_module_loaded;
		}
		/**
		 * @return array
		 */
		public function GetAppGlobalVar() {
			return self::$appGlobalVar;
		}
		
		function AddTopMenu( $title, $icon, $func, $class = '', $isTab = true, $attr = [] ) {
			$n        = new stdClass();
			$n->title = $title;
			$n->func  = $func;
			$n->icon  = $icon;
			$n->class = $class;
			$n->istab = $isTab;
			$n->attr  = "";
			if ( count( $attr ) > 0 ) {
				foreach ( $attr as $ke => $v ) {
					$n->attr .= ' ' . $ke . '="' . $v . '" ';
				}
			}
			
			$this->_topmenu[] = $n;
		}
		
		/**
		 * @param array $appGlobalVar
		 */
		public function AddAppGlobalVar( $key, $value ) {
			self::$appGlobalVar[ $key ] = $this->__( $value );
		}
		
		/**
		 * @return bool
		 */
		public function isDevelopmode() {
			return $this->isDevelopmode;
		}
		
		/**
		 * @param bool $isDevelopmode
		 */
		public function setIsDevelopmode( $isDevelopmode ) {
			$this->isDevelopmode = $isDevelopmode;
		}
		
		/**
		 * @return bool
		 */
		public function isLoadJqGrid() {
			return $this->isLoadJqGrid;
		}
		
		/**
		 * @param bool $isLoadJqGrid
		 */
		public function SetIsLoadJqGrid( $isLoadJqGrid ) {
			$this->isLoadJqGrid = $isLoadJqGrid;
		}
		
		public function SetPluginIconClass( $class ) {
			$this->pluginIconClass = $class;
		}
		
		/**
		 * @param string $set_action_prefix
		 */
		public function setSetActionPrefix( $set_action_prefix ) {
			$this->_set_action_prefix = $set_action_prefix;
		}
		
		/**
		 * @return string
		 */
		public function getHookActionStr( $str ) {
			return $this->_set_action_prefix . "/" . $str;
		}
		
		
		
		abstract function GetHeaderHtml();
		
		abstract function GetFooterHtml();
		
		function __construct($pluginBaseFile,$version = '1.0.0' ) {
		    $this->pluginFile=$pluginBaseFile;
			self::$_instence[ get_class( $this ) ]         = &$this;
			self::$_instence_base[ $this->pluginBaseName ] = &self::$_instence[ get_class( $this ) ];
			spl_autoload_register( array( $this, "_myautoload_method" ) );
			
		}
		
		function initialize() {
		
		}
		
		public static function __callStatic( $func, $args ) {
			if ( isset( self::$setAppProperies[ $func ] ) ) {
				return call_user_func_array( self::$setAppProperies[ $func ], $args );
			}
			
			return;
		}
		
		public static function SetProptety( $name, $value ) {
			self::$setAppProperies[ $name ] = $value;
		}
		
		function __destruct() {
			if ( $this->isDevelopmode ) {
				$qu   = AppsBDModel::GetTotalQueriesForLog();
				$path = plugin_dir_path( $this->pluginFile ) . "logs/";
				if ( is_writable( $path ) ) {
					if ( ! is_dir( $path ) ) {
						mkdir( $path, 0740, true );
					}
					$path .= "queries.sql";
					if ( file_exists( $path ) && filesize( $path ) > ( 1024 * 500 ) ) {
						unlink( $path );
					}
					if ( ! empty( $qu ) ) {
						$fh = fopen( $path, 'a' );
						if ( $fh ) {
							$count   = AppsBDModel::GetTotalQueriesCountStr();
							$queries = "-- " . get_permalink() . "----" . ( date( 'Y-m-d h:i:s A' ) ) . "--$count\n";
							$queries .= $qu;
							$queries .= "-- -----------------------------------------------------\n\n";
							fwrite( $fh, $queries );
							fclose( $fh );
						}
					}
				}
			}
		}
		
		final function CheckPluginVersionUpdate() {
			$db_version = get_option( "APBD_pv_" . $this->pluginBaseName, "" );
			if ( $db_version != $this->pluginVersion ) {
				update_option( "APBD_pv_" . $this->pluginBaseName, $this->pluginVersion ) || add_option( "APBD_pv_" . $this->pluginBaseName, $this->pluginVersion );
				foreach ( $this->moduleList as $moduleObject ) {
					$moduleObject->OnTableCreate();
					$moduleObject->OnPluginVersionUpdated( $this->pluginVersion );
				}
			}
		}
		
		public function _myautoload_method( $class ) {
			$basepath  = $path = plugin_dir_path( $this->pluginFile );
			$firstchar = substr( $class, 0, 1 );
			if ( strtoupper( $firstchar ) == "M" ) {
				$modelfilename = $basepath . "models/";
				if ( file_exists( $modelfilename . "database/{$class}.php" ) ) {
					APBD_LoadDatabaseModel( $this->pluginFile, $class, $class );
					
					return;
				}
			} elseif ( file_exists( $basepath . "libs/{$class}.php" ) ) {
				APBD_LoadLib( $this->pluginFile, $class );
			} elseif ( file_exists( $basepath . "core/{$class}.php" ) ) {
				APBD_Load_Any( $basepath . "core/{$class}.php", $class );
			} elseif ( file_exists( $basepath . "appcore/{$class}.php" ) ) {
				APBD_Load_Any( $basepath . "appcore/{$class}.php", $class );
			}
			
		}
		
		public static function AddError( $msg ) {
			self::$errorMessage[] = $msg;
		}
		
		public static function AddWarning( $msg ) {
			self::$warningMessage[] = $msg;
		}
		
		public static function AddInfo( $msg ) {
			self::$infoMessage[] = $msg;
		}
		
		public static function GetError( $prefix = '', $postfix = '' ) {
			if ( count( self::$errorMessage ) > 0 ) {
				return $prefix . implode( $postfix . $prefix, self::$errorMessage ) . $postfix;
			}
			
			return '';
		}
		
		public static function GetInfo( $prefix = '', $postfix = '' ) {
			if ( count( self::$infoMessage ) > 0 ) {
				return $prefix . implode( $postfix . $prefix, self::$infoMessage ) . $postfix;
			}
			
			return '';
		}
		
		public static function GetWarning( $prefix = '', $postfix = '' ) {
			if ( count( self::$warningMessage ) > 0 ) {
				return $prefix . implode( $postfix . $prefix, self::$warningMessage ) . $postfix;
			}
			
			return '';
		}
		
		public static function GetMsg( $prefix1 = '', $prefix2 = '', $prefix3 = '', $postfix = '' ) {
			$str = self::GetError( $prefix2, $postfix );
			$str .= self::GetInfo( $prefix1, $postfix );
			$str .= self::GetWarning( $prefix3, $postfix );
			if ( ! empty( $str ) ) {
				return '<div class="d-m-b">' . $str . '</div>';
			}
			
			return '';
		}
		
		public static function HasUIMsg() {
			return count( self::$infoMessage ) > 0 || count( self::$errorMessage ) > 0;
		}
		
		public static function AddHiddenFields( $key, $value ) {
			self::$hiddenFilelds[ $key ] = $value;
		}
		
		public static function AddOldFields( $key, $value ) {
			self::AddHiddenFields( "old_" . $key, $value );
		}
		
		public static function GetHiddenFieldsArray() {
			return self::$hiddenFilelds;
		}
		
		public static function GetHiddenFieldsHTML() {
			ob_start();
			foreach ( self::$hiddenFilelds as $name => $value ) {
				?>
                <input type="hidden" name="<?php echo $name; ?>" value="<?php echo $value; ?>"/>
				<?php
			}
			
			return ob_get_clean();
		}
		
		function AddCoreLib( $libname ) {
			if ( ! class_exists( $libname ) ) {
				$path = dirname( __FILE__ ) . "/" . $libname . ".php";
				if ( file_exists( $path ) ) {
					@include_once( $path );
				}
			}
		}
		
		function AddLib( $libname ) {
			if ( ! class_exists( $libname ) ) {
				$path = plugin_dir_path( $this->pluginFile ) . "lib/" . $libname . ".php";
				if ( file_exists( $path ) ) {
					@include_once( $path );
				}
			}
		}
		
		/**
		 *
		 * @return self
		 */
		static function &GetInstance() {
			return self::$_instence[ static::class ];
		}
		
		/**
		 * @param $base
		 *
		 * @return self
		 */
		static function &GetInstanceByBase( $base ) {
			return self::$_instence_base[ $base ];
		}
		
		/**
		 * @param $moduleClassName
		 */
		function AddModule( $moduleClassName ) {
			if ( ! class_exists( $moduleClassName ) ) {
				$path = plugin_dir_path( $this->pluginFile ) . "modules/" . $moduleClassName . ".php";
				if ( file_exists( $path ) ) {
					@include_once( $path );
				}
			}
			$this->moduleList[] = new $moduleClassName( $this->pluginBaseName, $this );
			if ( ! $this->isTabMenu ) {
				if ( count( $this->moduleList ) > 1 ) {
					$this->isTabMenu = true;
				}
			}
		}
		
		function WPAdminCheckDefaultCssScript( $src ) {
			if ( empty( $src ) || $src == 1 || preg_match( "/\/wp-admin\/|\/wp-includes\//", $src ) ) {
				return true;
			}
			
			return false;
		}
		
		function AddJquery() {
			wp_enqueue_script( 'jquery' );
		}
		
		function WpHead() {
		
		}
		
		function AdminScriptData() {
			?>
            <script type="text/javascript">
                var <?php echo $this->pluginBaseName;?>=
                "<?php echo plugins_url( "", $this->pluginFile );?>";
                var appGlobalLang =<?php echo json_encode( self::$appGlobalVar ); ?>;
				
				<?php
				foreach ( $this->moduleList as $moduleObject ) {
					$moduleObject->AdminScriptData();
				}
				?>
            </script>
			<?php
		}
		
		function AddAdminStyle( $StyleId, $StyleFileName = '', $isFromRoot = false, $deps = [] ) {
			if ( $isFromRoot ) {
				$start = "/";
			} else {
				$start = "/css/";
			}
			
			if ( ! empty( $StyleFileName ) ) {
				self::RegisterAdminStyle( $StyleId, plugins_url( $start . $StyleFileName, $this->pluginFile ), $deps, $this->pluginVersion );
			} else {
				self::RegisterAdminStyle( $StyleId );
			}
			
		}
		
		function AddAdminScript( $ScriptId, $ScriptFileName = '', $isFromRoot = false, $deps = [] ) {
			if ( $isFromRoot ) {
				$start = "/";
			} else {
				$start = "/js/";
			}
			if ( ! empty( $ScriptFileName ) ) {
				self::RegisterAdminScript( $ScriptId, plugins_url( $start . $ScriptFileName, $this->pluginFile ), $deps, $this->pluginVersion );
			} else {
				self::RegisterAdminScript( $ScriptId, '' );
			}
		}
		
		static function RegisterAdminStyle( $handle, $src = "", $deps = [], $ver = false, $in_footer = false ) {

			self::$appsbd_globalCss[] = $handle;
			if ( ! empty( $src ) ) {
				wp_register_style( $handle, $src, $deps, $ver, $in_footer );
			}
			wp_enqueue_style( $handle );
		}
		
		static function RegisterAdminScript( $handle, $src = "", $deps = [], $ver = false, $in_footer = false ) {
			self::$appsbd_globalJS[] = $handle;
			if ( ! empty( $src ) ) {
				wp_deregister_script( $handle );
				wp_register_script( $handle, $src, $deps, $ver, $in_footer );
			}
			wp_enqueue_script( $handle );
		}
		
		function OnAdminMainOptionStyles() {
			
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->OnAdminMainOptionStyles( $this ) ) {
					return true;
				}
			}
		}
		
		function OnAdminGlobalStyles() {
			$this->AddAdminStyle( "appsbd-icon", "uilib/icon/style.css", true );
			$this->AddAdminStyle( $this->pluginBaseName."apsbdpluginall", "all-css.css" );
			
			
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->OnAdminGlobalStyles() ) {
					return true;
				}
			}
		}
		
		function OnAdminAppStyles() {
			$this->AddAdminStyle( 'wp-color-picker' );
			$this->AddAdminStyle( "apsbdboostrap", "uilib/boostrap/4.1.3/appsbdbootstrap.css", true );
			$this->AddAdminStyle( "font-awesome", "uilib/font-awesome/4.7.0/css/font-awesome.min.css", true );
			$this->AddAdminStyle( "apboostrap_magnificcss", "uilib/magnific/apbd-magnific-bootstrap.css", true );
			$this->AddAdminStyle( "apboostrap_validatior_css", "uilib/bootstrapValidation/css/bootstrapValidator.min.css", true );
			
			$this->AddAdminStyle( "apboostrap_sgnofi_css1", "uilib/sliding-growl-notification/css/notify.css", true );
			$this->AddAdminStyle( "apboostrap_sweetalertcss", "uilib/sweetalert/sweetalert.css", true );
			$this->AddAdminStyle( "apboostrap_datetimepickercss", "uilib/datetimepicker/jquery.datetimepicker.css", true );
			$this->AddAdminStyle( "apboostrap_boostrap_select", "uilib/boostrap-select/css/bootstrap-select-bundle.css", true );
			if ( $this->isLoadJqGrid ) {
				$this->AddAdminStyle( "jquery-grid-ui", "uilib/jqui/jquery-ui.min.css", true );
				$this->AddAdminStyle( "jquery-grid", "uilib/grid/css/ui.jqgrid.css", true );
			}
			$this->AddAdminStyle( "appsbdcore", "admin-core-style.css" );
			
			foreach ( $this->moduleList as $moduleObject ) {
				$moduleObject->AdminStyles();
			}
		}
		
		function OnAdminAppScripts() {
			$this->AddAdminScript( "boostrap4", "uilib/boostrap/4.1.3/js/bootstrap.bundle.min.js", true );
			$this->AddAdminScript( "apboostrap_validatior_js", "uilib/bootstrapValidation/js/bootstrapValidator4.min.js", true );
			$this->AddAdminScript( "apboostrap_magnificjs", "uilib/magnific/magnific.min.js", true );
			$this->AddAdminScript( "apboostrap_sgnofi_js", "uilib/sliding-growl-notification/js/notify.min.js", true );
			$this->AddAdminScript( "apboostrap_sweetalertjs", "uilib/sweetalert/sweetalert.min.js", true );
			$this->AddAdminScript( "apboostrap_datetimepickercss", "uilib/datetimepicker/jquery.datetimepicker.js", true );
			$this->AddAdminScript( "apboostrap_boostrap_select", "uilib/boostrap-select/js/bootstrap-select.min.js", true );
			$this->AddAdminScript( "apboostrap_ajax_boostrap_select", "uilib/boostrap-select/js/ajax-bootstrap-select.js", true );
			$this->AddAdminScript( "apd-main-js", "main.min.js", false, [ 'wp-color-picker' ] );
			if ( $this->isLoadJqGrid ) {
				$this->AddAdminScript( "jquery-grid-js-118n", "uilib/grid/js/i18n/grid.locale-en.js", true, [ 'jquery' ] );
				$this->AddAdminScript( "jquery-grid-js", "uilib/grid/js/jquery.jqGrid.src.min.js", true, [ 'jquery' ] );
			}
			
			foreach ( $this->moduleList as $moduleObject ) {
				$moduleObject->AdminScripts();
			}
		}
		
		function OnAdminMainOptionScripts() {
			
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->OnAdminMainOptionScripts() ) {
					return true;
				}
			}
		}
		
		function OnAdminGlobalScripts() {
			
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->OnAdminGlobalScripts() ) {
					return true;
				}
			}
		}
		
		final function SetAdminStyle() {
		
		}
		
		function SetAdminScript() {
		
		}
		
		
		function SetClientScript() {
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->IsActive() ) {
					$moduleObject->ClientScript();
				}
			}
		}
		
		function SetClientStyle() {
			foreach ( $this->moduleList as $moduleObject ) {
				if ( $moduleObject->IsActive() ) {
					$moduleObject->ClientStyle();
				}
			}
		}
		
		function CheckAdminPage() {
			$page = ! empty( $_REQUEST['page'] ) ? $_REQUEST['page'] : "";
			$page = trim( $page );
			if ( ! empty( $page ) ) {
				if ( $page == $this->pluginBaseName ) {
					return true;
				}
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->IsPageCheck( $page ) ) {
						return true;
					}
				}
			}
			
			return false;
			
		}
		
		static function IsMainOptionPage() {
			$file = basename( $_SERVER['SCRIPT_FILENAME'] );
			if ( $file == "plugins.php" ) {
				if ( empty( $_REQUEST['page'] ) ) {
					return true;
				}
			}
			
			return false;
		}
		
		final public function _OnInit() {
		
		}
		
		final function AdminMenu() {
		
		}
		
		function _e( $string, $parameter = NULL, $_ = NULL ) {
			$args = func_get_args();
			echo call_user_func_array( [ $this, "__" ], $args );
		}
		
		function _ee( $string, $parameter = NULL, $_ = NULL ) {
			$args = func_get_args();
			foreach ( $args as &$arg ) {
				if ( is_string( $arg ) ) {
					$arg = $this->__( $arg );
				}
			}
			echo call_user_func_array( "sprintf", $args );
		}
		
		function __( $string, $parameter = NULL, $_ = NULL ) {
			$args = func_get_args();
			array_splice( $args, 1, 0, array( $this->pluginBaseName ) );
			
			return call_user_func_array( "APBD_Lan__", $args );
		}
		
		function ___( $string, $parameter = NULL, $_ = NULL ) {
			$args = func_get_args();
			foreach ( $args as &$arg ) {
				if ( is_string( $arg ) ) {
					$arg = $this->__( $arg );
				}
			}
			
			return call_user_func_array( "sprintf", $args );
		}
		
		function OnInit() {

		}
		
		final function LinksActions( $links ) {
		
		}
		
		final function PluginRowMeta( $plugin_meta, $plugin_file ) {
		
		}
		
		final function SetClientScriptBase() {
		
		}
		
		final function SetClientStyleBase() {
		
		}
		
		final function SetAdminScriptBase() {
		
		}
		
		final function SetAdminStyleBase() {
		
		}
		
		final function OnActive() {
		
		}
		
		final function OnDeactive() {
		
		}
		
		function OptionFormBase() {
		}
		
		final function PluginUpdate( $transient ) {
			return $transient;
		}
		
		final function checkUpdateInfo( $false, $action, $arg ) {
			return $false;
		}
		final private function _getHeaderHtml() {
			$this->GetHeaderHtml();
		}
		final function StartPlugin() {
		
		}
		
	}
}