<?php
	/**
	 * @since: 11/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	
	class APBDLicIntegrator {
		/**
		 * @var APBDLicIntegration
		 */
		public $integratorModule;
		public $textDomain;
		protected $title;
		/**
		 * @var string
		 */
		private $icon;
		private $view_path="";
		private $_viewData=["_relaod_event" => ""];
		public $options=[];
		private $isMultipartForm=false;
		public $pluginFile="";
		
		
		/**
		 * Integrator constructor.
		 *
		 * @param APBDLicIntegration $integratorModule
		 * @param $title
		 * @param string $icon
		 */
		final function __construct($title,$icon='') {
			$this->integratorModule = APBDLicIntegration::getInstance();
			$this->textDomain = $this->integratorModule->pluginBaseName;
			$this->pluginFile = $this->integratorModule->pluginFile;
			$vpath=strtolower(get_class($this));
			$this->setViewPath(plugin_dir_path($this->integratorModule->kernelObject->pluginFile)."views/apbdlicintegration/addons/{$vpath}/");
			$this->AddAjaxAction('',[$this, 'AjaxRequestCallback']);
			$this->title = $title;
			$this->icon = $icon;
			$this->SetOption();
			
			$this->initialize();
		}
		function SetOption() {
			$modulename = get_class( $this );
			$this->SetReloadEvent( $modulename."_reload" );
			$this->options= get_option( $this->integratorModule->pluginBaseName . "_oig_" . $modulename, NULL );
		}
		function UpdateOption() {
			return  update_option( $this->integratorModule->pluginBaseName . "_oig_" . $this, $this->options ) || add_option( $this->integratorModule->pluginBaseName . "_oig_" . $this, $this->options );
		}
		/*function __call( $name, $arguments ) {
			if(!method_exists($this,$name) && method_exists($this->integratorModule,$name)){
				return call_user_func_array([$this->integratorModule,$name],$arguments);
			}
		}*/
		function GetReloadEvent(){
			return $this->_viewData["_relaod_event"];
		}
		protected function SetReloadEvent( $event ) {
			$this->_viewData["_relaod_event"] = $event;
		}
		function getTitleClass(){
			return '';
		}
		function AddWarning($message, $parameter = null, $_ = null){
			$args = func_get_args();
			$message=call_user_func_array( [$this, "___" ], $args );
			APBD_AddWarning($message);
		}
		function AddError($message, $parameter = null, $_ = null){
			$args = func_get_args();
			$message=call_user_func_array( [$this, "__" ], $args );
			APBD_AddError($message);
		}
		function AddInfo($message, $parameter = null, $_ = null){
			$args = func_get_args();
			$message=call_user_func_array( [$this, "__" ], $args );
			APBD_AddInfo($message);
		}
		/**
		 * @param $actionName
		 * @param callable $function_to_add
		 */
		function AddAjaxAction($actionName,$function_to_add){
			$actionName=$this->GetActionName($actionName);
			add_action( 'wp_ajax_' .$actionName, $function_to_add );
		}
		function GetActionName($actionString=''){
			if(!empty($actionString)){
				$actionString='_'.$actionString;
			}
			return $this->GetMainFormId().$actionString;
		}
		function GetActionUrl($actionString='',$params=[]){
			$actionName=$this->GetActionName($actionString);
			$paramStr=count($params)>0?"&".http_build_query($params):"";
			return admin_url( 'admin-ajax.php' ).'?action='.$actionName.$paramStr;
		}
		function SetPOPUPIconClass($icon_class){
			$this->AddViewData("__icon_class", $icon_class);
		}
		function SetPOPUPColClass($col_class){
			$this->AddViewData("__col_class", $col_class);
		}
		function SetSubtitle($title, $parameter = null, $_ = null){
			$args=func_get_args();
			//$title=call_user_func_array("__",$args);
			$this->AddViewData("_subTitle",$title);
		}
		function SetTitle($title, $parameter = null, $_ = null){
			$args=func_get_args();
			$title=call_user_func_array([$this,"___"],$args);
			$this->AddViewData("_title",$title);
		}
		public function __toString() {
			return get_class( $this );
		}
		function GetMainFormId() {
			return $this->integratorModule->kernelObject->pluginBaseName . '_AJ_IG_' . $this;
		}
		function initialize(){
		
		}
		
		/**
		 * @param $postData
		 *
		 * @return Mapbd_license
		 */
		function CheckLicenseKey($postData){
			return null;
		}
		function _e($string, $parameter = null, $_ = null) {
			$args = func_get_args();
			echo call_user_func_array( [ $this, "__" ], $args );
		}
		function _ee($string, $parameter = null, $_ = null) {
			$args = func_get_args();
			foreach ($args as &$arg){
				if(is_string($arg)) {
					$arg = $this->__( $arg );
				}
			}
			echo call_user_func_array( "sprintf", $args );
		}
		function __($string, $parameter = null, $_ = null) {
			$args=func_get_args();
			array_splice($args, 1, 0, array($this->textDomain));
			return call_user_func_array("APBD_Lan__",$args);
		}
		function ___($string, $parameter = null, $_ = null)
		{
			$args=func_get_args();
			foreach ($args as &$arg){
				if(is_string($arg)) {
					$arg = $this->__( $arg );
				}
			}
			return call_user_func_array("sprintf",$args);
		}
		
		function GetOption($key='',$default='') {
			if(empty($key)){
				return $this->options;
			}else{
				if(isset($this->options[$key])){
					return $this->options[$key];
				}else{
					return $default;
				}
			}
		}
		function OptionForm(){
			echo "Not initilized yet";
		}
		public function AjaxRequestCallback() {
			$response         = new AppsbdAjaxConfirmResponse();
			$beforeSave= $this->options;
			$posts = $_POST;
			if ( ! empty( $posts['action'] ) ) {
				unset( $posts['action'] );
			}
			foreach ( $posts as  $key=>$post ) {
				$this->options[$key]=$post;
			}
			if ( $beforeSave === $this->options ) {
				$response->DisplayWithResponse(false,$this->__( "No change for update" ));
			}else{
				$response->SetResponse(false,$this->__( "No change for update" ));
				if ( $this->UpdateOption() ) {
					$response->DisplayWithResponse(true,$this->__( "Saved Successfully" ));
				} else {
					$response->DisplayWithResponse(false,$this->__( "No change for update" ));
				}
			}
			
			//sleep(10);
			$response->Display();
		}
		
		/**
		 * @return mixed
		 */
		public function getTitle() {
			return $this->title;
		}
		
		/**
		 * @return bool
		 */
		public function isMultipartForm() {
			return $this->isMultipartForm;
		}
		
		/**
		 * @param bool $isMultipartForm
		 */
		public function setIsMultipartForm( $isMultipartForm ) {
			$this->isMultipartForm = $isMultipartForm;
		}
		
		protected function AddViewData($key,$value){
			$this->_viewData[$key]=$value;
		}
		function Display($viewName='main'){
			$viewName=strtolower($viewName);
			$dir=strtolower(get_class( $this ));
			extract($this->_viewData);
			$output="";
			$dir=strtolower($dir);
			$path=$this->view_path .$viewName . ".php";
			if(file_exists($path)){
				ob_start();
				include $path;
				echo ob_get_clean();
				return;
			}else{
				die("File not exists:".$path);
			}
			
		}
		function DisplayPOPUPMsg($msg="",$autoCloseTime=0,$redirectPage='',$hideCloseButton=false){
			$this->AddViewData('__message',$this->__($msg));
			$this->AddViewData('__act',$autoCloseTime);
			$this->AddViewData('__rdir_page',$redirectPage);
			$this->AddViewData('__force_close_dis',!$hideCloseButton);
			extract($this->_viewData);
			include plugin_dir_path($this->integratorModule->kernelObject->pluginFile)."/template/popup-msg.php";
			die;
		}
		function DisplayPOPUp($viewName){
			$viewName=strtolower($viewName);
			$dir=get_class( $this );
			extract($this->_viewData);
			$output="";
			$dir=strtolower($dir);
			$path=$path=$this->view_path .$viewName . ".php";
			if(file_exists($path)){
				ob_start();
				include $path;
				$output=ob_get_clean();
			}else{
				die("File not exists:".$path);
			}
			include plugin_dir_path($this->integratorModule->kernelObject->pluginFile)."/template/popup.php";
			die;
		}
		/**
		 * @return string
		 */
		public function getIcon() {
			return $this->icon;
		}
		
		/**
		 * @return string
		 */
		public function getViewPath() {
			return $this->view_path;
		}
		
		/**
		 * @param string $view_path
		 */
		public function setViewPath( $view_path ) {
			$this->view_path = $view_path;
		}
		
		function LoadView( $viewName = 'main', $isReturn = false ) {
			$viewName=strtolower($viewName);
			extract($this->_viewData);
			$path=$this->view_path .$viewName . ".php";
			if(file_exists($path)){
				ob_start();
				include $path;
				echo  ob_get_clean();
				return;
			}else{
				echo  ("File not exists:".$path);
				return;
			}
		}
		
	}