<?php
	/**
	 * @since: 23/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	class  APBDScriptGeneratorDotNet extends APBDScriptGeneratorBase {
		public function __construct() {
			parent::__construct();
			$this->name="C# .net Code";
			$this->icon="fa fa-code";
			$this->isActive=true;
		}
		function ReplaceString(&$replace_str_arr,&$stringD){
			foreach ($replace_str_arr as $key=>$sv){
				$stringD=str_replace("<<{$key}>>",$sv,$stringD);
			}
		}
		/**
		 * @param $product_id ; product id
		 *
		 * @return mixed
		 */
		function outputZip( $product_id ,$params=[]) {
			$product=Mapbd_product::FindBy("id",$product_id);
			if(empty($product)){
				die("Something went wrong");
			}
			$apiBase=APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("");
			$productname_without_space=str_replace(" ","",$product->product_name);
			$replace_str_arr=[
			
				"productname"=>$product->product_name,
				"productname_without_space"=>$productname_without_space,
				"product_class_name_without_space"=>$productname_without_space,
				"baseclassname"=>str_replace(" ","",$product->product_name)."Base",
				"encryptedkey"=>$product->enc_key,
				"productid"=>$product->id,
				"productbase"=>$product->product_base,
				"hostserver"=>$apiBase.APBDLicenseSettings::GetModuleInstance()->GetOption("api_end_point","licensor")."/",
				"programfilename"=>"program.cs",
			
			];
			$baseRawFilePath=plugin_dir_path($this->pluginFile)."/sample_script/dotnet/Program.cs";
			$dllFileFilePath=realpath(plugin_dir_path($this->pluginFile)."/sample_script/dotnet/EliteLicenser.dll");
			$readmeFileFilePath=realpath(plugin_dir_path($this->pluginFile)."/sample_script/dotnet/readme.txt");
			$mainContent= APBD_file_get_contents($baseRawFilePath);
			$this->ReplaceString($replace_str_arr,$mainContent);
			if(!is_dir($this->tempPath)){
				mkdir($this->tempPath,0755,true);
			}
			$zip = new ZipArchive();
			$tmp_file = tempnam($this->tempPath,'');
			
			if ($zip->open($tmp_file, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) !== TRUE) {
				echo "It can't create temp file name:".$this->tempPath.$tmp_file;
				die;
			}
			$baseRealPathLen=strlen(realpath(plugin_dir_path($this->pluginFile)."/sample_script/dotnet/"))+1;
			$zip->addFile($dllFileFilePath,substr($dllFileFilePath,$baseRealPathLen));
			$readmetxt= APBD_file_get_contents($readmeFileFilePath);
			$this->ReplaceString($replace_str_arr,$readmetxt);
			
			$zip->addFromString("readme.txt",$readmetxt);
			$zip->addFromString("Program.cs",$mainContent);
			
			$tt = $zip->close();
			if(file_exists($tmp_file))
			{
				// push to download the zip
				header('Content-type: application/zip');
				header('Content-Disposition: attachment; filename="'.$product->product_name.'_cSharp.zip"');
				readfile($tmp_file);
				unlink($tmp_file);
				// remove zip file is exists in temp path
				exit();
			}
			else {
				echo $tt;
				die();
			}
		}
	}