<?php
	/**
	 * @since: 23/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	class  APBDScriptGeneratorPHP extends APBDScriptGeneratorBase {
		
		public function __construct() {
			parent::__construct();
			$this->name="PHP Application";
			$this->icon="fa fa-code";
			$this->isActive=true;
		}
		function ReplaceString(&$replace_str_arr,&$stringD){
			foreach ($replace_str_arr as $key=>$sv){
				$stringD=str_replace("<<{$key}>>",$sv,$stringD);
			}
		}
		/**
		 * @param $product_id ; product id
		 *
		 * @return mixed
		 */
		function outputZip( $product_id,$params=[] ) {
			$product=Mapbd_product::FindBy("id",$product_id);
			if(empty($product)){
				die("Something went wrong");
			}
			$apiBase=APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("");
			$replace_str_arr=[
				"productname"=>$product->product_name,
				"productname_without_space"=>str_replace(" ","",$product->product_name),
				"baseclassname"=>str_replace(" ","",$product->product_name)."Base",
				"encryptedkey"=>$product->enc_key,
				"productid"=>$product->id,
				"productbase"=>$product->product_base,
				"hostserver"=>$apiBase.APBDLicenseSettings::GetModuleInstance()->GetOption("api_end_point","licensor")."/",
				"hascheckupdate"=>'true',
				
			];
			
			$baseRawFilePath=plugin_dir_path($this->pluginFile)."/sample_script/php/base.app";
		
			if(!file_exists($baseRawFilePath)){
				echo "Base raw file is not exists";
				die;
			}
			$baseFileContent= APBD_file_get_contents($baseRawFilePath);
			$this->ReplaceString($replace_str_arr,$baseFileContent);
			//echo $baseFileContent;
			//die;
			if(!is_dir($this->tempPath)){
				mkdir($this->tempPath,0755,true);
			}
			$zip = new ZipArchive();
			$tmp_file = tempnam($this->tempPath,'');
			
			if ($zip->open($tmp_file, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) !== TRUE) {
				echo "It can't create temp file name:".$this->tempPath.$tmp_file;
				die;
			}
			$this->Example1($zip,$replace_str_arr,$baseFileContent);
			$this->Example2($zip,$replace_str_arr,$baseFileContent);
			//$this->Example3($zip,$replace_str_arr,$baseFileContent);
			//$this->Example4($zip,$replace_str_arr,$baseFileContent);
			
			$tt = $zip->close();
			if(file_exists($tmp_file))
			{
				// push to download the zip
				header('Content-type: application/zip');
				header('Content-Disposition: attachment; filename="'.$product->product_name.'.zip"');
				readfile($tmp_file);
				unlink($tmp_file);
				// remove zip file is exists in temp path
				exit();
			}
			else {
				echo $tt;
				die();
			}
		}
		
		function Example1(&$zip,&$replace_str_arr,&$baseFileContent){
			$example1="example1_simple" ;
			//example 1 base file
			$zip->addEmptyDir( $example1 );
			$fileExampleBase1=$example1."/".$replace_str_arr['baseclassname'].".php";
			$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 1 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/php/example1.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example1."/index.php",$example1Function);
		}
		
		function Example2(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example2_base_encrypted" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['baseclassname'].".php";
			$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/php/example1.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/index.php",$example1Function);
		}
		
		
		
		function Example3(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example3_full_plugin" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['baseclassname'].".php";
			/*$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);*/
			$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/fullplugin.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/".$replace_str_arr['productname_without_space'].".php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		function Example4(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example4_full_plugin_base_encrypted" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['baseclassname'].".php";
			$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);
			//$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/fullplugin.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/".$replace_str_arr['productname_without_space'].".php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		
		
	}