<?php
	/**
	 * @since: 23/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	class  APBDScriptGeneratorWordPress extends APBDScriptGeneratorBase {
		
		public function __construct() {
			parent::__construct();
			$this->name="WordPress";
			$this->icon="fa fa-wordpress";
			$this->isActive=true;
		}
		function ReplaceString(&$replace_str_arr,&$stringD){
			foreach ($replace_str_arr as $key=>$sv){
				$stringD=str_replace("<<{$key}>>",$sv,$stringD);
			}
		}
		
		/**
		 * @param $product_id ; product id
		 *
		 * @return mixed
		 */
		function outputZip( $product_id,$params=[] ) {
			$product=Mapbd_product::FindBy("id",$product_id);
			if(empty($product)){
				die("Something went wrong");
			}
			$apiBase=APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("");
			$productname_without_space=str_replace(" ","",$product->product_name);
			$base_class_name=self::camel_case_to_snake_case(str_replace(" ","",$product->product_name)."Base",true);
			$replace_str_arr=[
				"lic_form_header"=> APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/form-header.app"),
				"productname"=>$product->product_name,
				"productname_without_space"=>$productname_without_space,
				"product_class_name_without_space"=>$productname_without_space,
				"baseclassname"=>$base_class_name,
				"basefilename"=>"class-".strtolower(str_replace("_","-",$base_class_name)),
				"encryptedkey"=>$product->enc_key,
				"productid"=>$product->id,
				"productbase"=>$product->product_base,
				"hostserver"=>$apiBase.APBDLicenseSettings::GetModuleInstance()->GetOption("api_end_point","licensor")."/",
				"hascheckupdate"=>'true',
				"isencyptupdate"=>$product->is_enc_up_res=="Y"?'true':'false',
				"icon_or_file"=>'" dashicons-star-filled "',
				"themestylecss"=>'style.css',
				"source_version"=>time(),
				"activatedmenu"=>'
		add_menu_page (  "'.$productname_without_space.'", "'.$product->product_name.'", "activate_plugins", $this->slug, [$this,"activated"], " dashicons-star-filled ");
		//add_submenu_page(  $this->slug, "'.$productname_without_space.' License", "License Info", "activate_plugins",  $this->slug."_license", [$this,"activated"] );
'
			
			];
			$replace_str_arr['requirelink']='require_once "'.$replace_str_arr['basefilename'].'.php";';
			//$replace_str_arr[]="";
			$appHeaderContent= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/header.app");
			$this->ReplaceString($replace_str_arr,$appHeaderContent);
			$replace_str_arr['ptproperties']=$appHeaderContent;
			
			$baseRawFilePath=plugin_dir_path($this->pluginFile)."/sample_script/wp/base.app";
		
			if(!file_exists($baseRawFilePath)){
				echo "Base raw file is not exists";
				die;
			}
			$baseFileContent= APBD_file_get_contents($baseRawFilePath);
			$this->ReplaceString($replace_str_arr,$baseFileContent);
			//echo $baseFileContent;
			//die;
			if(!is_dir($this->tempPath)){
				mkdir($this->tempPath,0755,true);
			}
			$zip = new ZipArchive();
			$tmp_file = tempnam($this->tempPath,'');
			
			if ($zip->open($tmp_file, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) !== TRUE) {
				echo "It can't create temp file name:".$this->tempPath.$tmp_file;
				die;
			}
			$this->Example1($zip,$replace_str_arr,$baseFileContent);
			$this->Example2($zip,$replace_str_arr,$baseFileContent);
			$this->Example3($zip,$replace_str_arr,$baseFileContent);
			$this->Example4($zip,$replace_str_arr,$baseFileContent);
			$this->Example5($zip,$replace_str_arr,$baseFileContent);
			$this->Example6($zip,$replace_str_arr,$baseFileContent);
			
			$tt = $zip->close();
			if(file_exists($tmp_file))
			{
				// push to download the zip
				header('Content-type: application/zip');
				header('Content-Disposition: attachment; filename="'.$product->product_name.'_wp.zip"');
				readfile($tmp_file);
				unlink($tmp_file);
				// remove zip file is exists in temp path
				exit();
			}
			else {
				echo $tt;
				die();
			}
		}
		
		function Example1(&$zip,&$replace_str_arr,&$baseFileContent){
			$example1="example1_simple" ;
			//example 1 base file
			$zip->addEmptyDir( $example1 );
			$fileExampleBase1=$example1."/".$replace_str_arr['basefilename'].".php";
			$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 1 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/plugin_or_function.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example1."/plugin_or_function.php",$example1Function);
		}
		
		function Example2(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example2_base_encrypted" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['basefilename'].".php";
			$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/plugin_or_function.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/plugin_or_function.php",$example1Function);
		}
		
		
		
		function Example3(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example3_full_plugin" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['basefilename'].".php";
			/*$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);*/
			$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/fullplugin.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/".$replace_str_arr['productname_without_space'].".php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/_lic_style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		function Example4(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example4_full_plugin_base_encrypted" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['basefilename'].".php";
			$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);
			//$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/fullplugin.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/".$replace_str_arr['productname_without_space'].".php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/_lic_style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		function Example5(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example5_full_theme" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['basefilename'].".php";
			/*$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);*/
			$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/functions.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/functions.php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/_lic_style.css",$example1Function);
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		function Example6(&$zip,&$replace_str_arr,&$baseFileContent){
			$example="example6_full_theme_base_encrypted" ;
			//example 2 base file
			$zip->addEmptyDir( $example );
			$example.="/".$replace_str_arr['productname_without_space'];
			$zip->addEmptyDir( $example );
			$fileExampleBase1=$example."/".$replace_str_arr['basefilename'].".php";
			$sObfusationData=new Obfuscator($baseFileContent, 'Loading base file...');
			$zip->addFromString($fileExampleBase1,'<?php ' . "\r\n" . $sObfusationData);
			//$zip->addFromString($fileExampleBase1,$baseFileContent);
			
			//example 2 function  file
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/functions.app");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/functions.php",$example1Function);
			
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/_lic_style.css",$example1Function);
			//style
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/style.css");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/style.css",$example1Function);
			
			//readme.txt
			$example1Function= APBD_file_get_contents(plugin_dir_path($this->pluginFile)."/sample_script/wp/theme/readme.txt");
			$this->ReplaceString($replace_str_arr,$example1Function);
			$zip->addFromString($example."/readme.txt",$example1Function);
		}
		
	}