<?php
	/**
	 * @since: 11/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	
	class EnvatoIntegrator extends APBDLicIntegrator {
		function initialize() {
			$this->AddAjaxAction("view-details",[$this,'viewLicenseDetails']);
			$this->AddAjaxAction("add-link",[$this,'AddEnvatoProductLink']);
			$this->AddAjaxAction("save-api",[$this,'updateLicenseType']);
			$this->AddAjaxAction("get-envato-products",[$this,'getEnvatoProductsKeyValue']);
			$this->AddAjaxAction("get-linked-product",[$this,'getLinkedProductAjax']);
			$this->AddAjaxAction("get-license-type",[$this,'get_license_type']);
			$this->AddAjaxAction("delete-linked-item",[$this,'delete_linked_item']);
			//Mapbd_license::RegisterMarkets("E","Envato");
            add_filter($this->integratorModule->getHookActionStr("expire-filter"),[$this,"CheckEnvatoSupportRenew"]);
            add_filter($this->integratorModule->getHookActionStr("check-license"),[$this,"CheckLicenseFilter"],10,2);
            add_filter($this->integratorModule->getHookActionStr("check-license-key"),[$this,'getEnvatoLicense'],10,2);
            add_filter($this->integratorModule->getHookActionStr("before-active-response"),[$this,'checkEnvatoOnActive'],10,1);
		}
		
		/**
		 * @param Mapbd_license $licenseObj
		 */
		function checkEnvatoOnActive($licenseObj) {
			if ( $licenseObj->has_support == "Y" && time() > strtotime( $licenseObj->support_end_time ) ) {
				$licenseObj = $this->CheckEnvatoSupportRenew( $licenseObj );
			}
			return $licenseObj;
		}
		
		/**
		 * @param Mapbd_license $licenseObj
		 * @param $license_code
		 *
		 * @return Mapbd_license
		 */
		public function getEnvatoLicense($licenseObj,$license_code) {
			if ( empty( $licenseObj ) ) {
				$purchseDetails = $this->getPurchaseKeyDetails( $license_code );
				$linkedProduct = $this->getLinkedProductList();
				if ( ! empty( $purchseDetails->item->id ) ) {
					$product_id = NULL;
					foreach ( $linkedProduct as $pid => $linked_id ) {
						if ( $purchseDetails->item->id == $linked_id ) {
							$product_id = $pid;
							break;
						}
					}
					if ( ! empty( $product_id ) ) {
						if ( $purchseDetails->license == "Regular License" ) {
							$licenseTypeId = $this->GetOption( "envatoLR" );
						} else {
							$licenseTypeId = $this->GetOption( "envatoLE" );
						}
						if ( empty( $licenseTypeId ) ) {
							return NULL;
						}
						$licenseObj = Mapbd_license_type::FindBy( "id", $licenseTypeId );
						if ( empty( $licenseObj ) ) {
							return NULL;
						}
						if ( empty( $product ) ) {
							$product = Mapbd_product::FindBy( "id", $product_id );
						}
						if ( empty( $product ) ) {
							return NULL;
						}
						$client = Mapbd_client::FindBy( "username", $purchseDetails->buyer );
						if ( empty( $client ) ) {
							//new client
							$nc = new Mapbd_client();
							$nc->username( $purchseDetails->buyer );
							$nc->name( $purchseDetails->buyer );
							$nc->status( 'A' );
							$nc->country( "-" );
							$nc->company( "-" );
							$nc->DisableEmailInValidation();
							if ( $nc->Save() ) {
								$client = $nc;
							} else {
								return NULL;
							}
						}
						//now we are inserting license
						$liceobj = new Mapbd_license();
						$liceobj->client_id( $client->id );
						$liceobj->product_id( $product->id );
						$liceobj->product_base_name( $product->product_base );
						$liceobj->license_id( $licenseObj->id );
						
						$liceobj->purchase_key( $license_code );
						$liceobj->license_title( $purchseDetails->license );
						$liceobj->max_domain( $licenseObj->max_domain );
						$liceobj->verification_required( $licenseObj->verification_required );
						$liceobj->lictype_param( $licenseObj->extra_param );
						$liceobj->market( "E" );
						$liceobj->has_expiry( $licenseObj->has_expiry );
						if ( $licenseObj->has_expiry == "Y" ) {
							$liceobj->expiry_time( date( 'Y-m-d H:i:s', strtotime( $licenseObj->days_of_expiry . " DAYS" ) ) );
						}
						$liceobj->has_support( $licenseObj->has_support );
						if ( $licenseObj->has_support == "Y" ) {
							$liceobj->support_end_time( date( 'Y-m-d H:i:s', strtotime( $purchseDetails->supported_until ) ) );
						}
						$liceobj->status( 'W' );
						if ( $liceobj->Save() ) {
							$licenseObj = $liceobj;
						}
					}
				}
			}
			return $licenseObj;
		}
		public function CheckLicenseFilter($responseObject,$purchase_code) {
		    if(empty($responseObject)){
			    $purchseDetails = $this->getPurchaseKeyDetails( $purchase_code );
			    $linkedProduct=$this->getLinkedProductList();
			    $elite_product_id=null;
			    foreach ($linkedProduct as $product_id=>$value){
			        if(!empty($purchseDetails->item) && ($value==$purchseDetails->item->id)){
				        $elite_product_id=$product_id;
				        break;
                    }
                }
			    if(!empty($elite_product_id)){
			        $product=Mapbd_product::FindBy("id",$elite_product_id);
			        if($product) {
				        if ( $purchseDetails->license == "Regular License" ) {
					        $licenseTypeId = $this->GetOption( "envatoLR" );
				        } else {
					        $licenseTypeId = $this->GetOption( "envatoLE" );
				        }
				        $licenseObj=Mapbd_license_type::FindBy("id",$licenseTypeId);
				        if($licenseObj){
					        $client = Mapbd_client::FindBy( "username", $purchseDetails->buyer );
					        if ( empty( $client ) ) {
						        //new client
						        $nc = new Mapbd_client();
						        $nc->username( $purchseDetails->buyer );
						        $nc->name( $purchseDetails->buyer );
						        $nc->status( 'A' );
						        $nc->country( "-" );
						        $nc->company( "-" );
						        $nc->DisableEmailInValidation();
						        if ( $nc->Save() ) {
							        $client = $nc;
						        } else {
							        return $responseObject;
						        }
					        }
					
					        //now we are inserting license
					        $liceobj = new Mapbd_license();
					        $liceobj->client_id( $client->id );
					        $liceobj->product_id( $product->id );
					        $liceobj->product_base_name( $product->product_base );
					        $liceobj->license_id( $licenseObj->id );
					        //$liceobj->purchase_key();
					        //$liceobj->user_domain("");
					        //$liceobj->server_ip();
					        //$liceobj->current_version();
					        $liceobj->purchase_key( $purchase_code );
					        $liceobj->license_title( $purchseDetails->license );
					        $liceobj->max_domain( $licenseObj->max_domain );
					        $liceobj->verification_required( $licenseObj->verification_required );
					        $liceobj->lictype_param( $licenseObj->extra_param );
					
					        $liceobj->market( "E" );
					
					        $liceobj->has_expiry( $licenseObj->has_expiry );
					        if ( $licenseObj->has_expiry == "Y" ) {
						        $liceobj->expiry_time( date( 'Y-m-d H:i:s', strtotime( $licenseObj->days_of_expiry . " DAYS" ) ) );
					        }
					
					        $liceobj->has_support( $licenseObj->has_support );
					        if ( $licenseObj->has_support == "Y" ) {
						        $liceobj->support_end_time( date( 'Y-m-d H:i:s', strtotime( $purchseDetails->supported_until ) ) );
					        }
					        $liceobj->status( 'W' );
					        if ( $liceobj->Save() ) {
						        return $liceobj;
					        }
                        }
				        
			        }
                }
            }
			return $responseObject;
		}
		/**
		 * @param Mapbd_license $licenseObj
		 */
		public function CheckEnvatoSupportRenew($licenseObj) {
		    if(strtoupper($licenseObj->market)=="E") { //envato market place
			    $linkedProduct = $this->getLinkedProductList();
			    if ( isset( $linkedProduct[ $licenseObj->product_id ] ) ) {
				    //need to check api
				    $purchseDetails = $this->getPurchaseKeyDetails( $licenseObj->purchase_key );
				    if ( ! empty( $purchseDetails->item->id ) && $purchseDetails->item->id == $linkedProduct[ $licenseObj->product_id ] ) {
					    $updated_support=date( 'Y-m-d H:i:s', strtotime( $purchseDetails->supported_until ));
					    if($updated_support!=$licenseObj->support_end_time){
					        //update license end time
                            $uobj=new Mapbd_license();
                            $uobj->support_end_time($updated_support);
                            $uobj->SetWhereUpdate("id",$licenseObj->id);
                            $uobj->Update();//update license list
						     $licenseObj->support_end_time=$updated_support;
                        }
				    }
			    }
		    }
		    return $licenseObj;
		}
		public function OptionForm() {
			//echo $this->getViewPath();
			$this->AddViewData("EnvatoUserInfo",$this->getAPIUserHtmlDetails());
			$this->Display();
		}
		public function viewLicenseDetails(){
			$this->SetTitle("Envato Details");
			$this->SetPOPUPColClass("col-sm-5");
			$this->SetPOPUPIconClass("ap ap-envato");
			$this->DisplayPOPUp('viewLicenseDetails');
			
			exit;
		}
		public function getLinkedProductList(){
			return get_option("app_env_linked",[]);
        }
		public function AddEnvatoProductLink() {
			$this->SetTitle( "Link with Envato Product" );
			$this->SetPOPUPColClass( "col-sm-5" );
			$this->SetPOPUPIconClass( "ap ap-envato" );
			$linkedProduct=$this->getLinkedProductList();
			if(APPSBD_IsPostBack){
				$app_product=APBD_PostValue("product_id","");
				$env_product=APBD_PostValue("env_product_id","");
				$isOk=true;
				if(empty($app_product)){
				    $isOk=false;
				    $this->AddError("App product is required");
                }
				if(empty($env_product)){
					$isOk=false;
					$this->AddError("Envato product is required");
				}
				if($isOk) {
					if ( isset( $linkedProduct[ $app_product ] ) ) {
						$this->AddError("The product is already linked with envato product");
					} else {
						$linkedProduct[$app_product]=$env_product;
						if ( update_option("app_env_linked",$linkedProduct) or add_option("app_env_linked",$linkedProduct) ) {
							$this->AddInfo( "Linked Successfully" );
							$this->DisplayPOPUPMsg();
						} else {
							$this->AddError( "Linked failed");
						}
					}
				}
            }
			$this->DisplayPOPUp( 'link_product' );
			exit;
		}
		public function getLinkedProductAjax(){
		    echo $this->getLinkedProductHtml();
		    exit;
        }
        public function get_license_type() {
	       $licenseTypes=Mapbd_license_type::FindAllByKeyValue("status","A","id","license_title");
	       echo json_encode($licenseTypes);
	       die;
        }
		function delete_linked_item() {
			$param        = APBD_GetValue( "id" );
			$mainResponse = new AppsbdAjaxConfirmResponse();
			if ( empty( $param ) ) {
				$mainResponse->DisplayWithResponse( false, __( "Invalid Request" ) );
				
				return;
			}
			$linkedProduct = $this->getLinkedProductList();
			
			if ( isset( $linkedProduct[ $param ] ) ) {
				//$ur=new Mapbd_client();
				unset( $linkedProduct[ $param ] );
				if ( update_option( "app_env_linked", $linkedProduct ) or add_option( "app_env_linked", $linkedProduct ) ) {
					$mainResponse->DisplayWithResponse( true, $this->__( "Deleted Successfully" ) );
				} else {
					$mainResponse->DisplayWithResponse( false, $this->__( "Delete failed try again" ) );
				}
			} else {
				$mainResponse->DisplayWithResponse( false, $this->__( "Delete failed try again" ) );
			}
		}
		public function  getLinkedProductHtml() {
		    $linkedProducts=$this->getLinkedProductList();
		    $output="";
		    if(count($linkedProducts)==0){
			    ob_start();
		        ?>
                <tr>
                    <td colspan="5" class="text-center text-danger text-bold"><?php $this->_e("No product linked with Envato product") ?></td>
                </tr>
		        <?php
			    $output=ob_get_clean();
            }else{
		        $i=count($linkedProducts);
		        $products=Mapbd_product::FetchAllKeyValue("id","product_name");
			    foreach ( $linkedProducts as $appProduct=>$linked_product ) {
			        ob_start();
			        $evProductInfo=$this->getProductDetails($linked_product);
			        
                    ?>
                    <tr>
                        <th  class="text-center" width="5%;" scope="row"><?php echo $i--; ?></th>
                        <td width="35%;" scope="col"><?php echo !empty($products[$appProduct])?$products[$appProduct]:$appProduct; ?></td>
                        <td width="5%;" scope="col"><i class="fa fa-arrows-h"></i></td>
                        <td width="35%;" scope="col"><?php echo !empty($evProductInfo->name)?$evProductInfo->name:$linked_product; ?></td>
                        <td class="text-center"  width="10%;"  scope="col"><a  class='text-dange ConfirmAjaxWR ' data-on-complete='linkedDelete' data-msg="<?php $this->_e("Are you sure to delete?");?>"  href="<?php echo $this->GetActionUrl("delete-linked-item",["id"=>$appProduct]) ?>" ><i class="fa fa-trash-o"></i></a></td>

                    </tr>
                    <?php
				    $output=ob_get_clean().$output;
			   }
            }
			return $output;
		}
		public function updateLicenseType(){
			$response         = new AppsbdAjaxConfirmResponse();
			$beforeSave= $this->options;
			$posts = $_POST;
			if ( ! empty( $posts['action'] ) ) {
				unset( $posts['action'] );
			}
			if(isset($_POST['APIKey'])){
				$this->options['APIKey']=$_POST['APIKey'];
			}
			if ( $beforeSave === $this->options ) {
				$response->DisplayWithResponse(false,$this->__( "No change for update" ));
			}else{
				$api_key=isset($this->options["APIKey"])?$this->options['APIKey']:"";
				$response->SetResponse(false,$this->__( "No change for update" ));
				if ( $this->UpdateOption() ) {
					$response->DisplayWithResponse(true,$this->__( "Saved Successfully" ),$this->getAPIUserHtmlDetails());
				} else {
					$response->DisplayWithResponse(false,$this->__( "No change for update" ));
				}
			}
			
			//sleep(10);
			$response->Display();
			exit;
		}
		public function getEnvatoProductsKeyValue() {
			$EnvatoUserInfo = $this->get_envato_userdata();
			$siteName       = APBD_PostValue( "s" );
			$response=[];
			if ( ! empty( $EnvatoUserInfo->account->username ) && ! empty( $siteName ) ) {
				
				$products=$this->getEnvatoProducts($siteName);
				foreach ($products as $product){
					$response[$product->id]=$product->item;
				}
			}
			echo json_encode($response);die;
		}
		public function getProductDetails($product_id,$isForceCheck=false){
			
		    $datakey="env_".$product_id;
		    if(!$isForceCheck) {
			    $productInfo = get_option( $datakey, NULL );
			    if ( ! empty( $productInfo ) ) {
				    return $productInfo;
			    }
		    }
			
			$url="https://api.envato.com/v3/market/catalog/item?id={$product_id}";
			$json=$this->apicall($url);
			if(!empty($json)){
				$json=json_decode($json);
			}
			if(!empty($json->name)){
				$product_obj=new stdClass();
				$product_obj->id=$json->id;
				$product_obj->name=$json->name;
				$product_obj->author_username=$json->author_username;
				$product_obj->url=$json->url;
				$product_obj->icon=$json->previews->icon_preview->icon_url;
				update_option($datakey,$product_obj) OR add_option($datakey,$product_obj);
				return $product_obj;
            }
			return null;
        }
		public function getEnvatoProducts($siteName) {
			$EnvatoUserInfo = $this->get_envato_userdata();
			if ( ! empty( $EnvatoUserInfo->account->username ) && ! empty( $siteName ) ) {
				
				$obj = $this->product_list( $EnvatoUserInfo->account->username, $siteName );
				if(!empty($obj->{"new-files-from-user"})){
					return $obj->{"new-files-from-user"};
				}
			}
			return [];
		}
		public function CheckLicenseKey( $postData ) {
		 
			$product=null;
			if(empty($postData->product_id)){
			    $product=Mapbd_product::FindBy("product_base",$postData->product_base);
			    if(empty($product)){
			        return null;
                }
				$postData->product_id=$product->id;
			}
			$linkedProduct=$this->getLinkedProductList();
		    if(isset($linkedProduct[$postData->product_id])){
		        //need to check api
                $purchseDetails=$this->getPurchaseKeyDetails($postData->license_key);
                if(!empty($purchseDetails->item->id) && $purchseDetails->item->id==$linkedProduct[$postData->product_id]){
                    //yes sold product
	               $licenseTypeId="";
                    if($purchseDetails->license=="Regular License"){
	                    $licenseTypeId=$this->GetOption("envatoLR");
                    }else{
	                    $licenseTypeId=$this->GetOption("envatoLE");
                    }
                    if(empty($licenseTypeId )){
                        return null;
                    }
	                $licenseObj=Mapbd_license_type::FindBy("id",$licenseTypeId);
	                if(empty($licenseObj)) {
		                return null;
	                }
                    if(empty($product)) {
	                    $product = Mapbd_product::FindBy( "id", $postData->product_id );
                    }
	                if(empty($product)){
		                return null;
	                }
	               $client= Mapbd_client::FindBy("username",$purchseDetails->buyer);
	                if(empty($client)){
	                    //new client
		                $nc=new Mapbd_client();
		                $nc->username($purchseDetails->buyer);
		                $nc->name($purchseDetails->buyer);
		                $nc->status('A');
		                $nc->country("-");
		                $nc->company("-");
		                $nc->DisableEmailInValidation();
		                if($nc->Save()){
			                $client=$nc;
		                }else{
			               return null;
		                }
                    }
	               
	                //now we are inserting license
	                $liceobj=new Mapbd_license();
	                $liceobj->client_id($client->id);
	                $liceobj->product_id($product->id);
	                $liceobj->product_base_name($product->product_base);
	                $liceobj->license_id($licenseObj->id);
	                //$liceobj->purchase_key();
	                //$liceobj->user_domain("");
	                //$liceobj->server_ip();
	                //$liceobj->current_version();
	                $liceobj->purchase_key($postData->license_key);
	                $liceobj->license_title($purchseDetails->license);
	                $liceobj->max_domain($licenseObj->max_domain);
	                $liceobj->verification_required($licenseObj->verification_required);
	                $liceobj->lictype_param($licenseObj->extra_param);
	                
	                $liceobj->market("E");
	                
	                $liceobj->has_expiry($licenseObj->has_expiry);
	                if($licenseObj->has_expiry=="Y") {
		                $liceobj->expiry_time( date( 'Y-m-d H:i:s', strtotime( $licenseObj->days_of_expiry . " DAYS" ) ) );
	                }
	                
	                $liceobj->has_support($licenseObj->has_support);
	                if($licenseObj->has_support=="Y") {
		                $liceobj->support_end_time( date( 'Y-m-d H:i:s', strtotime($purchseDetails->supported_until)));
	                }
	                $liceobj->status('W');
	                if($liceobj->Save()){
		               return $liceobj;
	                }
                }
            }
			//return Mapbd_license::FindBy("purchase_key","TESTMULTI");
			
			return null;
		}
		function getPurchaseKeyDetails($purchase_code){
			$url="https://api.envato.com/v3/market/author/sale?code=$purchase_code";
			$data=$this->apicall($url);
            if(!empty($data)){
	            $data=json_decode($data);
                if(!empty($data->type) && $data->type=="curl_error"){
                   return null;
                }else{
                    if(!empty($data->message) && $data->message=="Unauthorized"	){
                        return null;
                    }else{
                        $skip_properties=array("description","classification_url","author_username","classification","site","author_url","author_image","summary","rating_count","trending","attributes","tags","previews");
                        if(!empty($data->item)){
                            foreach ($skip_properties as $vl){
                                if($vl=="previews"){
                                    if(!empty($data->item->$vl->icon_with_landscape_preview->icon_url)){
                                        $data->item->product_icon=$data->item->$vl->icon_with_landscape_preview->icon_url;
                                    }
                                }
                                if(isset($data->item->$vl)){
                                    unset($data->item->$vl);
                                }
                            }
                        }
                        if(!empty($data->buyer)){
                           return $data;
                        }
                    }
                }
            }
            return null;
				
			
        }
		function product_list($username,$site){
			
			$url="https://api.envato.com/v1/market/new-files-from-user:$username,$site.json";
			$json=$this->apicall($url);
			if(!empty($json)){
				$json=json_decode($json);
			}
			return $json;
		}
		function getAPIUserHtmlDetails(){
			$EnvatoUserInfo=$this->get_envato_userdata();
			ob_start();
			?>
			<?php if(empty($EnvatoUserInfo)){ ?>
				<div class="alert alert-danger" role="alert">
					<?php $this->_e("API Information is not valid or not set"); ?>
				</div>
			<?php }elseif(!empty($EnvatoUserInfo->error)){
			    ?>
                <div class="alert alert-danger" role="alert">
					<?php echo $EnvatoUserInfo->error; ?>
					
                </div>
			    <?php
            }else{
				//SMPrint($EnvatoUserInfo);
				?>
				<div class="card">
					<div class="row no-gutters">
						<div class="col-2 pl-2 pb-2 pt-2">
							<img src="<?php echo $EnvatoUserInfo->account->image; ?>" class="card-img img-fluid" alt="<?php echo $EnvatoUserInfo->account->surname; ?>">
						</div>
						<div class="col p-2">
							<div class="card-body">
								<h5 class="card-title mb-1"><?php echo $EnvatoUserInfo->account->username; ?></h5>
								<div class="card-text">
									<div><?php echo $EnvatoUserInfo->account->firstname." ".$EnvatoUserInfo->account->surname; ?></div>
									<div><?php echo $EnvatoUserInfo->account->email; ?></div>
									<div><?php echo $EnvatoUserInfo->account->country; ?></div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<?php
			} ?>
			<?php
			return ob_get_clean();
		}
		function get_envato_userdata(){
			$bearerToken=$this->GetOption("APIKey");
			$wpkey=hash('crc32b',$bearerToken)."_profile";
			$profile=get_option($wpkey,null);
			if(!empty($profile->account->username)){
				return $profile;
			}
			$url="https://api.envato.com/v1/market/private/user/account.json";
			$json=$this->apicall($url);
			if(!empty($json)){
				$json=json_decode($json);
			}
			if(!empty($json->account)) {
				$json->account->email="";
				$json->account->username="";
				
				$eurl   = "https://api.envato.com/v1/market/private/user/email.json";
				$ejson = $this->apicall( $eurl );
				if ( ! empty( $ejson ) ) {
					$ejson = json_decode( $ejson );
					if(!empty($ejson->email)){
						$json->account->email=$ejson->email;
					}
					
				}
				$uurl   = "https://api.envato.com/v1/market/private/user/username.json";
				$ejson = $this->apicall( $uurl );
				if ( ! empty( $ejson ) ) {
					$ejson = json_decode( $ejson );
					if(!empty($ejson->username)){
						$json->account->username=$ejson->username;
					}
					
				}
			}
			
			update_option($wpkey,$json) OR add_option($wpkey,$json);
			return $json;
		}
		private function apicall($url,$postarray=array()){
			
			$bearerToken=$this->GetOption("APIKey");
			if(empty($bearerToken)){
				return NULL;
			}
			$headers=array('Authorization: Bearer '.$bearerToken);
			//GPrint($headers);
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($ch, CURLOPT_AUTOREFERER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			if(count($postarray)>0){
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postarray);
			}
			$output = curl_exec($ch);
			$info = curl_getinfo($ch);
			//print_r($info);
			if ($output === FALSE) {
				$obj=new stdClass();
				$obj->status=false;
				$obj->type="curl_error";
				$obj->error_msg=curl_error($ch);
				$obj->curl_errno=curl_errno($ch);
				return  json_encode($obj);
			}
			curl_close($ch);
			return $output;
			
		}
		
	}