<?php 			
/** 
 * @since: 24/Feb/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,api_key,api_ip,add_product,edit_product,view_product,add_client,edit_client,view_client,add_license,edit_license,view_license,entry_time,status		
 */						
class Mapbd_apikey extends AppsBDModel{	
	public $id;
	public $api_key;
	public $api_ip;
	public $title;
	public $add_product;
	public $edit_product;
	public $view_product;
	public $add_client;
	public $edit_client;
	public $view_client;
	public $add_license;
	public $edit_license;
	public $view_license;
	public $entry_time;
	public $status;


	    /**
	     *@property id,api_key,api_ip,add_product,edit_product,view_product,add_client,edit_client,view_client,add_license,edit_license,view_license,entry_time,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_apikey";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("api_key"));	
			$this->multiKey=array();
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";
		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[10]|integer"),
			"api_key"=>array("Text"=>"API Key", "Rule"=>"xss_clean|max_length[40]"),
			"api_ip"=>array("Text"=>"Api Ip", "Rule"=>"xss_clean|max_length[50]"),
			"title"=>array("Text"=>"Api Ip", "Rule"=>"xss_clean|max_length[255]"),
			"add_product"=>array("Text"=>"Add Product", "Rule"=>"xss_clean|max_length[1]"),
			"edit_product"=>array("Text"=>"Edit Product", "Rule"=>"xss_clean|max_length[1]"),
			"view_product"=>array("Text"=>"View Product", "Rule"=>"xss_clean|max_length[1]"),
			"add_client"=>array("Text"=>"Add Client", "Rule"=>"xss_clean|max_length[1]"),
			"edit_client"=>array("Text"=>"Edit Client", "Rule"=>"xss_clean|max_length[1]"),
			"view_client"=>array("Text"=>"View Client", "Rule"=>"xss_clean|max_length[1]"),
			"add_license"=>array("Text"=>"Add License", "Rule"=>"xss_clean|max_length[1]"),
			"edit_license"=>array("Text"=>"Edit License", "Rule"=>"xss_clean|max_length[1]"),
			"view_license"=>array("Text"=>"View License", "Rule"=>"xss_clean|max_length[1]"),
			"entry_time"=>array("Text"=>"Entry Time", "Rule"=>"xss_clean|max_length[20]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "add_product":
	      case "edit_product":
	      case "view_product":
	      case "add_client":
	      case "edit_client":
	      case "view_client":
	      case "add_license":
	      case "edit_license":
	      case "view_license":        
	         $returnObj=array("Y"=>"Yes","N"=>"No");
	         break;
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

 
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
        case "status":
	         $returnObj=array("A"=>"success","I"=>"danger");
	         break;
	      default:
	    }       
        return $returnObj;
	
	}
   
	   

 
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      case "status":
	         $returnObj=array("A"=>"fa fa-check-circle","I"=>"fa fa-times-circle");
	         break;
	      default:
	    }
        return $returnObj;
	
	}
 
	 public static function DeleteByID($id){
		    return parent::DeleteByKeyValue("id",$id);
     }
	    	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/


	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `api_key` char(40) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `api_ip` char(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `title` varchar(255) NOT NULL DEFAULT '',
					  `add_product` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `edit_product` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `view_product` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `add_client` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `edit_client` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `view_client` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `add_license` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `edit_license` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `view_license` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `entry_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'Y' COMMENT 'bool(A=Active,I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE,
					  UNIQUE KEY `api_key_ind` (`api_key`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	function generate_API_code(){
		$liccode=strtoupper(md5(rand(10,99).rand(10,99).time().rand(10,99)));
		$finallicense=substr($liccode,0,8)."-".substr($liccode,8,8)."-".substr($liccode,16,8)."-".substr($liccode,24,8);
		$this->api_key(strtoupper($finallicense));
	}
	
	function DropDBTable(){
		global $wpdb;
		$table=$wpdb->prefix.$this->tableName;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	}
	/* add custom function here*/
    function Save() {
	    if ( !$this->IsSetPrperty( 'api_key' ) ) {
		    $this->generate_API_code();
	    }
	    return parent::Save();
    }
	static function getActiveApiKeys(){
		$apiObject=new Mapbd_apikey();
		$apiObject->status('A');
		return $apiObject->SelectAllGridData('id,api_key,title');
    }
	/* end custom function */
	function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){

		if(!$mainobj){
			$mainobj=$this;
		}
		?>
        <style>
            .app-p-title label.col-form-label{
                width: 105px;
            }
        </style>
        <div class="form-row">
			<?php if(!in_array("title",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="title">
						<?php $this->_ee("API Title");?>
                    </label>
                    <input  class="form-control form-control-sm " type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("title");?>" id="api_key" <?php echo in_array("title", $disabled)?' disabled="disabled" ':' name="title" ';?>     placeholder="<?php $this->_ee("ex. For WooCommerce App");?>">
                </div>
			<?php } ?>
			
        </div>
        <div class="form-row">
	        <?php if(!in_array("api_key",$except)){ ?>
                <div class="form-group col-sm-6">
                    <label class="col-form-label" for="api_key">
                        <?php $this->_ee("API Key");
			            if(empty($mainobj->id) && empty($mainobj->api_key)) {
				            echo "( " . $this->__( "Auto Generate?" ) . " ";
				            APBD_GetHTMLSwitchButtonInline( "is_auto_generate", "is_auto_generate", "N", "Y", 'N', false, "has_depend_fld2" );
				            echo ")";
			            }
	                    ?>
                    </label>
                    <input  class="form-control form-control-sm  fld-is-auto-generate fld-is-auto-generate-n" type="text" maxlength="40"   value="<?php echo  $mainobj->GetPostValue("api_key");?>" id="api_key" <?php echo in_array("api_key", $disabled)?' disabled="disabled" ':' name="api_key" ';?>     placeholder="<?php $this->_ee("API Key");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","API Key");?>">
			        <span class="form-text text-muted"><?php $this->_ee("Enter any API Key");?></span>
                </div>
	        <?php } ?>
			<?php if(!in_array("api_ip",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="api_ip"><?php $this->_ee("API IP"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("api_ip");?>" id="api_ip" <?php echo in_array("api_ip", $disabled)?' disabled="disabled" ':' name="api_ip" ';?>     placeholder="<?php $this->_ee("API IP");?>" >
					 <span class="form-text text-muted app-tooltip" data-placement="bottom" title="Keep blank if you want to allow all IP, this ip won't be check on product license validation"><?php $this->_ee("Enter IP Address");?><span > <i class="fa fa-exclamation-circle"></i></span></span>
                </div>
			<?php } ?>
			
			
			<?php if(!in_array("status",$except)){ ?>
                <div class="form-group col-sm-2">
                    <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
					
					
					<?php /*<span class="form-text text-muted"><?php $this->_ee("status");?></span>	*/?>

                    <div class="input-group input-group-sm">
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
	                        ?>
                        </div>
                    </div>
                </div>
			<?php } ?>
        </div>
        <h6 class="mt-3" ><?php $this->_ee("API Permissions"); ?></h6>
        <div class="form-row">
			<?php if(!in_array("add_client",$except)){ ?>
                <div class="form-group col-sm">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("add_client");?></span>	*/?>
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="add_client" class="input-group-text col-form-label"><?php $this->_ee("Add Client"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                    <?php
		                    APBD_GetHTMLSwitchButton("add_client","add_client","N","Y",$mainobj->GetPostValue("add_client"));
	                    ?>
                        </div>

                    </div>

                </div>
			<?php } ?>
	        <?php if(!in_array("add_license",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="add_license" class="input-group-text col-form-label"><?php $this->_ee("Add License"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("add_license","add_license","N","Y",$mainobj->GetPostValue("add_license"));
	                        ?>
                        </div>

                    </div>
			        <?php /*<span class="form-text text-muted"><?php $this->_ee("add_license");?></span>	*/?>
                </div>
	        <?php } ?>
	        <?php if(!in_array("add_product",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="add_product" class="input-group-text col-form-label"><?php $this->_ee("Add Product"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("add_product","add_product","N","Y",$mainobj->GetPostValue("add_product"));
	                        ?>
                        </div>
                    </div>
	                <?php /*<span class="form-text text-muted"><?php $this->_ee("add_product");?></span>	*/?>
                </div>
	        <?php } ?>

        </div>
        
        <div class="form-row">
			<?php if(!in_array("edit_client",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="edit_client" class="input-group-text col-form-label"><?php $this->_ee("Edit Client"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("edit_client","edit_client","N","Y",$mainobj->GetPostValue("edit_client"));
	                        ?>
                        </div>
                    </div>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("edit_client");?></span>	*/?>
                </div>
			<?php } ?>

			<?php if(!in_array("edit_license",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="edit_license" class="input-group-text col-form-label"><?php $this->_ee("Edit License"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("edit_license","edit_license","N","Y",$mainobj->GetPostValue("edit_license"));
	                        ?>
                        </div>
                    </div>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("edit_license");?></span>	*/?>
                </div>
			<?php } ?>
	
	        <?php if(!in_array("edit_product",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="edit_product" class="input-group-text col-form-label"><?php $this->_ee("Edit Product"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("edit_product","edit_product","N","Y",$mainobj->GetPostValue("edit_product"));
	                        ?>
                        </div>
                    </div>
			        <?php /*<span class="form-text text-muted"><?php $this->_ee("edit_product");?></span>	*/?>
                </div>
	        <?php } ?>
         
         
        </div>
       
        <div class="form-row">
			<?php if(!in_array("view_client",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="view_client" class="input-group-text col-form-label"><?php $this->_ee("View Client"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("view_client","view_client","N","Y",$mainobj->GetPostValue("view_client"));
	                        ?>
                        </div>
                    </div>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("view_client");?></span>	*/?>
                </div>
			<?php } ?>

			<?php if(!in_array("view_license",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="view_license" class="input-group-text col-form-label"><?php $this->_ee("View License"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("view_license","view_license","N","Y",$mainobj->GetPostValue("view_license"));
	                        ?>
                        </div>
                    </div>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("view_license");?></span>	*/?>
                </div>
			<?php } ?>
	        <?php if(!in_array("view_product",$except)){ ?>
                <div class="form-group col-sm">
                    <div class="input-group input-group-sm">
                        <div class="input-group-prepend app-p-title">
                            <label for="view_product" class="input-group-text col-form-label"><?php $this->_ee("View Product"); ?></label>
                        </div>
                        <div class="form-control form-control-sm col col-sm">
	                        <?php
		                        APBD_GetHTMLSwitchButton("view_product","view_product","N","Y",$mainobj->GetPostValue("view_product"));
	                        ?>
                        </div>
                    </div>
                    <?php /*<span class="form-text text-muted"><?php $this->_ee("view_product");?></span>	*/?>
                </div>
	        <?php } ?>
        </div>
       
		<?php
	}


}
?>