<?php
/**
 * @since: 08/Mar/2019
 * @author: Sarwar Hasan
 * @version 1.0.0
 * @property:entry_time,id,purchase_key,server_ip,status,used_domain,version
 */
class Mapbd_domain_log extends AppsBDModel{
	public $entry_time;
	public $id;
	public $purchase_key;
	public $server_ip;
	public $status;
	public $used_domain;
	public $version;
	public $client_email;


	/**
	 *@property entry_time,id,purchase_key,server_ip,status,used_domain,version
	 */
	function __construct() {
		parent::__construct ();
		$this->SetValidation();
		$this->tableName="apbd_domain_log";
		$this->primaryKey="id";
		$this->uniqueKey=array(array("purchase_key","used_domain"));
		$this->multiKey=array();
		$this->autoIncField=array("id");
		$this->app_base_name="APBLIC";

	}


	function SetValidation(){
		$this->validations=array(
			"entry_time"=>array("Text"=>"Entry Time", "Rule"=>"xss_clean|max_length[20]"),
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[10]|integer"),
			"purchase_key"=>array("Text"=>"Purchase Key", "Rule"=>"xss_clean|required|max_length[50]"),
			"server_ip"=>array("Text"=>"Server Ip", "Rule"=>"xss_clean|max_length[64]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
			"used_domain"=>array("Text"=>"Used Domain", "Rule"=>"xss_clean|required|max_length[200]"),
			"version"=>array("Text"=>"Version", "Rule"=>"xss_clean|max_length[15]"),
			"client_email"=>array("Text"=>"Version", "Rule"=>"xss_clean|max_length[100]")

		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
		$returnObj=array();
		switch ($property) {
			case "status":
				$returnObj=array("A"=>"Activated","R"=>"Refunded","W"=>"Free","D"=>'Deactivated');
				break;
			default:
		}
		if($isWithSelect){
			return array_merge(array(""=>"Select"),$returnObj);
		}
		return $returnObj;

	}

	public function GetPropertyOptionsColor($property){
		$returnObj=array();
		switch ($property) {
			case "status":
				$returnObj=array("A"=>"success apbd-nowrap","R"=>"danger apbd-nowrap","W"=>"success apbd-nowrap","D"=>"danger apbd-nowrap");
				break;
			default:
		}
		return $returnObj;

	}

	public function GetPropertyOptionsIcon($property){
		$returnObj=array();
		switch ($property) {
			case "status":
				$returnObj=array("A"=>"fa fa-check-circle-o","R"=>"fa fa-times-circle-o","W"=>"fa fa-circle-o","D"=>'fa fa-times-circle-o');
				break;
			default:
		}
		return $returnObj;

	}

	//auto generated
	/*function Save(){
		return parent::Save();
	}*/
    static function Add($purchase_key,$domain,$server_id,$version,$status,$email=""){
        /**
         * Its for check is there any change before process
         *
         * @since 2.3
         */
        $domain=apply_filters('elite-licenser/filter/domain-log',$domain);
        $obj=new self();
        $obj->purchase_key($purchase_key);
        $obj->server_ip($server_id);
        $obj->used_domain($domain);
        $obj->status($status);
	    $obj->version($version);
	    if(!empty($email)){
		    $obj->client_email($email);
        }
	    APBD_AddFileLog(print_r($obj->getPropertiesArray(),true));
	    return $obj->Save();

    }
	
	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `purchase_key` char(50) NOT NULL,
					  `used_domain` char(200) NOT NULL,
					  `server_ip` char(64) NOT NULL DEFAULT '',
					  `status` char(1) NOT NULL DEFAULT 'I' COMMENT 'drop(A=Activated, R=Removed)',
					  `version` char(15) NOT NULL DEFAULT '',
					  `entry_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `client_email` char(100) NOT NULL DEFAULT '',
					  PRIMARY KEY (`id`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	function DropDBTable(){
		global $wpdb;
		$table=$wpdb->prefix.$this->tableName;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	}
	/* add custom function here*/

	/* end custom function */
	function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){

		if(!$mainobj){
			$mainobj=$this;
		}
		?>
        <div class="form-row">
			<?php if(!in_array("entry_time",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="entry_time"><?php $this->_ee("Entry Time"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("entry_time");?>" id="entry_time" <?php echo in_array("entry_time", $disabled)?' disabled="disabled" ':' name="entry_time" ';?>     placeholder="<?php $this->_ee("Entry Time");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Entry Time");?>">
					
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php /*if(!in_array("id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="id"><?php $this->_ee("Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("id");?>" id="id" <?php echo in_array("id", $disabled)?' disabled="disabled" ':' name="id" ';?>     placeholder="<?php $this->_ee("Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Id");?>">

		      </div>
		     <?php } */?>

			<?php if(!in_array("purchase_key",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="purchase_key"><?php $this->_ee("Purchase Key"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("purchase_key");?>" id="purchase_key" <?php echo in_array("purchase_key", $disabled)?' disabled="disabled" ':' name="purchase_key" ';?>     placeholder="<?php $this->_ee("Purchase Key");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Purchase Key");?>">
					
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if(!in_array("server_ip",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="server_ip"><?php $this->_ee("Server Ip"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="15"   value="<?php echo  $mainobj->GetPostValue("server_ip");?>" id="server_ip" <?php echo in_array("server_ip", $disabled)?' disabled="disabled" ':' name="server_ip" ';?>     placeholder="<?php $this->_ee("Server Ip");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Server Ip");?>">
					
                </div>
			<?php } ?>

			<?php if(!in_array("status",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
                    <select   class="custom-select form-control-sm" id="status" <?php echo in_array("status", $disabled)?' disabled="disabled" ':' name="status" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_ee("%s is required","Status");?>">
                        <option value=""><?php $this->_e("Select"); ?></option>
						<?php $status_selected= $mainobj->GetPostValue("status","I");
						APBD_GetHTMLOptionByArray($mainobj->GetPropertyOptions("status"),$status_selected);
						?>

                    </select>
					
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if(!in_array("used_domain",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="used_domain"><?php $this->_ee("Used Domain"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="200"   value="<?php echo  $mainobj->GetPostValue("used_domain");?>" id="used_domain" <?php echo in_array("used_domain", $disabled)?' disabled="disabled" ':' name="used_domain" ';?>     placeholder="<?php $this->_ee("Used Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Used Domain");?>">
					
                </div>
			<?php } ?>

			<?php if(!in_array("version",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="version"><?php $this->_ee("Version"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="6"   value="<?php echo  $mainobj->GetPostValue("version");?>" id="version" <?php echo in_array("version", $disabled)?' disabled="disabled" ':' name="version" ';?>     placeholder="<?php $this->_ee("Version");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Version");?>">
					
                </div>
			<?php } ?>

        </div>
		<?php
	}


}
?>