<?php 			
/** 
 * @since: 30/Mar/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:k_word,grp,title,status,subject,props,content		
 */						
class Mapbd_email_templates extends AppsBDModel{	
	public $k_word;
	public $grp;
	public $title;
	public $status;
	public $subject;
	public $props;
	public $content;


	    /**
	     *@property k_word,grp,title,status,subject,props,content
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_email_templates";
			$this->primaryKey="k_word";
			$this->uniqueKey=array(array("k_word"));	
			$this->multiKey=array();
			$this->autoIncField=array();	
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"k_word"=>array("Text"=>"K Word", "Rule"=>"max_length[3]"),
			"grp"=>array("Text"=>"Grp", "Rule"=>"xss_clean|required|max_length[20]"),
			"title"=>array("Text"=>"Title", "Rule"=>"xss_clean|required|max_length[100]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
			"subject"=>array("Text"=>"Subject", "Rule"=>"xss_clean|required|max_length[150]"),
			"props"=>array("Text"=>"Props", "Rule"=>"xss_clean|max_length[255]"),
			"content"=>array("Text"=>"Content", "Rule"=>"html_clean||required")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

    /*
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }       
        return $returnObj;
	
	}
    */
	   

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	   		

	 
	//auto generated
    function Save(){
	    if(!$this->IsSetPrperty("k_word")){
	        $k_word=$this->GetNewIncId("k_word","AAA");
	        $this->k_word($k_word);
	    }
	    return parent::Save();
	}	          
	

	/*  
	//Delete override
	public static function DeleteByKeyValue($key,$value,$noLimit=false){
	   return parent::DeleteByKeyValue($key,$value,$noLimit);
	}
	//*/
	 static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;			
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `k_word` char(3) NOT NULL DEFAULT '',
					  `grp` char(20) NOT NULL DEFAULT '',
					  `title` char(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
					  `status` char(1) NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active,I=Inactive)',
					  `subject` char(150) CHARACTER SET utf8 NOT NULL DEFAULT '',
					  `props` char(255) NOT NULL DEFAULT '',
					  `content` text CHARACTER SET utf8 NOT NULL,
					  PRIMARY KEY (`k_word`) USING BTREE,
					  UNIQUE KEY `email_keyword` (`k_word`) USING BTREE
					) ";				 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	 }
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	/**
	 * @param $keyword
	 * @param string $props
	 *
	 * @return array
	 */
	public static function getEmailParamList($keyword,$props=NULL) {
	 
		$return_obj              = array();
		$return_obj["site_name"] = get_bloginfo('name');;
		$return_obj["site_url"]  = get_bloginfo('url');
		
		if($props==NULL){
		    $obj=self::FindBy("k_word",$keyword);
		    $props=!empty($obj->props)?$obj->props:"";
        }
		if(!empty($props)){
		    $params=explode(",",$props);
			foreach ( $params as $param ) {
                $paramar=explode("=",$param);
                if(!empty($paramar[0]) && !empty($paramar[1])){
	                $return_obj[trim($paramar[0])]=trim($paramar[1]);
                }
		    }
        }
		
		
		return $return_obj;
	}
	public static function getEmailParamListClearData($kayword){
		$return_obj=self::getEmailParamList($kayword);
		$return_obj=array_map(function($value){
			$value="";
		}, $return_obj);
		$return_obj["site_name"] = get_bloginfo('name');;
		$return_obj["site_url"]  = get_bloginfo('url');
		return $return_obj;
	}
	public static function AddNewTemplate($k_word,$grp, $title,$status,$subject,$props,$content){
		$obj=new self();
		if(!$obj->IsExists("k_word",$k_word)){
			$newobj=new self();
			$newobj->k_word($k_word);
			$newobj->grp($grp);
			$newobj->title($title);
			$newobj->status($status);
			$newobj->subject($subject);
			$newobj->content($content);
			$newobj->props($props);
			return $newobj->Save();
		}else{
			return false;
		}
	}
	static  function SendEmailTemplates($keyword,$toEmail,$params=array(),$subject=""){
		if(empty($toEmail)){
		    return true;
        }
		$obj=self::FindBy("k_word", $keyword);
		if(!empty($obj)){
			if($obj->status!="A"){
				return true;
			}
		}
		if(!isset($params["site_name"])) {
			$params["site_name"] = get_bloginfo( 'name' );
		}
		if(!isset($params["site_url"])) {
			$params["site_url"] = get_bloginfo( 'url' );
		}
		$search=array();
		$replace=array();
		foreach ($params as $key=>$value){
			if(is_string($value)) {
				$search[]  = "{{" . $key . "}}";
				$replace[] = $value;
			}
		}
		$content=str_replace($search, $replace, $obj->content);
		
		if(empty($subject)){
			$subject=$obj->subject;
		}
		$subject=str_replace($search, $replace, $subject);
		$headers = array('Content-Type: text/html; charset=UTF-8');
		return wp_mail( $toEmail, $subject, $content,$headers);
	}
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
		        $paramlist=self::getEmailParamList($mainobj->k_word,$mainobj->props);
					?>
	
            <div class="form-row">
		        <?php if(!in_array("subject",$except)){ ?>
                    <div class="form-group col-sm-8">
                        <label class="col-form-label" for="subject"><?php $this->_ee("Subject"); ?></label>
                        <input  class="form-control form-control-sm" type="text" maxlength="150"   value="<?php echo  $mainobj->GetPostValue("subject");?>" id="subject" <?php echo in_array("subject", $disabled)?' disabled="disabled" ':' name="subject" ';?>     placeholder="<?php $this->_ee("Subject");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Subject");?>">
				        <?php /*<span class="form-text text-muted"><?php $this->_ee("subject");?></span>	*/?>
                    </div>
		        <?php } ?>
		        <?php if(!in_array("status",$except)){ ?>
                    <div class="form-group col-sm-4">
                        <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
				
				        <?php
					        APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
				        ?>
				        <?php /*<span class="form-text text-muted"><?php $this->_ee("status");?></span>	*/?>


                    </div>
		        <?php } ?>


            </div>
            <div class="form-row">
		        <?php if(!in_array("content",$except)){ ?>
                    <div class="form-group col-sm-8">
                        <label class="col-form-label" for="content"><?php $this->_ee("Content"); ?></label>
                        <textarea  class="form-control form-control-sm apd-wp-editor ht-300"  type="text" id="content" <?php echo in_array("content", $disabled)?' disabled="disabled" ':' name="content" ';?>     placeholder="<?php $this->_ee("Content");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Content");?>"><?php echo  $mainobj->GetPostValue("content");?></textarea>
				        <?php /*<span class="form-text text-muted"><?php $this->_ee("content");?></span>	*/?>
                    </div>
		        <?php } ?>
                <div class="col-sm">
                    <div class="card border-success mt-69">
                        <div class="card-header  bg-success text-white border-success">
				            <?php $this->_e("Properties"); ?>
                        </div>
                        <div class="card-body p-0">
                            <table class="table table-striped m-0 table-sm">
                                <thead>
                                <tr class="">
                                    <th width="20px;"></th>
                                    <th width="120px;"><?php $this->_e("Property") ; ?></th>
                                    <th><?php $this->_e("Description") ; ?></th>
                                </tr>
                                </thead>
                                <tbody>
		                        <?php foreach ($paramlist as $key=>$des){?>
                                    <tr>
                                        <th ><i title="Click to insert {{<?php echo $key;?>}} to edittor"  class="afs-16 apbd-editor-insert-btn ap ap-insert app-ins-btn text-green text-bold" data-tooltip-position="left" data-tooltip-delay="2000" data-text="{{<?php echo $key;?>}}"></i>  </th>
                                        <th>{{<?php echo $key;?>}} </th>
                                        <td><?php $this->_e($des);?></td>
                                    </tr>
		                        <?php }?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
       
			
			<?php 
	}


}
?>