<?php
	/**
	 * @since: 26/Feb/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 * @property:id,client_id,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status
	 */
	class Mapbd_license extends AppsBDModel{
		public $id;
		public $client_id;
		public $product_id;
		public $product_base_name;
		public $license_id;
		public $purchase_key;
		public $user_domain;
		public $server_ip;
		public $current_version;
		public $license_title;
		public $max_domain;
		public $is_unlimited;
		public $verification_required;
		public $has_expiry;
		public $expiry_time;
		public $has_support;
		public $support_end_time;
		public $entry_time;
		public $active_time;
		public $request_counter;
		public $request_delay_time;
		public $status;
		public $market;
		public $extra_param;
		public $extra_param2;
		public $lictype_param;
		public $other_param;
		private static $reg_markets=[];
		private static $gen_id=1;
		
		/**
		 *@property id,client_id,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();
			$this->tableName="apbd_license";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("purchase_key"));
			$this->multiKey=array(array("user_domain"),array("server_ip"),array("product_base_name"));
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";
		}

		function SetValidation(){
			$this->validations=array(
				"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[9]|integer"),
				"client_id"=>array("Text"=>"Client Id", "Rule"=>"xss_clean|max_length[11]|integer"),
				"product_id"=>array("Text"=>"Product Id", "Rule"=>"xss_clean|max_length[11]|integer"),
				"product_base_name"=>array("Text"=>"Product Base Name", "Rule"=>"xss_clean|max_length[50]"),
				"license_id"=>array("Text"=>"License Id", "Rule"=>"xss_clean|required|max_length[3]|integer"),
				"purchase_key"=>array("Text"=>"License Key", "Rule"=>"xss_clean|max_length[50]"),
				"user_domain"=>array("Text"=>"User Domain", "Rule"=>"xss_clean|max_length[200]"),
				"server_ip"=>array("Text"=>"Server Ip", "Rule"=>"xss_clean|max_length[50]"),
				"current_version"=>array("Text"=>"Current Version", "Rule"=>"xss_clean|max_length[20]"),
				"license_title"=>array("Text"=>"License Title", "Rule"=>"xss_clean|max_length[100]"),
				"max_domain"=>array("Text"=>"Max Domain", "Rule"=>"xss_clean|max_length[11]|integer"),
				"is_unlimited"=>array("Text"=>"Max Domain", "Rule"=>"xss_clean|max_length[1]"),
                "verification_required"=>array("Text"=>"Verification Required", "Rule"=>"xss_clean|max_length[11]|integer"),
				"has_expiry"=>array("Text"=>"Has Expiry", "Rule"=>"xss_clean|required|max_length[1]"),
				"expiry_time"=>array("Text"=>"Expiry Time", "Rule"=>"xss_clean|max_length[20]"),
				"has_support"=>array("Text"=>"Has Support", "Rule"=>"xss_clean|required|max_length[1]"),
				"support_end_time"=>array("Text"=>"Support End Time", "Rule"=>"xss_clean|max_length[20]"),
				"entry_time"=>array("Text"=>"Entry Time", "Rule"=>"xss_clean|max_length[20]"),
				"active_time"=>array("Text"=>"Entry Time", "Rule"=>"xss_clean|max_length[20]"),
				"request_counter"=>array("Text"=>"Request Counter", "Rule"=>"xss_clean|max_length[2]|integer"),
				"request_delay_time"=>array("Text"=>"Request Delay Time", "Rule"=>"xss_clean|max_length[13]"),
				"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
				"market"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
				"extra_param"=>array("Text"=>"Extra Param", "Rule"=>"xss_clean|max_length[100]"),
				"extra_param2"=>array("Text"=>"Extra Param", "Rule"=>"xss_clean|max_length[150]"),
				"lictype_param"=>array("Text"=>"Lic Type Param", "Rule"=>"xss_clean|max_length[20]"),
				"other_param"=>array("Text"=>"Other Param", "Rule"=>"xss_clean|max_length[20]")
			
			);
		}
		
		/**
		 * @return array
		 */
		public static function getRegMarkets() {
			return self::$reg_markets;
		}
		
		/**
		 * @param array $register_markets
		 */
		public static function RegisterMarkets( $key,$value ) {
			self::$reg_markets[$key] =$value;
		}
		
		/**
		 * @param self $licenseObject
		 */
		public static function RemoveALlDomainByLicenseObject($licenseObject){
		    if($licenseObject instanceof self && !empty($licenseObject->purchase_key)){
		        $product=Mapbd_product::FindBy("id",$licenseObject->product_id);
		        if(!empty($licenseObject->purchase_key) && !empty($product)){
		            if($licenseObject->max_domain>1){
		                //multi
                        $UsedDomains=Mapbd_useddomain::FindAllBy("product_id",$product->id,['purchase_key'=>$licenseObject->purchase_key]);
			            foreach ( $UsedDomains as $used_domain ) {
                            self::RemoveLicenseFromDomain($product->id,$product->enc_key,$used_domain->full_domain);
                        }
                    }else{
		                //single
			            self::RemoveLicenseFromDomain($product->id,$product->enc_key,$licenseObject->user_domain);
                    }
                }
            }
        }
		/**
		 * @param self $licenseObject
		 */
		public static function RemoveALlPluginByLicenseObject($licenseObject,$is_remove_from_db=false){
			if($licenseObject instanceof self && !empty($licenseObject->purchase_key)){
				$product=Mapbd_product::FindBy("id",$licenseObject->product_id);
				if(!empty($licenseObject->purchase_key) && !empty($product)){
					if($licenseObject->max_domain>1){
						//multi
						$UsedDomains=Mapbd_useddomain::FindAllBy("product_id",$product->id,['purchase_key'=>$licenseObject->purchase_key]);
						foreach ( $UsedDomains as $used_domain ) {
							self::RemovePluginFromDomain($product->id,$product->enc_key,$used_domain->full_domain);
							if($is_remove_from_db){
								Mapbd_useddomain::DeleteByID($used_domain->id);
                            }
						}
					}else{
						//single
						self::RemovePluginFromDomain($product->id,$product->enc_key,$licenseObject->user_domain);
					}
				}
			}
		}
        public static function RemoveLicenseBy($license_id,$used_domain_id=''){
		    $license_object=self::FindBy("id",$license_id);
		    if(!empty($license_object)) {
		        $product=Mapbd_product::FindBy("id",$license_object->product_id);
		        if(!empty($product)) {
			        if ( $license_object->max_domain <= 1 ) {
			            return self::RemoveLicenseFromDomain($product->id,$product->enc_key,$license_object->user_domain);
			        }else{
			            if(!empty($used_domain_id)) {
				            $used_domain = Mapbd_useddomain::FindBy( "id", $used_domain_id );
				            if(!empty($used_domain)){
					            return self::RemoveLicenseFromDomain($product->id,$product->enc_key,$used_domain->full_domain);
                            }
			            }
                    }
		        }
		    }
		    return false;
        }
		public static function RemovePluginBy($license_id,$used_domain_id='',$is_removed=false){
			$license_object=self::FindBy("id",$license_id);
			if(!empty($license_object)) {
				$product=Mapbd_product::FindBy("id",$license_object->product_id);
				if(!empty($product)) {
					if ( $license_object->max_domain <= 1 ) {
						return self::RemovePluginFromDomain($product->id,$product->enc_key,$license_object->user_domain);
					}else{
						if(!empty($used_domain_id)) {
							$used_domain = Mapbd_useddomain::FindBy( "id", $used_domain_id );
							if(!empty($used_domain)){
								if(self::RemovePluginFromDomain($product->id,$product->enc_key,$used_domain->full_domain)){
								    if($is_removed){
								        Mapbd_useddomain::DeleteByID($used_domain->id);
                                    }
								    return true;
                                }
							}
						}
					}
				}
			}
			return false;
		}
		public static function RequestRemoteAction($user_domain,$product_enc_key,$hash,$type='rl'){
			$requst_url     = $user_domain . "?action=" . $hash . "&type=".$type;
			$serverResponse = wp_remote_get( $requst_url, array(
					'timeout'     => 120,
					'redirection' => 5,
					'httpversion' => '1.0',
					'sslverify' => false,
					'blocking'    => true,
					'headers'     => array(),
					'body'        => '',
					'cookies'     => array()
				)
			);
			if ( ! is_wp_error( $serverResponse ) ) {
				$rmObj = APBDEncryptionLib::getInstance( $product_enc_key )->decryptObj( $serverResponse['body'] );
				if ( ! empty( $rmObj->status ) ) {
					return true;
				}
			}
			return false;
        }
		public static function RemoveLicenseFromDomain($product_id , $product_enc_key , $user_domain) {
			$hash_md5 = md5( $product_id . $product_enc_key . $user_domain ) . "_handle";
			if ( self::RequestRemoteAction( $user_domain, $product_enc_key, $hash_md5, 'rl' ) ) {
				return true;
			} else {
				$hash = hash( "crc32b", $product_id . $product_enc_key . $user_domain ) . "_handle";
				return self::RequestRemoteAction( $user_domain, $product_enc_key, $hash, 'rl' );
			}
		}
		public static function RemovePluginFromDomain($product_id , $product_enc_key , $user_domain){
			$hash_md5 = md5( $product_id . $product_enc_key . $user_domain ) . "_handle";
			if ( self::RequestRemoteAction( $user_domain, $product_enc_key, $hash_md5, 'dl' ) ) {
				return true;
			} else {
				$hash = hash( "crc32b", $product_id . $product_enc_key . $user_domain ) . "_handle";
				return self::RequestRemoteAction( $user_domain, $product_enc_key, $hash, 'dl' );
			}
		}
		public static function ResetLicenseFromDomain($product_id , $product_enc_key , $user_domain){
			$hash_md5 = md5( $product_id . $product_enc_key . $user_domain ) . "_handle";
			if ( self::RequestRemoteAction( $user_domain, $product_enc_key, $hash_md5, 'rc' ) ) {
				return true;
			} else {
				$hash = hash( "crc32b", $product_id . $product_enc_key . $user_domain ) . "_handle";
				return self::RequestRemoteAction( $user_domain, $product_enc_key, $hash, 'rc' );
			}
		}
		public function GetPropertyRawOptions($property,$isWithSelect=false){
			$returnObj=array();
			switch ($property) {
				case "has_expiry":
				case "has_support":
					$returnObj=array("Y"=>"Yes","N"=>"No");
					break;
				case "market":
					$returnObj=array("E"=>"Envato","J"=>"JVZoo","F"=>"FastSpring","P"=>"Paddle","W"=>"WooCommerce","O"=>"Others");
					$returnObj=array_merge($returnObj,self::$reg_markets);
					break;
				case "status":
					$returnObj=array("A"=>"Active","R"=>"Refunded","I"=>"Inactive","W"=>"Free");
					break;
				default:
			}
			if($isWithSelect){
				return array_merge(array(""=>"Select"),$returnObj);
			}
			return $returnObj;
			
		}
		
		public function GetPropertyOptionsColor($property){
			$returnObj=array();
			switch ($property) {
				case "status":
					$returnObj=array("A"=>"success","R"=>"danger","I"=>"danger","W"=>"success");
					break;
				default:
			}
			return $returnObj;
			
		}
		
		public function GetPropertyOptionsIcon($property){
			$returnObj=array();
			switch ($property) {
				case "status":
					$returnObj=array("A"=>"fa fa-check-circle-o","R"=>"fa fa-times-circle-o","I"=>"fa fa-times-circle-o","W"=>"fa fa-circle-o");
					break;
				default:
			}
			return $returnObj;
			
		}
		
		function generate_license_code(){
			$product=Mapbd_product::FindBy("id",$this->product_id);
			$liccode=strtoupper(md5(self::$gen_id.$this->license_id.$this->license_title.time().rand(10,99)));
			self::$gen_id++;
			$finallicense=$product->lic_prefix.substr($liccode,0,8)."-".substr($liccode,8,8)."-".substr($liccode,16,8)."-".substr($liccode,24,8);
			$this->purchase_key(strtoupper($finallicense));
		}
		function setExtraPropertyForSaveUpdate($isForNew=true){
		    $isOk=true;
			if($this->IsSetPrperty('product_id') && !$this->IsSetPrperty('product_base_name')){
				$product=Mapbd_product::FindBy("id",$this->product_id);
				if(empty($product) || $product->status !='A'){
					$this->AddError("Product has not been exists");
					$isOk=false;
				}else{
					$this->product_base_name($product->product_base);
				}

			}
			if($this->IsSetPrperty('license_id') && !$this->IsSetPrperty('license_title')){
				$licenseObj=Mapbd_license_type::FindBy("id",$this->license_id);
				if(empty($licenseObj) || $licenseObj->status !='A'){
					$this->AddError("License info has not been exists");
					$isOk=false;
				}else{
					$this->license_title($licenseObj->license_title);
					$this->max_domain($licenseObj->max_domain);
				}
			}

            if ($this->IsSetPrperty( 'has_expiry' ) ) {
                if ( $isForNew ) {
                    if ( $this->has_expiry == "Y" && ! $this->IsSetPrperty( 'expiry_time' ) ) {
                        $this->AddError( "%s is required", "Expiry Date" );
                        $isOk = false;
                    }
                }
	            if ( !$this->IsSetPrperty( 'expiry_time' ) && !empty($this->expiry_time)) {
		            $this->expiry_time(date('Y-m-d 23:59:59',strtotime($this->expiry_time)));
	            }
            }

			if ( $this->IsSetPrperty( 'has_support' ) ) {
				if ( $isForNew ) {
					if ( $this->has_support == "Y" && !$this->IsSetPrperty( 'support_end_time' ) ) {
						$this->AddError( "%s is required", "Support end date" );
						$isOk = false;
					}
				}
				if ( !$this->IsSetPrperty( 'support_end_time' ) && !empty($this->support_end_time) ) {
					$this->support_end_time(date('Y-m-d 23:59:59',strtotime($this->support_end_time)));
				}
			}

			return $isOk;

        }
        public static function update_status_by($prop,$value,$status,$allow_multiple=true) {
	        $obj=new self();
	        $obj->status($status);
	       // $obj->Update($)
        }
		//auto generated
        function Update( $notLimit = false, $isShowMsg = true, $dontProcessIdWhereNotset = true ) {
	        if(!$this->setExtraPropertyForSaveUpdate(false)){
		        return false;
	        }
	        
	        return parent::Update( $notLimit, $isShowMsg, $dontProcessIdWhereNotset );
        }
		static function DeleteByID(  $id) {
			return parent::DeleteByKeyValue( "id", $id );
		}
        static function GetExpireTimeSpan($time){
	        $dateString=APBD_getWPDateTimeWithFormat($time);
	        $timeTick=strtotime($time);
	        $class=" text-bold ";
	       
	        if($timeTick>time()){
		        $class.=" text-danger ";
            }
	       return sprintf('<span class="%s">%s</span>',$class,$dateString);
        }
		static function GetExpireDateSpan($time){
			$dateString=APBD_getWPDateWithFormat($time);
			$timeTick=strtotime($time);
			$class=" text-bold ";
			
			if($timeTick<time()){
				$class.=" text-danger ";
			}
			return sprintf('<span class="%s">%s</span>',$class,$dateString);
		}
		function SaveWithoutHook(){
			if ( !$this->IsSetPrperty( 'purchase_key' ) ) {
				$this->generate_license_code();
			}
			if(!$this->setExtraPropertyForSaveUpdate()){
			    return false;
            }
			return parent::Save();
		}
		function Save(){
		    $isSaved=$this->SaveWithoutHook();
		    if($isSaved){
			    $licHook=new stdClass();
			    $licHook->license=$this;
			    $licHook->client=new Mapbd_client();;
			    $licHook->product=new Mapbd_product();
			    if(!empty($this->client_id)){
				    $licHook->client=Mapbd_client::FindBy("id",$this->client_id);
			    }
			    if(!empty($this->product_id)){
				    $licHook->product=Mapbd_product::FindBy("id",$this->product_id);
			    }
			    
			    do_action(APBDLic::GetInstance()->getHookActionStr("new_license"),$licHook);
			    return true;
            }else{
		        return false;
            }
        }

        static function getLicenseStats() {
	        $thisObj                   = new Mapbd_license();
	        $table                     = $thisObj->db->prefix . $thisObj->tableName;
	        $result                    = $thisObj->db->get_results( "select `status` , count(*)as total,max(entry_time) as last_entry_time from $table GROUP BY `status`" );
	        $response                  = new stdClass();
	        $response->active          = 0;
	        $response->free            = 0;
	        $response->inactive        = 0;
	        $response->refunded        = 0;
	        $response->others          = 0;
	        $response->last_entry_time = 0;
	        if ( ! empty( $result ) ) {
		        foreach ( $result as $item ) {
			        $item->status = strtoupper( $item->status );
			        $etime=strtotime($item->last_entry_time);
			        if($etime>$response->last_entry_time){
			            $response->last_entry_time=$etime;
                    }
			        if ( $item->status == "A" ) {
				        $response->active += $item->total;
			        }elseif ( $item->status == "W" ) {
				        $response->free += $item->total;
			        }elseif ( $item->status == "I" ) {
				        $response->inactive += $item->total;
			        }elseif ( $item->status == "R" ) {
				        $response->refunded += $item->total;
			        }else {
				        $response->others += $item->total;
			        }
		        }
		        if($response->last_entry_time>0){
			        $response->last_entry_time=date('Y-m-d H:i:s', $response->last_entry_time);
                }
		        
	        }
	        //Product wise
	        $product_result = $thisObj->db->get_results( "select product_id,product_base_name, count(*)as total,max(entry_time) as last_entry_time from $table GROUP BY  product_id ORDER BY total DESC LIMIT 5" );
	        $productList=Mapbd_product::FetchAllKeyValue("id","product_name");
	        $response->products=$product_result;
	        if(!empty($response->products)){
		        foreach ( $response->products as &$product ) {
                    $product->name=isset($productList[$product->product_id])?$productList[$product->product_id]:"";
	            }
            }else{
		        $response->products=[];
            }
	        return $response;
        }



		static function CreateDBTable(){
			$thisObj=new static();
			$table=$thisObj->db->prefix.$thisObj->tableName;
			if($thisObj->db->get_var("show tables like '{$table}'") != $table){
				$sql = "CREATE TABLE `{$table}` (
					  `id` int(9) NOT NULL AUTO_INCREMENT,
					  `client_id` int(11) unsigned NOT NULL DEFAULT '0',
					  `product_id` int(11) NOT NULL DEFAULT '0',
					  `product_base_name` char(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'FK(wp_apbd_product,product_base,product_name)',
					  `license_id` int(3) NOT NULL COMMENT 'FK({$table}_type,id,license_title)',
					  `purchase_key` char(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `user_domain` char(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `server_ip` char(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `current_version` char(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'Using Version ',
					  `license_title` char(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `max_domain` int(11) NOT NULL,
					  `is_unlimited` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes,N=No)',
					  `verification_required` int(11) NOT NULL COMMENT 'manual verification required when the limit is over',
					  `has_expiry` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'bool(Y=Yes,N=No)',
					  `expiry_time` timestamp NULL DEFAULT NULL COMMENT 'if has expiry is yes then all license will be set expiry with this date',
					  `has_support` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'bool(Y=Yes,N=No)',
					  `support_end_time` timestamp NULL DEFAULT NULL COMMENT 'if has expiry is yes then all license will be set expiry with this date',
					  `entry_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `active_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `request_counter` int(2) unsigned NOT NULL DEFAULT '0',
					  `request_delay_time` char(13) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'A' COMMENT 'drop(A =Active, R =Refunded,I=Inactive,W=Waiting For Domain)',
					  `market` char(1) NOT NULL DEFAULT '' COMMENT 'drop(E=Envato, J=JvZoo, S=Self)',
					  `extra_param` char(100) NOT NULL DEFAULT '',
					  `extra_param2` char(150) NOT NULL DEFAULT '',
					  `lictype_param` char(20) NOT NULL DEFAULT '',
					  `other_param` char(20) NOT NULL DEFAULT '',
					  PRIMARY KEY (`id`) USING BTREE,
					  UNIQUE KEY `purchase_key` (`purchase_key`) USING BTREE,
					  KEY `user_domain` (`user_domain`) USING BTREE,
					  KEY `server_ip` (`server_ip`) USING BTREE,
					  KEY `product_base_name` (`product_base_name`) USING BTREE,
					  KEY `product_id` (`product_id`,`purchase_key`) USING BTREE
					) ";
				require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
				dbDelta($sql);
			}
		}

		function DropDBTable(){
			global $wpdb;
			$table=$wpdb->prefix.$this->tableName;
			$table_name = $wpdb->prefix . $this->tableName;
			$sql        = "DROP TABLE IF EXISTS $table_name;";
			$wpdb->query( $sql );
		}
		/* add custom function here*/
		static function decreaseCounter($license_code,$product_id){
			$obj=new self();
			$obj->request_counter('request_counter - 1',true);
			$obj->SetWhereUpdate("purchase_key",$license_code);
			$obj->SetWhereUpdate("product_id",$product_id);
			return $obj->Update();
        }
		static function updateRequestManageTime($license_code,$product_id,$counter,$duration_in_hour){
			$obj=new self();
			$obj->request_counter($counter);
			$obj->request_delay_time($duration_in_hour);
			$obj->SetWhereUpdate("purchase_key",$license_code);
			$obj->SetWhereUpdate("product_id",$product_id);
			return $obj->Update();
		}
		static function updateVersion($license_code,$product_id,$app_version){
			$obj=new self();
			$obj->current_version($app_version);
			$obj->SetWhereUpdate("purchase_key",$license_code);
			$obj->SetWhereUpdate("product_id",$product_id);
			return $obj->Update();
		}
		static function updateStatus($license_code,$product_id,$status) {
			$obj = new self();
			$obj->status( $status );
			$obj->SetWhereUpdate( "purchase_key", $license_code );
			$obj->SetWhereUpdate( "product_id", $product_id );
			
			return $obj->Update();
		}
		static function DeleteByClient($client_id){
			return parent::DeleteByKeyValue("client_id",$client_id,true);
		}
		static function DeleteByProduct($product_id){
			return parent::DeleteByKeyValue("product_id",$product_id,true);
		}
		static function ReplaceLicenseTitle($license_id,$newLicesneTitle){
		    global $wpdb;
		    $obj=new self();
			$table=$wpdb->prefix.$obj->tableName;
			$table_name = $wpdb->prefix . $obj->tableName;
			$sql        = "UPDATE  $table_name SET license_title='$newLicesneTitle' WHERE license_id='$license_id' and market <>'E'";
			return $wpdb->query( $sql );
        }
		/* end custom function */
		function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
			
			if(!$mainobj){
				$mainobj=$this;
			}
			?>
            <div class="form-row">

				<?php if(!in_array("product_id",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="product_id"><?php $this->_e("Product"); ?></label>

							<?php $options_product_base_name= Mapbd_product::FetchAllKeyValue("id", "product_name");?>
                            <select class="custom-select form-control-sm " id="product_id" <?php echo in_array("product_id", $disabled)?' disabled="disabled" ':' name="product_id" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Product"));?>">
                                <option value=""><?php $this->_e("Select"); ?></option>
                                <?php $product_base_name_selected= $mainobj->GetPostValue("product_id");
								APBD_GetHTMLOptionByArray($options_product_base_name,$product_base_name_selected);
								?>
                            </select>

							<?php /*<span class="form-group-help-block"><?php $this->_e("product_id");?></span>	*/?>

                    </div>
				<?php } ?>

	            <?php if(!in_array("license_id",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label " for="license_id"><?php $this->_e("License"); ?></label>

			            <?php
                            $options_license_id= Mapbd_license_type::FindAllByKeyValue("status","A","id", "license_title");
                            $projectLicenses=Mapbd_product_license::FindAllBy("status","A");
                            $licenseProjects=[];
                            foreach ( $projectLicenses as $project_licens ) {
	                            if(!isset($licenseProjects[$project_licens->license_id])){
		                            $licenseProjects[$project_licens->license_id]="";
	                            }
	                            $licenseProjects[$project_licens->license_id].=" data-p".$project_licens->product_id.'= "'.$project_licens->product_id.'"';
                            }
			            ?>
                        <select class="custom-select form-control-sm " id="license_id" <?php echo in_array("license_id", $disabled)?' disabled="disabled" ':' name="license_id" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("License License_title"));?>">
                            <option value=""><?php $this->_ee("Select"); ?></option>
                            <?php $license_id_selected= $mainobj->GetPostValue("license_id");
                            foreach ( $options_license_id as $key=>$value ) { ?>
                                <option <?php echo isset($licenseProjects[$key])?$licenseProjects[$key]:"";?> <?php echo $license_id_selected==$key?"selected='selected'":"";?>  value="<?php echo $key;?>"><?php echo $value;?></option>
	                            <?php
                            }
				            ?>
                        </select>
                        
                        <script type="text/javascript">
                            jQuery( document ).ready(function( $ ) {
                               $("#product_id").on("change",function(){
                                   var thisObj=$(this);
                                   var cval=$(this).val();
                                   if(cval!="") {
                                       $("#license_id option:not([data-p" + cval + "])").prop("disable", true).hide();
                                       $("#license_id option[data-p" + cval + "]").prop("disable", false).show();
                                   }else{
                                       $("#license_id").val("");
                                       $("#license_id option").prop("disable", false).show();
                                   }
                               })
                            });
                        </script>
			            <?php /*<span class="form-group-help-block"><?php $this->_e("license_id");?></span>	*/?>

                    </div>

	            <?php } ?>
	           
            </div>


            <div class="form-row">
	            <?php if(!in_array("max_domain",$except)){ ?>
                    <div class="form-group col-sm-5">
                        <label class="col-form-label" for="max_domain">
                            <?php $this->_ee("Max Domain"); ?>
                            <?php
	                            echo "( ".$this->__("Unlimited")." ";
	                            APBD_GetHTMLSwitchButtonInline("is_unlimited","is_unlimited","N","Y",$mainobj->GetPostValue("is_unlimited","N"),false,"has_depend_fld2");
	                            echo ")";
                            ?>
                        </label>
                        <input  class="form-control form-control-sm text-center fld-is-unlimited fld-is-unlimited-n" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("max_domain");?>" id="max_domain" <?php echo in_array("max_domain", $disabled)?' disabled="disabled" ':' name="max_domain" ';?>     placeholder="<?php $this->_ee("Max Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Max Domain");?>">
			            <?php /*<span class="form-text text-muted"><?php $this->_ee("max_domain");?></span>	*/?>
                    </div>
	            <?php } ?>
	            <?php if(!in_array("verification_required",$except)){ ?>
                    <div class="form-group col-sm-3">
                        <label class="col-form-label" for="max_domain"><?php $this->_ee("Verification Domain"); ?></label>
                        <input  class="form-control form-control-sm text-center" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("verification_required",'0');?>" id="verification_required" <?php echo in_array("verification_required", $disabled)?' disabled="disabled" ':' name="verification_required" ';?>     placeholder="<?php $this->_ee("Verification Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Verification Domain");?>">
			            <?php /*<span class="form-text text-muted"><?php $this->_ee("max_domain");?></span>	*/?>
                    </div>
	            <?php } ?>
	            <?php if(!in_array("has_expiry",$except)){ ?>
                    <div class="form-group col-sm-4">
                        <label class="col-form-label " for="has_expiry"><?php $this->_e("License Expiry"); ?></label>
                        <div class="input-group">
                            <div class="input-group-prepend  has-mat-sw">
                                <?php
                                APBD_GetHTMLSwitchButton("has_expiry","has_expiry","N","Y",$mainobj->GetPostValue("has_expiry"),false,"has_depend_fld2");
                                ?>
                            </div>
                            <input class="form-control form-control-sm col col-sm app-date-picker fld-has-expiry fld-has-expiry-y" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("expiry_time");?>"  id="expiry_time" <?php echo in_array("expiry_time", $disabled)?' disabled="disabled" ':' name="expiry_time" ';?>     placeholder="<?php $this->_e("Expiry Time");?>" >

                        </div>

                    </div>
	            <?php }?>


				

            </div>

            <div class="form-row">
                <?php if(!in_array("lictype_param",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="lictype_param"><?php $this->_ee("License Type Param"); ?></label>
                        <input  class="form-control form-control-sm" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("lictype_param");?>" id="lictype_param" <?php echo in_array("lictype_param", $disabled)?' disabled="disabled" ':' name="lictype_param" ';?>   placeholder="<?php $this->_ee("License Type Param");?>">
                        <?php /*<span class="form-text text-muted"><?php $this->_ee("max_domain");?></span>	*/?>
                    </div>
                <?php } ?>
                <?php if(!in_array("other_param",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="max_domain"><?php $this->_ee("Other Param"); ?></label>
                        <input  class="form-control form-control-sm" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("other_param");?>" id="other_param" <?php echo in_array("other_param", $disabled)?' disabled="disabled" ':' name="other_param" ';?>     placeholder="<?php $this->_ee("Other Param");?>" >
                        <?php /*<span class="form-text text-muted"><?php $this->_ee("max_domain");?></span>	*/?>
                    </div>
                <?php } ?>
            </div>
            <div class="form-row">
				<?php if(!in_array("extra_param",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="extra_param"><?php $this->_ee("Extra Param"); ?>
                            <i class="fa fa-edit text-info" id="exparam_enable"></i>
                        </label>
                        <input disabled  class="form-control form-control-sm" type="text" value="<?php echo  $mainobj->GetPostValue("extra_param");?>" id="extra_param" <?php echo in_array("lictype_param", $disabled)?' disabled="disabled" ':' name="extra_param" ';?>   placeholder="<?php $this->_ee("License Type Param");?>">
						<span class="form-text text-warning"><?php $this->_ee("Keep it just as it is. Change only when necessary");?></span>
                    </div>
				<?php } ?>
				
            </div>
            
            <div class="form-row">
	            <?php if(!in_array("has_support",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label " for="has_support"><?php $this->_e("Support Status"); ?></label>
                        <div class="input-group">
                            <div class="input-group-prepend has-mat-sw">
                                <div class="pt-1">
					            <?php
						            APBD_GetHTMLRadioByArray("has_support","has_support","has_support",true,["N"=>"No Support","U"=>"Unlimited","Y"=>"Day Interval"],$mainobj->GetPostValue("has_support"),false,true,"has_depend_fld2");
						            //APBD_GetHTMLSwitchButton("has_support","has_support","N","Y",$mainobj->GetPostValue("has_support"),false,"has_depend_fld2");
					            ?>
                                </div>
                            </div>
                            <input class="form-control form-control-sm col col-sm app-date-picker fld-has-support fld-has-support-y" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("support_end_time");?>"  id="expiry_time" <?php echo in_array("expiry_time", $disabled)?' disabled="disabled" ':' name="support_end_time" ';?>     placeholder="<?php $this->_e("Support End Time");?>" >

                        </div>

                    </div>
	            <?php }?>
            </div>
            <div class="form-row">
				<?php if(!in_array("purchase_key",$except)){ ?>
                    <div class="form-group col-sm-8">
                        <label class="col-form-label" for="purchase_key">
                            <?php $this->_e("License Code"); ?>
                            <?php
                            if(empty($mainobj->id) && empty($mainobj->purchase_key)){
                                echo "( ".$this->__("Auto Generate?")." ";
	                            APBD_GetHTMLSwitchButtonInline("is_auto_generate","is_auto_generate","N","Y",APBD_PostValue("is_auto_generate","N"),false,"has_depend_fld2");
	                            echo ")";
                            }
                            ?>
                        </label>
                        <input class="form-control form-control-sm  fld-is-auto-generate fld-is-auto-generate-n" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("purchase_key");?>"  id="purchase_key" <?php echo in_array("purchase_key", $disabled)?' disabled="disabled" ':' name="purchase_key" ';?>     placeholder="<?php $this->_e("Purchase Key");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_ee("%s is required","License Code");?>">
						<?php /*<span class="form-group-help-block"><?php $this->_e("purchase_key");?></span>	*/?>
                    </div>
				<?php } ?>

				<?php if(!in_array("status",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label " for="status"><?php $this->_e("Status"); ?></label>

                        <select    class="custom-select form-control-sm" id="status" <?php echo in_array("status", $disabled)?' disabled="disabled" ':' name="status" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Status"));?>">
                            <option value=""><?php $this->_ee("Select"); ?></option>
                            <?php $status_selected= $mainobj->GetPostValue("status","W");
							APBD_GetHTMLOptionByArray($mainobj->GetPropertyOptions("status"),$status_selected);
							?>

                        </select>
						<?php /*<span class="form-group-help-block"><?php $this->_e("status");?></span>	*/?>

                    </div>
				<?php } ?>

            </div>
            <script type="text/javascript">
                'use strict';
                jQuery( document ).ready(function( $ ) {
                    $("#exparam_enable").on("click",function(e){
                        e.preventDefault();
                        $("#extra_param").prop("disabled",false).focus();
                        
                    })
                });
            </script>
          
            <?php
		}
		
		
	}
?>