<?php 			
/** 
 * @since: 24/Feb/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,license_title,max_domain,verification_required,has_expiry,days_of_expiry,has_support,days_of_support,status		
 */						
class Mapbd_license_type extends AppsBDModel{	
	public $id;
	public $license_title;
	public $is_unlimited;
	public $max_domain;
	public $verification_required;
	public $has_expiry;
	public $days_of_expiry;
	public $has_support;
	public $days_of_support;
	public $extra_param;
	public $status;


	    /**
	     *@property id,license_title,max_domain,verification_required,has_expiry,days_of_expiry,has_support,days_of_support,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_license_type";
			$this->primaryKey="id";
			$this->uniqueKey=array();	
			$this->multiKey=array();
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";
		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[3]|integer"),
			"license_title"=>array("Text"=>"License Title", "Rule"=>"xss_clean|required|max_length[100]"),
			"max_domain"=>array("Text"=>"Max Domain", "Rule"=>"xss_clean|required|max_length[11]|integer"),
			"is_unlimited"=>array("Text"=>"Max Domain", "Rule"=>"xss_clean|max_length[1]"),
			"verification_required"=>array("Text"=>"Verification Required", "Rule"=>"xss_clean|max_length[11]|integer"),
			"has_expiry"=>array("Text"=>"Has Expiry", "Rule"=>"xss_clean|required|max_length[1]"),
			"days_of_expiry"=>array("Text"=>"Days Of Expiry", "Rule"=>"xss_clean|max_length[11]|integer"),
			"has_support"=>array("Text"=>"Has Support", "Rule"=>"xss_clean|required|max_length[1]"),
			"days_of_support"=>array("Text"=>"Days Of Support", "Rule"=>"xss_clean|max_length[11]|integer"),
			"extra_param"=>array("Text"=>"Extra Param", "Rule"=>"xss_clean|max_length[20]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "has_expiry":        
	         $returnObj=array("Y"=>"Yes","N"=>"No");
	         break;
	      case "has_support":        
	         $returnObj=array("Y"=>"Day Interval","N"=>"No Support","U"=>"Unlimited");
	         break;
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

 
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
			case "has_support":
				$returnObj=array("Y"=>"success text-bold","N"=>"danger text-bold","U"=>"info text-bold");
				break;
	      default:
	    }       
        return $returnObj;
	
	}
    
	   

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	static function DeleteByID(  $id) {
		if(parent::DeleteByKeyValue( "id", $id)){
			Mapbd_product_license::DeleteByTypeID($id);
			return true;
		}
		return false;
	}
	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/

	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(3) unsigned NOT NULL AUTO_INCREMENT,
					  `license_title` char(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `max_domain` int(11) NOT NULL,
					  `is_unlimited` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes,N=No)',
					  `verification_required` int(11) NOT NULL COMMENT 'manual verification required when the limit is over',
					  `has_expiry` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'bool(Y=Yes,N=No)',
					  `days_of_expiry` int(11) unsigned NOT NULL DEFAULT '30' COMMENT 'if has expiry is yes then all license will be set expiry with this date',
					  `has_support` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'bool(Y=Yes,N=No)',
					  `days_of_support` int(11) unsigned NOT NULL DEFAULT '30' COMMENT 'if has expiry is yes then all license will be set expiry with this date',
					  `extra_param` char(20) NOT NULL DEFAULT '',
					  `status` char(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active,I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	function DropDBTable(){
		global $wpdb;
		$table=$wpdb->prefix.$this->tableName;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	}
	/* add custom function here*/

	/* end custom function */
	function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){

		if(!$mainobj){
			$mainobj=$this;
		}
		?>
        <div class="form-row">
	        <?php if(!in_array("license_title",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="license_title"><?php $this->_ee("License Title"); ?></label>
                    <input  class="form-control form-control-sm " type="text" maxlength="100"   value="<?php echo  $mainobj->GetPostValue("license_title");?>" id="license_title" <?php echo in_array("license_title", $disabled)?' disabled="disabled" ':' name="license_title" ';?>     placeholder="<?php $this->_ee("License Title");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","License Title");?>">
			        
                </div>
	        <?php } ?>
	        <?php if(!in_array("has_expiry",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="has_expiry"><?php $this->_ee("Enable Expiry & Days"); ?></label>

                    <div class="input-group">
                        <div class="input-group-prepend  has-mat-sw ">
					        <?php
						       
						        APBD_GetHTMLSwitchButton("has_expiry","has_expiry","N","Y",$mainobj->GetPostValue("has_expiry"),false,"has_depend_fld2");
					        ?>
                        </div>
				        <?php if(!in_array("days_of_expiry",$except)){ ?>
                            <input  class="form-control form-control-sm text-center fld-has-expiry fld-has-expiry-y" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("days_of_expiry");?>" id="days_of_expiry" <?php echo in_array("days_of_expiry", $disabled)?' disabled="disabled" ':' name="days_of_expiry" ';?>     placeholder="<?php $this->_ee("Days Of Expiry");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Days Of Expiry");?>">
				        <?php } ?>
                    </div>
			        <?php /*<span class="form-text text-muted"><?php $this->_ee("has_expiry");?></span>	*/?>


                </div>
	        <?php } ?>
	       
        </div>
        <div class="form-row">
	        <?php if(!in_array("has_support",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="has_support"><?php $this->_ee(" Has Support & Days"); ?></label>
                    <div class="input-group">
                        <div class="input-group-prepend  has-mat-sw min-h-unset">
                            <div class="pt-1 pl-1">
					        <?php
						        APBD_GetHTMLRadioByArray("has_support","has_support","has_support",true,["N"=>"No Support","U"=>"Unlimited","Y"=>"Day Interval"],$mainobj->GetPostValue("has_support"),false,true,"has_depend_fld2");
						        ?>
                        
                            </div>
                        </div>
                        <input  class="form-control form-control-sm text-center fld-has-support fld-has-support-y" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("days_of_support");?>" id="days_of_support" <?php echo in_array("days_of_support", $disabled)?' disabled="disabled" ':' name="days_of_support" ';?>     placeholder="<?php $this->_ee("Days Of Support");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Days Of Support");?>">
                    </div>
			        <?php /*<span class="form-text text-muted"><?php $this->_ee("has_support");?></span>	*/?>
                </div>
	        <?php } ?>
        </div>
        <div class="form-row">
	        <?php if(!in_array("extra_param",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="status"><?php $this->_ee("Extra Param"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("extra_param");?>" id="extra_param" <?php echo in_array("extra_param", $disabled)?' disabled="disabled" ':' name="extra_param" ';?>     placeholder="<?php $this->_ee("Extra Param");?>" >

                    <span class="form-text text-muted"><?php $this->_ee("[optional] This param will pass into your license response, so you can add condition to your plugin/app with this param");?></span>


                </div>
	        <?php } ?>
        </div>
        <div class="form-row">
	
	        <?php if(!in_array("max_domain",$except)){ ?>
                <div class="form-group col-sm-5">
                    <label class="col-form-label" for="max_domain">
                        <?php $this->_ee("Max Domain"); ?>
                        <?php
                        echo "( ".$this->__("Unlimited")." ";
                        if($mainobj->is_unlimited=='Y'){
	                        $mainobj->max_domain='';
                        }
                        APBD_GetHTMLSwitchButtonInline("is_unlimited","is_unlimited","N","Y",$mainobj->GetPostValue("is_unlimited","N"),false,"has_depend_fld2");
                        echo ")";
                        ?>
                    </label>
                    <input  class="form-control form-control-sm text-center fld-is-unlimited fld-is-unlimited-n" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("max_domain");?>" id="max_domain" <?php echo in_array("max_domain", $disabled)?' disabled="disabled" ':' name="max_domain" ';?>     placeholder="<?php $this->_ee("Max Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Max Domain");?>">
			        
                </div>
	        <?php } ?>
	
	
	        <?php if(!in_array("verification_required",$except)){ ?>
                <div class="form-group col-sm-5">
                    <label class="col-form-label" for="verification_required"><?php $this->_ee("Verification Required"); ?></label>
                    <input  class="form-control form-control-sm text-center" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("verification_required");?>" id="verification_required" <?php echo in_array("verification_required", $disabled)?' disabled="disabled" ':' name="verification_required" ';?>     placeholder="<?php $this->_ee("Verification Required");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Verification Required");?>">
			        
                </div>
	        <?php } ?>

			
			
	
	        <?php if(!in_array("status",$except)){ ?>
                <div class="form-group col-sm-2">
                    <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
			
			        <?php
            
				        APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
			        ?>
			        <?php /*<span class="form-text text-muted"><?php $this->_ee("status");?></span>	*/?>


                </div>
	        <?php } ?>
        </div>
       
        <div class="form-row">
	      
			

			

        </div>
		<?php
	}

}
?>