<?php 			
/** 
 * @since: 25/Feb/2022
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,alert_id,alert_name,checkout_id,subscription_id,next_bill_date,alert_log		
 */						
class Mapbd_paddle_log extends AppsBDModel{	
	public $id;
	public $alert_id;
	public $alert_name;
	public $checkout_id;
	public $subscription_id;
	public $next_bill_date;
	public $alert_log;


	    /**
	     *@property id,alert_id,alert_name,checkout_id,subscription_id,next_bill_date,alert_log
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_paddle_log";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("alert_id"));	
			$this->multiKey=array();
			$this->autoIncField=array("id");	
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[11]|integer"),
			"alert_id"=>array("Text"=>"Alert Id", "Rule"=>"required|max_length[15]"),
			"alert_name"=>array("Text"=>"Alert Name", "Rule"=>"max_length[50]"),
			"checkout_id"=>array("Text"=>"Checkout Id", "Rule"=>"max_length[50]"),
			"subscription_id"=>array("Text"=>"Subscription Id", "Rule"=>"max_length[50]"),
			//"next_bill_date"=>array("Text"=>"Next Bill Date", "Rule"=>""),
			"alert_log"=>array("Text"=>"Alert Log", "Rule"=>"")
			
		);
	}

    /*
	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}  
    */
	   

    /*
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }       
        return $returnObj;
	
	}
    */
	   

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	   		
	    	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/
			
    static  function AddPaddleWebhookFromPost() {
	    $alert_id   = APBD_PostValue( "alert_id" );
	    $alert_name = APBD_PostValue( "alert_name", "" );
	    $chk        = new self();
	    if ( ! empty( $alert_id ) && ! $chk->IsExists( "alert_id", $alert_id ) ) {
		    $newObj = new self();
		    $newObj->alert_id( $alert_id );
		    $newObj->alert_name( APBD_PostValue( "alert_name", "" ) );
		    $newObj->checkout_id( APBD_PostValue( "checkout_id", "" ) );
		    $newObj->subscription_id( APBD_PostValue( "subscription_id", "" ) );
		    if ( in_array( $alert_name, [ 'subscription_cancelled', ] ) ) {
			    $next_bill_date = APBD_PostValue( "cancellation_effective_date", "" );
		    } else {
			    $next_bill_date = APBD_PostValue( "next_bill_date", "" );
		    }
		
		    if ( ! empty( $next_bill_date ) ) {
			    $next_bill_date = date( 'Y-m-d', strtotime( $next_bill_date) );
			    $newObj->next_bill_date( $next_bill_date );
		    }
		    if ( isset( $_POST['p_signature'] ) ) {
			    unset( $_POST['p_signature'] );
		    }
		    $newObj->alert_log( json_encode( $_POST ) );
		
		    return $newObj->Save();
	    }
	
	    return false;
    }
	 static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;			
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
					  `alert_id` char(15) NOT NULL,
					  `alert_name` varchar(50) NOT NULL DEFAULT '',
					  `checkout_id` varchar(50) NOT NULL DEFAULT '',
					  `subscription_id` varchar(50) NOT NULL DEFAULT '',
					  `next_bill_date` date NOT NULL DEFAULT '0000-00-00',
					  `alert_log` text DEFAULT NULL,
					  `entry_time` timestamp NOT NULL DEFAULT current_timestamp(),
					  PRIMARY KEY (`id`),
					  UNIQUE KEY `alert_unique_id` (`alert_id`) USING BTREE
					) ";				 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	 }
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
					?>
			<div class="form-row">
			<?php /*if(!in_array("id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="id"><?php $this->_ee("Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("id");?>" id="id" <?php echo in_array("id", $disabled)?' disabled="disabled" ':' name="id" ';?>     placeholder="<?php $this->_ee("Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Id");?>">
			     				      	
		      </div> 
		     <?php } */?>
			</div>
			<div class="form-row">
			<?php if(!in_array("alert_id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="alert_id"><?php $this->_ee("Alert Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="15"   value="<?php echo  $mainobj->GetPostValue("alert_id");?>" id="alert_id" <?php echo in_array("alert_id", $disabled)?' disabled="disabled" ':' name="alert_id" ';?>     placeholder="<?php $this->_ee("Alert Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Alert Id");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("alert_id");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("alert_name",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="alert_name"><?php $this->_ee("Alert Name"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("alert_name");?>" id="alert_name" <?php echo in_array("alert_name", $disabled)?' disabled="disabled" ':' name="alert_name" ';?>     placeholder="<?php $this->_ee("Alert Name");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Alert Name");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("alert_name");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("checkout_id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="checkout_id"><?php $this->_ee("Checkout Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("checkout_id");?>" id="checkout_id" <?php echo in_array("checkout_id", $disabled)?' disabled="disabled" ':' name="checkout_id" ';?>     placeholder="<?php $this->_ee("Checkout Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Checkout Id");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("checkout_id");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("subscription_id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="subscription_id"><?php $this->_ee("Subscription Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="5"   value="<?php echo  $mainobj->GetPostValue("subscription_id");?>" id="subscription_id" <?php echo in_array("subscription_id", $disabled)?' disabled="disabled" ':' name="subscription_id" ';?>     placeholder="<?php $this->_ee("Subscription Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Subscription Id");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("subscription_id");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("next_bill_date",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="next_bill_date"><?php $this->_ee("Next Bill Date"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength=""   value="<?php echo  $mainobj->GetPostValue("next_bill_date");?>" id="next_bill_date" <?php echo in_array("next_bill_date", $disabled)?' disabled="disabled" ':' name="next_bill_date" ';?>     placeholder="<?php $this->_ee("Next Bill Date");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Next Bill Date");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("next_bill_date");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("alert_log",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="alert_log"><?php $this->_ee("Alert Log"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength=""   value="<?php echo  $mainobj->GetPostValue("alert_log");?>" id="alert_log" <?php echo in_array("alert_log", $disabled)?' disabled="disabled" ':' name="alert_log" ';?>     placeholder="<?php $this->_ee("Alert Log");?>" >
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("alert_log");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			
			</div>
			<?php 
	}


}