<?php 			
/** 
 * @since: 24/Feb/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,product_base,product_name,entry_date,status		
 */						
class Mapbd_product extends AppsBDModel{	
	public $id;
	public $product_base;
	public $product_name;
	public $entry_date;
	public $enc_key;
	public $renew_link;
	public $lic_prefix;
	public $product_link;
	public $is_enc_up_res;
	public $is_check_lic_on_update;
	public $is_check_sup_on_update;
	public $status;
	private static $reg_generators=[];


	    /**
	     *@property id,product_base,product_name,entry_date,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_product";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("product_base"));	
			$this->multiKey=array();
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";
		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[10]|integer"),
			"product_base"=>array("Text"=>"Product Base", "Rule"=>"xss_clean|required|max_length[50]"),
			"product_name"=>array("Text"=>"Product Name", "Rule"=>"xss_clean|required|max_length[50]"),
			"entry_date"=>array("Text"=>"Entry Date", "Rule"=>"xss_clean|max_length[20]"),
			"enc_key"=>array("Text"=>"Request Encryption Key", "Rule"=>"xss_clean|max_length[32]"),
			"lic_prefix"=>array("Text"=>"Renew Link", "Rule"=>"xss_clean|max_length[10]"),
			"renew_link"=>array("Text"=>"Renew Link", "Rule"=>"xss_clean|max_length[255]"),
			"product_link"=>array("Text"=>"Product Link", "Rule"=>"xss_clean|max_length[255]"),
			"is_enc_up_res"=>array("Text"=>"Encrypt Update Data", "Rule"=>"xss_clean|max_length[1]"),
			"is_check_lic_on_update"=>array("Text"=>"Check Lic On Update", "Rule"=>"xss_clean|max_length[1]"),
			"is_check_sup_on_update"=>array("Text"=>"Check Lic On Update", "Rule"=>"xss_clean|max_length[1]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]")
			
		);
	}
	
	
	
	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

 
	public function GetPropertyOptionsColor($property) {
		$returnObj = array();
		switch ( $property ) {
			case "status":
				$returnObj = array( "A" => "success", "I" => "danger" );
				break;
			default:
		}

		return $returnObj;

	}
	
	
	/**
	 * @param $key
	 * @param APBDScriptGeneratorBase $object
	 */
	public static function RegisterGenerators( $key,&$object ) {
		self::$reg_generators[$key] = &$object;
	}
	/**
	 * @return APBDScriptGeneratorBase []
	 */
	static function getScriptGenerators() {
	    $responseArray=[
			"WP" =>APBDScriptGeneratorWordPress::getInstance(),
			"PH" =>APBDScriptGeneratorPHP::getInstance(),
			//"JM" =>APBDScriptGeneratorJoomla::getInstance(),
		    "DN" => APBDScriptGeneratorDotNet::getInstance(),
		    "VB" => APBDScriptGeneratorVBNet::getInstance(),
		    "JV" => APBDScriptGeneratorJava::getInstance(),
      
		    //"AN" => "Android App",
		];
	    foreach (self::$reg_generators as $key=>$obj){
		    $responseArray[$key]=&$obj;
        }
	    return $responseArray;
	}

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	   		
	    	
	//auto generated
    function SetAutoEncryptedKey(){
        $this->enc_key(strtoupper(hash('crc32b',rand(1000,9999))).strtoupper(hash('crc32b',rand(1000,9999))));
    }
    function Save(){
        if($this->IsExists("product_base",$this->product_base)){
            $this->AddError("Product base is already exists");
            return false;
        }
        if(empty($this->enc_key)){
            $this->SetAutoEncryptedKey();
        }
	    return parent::Save();
	}
	
	public static function GetProductWithLicenseType($status='',$limit="",$limitStart="",&$totalProduct=null){
		$p=new Mapbd_product();
		if(!empty($status)){
			$p->status($status);
		}
		$totalProduct=$p->CountALL();
		$products = $p->SelectAll("id,product_base,product_name,entry_date,status","","",$limit,$limitStart);
		$allProductTypes=Mapbd_license_type::FindAllByKeyValue("status","A","id","license_title");
		foreach ($products as &$product){
			$product->product_licenses=[];
			$productlicenses=Mapbd_product_license::FindAllBy("product_id",$product->id);
			foreach ($productlicenses as $pl){
				if(isset($allProductTypes[$pl->license_id])) {
					$product->product_licenses[ $pl->license_id ]=$allProductTypes[$pl->license_id];
				}
			}
			
		}
		return $products;
    }
	
	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `product_base` char(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
					  `product_name` char(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `entry_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
					  `enc_key` char(32) NOT NULL DEFAULT '',
					  `renew_link` varchar(255) NOT NULL DEFAULT '',
					  `lic_prefix` varchar(10) NOT NULL DEFAULT '',
					  `product_link` varchar(255) NOT NULL DEFAULT '',
                      `is_enc_up_res` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes, N=No)',
                      `is_check_lic_on_update` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes, N=No)',
                      `is_check_sup_on_update` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes, N=No)',
                      `status` char(1) NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active, N=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE,
					  UNIQUE KEY `product_base` (`product_base`) USING BTREE
					)";
			
			
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	function DropDBTable(){
		global $wpdb;
		$table=$wpdb->prefix.$this->tableName;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	}
	/* add custom function here*/
	static function DeleteByID(  $id) {
		if(parent::DeleteByKeyValue( "id", $id)){
		    Mapbd_product_license::DeleteByProductID($id);
		    Mapbd_license::DeleteByProduct($id);
		    return true;
        }
		return false;
	}
	/* end custom function */
	function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){

		if(!$mainobj){
			$mainobj=$this;
		}
		?>
        <div class="form-row">
	        <?php if(!in_array("product_name",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="product_name"><?php $this->_ee("Product Name"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("product_name");?>" id="product_name" <?php echo in_array("product_name", $disabled)?' disabled="disabled" ':' name="product_name" ';?>     placeholder="<?php $this->_ee("Product Name");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Product Name");?>">
			        
                </div>
	        <?php } ?>
            <?php if(!in_array("product_base",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="product_base"><?php $this->_ee("Product Base/Slug"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("product_base");?>" id="product_base" <?php echo in_array("product_base", $disabled)?' disabled="disabled" ':' name="product_base" ';?>     placeholder="<?php $this->_ee("Product Base");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Product Base");?>">
					<span class="form-group-help-block"><?php $this->_ee("(For WordPress, it will be slug Name of Plugin or Theme)");?></span>
                </div>
			<?php } ?>
	       
        </div>
        <div class="form-row">
	        <?php if(!in_array("enc_key",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="enc_key"><?php $this->_ee("Request Encryption");
                        if(empty($mainobj->id) && empty($mainobj->enc_key)) {
                            echo "( " . $this->__( "Auto Generate?" ) . " ";
                            APBD_GetHTMLSwitchButtonInline( "is_auto_generate", "is_auto_generate", "N", "Y", 'N', false, "has_depend_fld2" );
                            echo ")";
                        }
                    ?>
                    </label>
                    <input  class="form-control form-control-sm fld-is-auto-generate fld-is-auto-generate-n" type="text" maxlength="32"   value="<?php echo  $mainobj->GetPostValue("enc_key");?>" id="enc_key" <?php echo in_array("enc_key", $disabled)?' disabled="disabled" ':' name="enc_key" ';?>     placeholder="<?php $this->_e("Request Encryption");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Request Encryption");?>">
			        <?php  if(empty($mainobj->id)){?>
                        <span class="form-text text-success"> <i class="animated faa-ring fa fa-exclamation"></i> <?php $this->_e("By this key all acitve/deactive request between this license server and your app will be encrypted.");?></span>
			            <?php
			        }else{?>
                    <span class="form-text text-danger"> <i class="animated faa-pulse fa fa-exclamation-triangle"></i> <?php $this->_e("Careful, If you change the %s then your all older version products (app, plugin,theme,etc) won't be valid anymore. You must need to update old version product.",'<span class="text-bold">'.$this->__("Request Encryption").'</span>');?></span>
                    <?php } ?>
                </div>
	        <?php } ?>
      
	        <?php if(!in_array("renew_link",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="renew_link"><?php $this->_ee("Renew Link");?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("renew_link");?>" id="renew_link" <?php echo in_array("renew_link", $disabled)?' disabled="disabled" ':' name="renew_link" ';?>     placeholder="<?php $this->_e("Renew Link");?>">
                    <span class="form-text text-muted">
                        <?php $this->_e("Your product will show a button for renew %s, if you enter a link here, The button will redirect to your link, ex http://yourlink.com?type=s&lic=[licensecode], where(type s=support,l=licenser)",'<span class="text-bold">'.$this->__("License or support").'</span>');?></span>

                </div>
	        <?php } ?>
	      
        </div>
        <div class="form-row">
	        <?php if(!in_array("lic_prefix",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="lic_prefix"><?php $this->_ee("License Prefix");?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="5"   value="<?php echo  $mainobj->GetPostValue("lic_prefix");?>" id="lic_prefix" <?php echo in_array("lic_prefix", $disabled)?' disabled="disabled" ':' name="lic_prefix" ';?>     placeholder="<?php $this->_e("License prefix");?>">
                    <span class="form-text text-muted">
                        <?php $this->_e("The prefix will be added when license generate.");?></span>

                </div>
	        <?php } ?>
	        <?php if(!in_array("product_link",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="product_link"><?php $this->_ee("Product Link (Landing Page)");?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("product_link");?>" id="product_link" <?php echo in_array("product_link", $disabled)?' disabled="disabled" ':' name="product_link" ';?>     placeholder="<?php $this->_e("Product landing page link");?>">
                    <span class="form-text text-muted">
                        <?php $this->_e("This will be your product's landing page link.");?></span>

                </div>
	        <?php } ?>
        </div>
        <div class="form-row">
			<?php if(!in_array("is_check_lic_on_update",$except)){ ?>
                <div class="form-group col">
                    <label class="col-form-label" for="is_check_lic_on_update"><?php $this->_ee("Check License Expiry On Update"); ?></label>
					<?php
						APBD_GetHTMLSwitchButton("is_check_lic_on_update","is_check_lic_on_update","N","Y",$mainobj->GetPostValue("is_check_lic_on_update"));
                    ?>
                    <small  class="form-text text-muted">
		                <?php $this->_e("if you enabled it, license expiry date need to be valid on update checking") ; ?>
                    </small>
                </div>
			<?php } ?>
	        <?php if(!in_array("is_check_sup_on_update",$except)){ ?>
                <div class="form-group col">
                    <label class="col-form-label" for="is_check_sup_on_update"><?php $this->_ee("Check Support Expiry On Update"); ?></label>
			        <?php
				        APBD_GetHTMLSwitchButton("is_check_sup_on_update","is_check_sup_on_update","N","Y",$mainobj->GetPostValue("is_check_sup_on_update"));
			        ?>
                    <small  class="form-text text-muted">
				        <?php $this->_e("if you enabled it, support expiry date need to be valid on update checking") ; ?>
                    </small>
                </div>
	        <?php } ?>
			<?php if(!in_array("is_enc_up_res",$except)){ ?>
                <div class="form-group col ">
                    <label class="col-form-label" for="is_enc_up_res"><?php $this->_ee("Secure Update-Encrypted"); ?></label>
					<?php
						APBD_GetHTMLSwitchButton("is_enc_up_res","is_enc_up_res","N","Y",$mainobj->GetPostValue("is_enc_up_res"),false,"");
					?>
                    <small  class="form-text text-muted">
		                <?php $this->_e("if you enabled it, It will encrypt update response to protect publicly distribution") ; ?>
                    </small>
                </div>
			<?php } ?>
	        <?php if(!in_array("status",$except)){ ?>
                <div class="form-group col-sm-1">
                    <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
			
			        <?php
				        APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
			        ?>
                </div>
	        <?php } ?>
        </div>
		<?php
	}

}
?>