<?php 			
/** 
 * @since: 10/Mar/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,product_id,license_id,status		
 */						
class Mapbd_product_license extends AppsBDModel{	
	public $id;
	public $product_id;
	public $license_id;
	public $status;


	    /**
	     *@property id,product_id,license_id,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_product_license";
			$this->primaryKey="id";
			$this->uniqueKey=array();	
			$this->multiKey=array();
			$this->autoIncField=array("id");	
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[11]|integer"),
			"product_id"=>array("Text"=>"Product Id", "Rule"=>"xss_clean|required|max_length[20]|integer"),
			"license_id"=>array("Text"=>"License Id", "Rule"=>"xss_clean|required|max_length[11]|integer"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

 
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
        case "status":
	         $returnObj=array("A"=>"success","I"=>"danger");
	      default:
	    }       
        return $returnObj;
	
	}
 
	   

 
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
			case "status":
				$returnObj = array( "A" => "fa fa-check-circle", "I" => "fa fa-times-circle" );
			default:
		}
        return $returnObj;
	
	}
 
	   		
	    	
	//auto generated
    static function CheckIsExistsLicense($product_id,$license_type_id){
        $ob=new self();
        return $ob->IsExists("product_id",$product_id,["license_id"=>$license_type_id]);
    }
    function Save(){
        if($this->IsSetPrperty("license_id")){
            if(self::CheckIsExistsLicense($this->product_id,$this->license_id)){
                $this->AddError("License type has been already exists on this product");
                return false;
            }
        }
	    return parent::Save();
	}
	
	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;			
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
					  `product_id` int(20) unsigned NOT NULL DEFAULT '0' COMMENT 'FK(wp_apbd_product,id,product_name)',
					  `license_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'FK(wp_apbd_license_type,id,license_title)',
					  `status` char(1) NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active, I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE
					) ";				 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	 }
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	static function DeleteByID(  $id) {
		return parent::DeleteByKeyValue( "id", $id);
	}
	static function DeleteByProductID( $id) {
		return parent::DeleteByKeyValue( "product_id", $id,true);
	}
	static function DeleteByTypeID( $id) {
		return parent::DeleteByKeyValue( "license_id", $id,true);
	}
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
        if(!$mainobj) {
	        $mainobj = $this;
        }
        if(!empty($mainobj->id)){
			 $disabled[]='product_id';
        }
					?>
			<div class="form-row">
			<?php if(!in_array("product_id",$except)){ ?>
			 <div class="form-group col-sm-5">
		      	<label class="col-form-label" for="product_id"><?php $this->_ee("Product"); ?></label>
		      	 <?php $options_product_id= Mapbd_product::FetchAllKeyValue("id", "product_name");?>
			        <select class="custom-select form-control-sm" id="product_id" <?php echo in_array("product_id", $disabled)?' disabled="disabled" ':' name="product_id" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Product Product_name");?>">
			        <option value=""><?php $this->_e("Select"); ?></option>
			        <?php $product_id_selected= $mainobj->GetPostValue("product_id");
			            APBD_GetHTMLOptionByArray($options_product_id,$product_id_selected);
			            ?>			        
			        </select>
			        
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("license_id",$except)){ ?>
			 <div class="form-group col-sm-5">
		      	<label class="col-form-label" for="license_id"><?php $this->_ee("License"); ?></label>
		      	 <?php $options_license_id= Mapbd_license_type::FetchAllKeyValue("id", "license_title");?>
			        <select class="custom-select form-control-sm" id="license_id" <?php echo in_array("license_id", $disabled)?' disabled="disabled" ':' name="license_id" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","License License_title");?>">
			        <option value=""><?php $this->_e("Select"); ?></option>
			        <?php $license_id_selected= $mainobj->GetPostValue("license_id");
			            APBD_GetHTMLOptionByArray($options_license_id,$license_id_selected);
			            ?>			        
			        </select>
			       
		      </div> 
		     <?php } ?>
				<?php if(!in_array("status",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
						
						<?php
							APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
						?>
						


                    </div>
				<?php } ?>
			</div>
			<?php 
	}


}
?>