<?php 			
/** 
 * @since: 13/Mar/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:aditional_sections,banner_high,banner_low,change_log,download_link,id,new_version,product_id,required_version,status,tested,update_des,update_time		
 */						
class Mapbd_product_update extends AppsBDModel{	
	public $aditional_sections;
	public $banner_high;
	public $banner_low;
	public $change_log;
	public $download_link;
	public $id;
	public $new_version;
	public $product_id;
	public $required_version;
	public $status;
	public $tested;
	public $update_des;
	public $update_time;


	    /**
	     *@property aditional_sections,banner_high,banner_low,change_log,download_link,id,new_version,product_id,required_version,status,tested,update_des,update_time
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_product_update";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("product_id","new_version"));	
			$this->multiKey=array();
			$this->autoIncField=array("id");	
			$this->app_base_name="APBLIC";
			$this->htmlInputField=['update_des','change_log'];

		}
			

	function SetValidation(){
		$this->validations=array(
			//"aditional_sections"=>array("Text"=>"Aditional Sections", "Rule"=>""),
			"banner_high"=>array("Text"=>"Banner High", "Rule"=>"xss_clean|max_length[255]"),
			"banner_low"=>array("Text"=>"Banner Low", "Rule"=>"xss_clean|max_length[255]"),
			"change_log"=>array("Text"=>"Change Log", "Rule"=>"required"),
			"download_link"=>array("Text"=>"Download Link", "Rule"=>"xss_clean|required|max_length[255]"),
			"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[10]|integer"),
			"new_version"=>array("Text"=>"New Version", "Rule"=>"xss_clean|required|max_length[10]"),
			"product_id"=>array("Text"=>"Product Id", "Rule"=>"xss_clean|max_length[10]|integer"),
			"required_version"=>array("Text"=>"Required Version", "Rule"=>"xss_clean|required|max_length[10]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
			"tested"=>array("Text"=>"Tested", "Rule"=>"xss_clean|required|max_length[10]"),
			"update_des"=>array("Text"=>"Update Des", "Rule"=>"required"),
			"update_time"=>array("Text"=>"Update Time", "Rule"=>"xss_clean|max_length[20]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}


	public function GetPropertyOptionsColor($property) {
		$returnObj = array();
		switch ( $property ) {
			case "status":
				$returnObj = array( "A" => " text-success text-bold", "I" => " text-danger text-bold" );
				break;
			default:
		}
		return $returnObj;

	}
	/**
	 * @param Mapbd_product_update $mainobj
	 * @param $value
	 */
	function get_posted_additional_sections() {
		$aditionalSection = APBD_PostValue( "ad_sec_data" );
		if ( ! empty( $aditionalSection ) && is_array( $aditionalSection ) ) {
			ksort( $aditionalSection );
			return base64_encode( serialize( $aditionalSection ));
		}
		return '';
	}

	function decodeAdditionalSections(){
	    if(!empty($this->aditional_sections)){
		    return unserialize(base64_decode($this->aditional_sections ));
        }
	    return [];
    }
	   		
	 static function DeleteID( $id ) {
		 return parent::DeleteByKeyValue( "id", $id);
	 }
	
	//auto generated
    public function SetFromPostData( $isNew = false ) {
	    if($this->IsSetPrperty('update_des')){
		    $this->update_des(wp_kses_post($this->update_des));
        }
	    if($this->IsSetPrperty('change_log')){
		    $this->change_log(wp_kses_post($this->change_log));
	    }
	    return parent::SetFromPostData( $isNew );
    }
	
	function Save(){
        $this->status('I');
	    return parent::Save();
	}
	static function UpdateOtherVersion($product_id) {
        $Obj=new self();
        $Obj->status("I");
		$Obj->SetWhereUpdate("product_id",$product_id);
		return $Obj->Update(true);
	}

	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `product_id` int(10) NOT NULL DEFAULT '0' COMMENT 'FK(wp_apbd_product,id,product_name)',
					  `new_version` char(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `required_version` char(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'WP Required Version',
					  `tested` char(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `download_link` char(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'textarea',
					  `update_des` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'textarea',
					  `change_log` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'textarea',
					  `banner_high` char(255) NOT NULL DEFAULT '',
					  `banner_low` char(255) NOT NULL,
					  `aditional_sections` text COMMENT 'textarea',
					  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active,I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE,
					  UNIQUE KEY `product_base` (`product_id`,`new_version`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
					?>
         <div class="form-row">
			 <?php if(!in_array("product_id",$except)){ ?>
                 <div class="form-group  col-md-6 col-lg">
                     <label class="col-form-label" for="product_id"><?php $this->_ee("Product"); ?></label>
					 <?php $options_product_id= Mapbd_product::FetchAllKeyValue("id", "product_name");?>
                     <select class="custom-select form-control-sm" id="product_id" <?php echo in_array("product_id", $disabled)?' disabled="disabled" ':' name="product_id" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Product Product_name");?>">
                         <option value=""><?php $this->_e("Select"); ?></option>
						 <?php $product_id_selected= $mainobj->GetPostValue("product_id");
						 APBD_GetHTMLOptionByArray($options_product_id,$product_id_selected);
						 ?>
                     </select>
					 
                 </div>
			 <?php } ?>

			 <?php if(!in_array("new_version",$except)){ ?>
                 <div class="form-group col-md-6 col-lg">
                     <label class="col-form-label" for="new_version"><?php $this->_ee("New Version"); ?></label>
                     <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("new_version");?>" id="new_version" <?php echo in_array("new_version", $disabled)?' disabled="disabled" ':' name="new_version" ';?>     placeholder="<?php $this->_ee("New Version");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","New Version");?>">
					 
                 </div>
			 <?php } ?>

			 <?php if(!in_array("required_version",$except)){ ?>
                 <div class="form-group col-md-6 col-lg">
                     <label class="col-form-label" for="required_version"><?php $this->_ee("Required Version"); ?></label>
                     <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("required_version");?>" id="required_version" <?php echo in_array("required_version", $disabled)?' disabled="disabled" ':' name="required_version" ';?>     placeholder="<?php $this->_ee("Required Version");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Required Version");?>">
					 
                 </div>
			 <?php } ?>
			 <?php if(!in_array("tested",$except)){ ?>
                 <div class="form-group col-md-6 col-lg">
                     <label class="col-form-label" for="tested"><?php $this->_ee("Tested"); ?></label>
                     <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("tested");?>" id="tested" <?php echo in_array("tested", $disabled)?' disabled="disabled" ':' name="tested" ';?>     placeholder="<?php $this->_ee("Tested");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Tested");?>">
					 
                 </div>
			 <?php } ?>
         </div>
         <div class="form-row">
			<?php if(!in_array("banner_high",$except)){ ?>
			 <div class="form-group col-md-6 col-lg">
		      	<label class="col-form-label" for="banner_high"><?php $this->_ee("Banner"); ?></label>
                <div class="input-group input-group-sm">
                     <input  class="form-control form-control-sm " type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("banner_high");?>" id="banner_high" <?php echo in_array("banner_high", $disabled)?' disabled="disabled" ':' name="banner_high" ';?>     placeholder="<?php $this->_ee("Banner High");?>" >
                     <div class="input-group-append">
                        <button class="btn btn-secondary apd-wp-image-chooser" data-title="<?php $this->_e("Choose Banner file") ; ?>" data-button="<?php $this->_e("Choose Image") ; ?>" data-file-type="image"  data-target="#banner_high" type="button"><?php $this->_e("Choose Image") ?></button>
                     </div>
                </div>
                 
		      </div> 
		     <?php } ?>

	         <?php if(!in_array("download_link",$except)){ ?>
                 <div class="form-group col-md-6 col-lg">
                     <label class="col-form-label" for="download_link"><?php $this->_ee("Download Link"); ?></label>

                     <div class="input-group input-group-sm">
                         <input  class="form-control form-control-sm " type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("download_link");?>" id="download_link" <?php echo in_array("download_link", $disabled)?' disabled="disabled" ':' name="download_link" ';?>     placeholder="<?php $this->_ee("Download Link");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Download Link");?>">
                         <div class="input-group-append">
                             <button class="btn btn-secondary apd-wp-image-chooser" data-file-type="application/zip" data-title="<?php $this->_e("Choose Update file") ; ?>" data-button="<?php $this->_e("Choose File") ; ?>" data-target="#download_link" type="button"><?php $this->_e("Choose Update File") ?></button>
                         </div>
                     </div>


                 </div>
	         <?php } ?>


			</div>

         <div class="form-row">
	         <?php if(!in_array("change_log",$except)){ ?>
                 <div class="form-group col-sm-12 col-lg">
                     <label class="col-form-label" for="change_log"><?php $this->_ee("Change Log"); ?></label>
                     <textarea class="form-control form-control-sm apd-wp-editor" maxlength=""    id="change_log" <?php echo in_array("change_log", $disabled)?' disabled="disabled" ':' name="change_log" ';?>     placeholder="<?php $this->_ee("Change Log");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Change Log");?>"><?php echo  $mainobj->GetPostValue("change_log");?></textarea>
                 </div>
	         <?php } ?>
			 <?php if(!in_array("update_des",$except)){ ?>
                 <div class="form-group col-sm-12 col-lg">
                     <label class="col-form-label" for="update_des"><?php $this->_ee("Update Description"); ?></label>
                     <textarea class="form-control form-control-sm apd-wp-editor" maxlength=""    id="update_des" <?php echo in_array("update_des", $disabled)?' disabled="disabled" ':' name="update_des" ';?>     placeholder="<?php $this->_ee("Update Des");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Update Description");?>"><?php echo  $mainobj->GetPostValue("update_des");?></textarea>
                 </div>
			 <?php } ?>
         </div>
        <div id="additional_section_container" class=" mt-2 mb-3">

        </div>
         <div class="fomr-row text-center ">
             <button id="add_aditional_section" type="button" class="btn btn-sm btn-secondary"> <i class="fa fa-plus"></i> <?php $this->_e("Add New Section") ?></button>
         </div>

         <script type="text/javascript">
             var additionalSection='<div class="card new-section mb-3">\n' +
                 '                <div class="card-header pt-1 pb-1">Additional Section <span class="remove-card close-section pull-right btn btn-sm">X</span></div>\n' +
                 '                <div class="card-body pt-0">\n' +
                 '                    <div class="form-row">\n' +
                 '                        <div class="form-group col-12">\n' +
                 '                            <label class="col-form-label sec-name-lbl" for="aditional_sections"><?php $this->_ee( "Section Name" ); ?></label>\n' +
                 '                            <input class="form-control form-control-sm sec-name" id="ad_sec_name_1" name=""/>\n' +
                 '                        </div>\n' +
                 '                        <div class="form-group col-12">\n' +
                 '                            <label class="col-form-label sec-body-lbl" for="aditional_sections"><?php $this->_ee( "Additional Sections" ); ?></label>\n' +
                 '                            <textarea class="form-control form-control-sm apd-wp-editor sec-body"    id="ad_sec_data_1" name=""></textarea>\n' +
                 '                        </div>\n' +
                 '                    </div>\n' +
                 '                </div>\n' +
                 '            </div>';

                 function APBD_addNewSection(name,body){
                    var container=jQuery("#additional_section_container");
                    var data=jQuery(additionalSection);
                    var counter=container.find('.new-section').length;
                    data.find('.sec-name').attr("id","ad_sec_name_"+counter).attr("name","ad_sec_data["+counter+"][name]").val(name);
                    data.find('.sec-name-lbl').attr("for","ad_sec_name_"+counter).val(body);
                    data.find('.sec-body').attr("id","ad_sec_data_"+counter).attr("name","ad_sec_data["+counter+"][data]").val(body);
                    data.find('.sec-body-lbl').attr("for","ad_sec_data_"+counter).val(body);
                    data.find('.close-section').on("click",function(){
                        data.fadeOut('fast',function(){
                            data.remove();
                        });
                    })
                    container.append(data);
                    APPSBDAPPJS.WPEditor.InitEditorControl("ad_sec_data_"+counter);
                 }
                 
                 jQuery( document ).ready(function( $ ) {
                     $("#add_aditional_section").on("click",function (e) {
                        e.preventDefault();
                         APBD_addNewSection('','');
                     });
                     <?php
                        $addtionalSections=$mainobj->decodeAdditionalSections();
                        if(!empty($addtionalSections)){
                            ?>
                            var initAdditionalSections=<?php echo json_encode($mainobj->decodeAdditionalSections()) ?>;
                            setTimeout(function(){
                                for(var i in initAdditionalSections){
                                    APBD_addNewSection(initAdditionalSections[i].name,initAdditionalSections[i].data);
                                }
                            },500);
                            <?php
                        }
                     ?>
                 });

         </script>
			<?php 
	}


}
?>