<?php 			
/** 
 * @since: 26/Feb/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,title,duration_type,duration,duration_in_hour,counter_limit,status		
 */						
class Mapbd_request_manage extends AppsBDModel{	
	public $id;
	public $title;
	public $duration_type;
	public $duration;
	public $duration_in_hour;
	public $counter_limit;
	public $status;


	    /**
	     *@property id,title,duration_type,duration,duration_in_hour,counter_limit,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_request_manage";
			$this->primaryKey="id";
			$this->uniqueKey=array();	
			$this->multiKey=array(array("status"));
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[2]|integer"),
			"title"=>array("Text"=>"Title", "Rule"=>"xss_clean|required|max_length[150]"),
			"duration_type"=>array("Text"=>"Duration Type", "Rule"=>"xss_clean|max_length[1]"),
			"duration"=>array("Text"=>"Duration", "Rule"=>"xss_clean|required|max_length[11]|numeric"),
			"duration_in_hour"=>array("Text"=>"Duration In Hour", "Rule"=>"xss_clean|max_length[12]|numeric"),
			"counter_limit"=>array("Text"=>"Counter Limit", "Rule"=>"xss_clean|max_length[2]|numeric"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|required|max_length[1]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "duration_type":        
	         $returnObj=array("H"=>"hour(s)","D"=>"day(s)","W"=>"week(s)","M"=>"month(s)","Y"=>"year(s)");
	         break;
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      case "duration_type":
	         $returnObj=array("H"=>"success","D"=>"success","W"=>"success","M"=>"success","Y"=>"success");
	         break;
	      default:
	    }       
        return $returnObj;
	
	}

	/*public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      case "duration_type":
	         $returnObj=array("H"=>"","D"=>"fa fa-clock-o","M"=>"","Y"=>"");
	         break;
	      default:
	    }
        return $returnObj;
	
	}		*/
    static  function DeleteById($id){
        return parent::DeleteByKeyValue("id",$id);
    }
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/

	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(2) unsigned NOT NULL AUTO_INCREMENT,
					  `title` char(150) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
					  `duration_type` char(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'D' COMMENT 'drop(H=Hour, D=Day,M=Month,Y=Year)',
					  `duration` decimal(11,0) unsigned NOT NULL,
					  `duration_in_hour` decimal(12,0) unsigned NOT NULL DEFAULT '0',
					  `counter_limit` decimal(2,0) unsigned NOT NULL DEFAULT '0',
					  `status` char(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'A' COMMENT 'bool(A=Active,I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE,
					  KEY `status` (`status`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	 function DropDBTable(){
		global $wpdb;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	static function getHourFromDuration( $type, $duration ) {
		$responseHour = 0;
		//(H=Hour, D=Day,M=Month,Y=Year)
		switch ( $type ) {
			case 'H':
				$responseHour = 1;
				break;
			case 'D':
				$responseHour = 24;
				break;
			case 'W':
				$responseHour = 168;
				break;
			case 'M':
				$responseHour = 730;
				break;
			case 'Y':
				$responseHour = 8760;
				break;
			default:
				$responseHour = 1;
		}
		
		return $responseHour * $duration;
	}
	
	static function getNextTime( $currentTime, $counter) {
		$currentTime=''.$currentTime;
		$obj = new self();
		if(empty($currentTime)){
			$obj->duration_in_hour( ' > 0', true );
        }else{
			$obj->duration_in_hour( ' >'.$currentTime, true );
        }
		$obj->status('A');
		if ( $obj->Select() ) {
			$strC=new stdClass();
			$strC->status=true;
			$strC->counter=$obj->counter_limit;
			$strC->duration_in_hour=$obj->duration_in_hour;
			return $strC;
		}
		$strC=new stdClass();
		$strC->status=false;
		$strC->counter=$counter;
		$strC->duration_in_hour=!empty($currentTime)?$currentTime:0;
		return $strC;
	}
	
	//auto generated
	function Save() {
		$hourtime = self::getHourFromDuration( $this->duration_type, $this->duration );
		$this->duration_in_hour( $hourtime );
		
		return parent::Save();
	}
	
	function Update( $notLimit = false, $isShowMsg = true, $dontProcessIdWhereNotset = true ) {
		if ( $this->IsSetPrperty( "duration" ) || $this->IsSetPrperty( "duration_type" ) ) {
			$dtype    = "";
			$duration = 0;
			if ( $this->IsSetPrperty( "duration_type" ) && $this->IsSetPrperty( "duration" ) ) {
				$dtype    = $this->duration_type;
				$duration = $this->duration;
			} else {
				$obj = new self();
				foreach ( $this->updateWhereExtraField as $ukey => $uvalue ) {
					if ( property_exists( $obj, $ukey ) ) {
						if ( in_array( $ukey, $this->updateWhereExtraFieldOption[ $ukey ] ) ) {
							$obj->{$ukey}( $ukey, $uvalue, true );
						} else {
							$obj->{$ukey}($uvalue );
						}
					}
				}
				if ( $obj->Select() ) {
					$dtype    = $this->IsSetPrperty( "duration_type" ) ? $this->duration_type : $obj->duration_type;
					$duration = $this->IsSetPrperty( "duration" ) ? $this->duration : $obj->duration;
				}
			}
			
			$hourtime = self::getHourFromDuration( $dtype, $duration );
			$this->duration_in_hour( $hourtime );
		}
		
		return parent::Update( $notLimit, $isShowMsg, $dontProcessIdWhereNotset );
	}
	
	
	/* end custom function */
	function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){

		if(!$mainobj){
			$mainobj=$this;
		}
		?>
        <div class="form-row">
	        <?php if(!in_array("title",$except)){ ?>
                <div class="form-group col-sm-4">
                    <label class="col-form-label" for="title"><?php $this->_ee("Title"); ?></label>
                    <input  class="form-control form-control-sm" type="text" maxlength="150"   value="<?php echo  $mainobj->GetPostValue("title");?>" id="title" <?php echo in_array("title", $disabled)?' disabled="disabled" ':' name="title" ';?>     placeholder="<?php $this->_ee("Title");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Title");?>">
			        
                </div>
	        <?php } ?>


			<?php if(!in_array("duration",$except)){ ?>
                <div class="form-group col-sm-3">
                    <label class="col-form-label" for="duration"><?php $this->_ee("Duration"); ?></label>
                    <div class="input-group input-group-sm">
                        <input  class="form-control text-center" type="text" maxlength="11"   value="<?php echo  $mainobj->GetPostValue("duration");?>" id="duration" <?php echo in_array("duration", $disabled)?' disabled="disabled" ':' name="duration" ';?>     placeholder="<?php $this->_ee("Duration");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Duration");?>">
                        <select   class="custom-select" id="duration_type" <?php echo in_array("duration_type", $disabled)?' disabled="disabled" ':' name="duration_type" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_ee("%s is required","Duration Type");?>">
                            <option value=""><?php $this->_e("Select"); ?></option>
		                    <?php $duration_type_selected= $mainobj->GetPostValue("duration_type","D");
		                    APBD_GetHTMLOptionByArray($mainobj->GetPropertyOptions("duration_type"),$duration_type_selected);
		                    ?>

                        </select>
                    </div>
					
                </div>
			<?php } ?>
	        <?php if(!in_array("counter_limit",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="counter_limit"><?php $this->_ee("Counter"); ?></label>
                    <input  class="form-control form-control-sm text-center" type="text" maxlength="2"   value="<?php echo  $mainobj->GetPostValue("counter_limit");?>" id="counter_limit" <?php echo in_array("counter_limit", $disabled)?' disabled="disabled" ':' name="counter_limit" ';?>     placeholder="<?php $this->_ee("Counter Limit");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Counter Limit");?>">
                    <span class="form-text text-muted app-tooltip" title="<?php $this->_ee("After this limit the server automatically setup the next request manage item data"); ?>"><?php $this->_ee("The limit of request. ");?> <i class="fa fa-exclamation-circle"></i></span>
                </div>
	        <?php } ?>
			<?php if(!in_array("status",$except)){ ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>

					<?php
					APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
					?>
                </div>
			<?php } ?>


        </div>
		<?php
	}


}
?>