<?php 			
/** 
 * @since: 16/Nov/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,dir_id,name,version,author,textdomain,is_theme,main_file,func_file,target_product,icon_type,icon,upload_time,has_own_menu		
 */						
class Mapbd_upload extends AppsBDModel {
	public $id;
	public $dir_id;
	public $name;
	public $version;
	public $author;
	public $textdomain;
	public $is_theme;
	public $main_file;
	public $func_file;
	public $target_product;
	public $icon_type;
	public $icon;
	public $upload_time;
	public $has_own_menu;
	
	
	/**
	 * @property id,dir_id,name,version,author,textdomain,is_theme,main_file,func_file,target_product,icon_type,icon,upload_time,has_own_menu
	 */
	function __construct() {
		parent::__construct();
		$this->SetValidation();
		$this->tableName     = "apbd_upload";
		$this->primaryKey    = "id";
		$this->uniqueKey     = array();
		$this->multiKey      = array();
		$this->autoIncField  = array( "id" );
		$this->app_base_name = "APBLIC";
		
	}
	
	
	function SetValidation() {
		$this->validations = array(
			"id"             => array( "Text" => "Id", "Rule" => "xss_clean|max_length[10]|integer" ),
			"dir_id"         => array( "Text" => "Dir Id", "Rule" => "xss_clean|required|max_length[8]" ),
			"name"           => array( "Text" => "Name", "Rule" => "xss_clean|required|max_length[255]" ),
			"version"        => array( "Text" => "Version", "Rule" => "xss_clean|required|max_length[255]" ),
			"author"         => array( "Text" => "Author", "Rule" => "xss_clean|required|max_length[255]" ),
			"textdomain"     => array( "Text" => "Textdomain", "Rule" => "xss_clean|max_length[255]" ),
			"is_theme"       => array( "Text" => "Is Theme", "Rule" => "xss_clean|max_length[255]" ),
			"main_file"      => array( "Text" => "Main File", "Rule" => "xss_clean|required|max_length[255]" ),
			"func_file"      => array( "Text" => "Func File", "Rule" => "xss_clean|required|max_length[255]" ),
			"target_product" => array( "Text" => "Target Product", "Rule" => "xss_clean|max_length[10]|integer" ),
			"icon_type"      => array( "Text" => "Icon Type", "Rule" => "xss_clean|max_length[1]" ),
			"icon"           => array( "Text" => "Icon", "Rule" => "xss_clean|required|max_length[255]" ),
			"upload_time"    => array( "Text" => "Upload Time", "Rule" => "xss_clean|max_length[20]" ),
			"has_own_menu"   => array( "Text" => "Has Own Menu", "Rule" => "xss_clean|max_length[1]" )
		
		);
	}
	
	public function GetPropertyRawOptions( $property, $isWithSelect = false ) {
		$returnObj = array();
		switch ( $property ) {
			case "is_theme":
				$returnObj = array( "Y" => "Yes", "N" => "No" );
				break;
			case "icon_type":
				$returnObj = array( "I" => "Icon", "F" => "File" );
				break;
			case "has_own_menu":
				$returnObj = array( "Y" => "Yes", "N" => "No" );
				break;
			default:
		}
		if ( $isWithSelect ) {
			return array_merge( array( "" => "Select" ), $returnObj );
		}
		
		return $returnObj;
		
	}
	
	public function GetPropertyOptionsColor( $property ) {
		$returnObj = array();
		switch ( $property ) {
			case "icon_type":
				$returnObj = array( "I" => "danger", "F" => "danger" );
				break;
			default:
		}
		
		return $returnObj;
		
	}
	
	public function GetPropertyOptionsIcon( $property ) {
		$returnObj = array();
		switch ( $property ) {
			case "icon_type":
				$returnObj = array( "I" => "fa fa-star", "F" => "fa fa-file" );
				break;
			default:
		}
		
		return $returnObj;
		
	}
	
	//auto generated
	/*function Save(){
		return parent::Save();
	}*/
	
	
	static function CreateDBTable() {
		$thisObj = new static();
		$table   = $thisObj->db->prefix . $thisObj->tableName;
		if ( $thisObj->db->get_var( "show tables like '{$table}'" ) != $table ) {
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `dir_id` char(8) NOT NULL DEFAULT '',
					  `name` varchar(255) NOT NULL DEFAULT '',
					  `version` varchar(255) NOT NULL DEFAULT '',
					  `author` varchar(255) NOT NULL DEFAULT '',
					  `textdomain` varchar(255) NOT NULL DEFAULT '',
					  `is_theme` char(255) NOT NULL DEFAULT 'Y' COMMENT 'bool(Y=Yes,N=No)',
					  `main_file` varchar(255) NOT NULL DEFAULT '',
					  `func_file` varchar(255) NOT NULL DEFAULT '',
					  `target_product` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK(product,id)',
					  `icon_type` char(1) NOT NULL DEFAULT 'I' COMMENT 'radio(I=Icon,F=File)',
					  `icon` varchar(255) NOT NULL,
					  `upload_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  `has_own_menu` char(1) NOT NULL DEFAULT 'N' COMMENT 'bool(Y=Yes,N=No)',
					  PRIMARY KEY (`id`)
					) ";
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
			dbDelta( $sql );
		}
	}
	
	function DropDBTable() {
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	}
	
	/* add custom function here*/
	static function DeleteByID( $id ) {
		return parent::DeleteByKeyValue("id",$id);
	}
	
	/* end custom function */
	function GetAddForm( $label_col = 5, $input_col = 7, $mainobj = NULL, $except = array(), $disabled = array() ) {
		
		if ( ! $mainobj ) {
			$mainobj = $this;
		}
		?>
        <div class="form-row">
			<?php /*if(!in_array("id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="id"><?php $this->_ee("Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("id");?>" id="id" <?php echo in_array("id", $disabled)?' disabled="disabled" ':' name="id" ';?>     placeholder="<?php $this->_ee("Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Id");?>">
			     				      	
		      </div> 
		     <?php } */
			?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "dir_id", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="dir_id"><?php $this->_ee( "Dir Id" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="8"
                           value="<?php echo $mainobj->GetPostValue( "dir_id" ); ?>"
                           id="dir_id" <?php echo in_array( "dir_id", $disabled ) ? ' disabled="disabled" ' : ' name="dir_id" '; ?>
                           placeholder="<?php $this->_ee( "Dir Id" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Dir Id" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("dir_id");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "name", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="name"><?php $this->_ee( "Name" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "name" ); ?>"
                           id="name" <?php echo in_array( "name", $disabled ) ? ' disabled="disabled" ' : ' name="name" '; ?>
                           placeholder="<?php $this->_ee( "Name" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Name" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("name");?></span>	*/ ?>
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "version", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="version"><?php $this->_ee( "Version" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "version" ); ?>"
                           id="version" <?php echo in_array( "version", $disabled ) ? ' disabled="disabled" ' : ' name="version" '; ?>
                           placeholder="<?php $this->_ee( "Version" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Version" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("version");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "author", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="author"><?php $this->_ee( "Author" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "author" ); ?>"
                           id="author" <?php echo in_array( "author", $disabled ) ? ' disabled="disabled" ' : ' name="author" '; ?>
                           placeholder="<?php $this->_ee( "Author" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Author" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("author");?></span>	*/ ?>
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "textdomain", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="textdomain"><?php $this->_ee( "Textdomain" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "textdomain" ); ?>"
                           id="textdomain" <?php echo in_array( "textdomain", $disabled ) ? ' disabled="disabled" ' : ' name="textdomain" '; ?>
                           placeholder="<?php $this->_ee( "Textdomain" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Textdomain" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("textdomain");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "is_theme", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="is_theme"><?php $this->_ee( "Is Theme" ); ?></label>
					
					<?php
						APBD_GetHTMLSwitchButton( "is_theme", "is_theme", "N", "Y", $mainobj->GetPostValue( "is_theme" ) );
					?>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("is_theme");?></span>	*/ ?>


                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "main_file", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="main_file"><?php $this->_ee( "Main File" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "main_file" ); ?>"
                           id="main_file" <?php echo in_array( "main_file", $disabled ) ? ' disabled="disabled" ' : ' name="main_file" '; ?>
                           placeholder="<?php $this->_ee( "Main File" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Main File" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("main_file");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "func_file", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="func_file"><?php $this->_ee( "Func File" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "func_file" ); ?>"
                           id="func_file" <?php echo in_array( "func_file", $disabled ) ? ' disabled="disabled" ' : ' name="func_file" '; ?>
                           placeholder="<?php $this->_ee( "Func File" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Func File" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("func_file");?></span>	*/ ?>
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "target_product", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="target_product"><?php $this->_ee( "Target Product" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="10"
                           value="<?php echo $mainobj->GetPostValue( "target_product" ); ?>"
                           id="target_product" <?php echo in_array( "target_product", $disabled ) ? ' disabled="disabled" ' : ' name="target_product" '; ?>
                           placeholder="<?php $this->_ee( "Target Product" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Target Product" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("target_product");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "icon_type", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="icon_type"><?php $this->_ee( "Icon Type" ); ?></label>
                    <div class="form-row">
						<?php
							$icon_type_selected   = $mainobj->GetPostValue( "icon_type", "I" );
							$icon_type_isDisabled = in_array( "icon_type", $disabled );
							APBD_GetHTMLRadioByArray( "Icon Type", "icon_type", "icon_type", true, $mainobj->GetPropertyOptions( "icon_type" ), $icon_type_selected, $icon_type_isDisabled );
						?>
						<?php /*<span class="form-text text-muted"><?php $this->_ee("icon_type");?></span>	*/ ?>
                    </div>
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "icon", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="icon"><?php $this->_ee( "Icon" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="255"
                           value="<?php echo $mainobj->GetPostValue( "icon" ); ?>"
                           id="icon" <?php echo in_array( "icon", $disabled ) ? ' disabled="disabled" ' : ' name="icon" '; ?>
                           placeholder="<?php $this->_ee( "Icon" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Icon" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("icon");?></span>	*/ ?>
                </div>
			<?php } ?>
			
			<?php if ( ! in_array( "upload_time", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="upload_time"><?php $this->_ee( "Upload Time" ); ?></label>
                    <input class="form-control form-control-sm" type="text" maxlength="20"
                           value="<?php echo $mainobj->GetPostValue( "upload_time" ); ?>"
                           id="upload_time" <?php echo in_array( "upload_time", $disabled ) ? ' disabled="disabled" ' : ' name="upload_time" '; ?>
                           placeholder="<?php $this->_ee( "Upload Time" ); ?>" data-bv-notempty="true"
                           data-bv-notempty-message="<?php $this->_ee( "%s is required", "Upload Time" ); ?>">
					<?php /*<span class="form-text text-muted"><?php $this->_ee("upload_time");?></span>	*/ ?>
                </div>
			<?php } ?>
        </div>
        <div class="form-row">
			<?php if ( ! in_array( "has_own_menu", $except ) ) { ?>
                <div class="form-group col-sm">
                    <label class="col-form-label" for="has_own_menu"><?php $this->_ee( " Own Menu" ); ?></label>
					
					<?php
						APBD_GetHTMLSwitchButton( "has_own_menu", "has_own_menu", "N", "Y", $mainobj->GetPostValue( "has_own_menu" ) );
					?>
					<?php /*<span class="form-text text-muted"><?php $this->_ee("has_own_menu");?></span>	*/ ?>


                </div>
			<?php } ?>

        </div>
		<?php
	}
	
	
}
?>