<?php 			
/** 
 * @since: 08/Apr/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,product_id,purchase_key,full_domain,used_domain,server_ip,status,version,entry_time		
 */						
class Mapbd_useddomain extends AppsBDModel{	
	public $id;
	public $product_id;
	public $purchase_key;
	public $full_domain;
	public $used_domain;
	public $server_ip;
	public $status;
	public $version;
	public $entry_time;


	    /**
	     *@property id,product_id,purchase_key,full_domain,used_domain,server_ip,status,version,entry_time
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_useddomain";
			$this->primaryKey="id";
			$this->uniqueKey=array(array("purchase_key","used_domain"));	
			$this->multiKey=array();
			$this->autoIncField=array("id");
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"xss_clean|max_length[10]|integer"),
			"product_id"=>array("Text"=>"Product Id", "Rule"=>"xss_clean|max_length[10]|integer"),
			"purchase_key"=>array("Text"=>"Purchase Key", "Rule"=>"xss_clean|required|max_length[50]"),
			"full_domain"=>array("Text"=>"Full Domain", "Rule"=>"xss_clean|max_length[255]"),
			"used_domain"=>array("Text"=>"Used Domain", "Rule"=>"xss_clean|max_length[200]"),
			"server_ip"=>array("Text"=>"Server Ip", "Rule"=>"xss_clean|required|max_length[64]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
			"version"=>array("Text"=>"Version", "Rule"=>"xss_clean|max_length[10]"),
			"entry_time"=>array("Text"=>"Entry Time", "Rule"=>"xss_clean|max_length[20]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "status":        
	         $returnObj=array("I"=>"Initial Install","A"=>"Active","D"=>"Deny Domain","W"=>"Waiting for Approval","R"=>"Removed Form Domain");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      case "status":
	         $returnObj=array("I"=>"danger","A"=>"success","D"=>"danger","W"=>"success","R"=>"danger");
	         break;
	      default:
	    }       
        return $returnObj;
	
	}

	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      case "status":
	         $returnObj=array("I"=>"fa fa-times-circle-o","A"=>"fa fa-check-circle-o","D"=>"fa fa-times-circle-o","W"=>"","R"=>"fa fa-times-circle-");
	         break;
	      default:
	    }
        return $returnObj;
	
	}		
	    	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/
	
	
	static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `product_id` int(10) DEFAULT NULL,
					  `purchase_key` char(50) NOT NULL,
					  `full_domain` char(255) NOT NULL,
					  `used_domain` char(200) NOT NULL,
					  `server_ip` char(64) NOT NULL DEFAULT '',
					  `status` char(1) NOT NULL DEFAULT 'I' COMMENT 'drop(I=Initial Install,A=Approve Domain,D=Deny Domain, W= Waiting for Approval,R=Removed Form Domain)',
					  `version` char(10) NOT NULL DEFAULT '',
					  `entry_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
					  PRIMARY KEY (`id`) USING BTREE,
					  UNIQUE KEY `purchase_key` (`purchase_key`,`used_domain`) USING BTREE
					) ";
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	}
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	static function CountAllByKey($product_id,$purchase_key){
		$obj=new self();
		$obj->product_id($product_id);
		$obj->purchase_key($purchase_key);
		$obj->status("in ('A','W')", true);
		return $obj->CountALL();
	}
	static function Add($product_id,$purchase_key,$domain,$full_domain,$server_id,$version,$status,&$addObject=null){
		$addObject=new self();
		$addObject->product_id($product_id);
		$addObject->purchase_key($purchase_key);
		$addObject->server_ip($server_id);
		$addObject->used_domain($domain);
		$addObject->full_domain($full_domain);
		$addObject->status($status);
		$addObject->version($version);
		return $addObject->Save();
		
	}
	static function DeleteByPurchaseKey($purchase_key,$domainName){
	    return parent::DeleteByKeyValue("purchase_key",$purchase_key,false,["used_domain"=>$domainName]);
    }
	static function DeleteByID($id){
		return parent::DeleteByKeyValue("id",$id);
	}
	
    static function DeleteDomainById($id){
	    $mr=new Mapbd_useddomain();
	    $mr->id($id);
	    if($mr->Select()){
	        //select product
            $product=Mapbd_product::FindBy("id",$mr->product_id);
            if($product){
                //remove from user domain
                Mapbd_license::RemoveLicenseFromDomain($product->id,$product->enc_key,$mr->full_domain);
            }
            if(self::DeleteByKeyValue("id",$id)){
                return true;
            }
	    }
	    return false;
    }
	static function AcceptDomainById($id){
		$mr=new self();
		$mr->id($id);
		if($mr->Select()){
			if($mr->status=="A"){
			    return true;
            }
			$uo=new self();
			$uo->status("A");
			$uo->SetWhereUpdate("id",$id);
			return $uo->Update();
		}
		return false;
	}
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
					?>
			<div class="form-row">
			<?php /*if(!in_array("id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="id"><?php $this->_ee("Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("id");?>" id="id" <?php echo in_array("id", $disabled)?' disabled="disabled" ':' name="id" ';?>     placeholder="<?php $this->_ee("Id");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Id");?>">
			     				      	
		      </div> 
		     <?php } */?>
			</div>
			<div class="form-row">
			<?php if(!in_array("product_id",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="product_id"><?php $this->_ee("Product Id"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="10"   value="<?php echo  $mainobj->GetPostValue("product_id");?>" id="product_id" <?php echo in_array("product_id", $disabled)?' disabled="disabled" ':' name="product_id" ';?>     placeholder="<?php $this->_ee("Product Id");?>" >
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("product_id");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("purchase_key",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="purchase_key"><?php $this->_ee("Purchase Key"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("purchase_key");?>" id="purchase_key" <?php echo in_array("purchase_key", $disabled)?' disabled="disabled" ':' name="purchase_key" ';?>     placeholder="<?php $this->_ee("Purchase Key");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Purchase Key");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("purchase_key");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("full_domain",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="full_domain"><?php $this->_ee("Full Domain"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="255"   value="<?php echo  $mainobj->GetPostValue("full_domain");?>" id="full_domain" <?php echo in_array("full_domain", $disabled)?' disabled="disabled" ':' name="full_domain" ';?>     placeholder="<?php $this->_ee("Full Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Full Domain");?>">
			     		
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("used_domain",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="used_domain"><?php $this->_ee("Used Domain"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="200"   value="<?php echo  $mainobj->GetPostValue("used_domain");?>" id="used_domain" <?php echo in_array("used_domain", $disabled)?' disabled="disabled" ':' name="used_domain" ';?>     placeholder="<?php $this->_ee("Used Domain");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Used Domain");?>">
			     		
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("server_ip",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="server_ip"><?php $this->_ee("Server Ip"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="15"   value="<?php echo  $mainobj->GetPostValue("server_ip");?>" id="server_ip" <?php echo in_array("server_ip", $disabled)?' disabled="disabled" ':' name="server_ip" ';?>     placeholder="<?php $this->_ee("Server Ip");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Server Ip");?>">
			     	 
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("status",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
		      	 <select   class="custom-select form-control-sm" id="status" <?php echo in_array("status", $disabled)?' disabled="disabled" ':' name="status" ';?>      data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_ee("%s is required","Status");?>">
			        <option value=""><?php $this->_e("Select"); ?></option>
			        <?php $status_selected= $mainobj->GetPostValue("status","I");
			            APBD_GetHTMLOptionByArray($mainobj->GetPropertyOptions("status"),$status_selected);
			            ?>
			        
			        </select>
			        
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("version",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="version"><?php $this->_ee("Version"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="6"   value="<?php echo  $mainobj->GetPostValue("version");?>" id="version" <?php echo in_array("version", $disabled)?' disabled="disabled" ':' name="version" ';?>     placeholder="<?php $this->_ee("Version");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Version");?>">
			     	 
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("entry_time",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="entry_time"><?php $this->_ee("Entry Time"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("entry_time");?>" id="entry_time" <?php echo in_array("entry_time", $disabled)?' disabled="disabled" ':' name="entry_time" ';?>     placeholder="<?php $this->_ee("Entry Time");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Entry Time");?>">
			     	 
		      </div> 
		     <?php } ?>
			
			</div>
			<?php 
	}


}
?>