<?php 			
/** 
 * @since: 03/Nov/2020
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:id,title,url,private_key,is_on_client,is_on_license,status		
 */						
class Mapbd_webhook extends AppsBDModel{	
	public $id;
	public $title;
	public $url;
	public $private_key;
	public $is_on_client;
	public $is_on_license;
	public $status;


	    /**
	     *@property id,title,url,private_key,is_on_client,is_on_license,status
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_webhook";
			$this->primaryKey="id";
			$this->uniqueKey=array();	
			$this->multiKey=array();
			$this->autoIncField=array("id");	
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[11]|integer"),
			"title"=>array("Text"=>"Title", "Rule"=>"max_length[100]"),
			"url"=>array("Text"=>"Url", "Rule"=>"max_length[225]"),
			"private_key"=>array("Text"=>"Private Key", "Rule"=>"max_length[150]"),
			"is_on_client"=>array("Text"=>"Is On Client", "Rule"=>"max_length[1]"),
			"is_on_license"=>array("Text"=>"Is On License", "Rule"=>"max_length[1]"),
			"status"=>array("Text"=>"Status", "Rule"=>"required|max_length[1]")
			
		);
	}

	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      case "is_on_client":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      case "is_on_license":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      case "status":        
	         $returnObj=array("A"=>"Active","I"=>"Inactive");
	         break;
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}

    /*
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }       
        return $returnObj;
	
	}
    */
	   

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	   		
	    	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/
			

	 static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;			
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
					  `title` char(100) NOT NULL DEFAULT '',
					  `url` char(225) NOT NULL DEFAULT '' COMMENT 'textarea',
					  `private_key` char(150) NOT NULL DEFAULT '',
					  `is_on_client` char(1) NOT NULL DEFAULT '' COMMENT 'bool(A=Active, I=Inactive)',
					  `is_on_license` char(1) NOT NULL DEFAULT '' COMMENT 'bool(A=Active, I=Inactive)',
					  `status` char(1) NOT NULL COMMENT 'bool(A=Active, I=Inactive)',
					  PRIMARY KEY (`id`) USING BTREE
					) ";				 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	 }
	 function DropDBTable(){
		global $wpdb;
		
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
					?>
			
			<div class="form-row">
			<?php if(!in_array("title",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="title"><?php $this->_ee("Title"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="100"   value="<?php echo  $mainobj->GetPostValue("title");?>" id="title" <?php echo in_array("title", $disabled)?' disabled="disabled" ':' name="title" ';?>     placeholder="<?php $this->_ee("Title");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Title");?>">
			     		<?php /*<span class="form-text text-muted"><?php $this->_ee("title");?></span>	*/?>		      	
		      </div> 
		     <?php } ?>
				<?php if(!in_array("private_key",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="private_key"><?php $this->_ee("Private Key"); ?></label>
                        <input  class="form-control form-control-sm" type="text" maxlength="150"   value="<?php echo  $mainobj->GetPostValue("private_key");?>" id="private_key" <?php echo in_array("private_key", $disabled)?' disabled="disabled" ':' name="private_key" ';?>     placeholder="<?php $this->_ee("Private Key");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Private Key");?>">
						<?php /*<span class="form-text text-muted"><?php $this->_ee("private_key");?></span>	*/?>
                    </div>
				<?php } ?>
				<?php if(!in_array("status",$except)){ ?>
                    <div class="form-group col-sm-2">
                        <label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
						
						<?php
							APBD_GetHTMLSwitchButton("status","status","I","A",$mainobj->GetPostValue("status"));
						?>
						<?php /*<span class="form-text text-muted"><?php $this->_ee("status");?></span>	*/?>


                    </div>
				<?php } ?>
			</div>
			<div class="form-row">
				<?php if(!in_array("url",$except)){ ?>
                    <div class="form-group col-sm">
                        <label class="col-form-label" for="url"><?php $this->_ee("Remote URL"); ?></label>
                        <input class="form-control form-control-sm" type="url" maxlength="225"    id="url" <?php echo in_array("url", $disabled)?' disabled="disabled" ':' name="url" ';?>     placeholder="<?php $this->_ee("Url");?>" data-bv-notempty="true" value="<?php echo  $mainobj->GetPostValue("url");?>"	data-bv-notempty-message="<?php   $this->_ee("%s is required","Url");?>"/>
                    </div>
				<?php } ?>
			
			
			</div>
          
                <h3 class="mt-3"><?php $this->_e("Events:") ; ?></h3>
            
			<div class="form-row ">
				<?php if(!in_array("is_on_client",$except)){ ?>
                    <div class="form-group col-sm">
                        <div class="input-group input-group-sm">
                            <div class="input-group-prepend app-p-title">
                                <label for="is_on_client" class="input-group-text col-form-label"><?php $this->_ee("On Client Creation"); ?></label>
                            </div>
                            <div class="form-control form-control-sm col col-sm">
								<?php
									APBD_GetHTMLSwitchButton("is_on_client","is_on_client","I","A",$mainobj->GetPostValue("is_on_client"));
								?>
                            </div>

                        </div>

                    </div>
				<?php } ?>
				<?php if(!in_array("is_on_license",$except)){ ?>
                    <div class="form-group col-sm">
                        <div class="input-group input-group-sm">
                            <div class="input-group-prepend app-p-title">
                                <label for="is_on_license" class="input-group-text col-form-label"><?php $this->_ee("On License Creation"); ?></label>
                            </div>
                            <div class="form-control form-control-sm col col-sm">
								<?php
									APBD_GetHTMLSwitchButton("is_on_license","is_on_license","I","A",$mainobj->GetPostValue("is_on_license"));
								?>
                            </div>

                        </div>

                    </div>
				<?php } ?>
			</div>
			<?php 
	}


}
?>