<?php
//Elite Licenser
class APBDDragDrop extends AppsBDBaseModule {
	public $uploadBasePath;
	function initialize() {
		parent::initialize();
		
		$this->disableDefaultForm();
		$this->uploadBasePath= wp_upload_dir()['basedir']."/elitedd/";
		if(!is_dir($this->uploadBasePath)){
			$this->createBaseFolder();
		}
		if(!is_dir($this->uploadBasePath."products")){
			wp_mkdir_p($this->uploadBasePath."products");
		}
		if(!is_dir($this->uploadBasePath."tmp")){
			wp_mkdir_p($this->uploadBasePath."tmp");
		}
		//$this->setDisabledMenu();
		$this->AddAjaxAction("choose-product",[$this,"choose_product"]);
		$this->AddAjaxAction("view",[$this,"product_details"]);
		$this->AddAjaxAction("download",[$this,"product_download"]);
		$this->AddAjaxAction("delete_item",[$this,"delete_item"]);
	}
	function createBaseFolder(){
		wp_mkdir_p($this->uploadBasePath);
		file_put_contents($this->uploadBasePath."/.htaccess",
'<IfModule authz_core_module>
    Require all denied
</IfModule>
<IfModule !authz_core_module>
    Deny from all
</IfModule>
			');
	}
	function OptionForm() {
		$this->SetTitle( "Wordpress Auto Licnese Integration" );
		$this->SetSubtitle( "WP Dragdrop Licensing" );
		
		
		$this->Display();
	}
	function GetMenuTitle() {
		return $this->__( "Wordpress Auto License Integration" );
	}
	
	function GetMenuSubTitle() {
		return '';//$this->__( "View All Add-ons" );
	}
	function GetMenuIcon() {
		return "ap ap-wp-drop";
	}
	public function GetMenuCounter() {
		return '<span class=" apbd-tab-counter badge badge-danger animated ani-count-3 delay-1s slower flash">'.$this->__("New").'</span>';
	}
	function data(){
		$mainResponse = new AppsbdAjaxDataResponse();
		$mainResponse->setDownloadFileName("apbd-upload-list");
		$mainobj=new Mapbd_upload();
		$mainResponse->setDateRange($mainobj);
		$records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
		if($records>0){
			$mainResponse->SetGridRecords($records);
			//$mainResponse->setOrderByIfEmpty("id","DESC");
			//wp_apbd_upload:id,name,version,author,textdomain,is_theme,main_file,func_file,target_product,icon_type,icon
			$result=$mainobj->SelectAllGridData("id,name,version,author,textdomain,is_theme,dir_id,upload_time,target_product", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
			if($result){
				
				$is_theme_change=$mainobj->GetPropertyOptionsTag("is_theme");
				$icon_type_options=$mainobj->GetPropertyOptionsTag("icon_type");
				$products=Mapbd_product::FetchAllKeyValue("id","product_name");
				foreach ($result as &$data){
					$data->action="";
					
					$isFileExists=file_exists($this->uploadBasePath."products/".$data->dir_id."/code.elite");
					if($isFileExists) {
						$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-success btn-xs' href='" .$this->GetActionUrl("view",["id"=>$data->id])."'><i class='fa fa-download'></i> ".$this->__("View & Download")."</a>";
						//$data->action .= "<a data-effect='mfp-move-from-top' target='_blank' class='apbd-download btn btn-success btn-xs' href='" . $this->GetActionUrl( "download", [ "id" => $data->id ] ) . "'> <i class='fa fa-download'></i> " . $this->__( "Download" ) . "</a>";
					}else{
						$data->action.="<span class='text-danger'>".$this->__("File Missing")."</span> ";
					}
					$data->action .= " <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_draddrop_type_reload' data-msg='" . $this->__( "Are you sure to delete?" ) . "' href='" . $this->GetActionUrl( "delete_item", [ "id" => $data->id ] ) . "'><i class='fa fa-trash'></i>  " . $this->__( "Delete" ) . "</a>";
					$data->is_theme=$data->is_theme=="Y"?$this->__("Theme"):$this->__("Plugin");
					$data->upload_time=APBD_getWPDateTimeWithFormat($data->upload_time);
					$data->target_product=APBD_getTextByKey($data->target_product,$products);
					if(strtoupper($data->name)==strtoupper($data->target_product)){
						$data->target_product="<span class='app-tooltip ' title='".$this->__("Match with uploaded product")."' ><i  class=' fa v-align-n4 fa-2x fa-check-circle text-success'></i> ".$data->target_product.'</span>';
					}else{
						$data->target_product="<span class='app-tooltip ' title='".$this->__("Do not match with uploaded product name")."' ><i  class='animated v-align-n4 faa-pulse fa fa-2x fa-exclamation-circle text-danger'></i> ".$data->target_product.'</span>';
					}
					$data->name.=" (".$data->version.")";
					
					//$data->icon_type=APBD_getTextByKey($data->icon_type,$icon_type_options);
					
				}
			}
			$mainResponse->SetGridData($result);
		}
		$mainResponse->DisplayGridResponse();
	}
	
	function delete_item(){
		WP_Filesystem();
		global $wp_filesystem;
		$param = APBD_GetValue( "id" );
		$mainResponse = new AppsbdAjaxConfirmResponse();
		if(empty($param)){
			$mainResponse->DisplayWithResponse(false, __("Invalid Request"));
			return;
		}
		$mr=new Mapbd_upload();
		$mr->id($param);
		if($mr->Select()){
			//$ur=new Mapbd_upload();
			
			if(Mapbd_upload::DeleteByID($param)){
				APBD_AddLog("D","id={$param}", "l003","Wp_apbd_upload_confirm");
				
				if(is_dir($this->uploadBasePath."products/".$mr->dir_id)) {
					$wp_filesystem->delete( $this->uploadBasePath . "products/" . $mr->dir_id, true );
				}
				$mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
			}else{
				$mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
			}
		}
	}
	function choose_product() {
		
		$this->SetTitle( "Choose product to add license code" );
		$this->SetPOPUPColClass( "col-sm-11" );
		$mainObj = new Mapbd_product();
		if ( APPSBD_IsPostBack ) {
			if($this->kernelObject->isDemoMode()){
				$this->AddError("This feature has been disabled in demo mode");
			}else{
				$productId=APBD_PostValue("product_id","");
				$has_own_menu=APBD_PostValue("has_own_menu","N");
				$icon_type=APBD_PostValue("icon_type","I");
				$icon="";
				$isOk=true;
				$destinationZip="";
				if(empty($productId)){
					$isOk = false;
					$this->AddError( "Product is required" );
				}
				if(empty($icon_type)){
					$isOk = false;
					$this->AddError( "Icon type is required" );
				}
				if($isOk && !empty($_FILES['plgFile']['name']) && empty($_FILES['plgFile']['error'])) {
					$destinationZip = $this->uploadBasePath . "tmp/" . $_FILES['plgFile']['name'];
					if ( file_exists( $destinationZip ) ) {
						unlink( $destinationZip );
					}
					if ( move_uploaded_file( $_FILES['plgFile']['tmp_name'],$destinationZip ) ) {
						if($icon_type=="F") {
							if(!empty($_FILES['icon_file']['name']) && empty($_FILES['icon_file']['error'])) {
								$icon = $this->uploadBasePath . "tmp/" . $_FILES['icon_file']['name'];
								if ( !move_uploaded_file( $_FILES['icon_file']['tmp_name'], $icon ) ) {
									$isOk=false;
									$this->AddError("Icon process failed");
								}
							}else{
								$isOk=false;
								$this->AddError("Icon upload failed try again");
							}
						}else{
							$icon=APBD_PostValue("icon_class","");
						}
					}else{
						$isOk=false;
						$this->AddError("Product file upload failed try again");
					}
					
				}
				if($isOk){
					$project=new Mapbd_dropdown();
					$project->setUploadBasePath($this->uploadBasePath);
					$responseObj=null;
					$instruction=APBD_PostValue("instruction","");
					if($project->processLicensing($destinationZip,$productId,$icon,$icon_type,$has_own_menu,$instruction,$responseObj)){
						$this->RedirectActionUrl("view",["id"=>$responseObj->id,"reld"=>1]);
						return;
					}else{
						if(file_exists($destinationZip)) {
							unlink( $destinationZip );
						}
						if($icon_type=="F" && file_exists($icon)) {
							unlink( $icon );
						}
						
					}
				}
			}//demo end
			
			
		}
		if(!$this->kernelObject->isDemoMode()) {
			$this->setIsMultipartForm( true );
		}
		$this->AddViewData( "isUpdateMode", false );
		$this->AddViewData( "mainObj", $mainObj );
		$this->DisplayPOPUp( "choose_product" );
		
	}
	function product_details(){
		$this->SetPOPUPColClass ( "col-sm-10" );
		
		$param_id=APBD_GetValue("id");
		if(empty($param_id)){
			$this->AddError("Invalid request");
			$this->DisplayPOPUPMsg();
			return;
		}
		$this->SetTitle("Product Details");
	
		$mainobj=new Mapbd_upload();
		$mainobj->id($param_id);
		if(!$mainobj->Select()){
			$this->AddError("Invalid request");
			$this->DisplayPOPUPMsg();
			return;
		}
		//APBD_OldFields($mainobj, "dir_id,name,version,author,textdomain,is_theme,main_file,func_file,target_product,icon_type,icon,upload_time,has_own_menu");
		//$this->SetPopupFromMutipart();
		$this->AddViewData("mainobj", $mainobj);
		$this->DisplayPOPUP("view");
	}
	function product_download() {
		$isEncrypted=!empty($_GET['enc'])?$_GET['enc']:"N";
		
		$param_id = APBD_GetValue( "id" );
		if ( empty( $param_id ) ) {
			die( "Invalid request" );
			
			return;
		}
		$mainobj = new Mapbd_upload();
		$mainobj->id( $param_id );
		if ( ! $mainobj->Select() ) {
			die( "Invalid request" );
			
			return;
		}
		
		$dirpath = $this->uploadBasePath."products/" . $mainobj->dir_id;
		$isOk    = true;
		if($isEncrypted=="N") {
			if ( ! file_exists( $dirpath . "/output.zip" ) ) {
				$isOk    = false;
				$project = new Mapbd_dropdown();
				$project->setUploadBasePath( $this->uploadBasePath );
				$responseObj = NULL;
				if ( $project->makeZip( $mainobj->dir_id ) ) {
					$isOk = true;
				}
			}
			if($isOk) {
				$targetfilename=realpath($dirpath . "/output.zip" );
				$dlname=str_replace([" ","."],"_",$mainobj->name."_v".$mainobj->version."_licensed").".zip";
				header( 'Content-type: application/zip' );
				header( 'Content-Disposition: attachment; filename="' .$dlname );
				readfile( $targetfilename );
			}
		}else{
			if ( ! file_exists( $dirpath . "/encrypted.zip" ) ) {
				$isOk    = false;
				$project = new Mapbd_dropdown();
				$project->setUploadBasePath( $this->uploadBasePath );
				$responseObj = NULL;
				if ( $project->makeZip( $mainobj->dir_id,true ) ) {
					$isOk = true;
				}
			}
			if($isOk) {
				$targetfilename=realpath($dirpath . "/encrypted.zip" );
				$dlname=str_replace([" ","."],"_",$mainobj->name."_v".$mainobj->version."_licensed_encrypted").".zip";
				header( 'Content-type: application/zip' );
				header( 'Content-Disposition: attachment; filename="' .$dlname );
				readfile( $targetfilename );
			}
		}
		
		
		exit;
		
	}
}