<?php
//Elite Licenser
class APBDELAddons extends AppsBDBaseModule {
	
	
	public $addonPath;
	
	function initialize() {
		parent::initialize();
		$this->disableDefaultForm();
		//$this->setDisabledMenu();
		$this->addonPath = realpath( $this->_base_path . "data/json_data/addons.json" );
		$this->AddAjaxAction("active-plugin",[$this,"ActivePlugin"]);
		$this->checkNewAddons();
	}
	function checkNewAddons(){
		$lastCheck=get_option("el_addon_last_check",0);
		$h=get_option("el_addon_info",null);
		if($lastCheck<time()) {
			$nextCheck=strtotime("+1 DAY");
			update_option("el_addon_last_check",$nextCheck) OR add_option("el_addon_last_check",$nextCheck);
			$url            = "http://appsbd.com/etc/addons.json";
			$serverResponse = wp_remote_get( $url );
			if ( ! is_wp_error( $serverResponse ) ) {
				if ( ! empty( $serverResponse['body'] ) ) {
					$jsonobj = json_decode( $serverResponse['body'] );
					if ( is_object( $jsonobj ) || is_array( $jsonobj ) ) {
						$oldData= APBD_file_get_contents( $this->addonPath);
						$oldCounter=0;
						if(!empty($oldData)){
							$oldData=json_decode($oldData);
							if(is_array($oldData)) {
								$oldCounter = count( $oldData );
							}else{
								$oldCounter=0;
							}
						}
						$hs=hash('crc32b',serialize($jsonobj));
						if(empty($h->h) || $h->h!=$hs) {
							$dt=new stdClass();
							$dt->h=$hs;
							$dt->count=$oldCounter<count($jsonobj)?count($jsonobj)-$oldCounter:0;
							$dt->noti_date = strtotime( "+2 DAY" );
							
							update_option( "el_addon_info", $dt ) OR add_option( "el_addon_info", $dt );
							file_put_contents( $this->addonPath, json_encode( $jsonobj ) );
						}
					}
				}
			}
		}
	}
	public function GetMenuCounter() {
		$h = get_option( "el_addon_info", NULL );
		
		if ( ! empty( $h->h ) && ! empty( $h->count ) && ! empty( $h->noti_date ) && $h->noti_date > time() ) {
			return '<span class=" apbd-tab-counter badge badge-danger animated ani-count-3 delay-1s slower flash">' . $h->count . '</span>';
		}
		
		return '';
	}
	
	function OptionForm() {
		$this->SetTitle( "Addons List" );
		
		$this->Display();
	}
	function get_nonce_url($plugin_slug,$action='install-plugin'){
		return wp_nonce_url(
			add_query_arg(
				array(
					'action' => $action,
					'plugin' => $plugin_slug
				),
				admin_url( 'update.php' )
			),
			$action . '_' . $plugin_slug
		);
	}
	function get_install_url($plugin_slug) {
		return $this->get_nonce_url($plugin_slug,'install-plugin');
	}
	
	function getButtonInstallLinkHtml($slug,$plugin_path,$pro_version_paths=[]) {
		$pluginObject=$this->getButtonInstallLink($slug,$plugin_path,$pro_version_paths);
		ob_start();
		if(!empty($pluginObject->isDisabled)) {?>
			<button  class="btn  <?php echo $pluginObject->cssClass; ?> btn-sm" disabled ><?php echo $pluginObject->title; ?></button>
		<?php }else{?>
			<a href="<?php echo $pluginObject->url; ?>" target="_blank" class="btn  <?php echo $pluginObject->cssClass; ?> btn-sm" <?php echo !empty($pluginObject->isDisabled)?"disabled":""; ?> ><?php echo $pluginObject->title; ?></a>
		<?php }
		return ob_get_clean();
	}
	function get_activate_install_url($plugin_path) {
		$activateUrl = sprintf(admin_url('plugins.php?action=activate&plugin=%s&plugin_status=all&paged=1&s'), $plugin_path);
		// change the plugin request to the plugin to pass the nonce check
		$_REQUEST['plugin'] = $plugin_path;
		$activateUrl = wp_nonce_url($activateUrl, 'activate-plugin_' . $plugin_path);
		return $activateUrl;
	}
	function GetAddonList() {
		
		
		$activates = get_option( 'active_plugins' );
		if ( ! file_exists( $this->addonPath ) ) {
			return [];
		}
		
		$plugins = get_plugins();
		$obj     =  APBD_file_get_contents( $this->addonPath );
		$objs    = json_decode( $obj );
		if ( ! empty( $objs ) && ( is_array( $objs ) || is_object( $objs ) ) ) {
			foreach ( $objs as &$plugin ) {
				$plugin->is_installed = isset( $plugins[ $plugin->addon_path ] );
				$plugin->is_activated = in_array( $plugin->addon_path, $activates );
				$plugin->install_button="";
				if(!empty($plugin->slug)) {
					$plugin->install_button = $this->get_install_url( $plugin->slug );
					if ( $plugin->is_installed ) {
						$plugin->install_button = $this->get_activate_install_url( $plugin->addon_path );
					}
				}
			}
			return $objs;
		} else {
			return [];
		}
	}
	function run_activate_plugin( $plugin ) {
		if(empty($plugin)){
			return false;
		}
		
		/*$current = get_option( 'active_plugins' );
		$plugin = plugin_basename( trim( $plugin ) );
		
		if ( !in_array( $plugin, $current ) ) {
			$current[] = $plugin;
			sort( $current );
			do_action( 'activate_plugin', trim( $plugin ) );
			update_option( 'active_plugins', $current );
			do_action( 'activate_' . trim( $plugin ) );
			do_action( 'activated_plugin', trim( $plugin) );
			return true;
		}
		
		return false;*/
	}

	function ActivePlugin(){
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$plugin=APBD_GetValue("p");
		
		if(empty($plugin)) {
			$mainResponse->DisplayWithResponse(false,__("Invalid param"));
		}
		$current = get_option( 'active_plugins' );
		if ( !in_array( $plugin, $current ) ) {
			activate_plugin( trim( $plugin ) );
			$current = get_option( 'active_plugins' );
			if ( in_array( $plugin, $current ) ) {
				$resdata=new stdClass();
				$resdata->text='<i class="fa fa-ban"></i> '.$this->__("Deactivate");
				$resdata->removeClass="btn-success";
				$resdata->addClass="btn-danger";
				$mainResponse->DisplayWithResponse( true, __( "Successfully Activated" ), $resdata );
			}
			
		}else {
			deactivate_plugins( [ trim( $plugin ) ] );
			$current = get_option( 'active_plugins' );
			if ( ! in_array( $plugin, $current ) ) {
				$resdata=new stdClass();
				$resdata->text='<i class="fa fa-check-circle-o"></i> '.$this->__("Active");
				$resdata->removeClass="btn-danger";
				$resdata->addClass="btn-success";
				$mainResponse->DisplayWithResponse( true, __( "Successfully Deactivated" ), $resdata );
			}
			
		}
		
		$mainResponse->DisplayWithResponse(false,__("Activation failed"));
		//$
		//run_activate_plugin( 'akismet/akismet.php' );
		
	}
	function GetMenuTitle() {
		return $this->__( "Add-ons" );
	}
	
	function GetMenuSubTitle() {
		return $this->__( "View All Add-ons" );
	}
	
	function GetMenuIcon() {
		return "fa fa-puzzle-piece";
	}
	
}