<?php
//Elite Licenser
class APBDEmailTemplate extends AppsBDBaseModule {
	
	
	function initialize() {
		parent::initialize();
		$this->disableDefaultForm();
		$this->AddAjaxAction( "add", [ $this, "add" ] );
		$this->AddAjaxAction( "edit", [ $this, "edit" ] );
		//$this->AddAjaxAction( "delete_item", [ $this, "delete_item" ] );
		//if($this->kernelObject->isDevelopmode()) {
			$this->AddAjaxAction( "view_params", [ $this, "view_params" ] );
		//}
		$this->AddAjaxAction( "status_change", [ $this, "status_change" ] );
	}
	
	/**
	 * @param $title
	 * @param callable $handler
	 * @param string $icon
	 */
	
	function OnActive() {
		parent::OnActive();
		Mapbd_email_templates::CreateDBTable();
		Mapbd_email_templates::AddNewTemplate('NCC', 'Client', 'Client welcome message', 'A', '{{client_name}}, Welcome to {{site_name}}', 'client_name=Client Name,client_country=Country Name of Client', '<p>Dear {{client_name}},</p><p>Welcome to {{site_name}}.</p><p><b><br /></b>Thanks,<br />{{site_name}}</p>');
		Mapbd_email_templates::AddNewTemplate('NLC', 'License', 'New license created', 'A', '[{{site_name}}] New license has been created', 'lic_product_name=product Name,lic_license_title=License type title,lic_purchase_key=License or purchase code,lic_max_domain=max domain counter,lic_status=License Status,client_name=param, Name of the client,client_status=Client Status,', '<p>Dear {{client_name}}</p><p>New license has been created for you.</p><p>License information is given below:</p><p>Product Name :<b>  </b><b>{{lic_product_name}}</b><br />License code:  <strong>{{lic_purchase_key}}</strong><b><br /></b>License Type  :<b> {{lic_license_title}}<br /><br /></b></p><p>Thanks<b><br /></b>{{site_name}}<b></b></p><p>&nbsp;</p>');
	}
	
	function OptionForm() {
		$this->SetTitle( "Email Template" );
		
		$this->Display();
	}
	
	function GetMenuTitle() {
		return $this->__( "Email Template" );
	}
	
	function GetMenuSubTitle() {
		return $this->__( "Modify Your Email Template" );
	}
	
	function GetMenuIcon() {
		return "ap  ap-email-template";
	}
	
	function add() {
		$this->SetTitle( "Add New Product " );
		$this->SetPOPUPColClass( "col-sm-12" );
		
		if ( APPSBD_IsPostBack ) {
			$nobject = new Mapbd_email_templates();
			if ( $nobject->SetFromPostData( true ) ) {
				if ( $nobject->Save() ) {
					$this->AddInfo( "Successfully added" );
					APBD_AddLog( "A", $nobject->settedPropertyforLog(), "l001", "" );
					$this->DisplayPOPUPMsg();
					
					return;
				}
			}
		}
		$mainobj = new Mapbd_email_templates();
		//$this->SetPopupFromMutipart();
		$this->AddViewData( "isUpdateMode", false );
		$this->AddViewData( "mainobj", $mainobj );
		$this->DisplayPOPUp( "add" );
	}
	
	function edit( $param_id = "" ) {
		$this->SetPOPUPColClass( "col-sm-12" );
		
		$param_id = APBD_GetValue( "id" );
		if ( empty( $param_id ) ) {
			$this->AddError( "Invalid request" );
			$this->DisplayPOPUPMsg();
			
			return;
		}
		$this->SetTitle( "Edit Email Template" );
		if ( APPSBD_IsPostBack ) {
			$uobject = new Mapbd_email_templates();
			if ( $uobject->SetFromPostData( false ) ) {
				$uobject->SetWhereUpdate( "k_word", $param_id );
				if ( $uobject->Update() ) {
					APBD_AddLog( "U", $uobject->settedPropertyforLog(), "l002", "" );
					$this->AddInfo( "Successfully updated" );
					$this->DisplayPOPUPMsg();
					
					return;
				}
			}
		}
		$mainobj = new Mapbd_email_templates();
		$mainobj->k_word( $param_id );
		if ( ! $mainobj->Select() ) {
			$this->AddError( "Invalid request" );
			$this->DisplayPOPUPMsg();
			
			return;
		}
		APBD_OldFields( $mainobj, "status,subject" );
		//$this->SetPopupFromMutipart();
		$this->AddViewData( "mainobj", $mainobj );
		$this->AddViewData( "isUpdateMode", true );
		$this->DisplayPOPUP( "add" );
	}
	
	
	function data() {
		$mainResponse = new AppsbdAjaxDataResponse();
		$mainResponse->setDownloadFileName( "apbd-email-templates-list" );
		$mainobj = new Mapbd_email_templates();
		$mainResponse->setDateRange( $mainobj );
		$records = $mainobj->CountALL( $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "after" );
		if ( $records > 0 ) {
			$mainResponse->SetGridRecords( $records );
			//$mainResponse->setOrderByIfEmpty("k_word","DESC");
			//wp_apbd_email_templates:k_word,grp,title,status,subject,props,content
			$result = $mainobj->SelectAllGridData( "k_word,grp,title,status,subject", [
				"grp"   => "ASC",
				"title" => "ASC"
			], $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "after" );
			if ( $result ) {
				
				$status_change = $mainobj->GetPropertyOptionsTag( "status" );
				
				foreach ( $result as &$data ) {
					$data->action = "";
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" . $this->GetActionUrl( "edit", [ "id" => $data->k_word ] ) . "'>" . $this->__( "Edit" ) . "</a>";
					//$data->action .= " <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='" . $this->__( "Are you sure to delete?" ) . "' href='" . $this->GetActionUrl( "delete_item", [ "id" => $data->k_word ] ) . "'>" . $this->__( "Delete" ) . "</a>";
					if ( $this->kernelObject->isDevelopmode() ) {
						$data->action .= " <a class='popupform btn btn-info btn-xs' href='" . $this->GetActionUrl( "view_params", [ "id" => $data->k_word ] ) . "'>" . $this->__( "View Param" ) . "</a>";
					}
					$data->status = " <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='" . $this->__( "Are you sure to change?" ) . "' href='" . $this->GetActionUrl( "status_change", [ "id" => $data->k_word ] ) . "'>" . APBD_getTextByKey( $data->status, $status_change ) . "</a>";
					
				}
			}
			$mainResponse->SetGridData( $result );
		}
		$mainResponse->DisplayGridResponse();
	}
	
	
	function delete_item( $param = "" ) {
		$mainResponse = new AppsbdAjaxConfirmResponse();
		//temporary
		$mainResponse->DisplayWithResponse( false, __( "Delete is temporary disabled" ) );
		
		return;
		if ( empty( $param ) ) {
			$mainResponse->DisplayWithResponse( false, __( "Invalid Request" ) );
			
			return;
		}
		$mr = new Mapbd_email_templates();
		$mr->k_word( $param );
		if ( $mr->Select() ) {
			//$ur=new Mapbd_email_templates();
			if ( Mapbd_email_templates::DeleteByKeyValue( "k_word", $param ) ) {
				APBD_AddLog( "D", "k_word={$param}", "l003", "APBDEmailTemplate_confirm" );
				$mainResponse->DisplayWithResponse( true, __( "Successfully deleted" ) );
			} else {
				$mainResponse->DisplayWithResponse( false, __( "Delete failed try again" ) );
			}
		}
	}
	
	function status_change() {
		$param = APBD_GetValue( "id" );
		if ( empty( $param ) ) {
			$this->DisplayWithResponse( false, __( "Invalid Request" ) );
			
			return;
		}
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$mr           = new Mapbd_email_templates();
		$statusChange = $mr->GetPropertyOptionsTag( "status" );
		
		$mr->k_word( $param );
		if ( $mr->Select( "status" ) ) {
			$newStatus = $mr->status == "A" ? "I" : "A";
			$uo        = new Mapbd_email_templates();
			$uo->status( $newStatus );
			$uo->SetWhereUpdate( "k_word", $param );
			if ( $uo->Update() ) {
				$status_text = APBD_getTextByKey( $uo->status, $statusChange );
				APBD_AddLog( "U", $uo->settedPropertyforLog(), "l002", "APBDEmailTemplate" );
				$mainResponse->DisplayWithResponse( true, __( "Successfully Updated" ), $status_text );
			} else {
				$mainResponse->DisplayWithResponse( false, __( "Update failed try again" ) );
			}
			
		}
		
	}
	
	
	function view_params() {
		$this->SetTitle( "View Params " );
		$this->SetPOPUPColClass( "col-sm-12" );
		$param_id = APBD_GetValue( "id" );
		$mainobj = new Mapbd_email_templates();
		//$this->SetPopupFromMutipart();
		$mainobj->k_word( $param_id );
		$this->AddViewData( "isUpdateMode", false );
		$this->AddViewData( "mainobj", $mainobj );
		$this->DisplayPOPUp( "view_param" );
	}
	
	
}