<?php
//Elite Licenser
class APBDLicenseList  extends AppsBDBaseModule {
	function initialize() {
		parent::initialize();
		$this->disableDefaultForm();
		$this->AddAjaxAction("add",[$this,"add"]);
		$this->AddAjaxAction("edit",[$this,"edit"]);
		$this->AddAjaxAction("view",[$this,"view"]);
		$this->AddAjaxAction("view-domain",[$this,"view_domain"]);
		$this->AddAjaxAction("view-log",[$this,"view_log"]);
		$this->AddAjaxAction("get-clients",[$this,"get_clients"]);
		$this->AddAjaxAction("delete_domain",[$this,"delete_domain"]);
		$this->AddAjaxAction("accept_domain",[$this,"accept_domain"]);
		$this->AddAjaxAction("delete_item",[$this,"delete_item"]);
		$this->AddAjaxAction("license-action",[$this,"license_action"]);
		$this->AddAjaxAction("license-action-rm-site-app",[$this,"remove_site_plugin_action"]);
		$this->AddAjaxAction("license-action-rm-single",[$this,"license_action_rm_single"]);
		jQGrid::setTranslatorMethod([$this,"__"]);
		/*add_filter($this->getHookActionStr("license-list-row-data"),function($data){
			return $data;
		});*/
	}
	function delete_item($param=""){
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$param=APBD_GetValue("id");
		if(empty($param)){
			$mainResponse->DisplayWithResponse(false, __("Invalid Request"));
			return;
		}
		$mr=new Mapbd_license();
		$mr->id($param);
		if($mr->Select()){
			//$ur=new Mapbd_license_type();
			if(Mapbd_license::DeleteByID($param)){
				APBD_AddLog("D","id={$param}", "l003","APBDLicenseType_confirm");
				$mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
			}else{
				$mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
			}
		}
	}
	function delete_domain() {
		$param        = APBD_GetValue( "id" );
		$mainResponse = new AppsbdAjaxConfirmResponse();
		if ( empty( $param ) ) {
			$mainResponse->DisplayWithResponse( false, __( "Invalid Request" ) );
			
			return;
		}
		//$mainResponse->DisplayWithResponse( true, __( "Successfully removed" ) );
		
		$mr = new Mapbd_useddomain();
		$mr->id( $param );
		if ( Mapbd_useddomain::DeleteDomainById( $param ) ) {
			APBD_AddLog( "D", "id={$param}", "l003", "APBDClient_confirm" );
			$mainResponse->DisplayWithResponse( true, __( "Successfully removed" ) );
			
		} else {
			$mainResponse->DisplayWithResponse( false, __( "Delete failed try again" ) );
		}
	}
	function accept_domain() {
		$param        = APBD_GetValue( "id" );
		$mainResponse = new AppsbdAjaxConfirmResponse();
		if ( empty( $param ) ) {
			$mainResponse->DisplayWithResponse( false, __( "Invalid Request" ) );
			
			return;
		}
		$mr = new Mapbd_useddomain();
		$mr->id( $param );
		if ( Mapbd_useddomain::AcceptDomainById( $param ) ) {
			APBD_AddLog( "U", "id={$param}", "l003", "APBDClient_confirm" );
			$objData=new stdClass();
			$mr->status="A";
			$objData->status_txt=$mr->getTextByKey("status");
			$mainResponse->DisplayWithResponse( true, __( "Successfully accepted" ),$objData );
			
		} else {
			$mainResponse->DisplayWithResponse( false, __( "Accept failed try again" ) );
		}
	}
	function OptionForm() {
		$this->Display();
	}
	
	function GetMenuTitle() {
		return $this->__( "License List" );
	}

	function GetMenuSubTitle() {
		return $this->__( "View all licenses" );
	}
	
	function GetMenuIcon() {
		return "ap ap-licence";
	}
	function get_clients(){
		$q=APBD_PostValue("q");
		$clientOb=new Mapbd_client();
		$srcField="name";
		//if (filter_var($q, FILTER_VALIDATE_EMAIL)) {
			$clientOb->name("like '%$q%' OR email like '%$q%'",true);
			$q="";
			$srcField="";
		
		//}
		$clients=$clientOb->SelectAll("id,name,email","","","10","0",$srcField,$q,[],"both");
		$responsed=[];
		foreach ($clients as $client){
			$obj=new stdClass();
			$obj->value=$client->id;    // Required.
	        $obj->text=$client->name." ({$client->email})";     // If not set, it will use the value as the text.
			$responsed[]=$obj;
		}
		echo json_encode($responsed);die;
	}
	function add(){
		$this->SetTitle("Add New License ");
		$this->SetPOPUPColClass ( "col-md-7 col-sm-7" );
		$mainObj=new Mapbd_license();
		if(APPSBD_IsPostBack){
			$nobject=new Mapbd_license();
			$isOk=true;
			if($nobject->SetFromPostData(true)){
				if(empty($nobject->client_id)){
					$this->AddError("%s is required",$this->__("Client"));
					$isOk=false;
				}
				if($isOk && $nobject->Save()){
					$this->AddInfo("Successfully added");
					APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
					$this->DisplayPOPUPMsg();
					return;
				}
			}
		}

		$this->AddViewData("isUpdateMode",false);
		$this->AddViewData("mainObj",$mainObj);
		$this->DisplayPOPUp("add");

	}
	function edit(){
		$this->SetTitle("Edit License ");
		$this->SetPOPUPColClass ( "col-md-7 col-sm-7" );
		$id=APBD_GetValue("id");
		$mainobj=new Mapbd_license();
		$mainobj->id($id);
		if(empty($id) || !$mainobj->Select()){
			$this->AddError("Invalid Param");
			$this->DisplayPOPUPMsg();
		}

		if(APPSBD_IsPostBack){
			$nobject=new Mapbd_license();
			if($nobject->SetFromPostData()) {
				$nobject->SetWhereUpdate( "id", $id );
				$isRemoveLicense = false;
				if ( $nobject->IsSetPrperty( "status" ) && in_array( strtoupper( $nobject->status ), ['F','R', 'I' ] ) ) {
					$isRemoveLicense = true;
				}
				if ( $nobject->Update() ) {
					if ( ! empty( $mainobj->user_domain ) ) {
						if($isRemoveLicense) {
							$product = Mapbd_product::FindBy( "id", $mainobj->product_id );
							if ( $product ) {
								if ( Mapbd_license::RemoveLicenseFromDomain( $mainobj->product_id, $product->enc_key, $mainobj->user_domain ) ) {
									$this->AddInfo( "Successfully removed license key form domain({$mainobj->user_domain})" );
								}
							}
						}
					}
					if(!empty($mainobj->user_domain)) {
						Mapbd_domain_log::Add( $mainobj->purchase_key, $mainobj->user_domain, "-", $mainobj->current_version, $nobject->status );
					}
					$this->AddInfo( "Successfully Updated" );
					APBD_AddLog( "U", $nobject->settedPropertyforLog(), "l001", "" );
					$this->DisplayPOPUPMsg();
					
					return;
				}
			}
		}
		$mainobj->expiry_time=APBD_GetValidDate($mainobj->expiry_time);
		$mainobj->support_end_time=APBD_GetValidDate($mainobj->support_end_time);
		APBD_OldFields($mainobj, "product_id,client_id,lictype_param,other_param,extra_param,verification_required,max_domain,license_id,purchase_key,has_expiry,expiry_time,has_support,support_end_time,entry_time,status");
		$this->AddViewData("isUpdateMode",true);
		$this->AddViewData("mainObj",$mainobj);
		$this->DisplayPOPUp("add");
	}
	function license_action() {
		$this->SetTitle( "License Actions" );
		$this->SetPOPUPColClass( "col-md-7 col-sm-7" );
		$id      = APBD_GetValue( "id" );
		$mainobj = new Mapbd_license();
		$mainobj->id( $id );
		if ( empty( $id ) || ! $mainobj->Select() ) {
			$this->AddError( "Invalid Param" );
			$this->DisplayPOPUPMsg();
		}
		
		if ( APPSBD_IsPostBack ) {
			$is_remove_app = APBD_PostValue( 'is_remove_app', "N" ) == "Y";
			$is_remove_lic = APBD_PostValue( 'is_remove_lic', $is_remove_app ) == "Y";
			$isOk          = true;
			$newStatus     = APBD_PostValue( 'status' );
			if ( $newStatus != $mainobj->status ) {
				if ( ! Mapbd_license::updateStatus( $mainobj->purchase_key, $mainobj->product_id, $newStatus ) ) {
					$isOk = false;
				}
			}
			if ( $isOk ) {
				if ( $is_remove_app || $is_remove_lic ) {
					$remove_type = APBD_PostValue( 'remove_type', 'L' );
					if ( $remove_type == "L" ) {
						$this->RedirectActionUrl( 'license-action-rm-site-app',
							[
								"lid"    => $mainobj->id,
								'rm_app' => $is_remove_app,
								'info'   => $is_remove_lic
							] );
					} else {
						if ( $is_remove_lic ) {
							Mapbd_license::RemoveALlDomainByLicenseObject( $mainobj );
							$this->AddInfo( "Removed all license, which are currently active in the registered domain" );
						}
						if ( $is_remove_app ) {
							Mapbd_license::RemoveALlPluginByLicenseObject( $mainobj, true );
							$this->AddInfo( "Removed all plugins, which are currently active in the registered domain" );
						}
					}
					
				}
			} else {
				$this->AddError( "Status Update failed, try again" );
			}
			
			
		}
		$mainobj->expiry_time      = APBD_GetValidDate( $mainobj->expiry_time );
		$mainobj->support_end_time = APBD_GetValidDate( $mainobj->support_end_time );
		APBD_OldFields( $mainobj, "status" );
		$this->AddViewData( "mainObj", $mainobj );
		$this->DisplayPOPUp( "license_action" );
	}
	function remove_site_plugin_action(){
		$this->SetTitle("Choose Domain to remove");
		$this->SetPOPUPColClass ( "col-md-12 col-sm-12" );
		$license_id=APBD_GetValue("lid");
		$isAppRemove=APBD_GetValue("rm_app",'N');
		$isInfoRemove=APBD_GetValue("info",$isAppRemove);
		$domainList=[];
		$licens_obj=Mapbd_license::FindBy('id',$license_id);
		if(empty($licens_obj)){
			$this->AddError("Invalid Param");
			$this->DisplayPOPUPMsg();
		}
		if($licens_obj->max_domain<=1){
			if(!empty($licens_obj->user_domain)) {
				$lic_domain_object=new stdClass();
				$lic_domain_object->ud_id=0;
				$lic_domain_object->user_domain=$licens_obj->user_domain;
				$lic_domain_object->full_domain=$licens_obj->user_domain;
				$domainList[] = $lic_domain_object;
			}
		}else{
			$used_domains=Mapbd_useddomain::FindAllBy("purchase_key",$licens_obj->purchase_key,["product_id"=>$licens_obj->product_id]);
			if(!empty($used_domains)){
				foreach ( $used_domains as $used_domain ) {
					$lic_domain_object=new stdClass();
					$lic_domain_object->ud_id=$used_domain->id;
					$lic_domain_object->user_domain=$used_domain->used_domain;
					$lic_domain_object->full_domain=$used_domain->full_domain;
					$domainList[] = $lic_domain_object;
				}
			}
		}
		$this->AddViewData( "isAppRemove", $isAppRemove );
		$this->AddViewData( "isInfoRemove", $isInfoRemove );
		$this->AddViewData( "mainObj", $licens_obj );
		$this->AddViewData( "domains", $domainList );
		$this->DisplayPOPUp( 'remove_site_plugin_action' );
		
	}
	function license_action_rm_single(){
		$license_id=APBD_PostValue("license_id","");
		$used_domain_id=APBD_PostValue("ud_id","");
		$remove_type=APBD_PostValue("rm_type","I");
		$dataResp=new stdClass();
		$isOk=true;
		if(Mapbd_license::RemoveLicenseBy($license_id,$used_domain_id)){
			$dataResp->l_info=$this->__("Removed");
		}else{
			$dataResp->l_info=$this->__("Failed, May be plugin is not activate on the domain");
			$isOk=false;
		}
		if($remove_type=="B") {
			if(Mapbd_license::RemovePluginBy($license_id,$used_domain_id,true)){
				$dataResp->pl_rm=$this->__("Removed");
			}else{
				$dataResp->pl_rm=$this->__("Failed, May be plugin is not activate on the domain");
				$isOk=false;
			}
		}else{
			$dataResp->pl_rm=$this->__("Not Removed");
		}
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$mainResponse->DisplayWithResponse($isOk,"Action Complete",$dataResp);
	}
	function view(){
		$this->SetTitle("License Details");
		$this->SetPOPUPColClass ( "col-sm-8" );
		$id=APBD_GetValue("id");
		$mainobj=new Mapbd_license();
		$mainobj->id($id);
		if(empty($id) || !$mainobj->Select()){
			$this->AddError("Invalid Param");
			$this->DisplayPOPUPMsg();
		}
		$mainobj->expiry_time=APBD_GetValidDate($mainobj->expiry_time);
		$mainobj->support_end_time=APBD_GetValidDate($mainobj->support_end_time);
		$this->AddViewData("mainObj",$mainobj);
		$this->DisplayPOPUp('view');
	}
	function view_domain() {
		$this->SetTitle( "License Domain List" );
		$this->SetPOPUPColClass( "col-sm-10" );
		$id      = APBD_GetValue( "id" );
		$mainobj = new Mapbd_license();
		$mainobj->id( $id );
		if ( empty( $id ) || ! $mainobj->Select() ) {
			$this->AddError( "Invalid Param" );
			$this->DisplayPOPUPMsg();
		}
		$mainobj->expiry_time      = APBD_GetValidDate( $mainobj->expiry_time );
		$mainobj->support_end_time = APBD_GetValidDate( $mainobj->support_end_time );
		$domains=Mapbd_useddomain::FindAllBy("product_id",$mainobj->product_id,["purchase_key"=>$mainobj->purchase_key],'expiry_time','DESC');
		$this->AddViewData( "mainObj", $mainobj );
		$this->AddViewData( "domains", $domains );
		$this->DisplayPOPUp( 'view_domain' );
	}
	function view_log() {
		$this->SetTitle( "License Domain Log(s)" );
		$this->SetPOPUPColClass( "col-sm-10" );
		$id      = APBD_GetValue( "id" );
		$mainobj = new Mapbd_license();
		$mainobj->id( $id );
		if ( empty( $id ) || ! $mainobj->Select() ) {
			$this->AddError( "Invalid Param" );
			$this->DisplayPOPUPMsg();
		}
		$mainobj->expiry_time      = APBD_GetValidDate( $mainobj->expiry_time );
		$mainobj->support_end_time = APBD_GetValidDate( $mainobj->support_end_time );
		$domains=Mapbd_domain_log::FindAllBy("purchase_key",$mainobj->purchase_key,[],'entry_time','DESC');
		$this->AddViewData( "mainObj", $mainobj );
		$this->AddViewData( "domains", $domains );
		$this->DisplayPOPUp( 'view_log' );
	}
	function data() {
		$mainResponse = new AppsbdAjaxDataResponse();
		$mainResponse->setDownloadFileName( "license-list" );
		$mainobj = new Mapbd_license();
		$client=new Mapbd_client();
		if($mainResponse->srcItem=="product_id"){
			$mainobj->product_id($mainResponse->srcText);
			$mainResponse->srcText="";
			$mainResponse->srcItem="";
		}
		if($mainResponse->srcItem=="status"){
			$mainobj->status($mainResponse->srcText);
			$mainResponse->srcText="";
			$mainResponse->srcItem="";
		}
		
		
		
		$mainResponse->setDateRange($mainobj);
		$mainobj->Join($client,"id","client_id");
		$records = $mainobj->CountALL( $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "both" );
		if ( $records > 0 ) {
			$mainResponse->SetGridRecords( $records );
			$mainResponse->setOrderByIfEmpty("entry_time","DESC");
			//$mainobj->Join($client,"id","client_id");
			//wp_apbd_license:id,client_id,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status
			$result = $mainobj->SelectAllGridData( "id,client_id,name,lictype_param,is_unlimited,email,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status,market,extra_param", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "both" );
			if ( $result ) {
				$has_expiry_change  = $mainobj->GetPropertyOptionsTag( "has_expiry" );
				$has_support_change = $mainobj->GetPropertyOptionsTag( "has_support" );
				$status_options     = $mainobj->GetPropertyOptionsTag( "status" );
				$products=Mapbd_product::FetchAllKeyValue("id","product_name");
				$markettype=$mainobj->GetPropertyOptionsTag( "market" );
				$supportWrapper='<span class="%s">%s</span>';
				$expireWrapper='<span class="%s">%s</span>';
				foreach ( $result as &$data ) {
					if ( $data->max_domain == 1 && $data->is_unlimited !='Y' ) {
						if ( ! empty( $data->user_domain )  && filter_var($data->user_domain, FILTER_VALIDATE_URL)) {
							$data->user_domain = ( ! empty( $data->user_domain ) ?"<a href='".$data->user_domain."' target='_blank' title='".$this->__("Click here to visit")."'><i class='fa fa-external-link'></i></a> ".$data->user_domain . "<br/>(" . $data->server_ip . ")" : "" );
						}
					} else {
						$data->user_domain = "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-xs btn-info' href='" . $this->GetActionUrl( "view-domain", [ "id" => $data->id ] ) . "'> <i class='fa fa-eye'></i> " . $this->__( "Activated Domains" ) . "</a>";
					}
					$data->action = "";
					$data->client_id=$data->name;
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-secondary btn-xs' href='" . $this->GetActionUrl( "view", [ "id" => $data->id ] ) . "'>" . $this->__( "Details" ) . "</a>";
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" . $this->GetActionUrl( "edit", [ "id" => $data->id ] ) . "'>" . $this->__( "Edit" ) . "</a>";
					$data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_license_list_delete' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-warning btn-xs' href='" . $this->GetActionUrl( "license-action", [ "id" => $data->id ] ) . "'>" . $this->__( "License Action" ) . "</a>";
					
					//$data->action .= " <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-msg='" . __( "Are you sure to delete?" ) . "' href='" . $this->GetActionUrl("confirm",["id"=>$data->id]) . "'>" . $this->__( "Delete" ) . "</a>";
					$data->product_id = APBD_getTextByKey( $data->product_id, $products );
					
					$data->entry_time       = APBD_getWPDateTimeWithFormat( $data->entry_time );
					
					$data->support_end_time = $data->has_support == "Y" ? Mapbd_license::GetExpireDateSpan($data->support_end_time ) :( $data->has_support == "U" ?"<span class='text-info text-bold'>".$this->__("Unlimited")."</span>":"-");
					$data->expiry_time      = $data->has_expiry == "Y" ? Mapbd_license::GetExpireDateSpan( $data->expiry_time ) : $this->__( "Never" );
					
					$data->license_id       = $data->license_title;
					$data->market           = APBD_getTextByKey( strtoupper($data->market), $markettype );
					//$data->has_expiry = " <a class='ConfirmAjaxWR' data-on-complete='confirm_wr_change' data-msg='" .$this-> __( "Are you sure to change?" ) . "' href='#'>" . __( APBD_getTextByKey( $data->has_expiry, $has_expiry_change ) ) . "</a>";
					//$data->has_support = " <a class='ConfirmAjaxWR' data-on-complete='confirm_wr_change' data-msg='" . $this->__( "Are you sure to change?" ) . "' href='" .$this->GetActionUrl("confirm",["id",$data->id]).'">'. $this->__( APBD_getTextByKey( $data->has_support, $has_support_change ) ) . "</a>";
					$data->status = APBD_getTextByKey( $data->status, $status_options );
					if ( ! empty( $data->user_domain ) ) {
						$data->user_domain .= "<br/><a data-effect='mfp-move-from-top' class='popupformWR btn btn-xs btn-success' href='" . $this->GetActionUrl( "view-log", [ "id" => $data->id ] ) . "'><i class='fa fa-eye'></i> " . $this->__( "Domain Log" ) . "</a>";
					}
					
					$data->action  =  apply_filters($this->getHookActionStr("license-list-action-button"),$data->action,$data,$this);
					$data=apply_filters($this->getHookActionStr("license-list-row-data"),$data);
				}
			}
			$mainResponse->SetGridData( $result );
		}
		$mainResponse->DisplayGridResponse();
		
	}
}