<?php
//Elite Licenser
class APBDProductList  extends AppsBDBaseModule {
	function initialize() {
		parent::initialize();
		$this->disableDefaultForm();
		$this->AddAjaxAction("choose-product",[$this,"choose_product"]);
		$this->AddAjaxAction("gen-script",[$this,"gen_script"]);
		$this->AddAjaxAction("down-script",[$this,"down_script"]);
		$this->AddAjaxAction("process-script",[$this,"process_script"]);
		
		$this->AddAjaxAction("edit",[$this,"edit"]);
		$this->AddAjaxAction("delete_item",[$this,"delete_item"]);
		
		$this->AddAjaxAction("ConfirmStatus",[$this,"ConfirmStatus"]);
		$this->AddAjaxAction("limit-overflow",[$this,"LimitOverflow"]);


	}
	function OnInit() {
		parent::OnInit();
		$mp=new Mapbd_product();
		$totalProduct=$mp->CountALL();
		$limit=APBDLic::GetProductCount();
		if($limit=="U" || $totalProduct<=$limit){
			$this->AddAjaxAction("add",[$this,"add"]);
		}else{
			$this->AddAjaxAction("add",[$this,"LimitOverflow"]);
		}
	}
	function LimitOverflow(){
		$this->SetTitle("Product Limit Overflow");
		$this->SetPOPUPColClass ( "col-sm-8" );
		$this->SetPOPUPIconClass( "abp abp-elite-licenser" );
		$this->DisplayPOPUp("limitoverflow");
	}
	
	function OptionForm() {
		$this->Display();
	}
	
	function GetMenuTitle() {
		return $this->__( "Product List" );
	}
	
	function GetMenuSubTitle() {
		return $this->__( "View all product" );
	}
	
	function GetMenuIcon() {
		return "ap ap-product-list";
	}
	function choose_product() {
	
	$this->SetTitle( "Choose Proudct to generate license code" );
	$this->SetPOPUPColClass( "col-sm-8" );
	$mainObj = new Mapbd_product();
	if ( APPSBD_IsPostBack ) {
		$productId=APBD_PostValue("product_id","");
		if(empty($productId)){
			AddError("Product is required");
		}else{
			$product=Mapbd_product::FindBy("id",$productId);
			if($product){
				$this->RedirectActionUrlWithBackButton("gen-script",["id"=>$productId],"choose-product",[],"Back to choose product");
			}else{
				AddError("Invalid product information");
			}
		}
	}
	
	$this->AddViewData( "isUpdateMode", false );
	$this->AddViewData( "mainObj", $mainObj );
	$this->DisplayPOPUp( "choose_product" );
	
}
	function gen_script() {
		$id=APBD_GetValue("id");
		$product=NULL;
		if(empty($id)){
			$this->SetTitle( "Generate license code" );
			$this->AddError("Invalid product param");
			$this->DisplayPOPUPMsg();
			return;
		}else{
			$product=Mapbd_product::FindBy("id",$id);
		}
		if(empty($product)){
			$this->SetTitle( "Generate license code" );
			$this->AddError("Invalid product param");
			$this->DisplayPOPUPMsg();
			return;
		}
		
		$this->SetTitle( "Generate license code( %s )",'<span class="text-success">'.$product->product_name."</span>" );
		$this->SetPOPUPColClass( "col-sm-8" );
		$mainObj = new Mapbd_product();
		if ( APPSBD_IsPostBack ) {
			$genType=APBD_PostValue("genType");
			$genTypes=Mapbd_product::getScriptGenerators();
			if(empty($genType) || !isset($genTypes[$genType])){
				$this->AddError("Unknown generator type");
			}else{
				if(!$genTypes[$genType]->isActive){
					$this->AddError("Generator is inactive");
				}else{
					//$this->RedirectActionUrl("down-script",["p"=>$id,"gt"=>$genType]);
					$this->RedirectActionUrlWithBackButton("down-script",["p"=>$id,"gt"=>$genType],null,[],"Go to generator selection");
					return;
				}
			}
		}
		
		$this->AddViewData( "isUpdateMode", false );
		$this->AddViewData( "mainObj", $mainObj );
		$this->DisplayPOPUp( "gen_script" );
		
	}
	function down_script() {
		$this->SetTitle( "Download Script" );
		$product_id      = APBD_GetValue( "p" );
		$genType      = APBD_GetValue( "gt" );
		
		$genTypes = Mapbd_product::getScriptGenerators();
		if ( empty( $genType ) || ! isset( $genTypes[ $genType ] ) ) {
			$this->AddError( "Unknown generator type" );
			$this->DisplayPOPUPMsg();
			return;
		}
		$product = NULL;
		if ( empty( $product_id ) ) {
			
			$this->AddError( "Invalid product param" );
			$this->DisplayPOPUPMsg();
			
			return;
		} else {
			$product = Mapbd_product::FindBy( "id", $product_id );
		}
		if ( empty( $product ) ) {
			$this->AddError( "Invalid product param" );
			$this->DisplayPOPUPMsg();
			return;
		}
		$this->SetPOPUPColClass( "col-sm-8" );
		
		if ( APPSBD_IsPostBack ) {
			/*$genType  = APBD_PostValue( "genType" );
			$genTypes = Mapbd_product::getScriptGenerators();
			if ( empty( $genType ) || ! isset( $genTypes[ $genType ] ) ) {
				$this->AddError( "Unknown generator type" );
			} else {
				if ( ! $genTypes[ $genType ]->isActive ) {
					$this->AddError( "Generator is inactive" );
				} else {
					$this->AddInfo( $genTypes[ $genType ]->name );
				}
			}*/
		}
		
		$this->AddViewData( "isUpdateMode", false );
		$this->AddViewData( "product", $product );
		$this->AddViewData( "generator", $genTypes[ $genType ] );
		$this->AddViewData( "gntype", $genType );
		$this->DisplayPOPUp( "down_script" );
		
	}
	function delete_item($param=""){
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$param=APBD_GetValue("id");
		if(empty($param)){
			$mainResponse->DisplayWithResponse(false, __("Invalid Request"));
			return;
		}
		$mr=new Mapbd_product();
		$mr->id($param);
		if($mr->Select()){
			//$ur=new Mapbd_license_type();
			if(Mapbd_product::DeleteByID($param)){
				APBD_AddLog("D","id={$param}", "l003","APBDLicenseType_confirm");
				$mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
			}else{
				$mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
			}
		}
	}
	function process_script() {
		if($this->kernelObject->isDemoMode()){
			die("You can't download script in demo mode");
		}
		$product_id      = APBD_GetValue( "p" );
		$genType      = APBD_GetValue( "gt" );
		
		$genTypes = Mapbd_product::getScriptGenerators();
		if ( empty( $genType ) || ! isset( $genTypes[ $genType ] ) ) {
			echo $this->__("Unknown generator type" );
			die;
		}
		$product = NULL;
		if ( empty( $product_id ) ) {
			echo $this->__("Invalid product param" );
			die;
		} else {
			$product = Mapbd_product::FindBy( "id", $product_id );
		}
		if ( empty( $product ) ) {
			echo $this->__("Invalid product param" );
			die;
		}
		$tempPath=WP_CONTENT_DIR."/uploads/eltmp/";
		if(!is_dir($tempPath)){
			mkdir($tempPath,0755,true);
		}
		$ctime = time();
		foreach (glob($tempPath . "*.tmp") as $file) {
			//24 hours = 86400, 2hour = 7200, 20 minutes= 1200
			if (($ctime - filectime($file)) > 1200) {
				unlink($file);
			}
		}
		$genTypes[ $genType ]->setPluginPath($this->pluginFile);
		$genTypes[ $genType ]->setTmpPath($tempPath);
		$genTypes[ $genType ]->outputZip($product_id);
		
	}
	function add(){
		$this->SetTitle("Add New Product ");
		$this->SetPOPUPColClass ( "col-sm-10" );
		$mainObj=new Mapbd_product();
		if(APPSBD_IsPostBack){
			$nobject=new Mapbd_product();
			$is_auto_generate=APBD_PostValue("is_auto_generate","N")=="Y";
			if($is_auto_generate){
			
			}
			if($nobject->SetFromPostData(true)){
				if($nobject->Save()){
					$this->AddInfo("Successfully added");
					APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
					$this->DisplayPOPUPMsg();
					return;
				}
			}
		}

		$this->AddViewData("isUpdateMode",false);
		$this->AddViewData("mainObj",$mainObj);
		$this->DisplayPOPUp("add");

	}
	function edit(){
		$this->SetTitle("Edit Product ");
		$this->SetPOPUPColClass ( "col-sm-10" );
		$id=APBD_GetValue("id");
		$mainobj=new Mapbd_product();
		$mainobj->id($id);
		if(empty($id) || !$mainobj->Select()){
			$this->AddError("Invalid Param");
			$this->DisplayPOPUPMsg();
		}

		if(APPSBD_IsPostBack){
			$nobject=new Mapbd_product();
			if($nobject->SetFromPostData()){
				$nobject->SetWhereUpdate("id",$id);
				if($nobject->Update()){
					$this->AddInfo("Successfully Updated");
					APBD_AddLog("U",$nobject->settedPropertyforLog(),"l001","");
					$this->DisplayPOPUPMsg();
					return;
				}
			}
		}
		APBD_OldFields($mainobj, "product_base,enc_key,product_name,renew_link,product_link,is_enc_up_res,is_check_lic_on_update,status");

		$this->AddViewData("isUpdateMode",true);
		$this->AddViewData("mainObj",$mainobj);
		$this->DisplayPOPUp("add");
	}
	function ConfirmStatus() {
		$param=APBD_GetValue("id");
		$mr=new Mapbd_product();
		$statusChange=$mr->GetPropertyOptionsTag("status");
		$mainResponse = new AppsbdAjaxConfirmResponse();
		$mr->id($param);
		if($mr->Select("status")){
			$newStatus=$mr->status=="A"?"I":"A";
			$uo=new Mapbd_product();
			$uo->status($newStatus);
			$uo->SetWhereUpdate("id",$param);
			if( $uo->Update()){
				$status_text = APBD_getTextByKey($newStatus, $statusChange);
				APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","Wp_apbd_product");
				$mainResponse->DisplayWithResponse(true, $this->__("Successfully Updated"), $status_text);
			}else{
				$mainResponse->DisplayWithResponse(false, $this->__("Update failed try again"));
			}

		}
	}
	function data() {
		$mainResponse = new AppsbdAjaxDataResponse();
		$mainResponse->setDownloadFileName( "license-list" );
		$mainobj = new Mapbd_product();
		$mainResponse->setDateRange($mainobj);
		$records = $mainobj->CountALL( $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "after" );
		if ( $records > 0 ) {
			$mainResponse->SetGridRecords( $records );
			$mainResponse->setOrderByIfEmpty("entry_time","DESC");
			//wp_apbd_license:id,client_id,product_id,product_base_name,license_id,purchase_key,user_domain,server_ip,current_version,license_title,max_domain,verification_required,has_expiry,expiry_time,has_support,support_end_time,entry_time,request_counter,request_delay_time,status
			$result = $mainobj->SelectAllGridData( "", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "after" );
			if ( $result ) {
				$status_change=$mainobj->GetPropertyOptionsTag("status");
				foreach ( $result as &$data ) {
					$data->product_name.=' <span class="text-success">( ID:'.$data->id.')</span>';
					$data->action = "";
					//$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-secondary btn-xs' href='" . $this->GetActionUrl("view",["id"=>$data->id]) . "'>" . $this->__( "Details" ) . "</a>";
					
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" . $this->GetActionUrl("edit",["id"=>$data->id]) . "'>" . $this->__( "Edit" ) . "</a>";
					$data->action .= "<a data-effect='mfp-move-from-top' class='popupformWR btn btn-success btn-xs' href='" . $this->GetActionUrl("gen-script",["id"=>$data->id]) . "'><i class='fa fa-gear'></i> " . $this->__( "Generate License Script" ) . "</a>";
					$data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_product_list_delete' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
					$data->entry_date=APBD_getWPDateTimeWithFormat($data->entry_date);

					$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".__("Are you sure to change?")."' href='" . $this->GetActionUrl("ConfirmStatus",["id"=>$data->id]) . "'>".$this->__(APBD_getTextByKey($data->status,$status_change))."</a>";

					$data->status = APBD_getTextByKey( $data->status, $status_change );
					
					$data->action  =  apply_filters($this->getHookActionStr("product-list-action-button"),$data->action,$data,$this);
					$data=apply_filters($this->getHookActionStr("product-list-row-data"),$data);
					
				}
			}
			$mainResponse->SetGridData( $result );
		}
		$mainResponse->DisplayGridResponse();
		
	}

}