<?php
//Elite Licenser
class APBDProductUpdate extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
		   parent::initialize();
		   $this->disableDefaultForm();
		   $this->AddAjaxAction( "add", [ $this, "add" ] );
		   $this->AddAjaxAction( "edit", [ $this, "edit" ] );
		   $this->AddAjaxAction( "delete_item", [ $this, "delete_item" ] );
		   $this->AddAjaxAction( "status_change", [ $this, "status_change" ] );
		   add_action( $this->getHookActionStr( "register-rest-api" ), array( $this, "product_rest_route" ) );
	   }
	   public function OnInit() {
		   parent::OnInit();
		   add_filter('elite-licenser/filter/update-download-link',[$this,"update_download_link"],10,2);
	   }
	
	/**
	 * The update download link is generated by appsbd
	 *
	 * @param mixed $download_link
	 * @param Mapbd_product $product
	 *
	 * @return string
	 */
	public function update_download_link($download_link,$product){
		$post_id = attachment_url_to_postid($download_link);
		if (empty($post_id)) {
			return $download_link;
		}
		if($product->is_enc_up_res=='Y') {
			$site_url = content_url();
			if ( strpos( $download_link, $site_url ) !== false ) {
				$real_path = realpath( WP_CONTENT_DIR . substr( $download_link, strlen( $site_url ) ) );
				if ( is_file( $real_path ) ) {
					$ip            = APBD_get_remote_ip();
					$download_link = wp_nonce_url( get_rest_url( NULL, APBDLicenseSettings::GetModuleOption( "api_end_point", "licensor" ) . '/product/download/' . $product->id),"elp_prp_download","k");
					
					
					//get_rest_url( NULL, $this->GetOption( "api_end_point", "licensor" ) . '/product/download/' . $product->id . '/' . wp_create_nonce( $product->id . '-' . $ip ) );
				}
			}
		}
		return $download_link;
	}
        function product_rest_route($licensor){
	        register_rest_route( $licensor, '/product/download/(?P<id>\d+)', array(
		        'methods'             => 'GET',
		        'callback'            => [ $this, "product_download" ],
		        'permission_callback' => [ $this, "download_nonce_check" ]
	        ) );
        }
        function download_nonce_check(){
	   	    $nonce= APBD_GetValue("k");
	   	    if(empty($nonce) || !wp_verify_nonce($nonce,'elp_prp_download')){
	   	    	return false;
	        }
	        return true;
        }
        function product_download($data){
	        $product_id=$data['id'];
	        $product_update = Mapbd_product_update::FindBy( "product_id", $product_id, [ "status" => "A" ] );
	   	    if(!empty($product_update->download_link)){
		        $post_id = attachment_url_to_postid($product_update->download_link);
		        if (!empty($post_id)) {
			        $file_path = get_attached_file($post_id);
			        if (file_exists($file_path)) {
				        header('Content-Type: ' . mime_content_type($file_path));
				        header('Content-Disposition: attachment; filename=' . basename($file_path));
				        readfile($file_path);
				        exit;
			        }
		        }
	        }
	        global $wp_query;
	        $wp_query->set_404();
	        status_header(404);
	        get_template_part(404);
	        exit();
        }
        function OptionForm() {
            $this->SetTitle("Product Updates");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Product Updates" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all Product Updates" );
        }
        
        function GetMenuIcon() {
            return "ap ap-product-update";
        }
        function AdminScripts() {
	        wp_enqueue_editor();
	        wp_enqueue_media();
        }


	function add(){
            $this->SetTitle("Add New Updates");
            $this->SetPOPUPColClass ( "col-sm-10" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_product_update();
	            $_POST['aditional_sections']=$nobject->get_posted_additional_sections();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_product_update();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit(){
            $this->SetPOPUPColClass ( "col-sm-10" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit Product Update");
	       $mainobj=new Mapbd_product_update();
	       $mainobj->id($param_id);
	       if(!$mainobj->Select()){
		       $this->AddError("Invalid request");
		       $this->DisplayPOPUPMsg();
		       return;
	       }
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_product_update();
	                $_POST['old_change_log']=$mainobj->change_log;
	                $_POST['old_update_des']=$mainobj->update_des;
	                $_POST['old_aditional_sections']=$mainobj->aditional_sections;
	                $_POST['aditional_sections']=$uobject->get_posted_additional_sections();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }


	        APBD_OldFields($mainobj, "banner_high,banner_low,download_link,new_version,product_id,required_version,status,tested");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("apbd-license-type-list");
        	$mainobj=new Mapbd_product_update();
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
            $products=Mapbd_product::FetchAllKeyValue("id","product_name");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		$mainResponse->setOrderByIfEmpty("update_time","DESC");
		        //wp_apbd_product_update:aditional_sections,banner_high,banner_low,change_log,download_link,id,new_version,product_id,required_version,status,tested,update_des,update_time
        		$result=$mainobj->SelectAllGridData("id,new_version,product_id,required_version,status,tested,update_time", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){
					$status_change=$mainobj->GetPropertyOptionsTag("status");
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_ProductUpdateDelete' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			    if($data->status=="A"){
				            $data->status=APBD_getTextByKey( $data->status, $status_change );
			            }else {
				            $data->status = APBD_getTextByKey( $data->status, $status_change )." <a class='ConfirmAjaxWR badge text-white badge-success' data-on-complete='OnProductUpdateStatusChange' data-msg='" . $this->__( "Are you sure to change?" ) . "' href='" . $this->GetActionUrl( "status_change", [ "id" => $data->id ] ) . "'>" . $this->__("Make Active") . "</a>";
			            }
        			   $data->product_id=APBD_getTextByKey($data->product_id,$products);
				
				       $data->action  =  apply_filters($this->getHookActionStr("product-update-list-action-button"),$data->action,$data,$this);
				       $data=apply_filters($this->getHookActionStr("product-update-list-row-data"),$data);
				
			        }
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item(){
		    $param=APBD_GetValue("id","");
	        $mainResponse = new AppsbdAjaxConfirmResponse();
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, $this->__("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_product_update();
            $mr->id($param);
            if($mr->Select()){
                if(Mapbd_product_update::DeleteID($param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDLicenseType_confirm");
                    $mainResponse->DisplayWithResponse(true, $this->__("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,$this->__("Delete failed try again"));
                }
            }
        }
        


        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_product_update();
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status,product_id")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_product_update();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param);
	            Mapbd_product_update::UpdateOtherVersion($mr->product_id);
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDLicenseType");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}