<?php
class APBDWebhook extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("is_on_client_change",[$this,"is_on_client_change"]);
			$this->AddAjaxAction("is_on_license_change",[$this,"is_on_license_change"]);
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
        }
    
        function OptionForm() {
            $this->SetTitle("Webhooks List");
    	    $this->SetSubtitle("Webhook");
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Webhooks" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all Webhooks" );
        }
        
        function GetMenuIcon() {
            return "ap ap-webhook";
        }
		public function GetMenuCounter() {
			return '<span class=" apbd-tab-counter badge badge-danger animated ani-count-3 delay-1s slower flash">'.$this->__("New").'</span>';
		}
       function add(){
            $this->SetTitle("Add New Webhook ");
            $this->SetPOPUPColClass ( "col-sm-6" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_webhook();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_webhook();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
            $this->SetPOPUPColClass ( "col-sm-6" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit APBDWebhook");
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_webhook();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            $mainobj=new Mapbd_webhook();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
            APBD_OldFields($mainobj, "title,url,private_key,is_on_client,is_on_license,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("apbd-webhook-list");
        	$mainobj=new Mapbd_webhook();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		$result=$mainobj->SelectAllGridData("", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){            	     
            	    
					$is_on_client_change=$mainobj->GetPropertyOptionsTag("is_on_client");  
					$is_on_license_change=$mainobj->GetPropertyOptionsTag("is_on_license");  
					$status_change=$mainobj->GetPropertyOptionsTag("status");  
            	                	    
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			   
						$data->is_on_client=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("is_on_client_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->is_on_client,$is_on_client_change)."</a>";
						$data->is_on_license=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("is_on_license_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->is_on_license,$is_on_license_change)."</a>";
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
        			     		    
        			}
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item($param=""){
	        $mainResponse = new AppsbdAjaxConfirmResponse();
            //temporary
            $mainResponse->DisplayWithResponse(false, __("Delete is temporary disabled"));
            return;
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_webhook();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_webhook();
                if(Mapbd_webhook::DeleteByKeyValue("id",$param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDWebhook_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function is_on_client_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_webhook();  
            $is_on_clientChange=$mr->GetPropertyOptionsTag("is_on_client");
		         
            $mr->id($param);
            if($mr->Select("is_on_client")){
                $newStatus=$mr->is_on_client=="A"?"I":"A";
                $uo=new Mapbd_webhook();
                $uo->is_on_client($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->is_on_client, $is_on_clientChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDWebhook");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function is_on_license_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_webhook();  
            $is_on_licenseChange=$mr->GetPropertyOptionsTag("is_on_license");
		         
            $mr->id($param);
            if($mr->Select("is_on_license")){
                $newStatus=$mr->is_on_license=="A"?"I":"A";
                $uo=new Mapbd_webhook();
                $uo->is_on_license($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->is_on_license, $is_on_licenseChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDWebhook");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_webhook();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_webhook();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDWebhook");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}