﻿using EliteLicenser;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EliteLicenserCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            //LicenserBase LB = new LicenserBase("Product Key", "Product Id", "Product Base", "Host url ex. https://example.com/wp-json/lic");
            LicenserBase LB = new LicenserBase("<<encryptedkey>>", "<<productid>>", "<<productbase>>", "<<hostserver>>");
            String LicenseKey = "THIS WILL BE THE LICENSE KEY";// Collect this license key using input box
            String AppUniqueId = EliteLicenser.EliteMachine.GetUniqueMachineId("<<productname>>_OR_ANYTHING");
            String AppVersion = "1.0";
            String AdminEmail = "Admin@email.com"; //Collect this license key using input box


            Console.WriteLine("\nActivating Update....\n------------------------------------------");


            //LB.Active(LicenseKey, AppUniqueId,AppVersion)
            //LB.Active(LicenseKey, AppUniqueId)
            if (LB.Active(LicenseKey, AppUniqueId, AppVersion, AdminEmail))
            {
                Console.WriteLine("Activated Successfully");
                Console.WriteLine("License Key : " + LicenseKey);
                Console.WriteLine("License Title : " + LB.EO.license_title);
                Console.WriteLine("License Expire Date : " + LB.EO.expire_date);
                Console.WriteLine("License Support Date : " + LB.EO.support_end);

                /* LB.EO.request_duration ---
                this field contains the minute of next request wait. 
                It will be good for your server,if you check the activation after this minute 
                from last request. 
                So you need to handle it locally. You can cache it manually.its upto you,                 
                if you handle it then your server will get les request, 
                if not then your server will get request always.

                **
                If you get 0 value always on this property then you haven't added any entry on Request Manager Module in Elite Licenser Server.
                You can add multiple entry on request manager, Elite Licenser will follow one by one. Last ently will be continue. 
                if app deactivated license then elite licenser will start form first entry.
                
                **
                Check the elite licenser documentation to know details
                */

            }
            else
            {
                Console.WriteLine("Activation Failed");
                Console.WriteLine("Error : " + LB.ErrorMessage);
            }
            Console.WriteLine("------------------------------------------\n\nPress any key to check update");
            Console.ReadKey();




            //update check
            Console.WriteLine("\n\nChecking Update....\n------------------------------------------");
            EliteUpdateResponse uo = LB.GetUpdateInfo(LicenseKey);
            if (uo.status)
            {
                Console.WriteLine("New Version:" + uo.data.new_version);
                Console.WriteLine("\nDescription:\n--------------\n" + uo.data.sections["description"]);
                Console.WriteLine("\n\nChange Log:\n-------------\n" + uo.data.sections["changelog"] + "\n");
                if (string.IsNullOrEmpty(uo.data.download_link))
                {
                    if (uo.data.update_denied_type == "L")
                    {
                        Console.WriteLine("Not updateable : License key required");
                    }
                    else if (uo.data.update_denied_type == "S")
                    {
                        Console.WriteLine("Not updateable : Support Expired");
                    }
                    else
                    {
                        Console.WriteLine("Not updateable : Unknown reason");
                    }
                }
                else
                {
                    Console.WriteLine("Download Link:" + uo.data.download_link);
                }
                Console.WriteLine("\n\n------------------------------------------\n\nPress any key to deactivate");
                Console.ReadKey();
            }
            else
            {
                Console.WriteLine(uo.msg);
            }




            //for deactivation
            if (LB.IsLicenseActivated)
            {
                Console.WriteLine("\nNow Deactivating....\n------------------------------------------");
                //LB.Active(LicenseKey, AppUniqueId)
                if (LB.Deactive(LicenseKey))
                {
                    Console.WriteLine("License Dactivated Successfully");
                }
                else
                {
                    Console.WriteLine("Dactivation Failed");
                    Console.WriteLine("Error : " + LB.ErrorMessage);
                }

                Console.ReadKey();
            }


        }
    }
}
