<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_product $mainObj;
	 */
?>
<div class="clearfix form pb-3">
<div class="row">
    <div class="col-sm p-0">
    <div class="form-group col-sm">
        <label class="col-form-label" for="product_id"><?php $this->_e("Product"); ?></label>
		
		<?php $options_products= Mapbd_product::FindAllBy("status", "A");?>
        <select class="custom-select form-control-sm" id="product_id"  name="product_id"     data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Product"));?>">
            <option value=""><?php $this->_e("Select"); ?></option>
			<?php $product_base_name_selected= APBD_PostValue("product_id","");
				foreach ( $options_products as $options_product ) {
					?>
            <option data-slug="<?php echo $options_product->product_base; ?>" value="<?php echo $options_product->id; ?>"><?php echo $options_product->product_name; ?></option>
					<?php
				}
			?>
        </select>
		
    

    </div>
    <div class="form-group col-sm d-none mt-3" id="slug-msg">
        <div class="alert alert-warning  text-center" >
            <?php $this->_e("Your uploading plugin's or themes's slug(or menu slug) must be same as product's base/slug "); ?>
            <br>(  <?php $this->_e("which is : "); ?><strong class="slug-con text-danger"></strong> )
            <br><strong class="text-danger"><?php $this->_e("if it mismatch, then the licensed plugin or theme won't work properly"); ?></strong>
            <br><?php $this->_e("You can change it in product edit panel"); ?>
        </div>
    </div>
    <div class="form-group col-sm ">
        <label class="col-form-label" for="product_id"><?php $this->_e("Upload or Dragdrop Your Wordpress Plugin or Theme"); ?></label>
        <div class="">
            <input type="file" name="plgFile" accept=".zip" class="app-drag-drop" data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("File"));?>">
            
        </div>
       <span class="form-text text-warning text-center"><?php $this->_e("Your server's maximum upload size : %s", min(ini_get('post_max_size'), ini_get('upload_max_filesize')));?></span>
    </div>
    <div class="form-group col-sm">
        <label class="col-form-label" for="has_own_menu"><?php $this->_ee("Your product has admin menu?"); ?></label>
		
		<?php
			APBD_GetHTMLSwitchButton("has_own_menu","has_own_menu","N","Y",APBD_PostValue("has_own_menu","N"));
		?>
		<?php /*<span class="form-text text-muted"><?php $this->_ee("status");?></span>	*/?>


    </div>
    <div class="form-group col-sm">
        <label class="col-form-label" for="product_id"><?php $this->_e("Menu Icon Type"); ?></label>
		
		<?php $options_products= Mapbd_product::FindAllBy("status", "A");?>
        <select class="custom-select form-control-sm has_depend_fld" id="icon_type"  name="icon_type"     data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Product"));?>">
           	<?php
                APBD_GetHTMLOption("I","CSS Class Type Icon");
                APBD_GetHTMLOption("F","File Type Icon");
			?>
        </select>
    </div>
    <div class="form-group col-sm fld-icon-type fld-icon-type-f">
        <label class="col-form-label" for="product_id"><?php $this->_e("Upload or Dragdrop your icon file"); ?></label>
        <div class="">
            <input type="file" name="icon_file" accept=".png,.jpg,.svg" class="app-drag-drop" data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Icon File"));?>">

        </div>
    </div>
    <div class="form-group col-sm fld-icon-type fld-icon-type-i">
        <label class="col-form-label" for="icon_class"><?php $this->_e("Icon Class"); ?></label>
        <div class="">
            <input type="text" name="icon_class" class="form-control form-control-sm" data-bv-notempty="true"  placeholder="ex. dashicons-star-filled"	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Menu Icon Class"));?>">

        </div>
    </div>
       
    </div>
    <div class="col-sm p-0">
        <div class="form-group col-sm pl-0">
            <label class="col-form-label" for="product_id"><?php $this->_e("License Instruction, It will be displayed before the license input box"); ?></label>
            <div class="">
                <textarea id="instruction" name="instruction"  class="form-control form-control-sm apd-wp-editor ht-260"></textarea>
            </div>
        </div>
    </div>
</div>
</div>
<div class="btn-group-md popup-footer ">
	<div class="clearfix">
		
		<div class="float-sm-right text-center text-sm-right ">
			<button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Next"); ?> <i class="fa fa-angle-double-right"></i> </button>
			<button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Cancel"); ?></button>
		</div>
		<div class="float-sm-left text-center text-sm-left">
			<?php echo getCustomBackButtion(); ?>
		</div>
	</div>
</div>

<script type="application/javascript">
    jQuery( document ).ready(function( $ ) {
       $("#product_id").on("change",function(){
           ccProductChange();
       });
    });
    
    function ccProductChange(){
        var v= $("#product_id").val();
        if(v !=''){
            var slug=$("#product_id option[value="+v+"]").data('slug');
            $("#slug-msg .slug-con").html(slug);
            $("#slug-msg").removeClass("d-none");
        }else{
            $("#slug-msg").addClass("d-none");
        }
    }
</script>