<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_license $mainObj;
	 */
	$mainObj = apply_filters( $this->getHookActionStr( "license-list-row-data" ), $mainObj );
?>
<div class="clearfix form pb-3">

    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-sm">
                    <div class="apd-view-title"><?php $this->_e("License Code"); ?></div>
                    <div class="apd-view-details mb-2">
				        <?php echo $mainObj->purchase_key;	?>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Product"); ?></div>
                    <div for="apd-view-details">
				        <?php
					        if(!empty($mainObj->product_id)) {
						        $product = Mapbd_product::FindBy( "id", $mainObj->product_id );
						        if ( $product ) {
							        echo $product->product_name;
						        }
					        }
				        ?>
                    </div>
                </div>
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("License"); ?></div>
                    <div class="apd-view-details mb-2">
				        <?php
					        if(!empty($mainObj->license_id)) {
						        $liceobj = Mapbd_license_type::FindBy( "id", $mainObj->license_id );
						        if ( $liceobj ) {
							        echo $liceobj->license_title;
						        }
					        }
				        ?>
                    </div>
                </div>
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Status"); ?></div>
                    <div for="apd-view-details">
				        <?php echo $mainObj->getTextByKey("status");	?>
                    </div>
                </div>

            </div>

            <div class="row">

                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Created"); ?></div>
                    <div class="apd-view-details  mb-2">
				        <?php echo APBD_getWPDateTimeWithFormat($mainObj->entry_time);	?>
                    </div>
                </div>
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Expiry Date"); ?></div>
                    <div class="apd-view-details mb-2">
				        <?php
					        if($mainObj->has_expiry=="Y") {
						        echo APBD_getWPDateTimeWithFormat( $mainObj->expiry_time );
					        }else{ $this->_e("Never");}?>
                    </div>
                </div>
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Support End Date"); ?></div>
                    <div class="apd-view-details  mb-2">
				        <?php
					        if($mainObj->has_support=="Y") {
						        ?>
                                <span class="<?php echo strtotime($mainObj->support_end_time)>time()?"text-success":"text-danger"; ?>">
                        <?php echo APBD_getWPDateTimeWithFormat($mainObj->support_end_time); ?>
                    </span>
						        <?php
					        }else{ $this->_e("-");}?>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-sm">
                    <div class="apd-view-title" for="product_id"><?php $this->_e("Max. Domain"); ?></div>
                    <div for="apd-view-details">
				        <?php echo $mainObj->max_domain;	?>
                    </div>
                </div>
                <div class="col-sm">
                    <div class="apd-view-title">
                        <?php $this->_e("Currently Using (Domains)") ?>
                    </div>
                    <div for="apd-view-details">
				        <?php echo Mapbd_useddomain::CountAllByKey($mainObj->product_id,$mainObj->purchase_key);	?>
                    </div>
                </div>
                <div class="col-sm">
                </div>
            </div>
           

        </div>
    </div>
    <div class="card mt-3">
        <div class="card-header"><?php $this->_e("License Action Form") ; ?></div>
        <div class="card-body">
            <div class="form-group row">
                <label class="col-form-label col-sm-3 " for="status"><?php $this->_e("Status"); ?></label>
                <div class="col-sm">
                    <select    class="custom-select form-control-sm" id="status" name="status"    data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Status"));?>">
                        <option value=""><?php $this->_ee("Select"); ?></option>
				        <?php $status_selected= $mainObj->GetPostValue("status","W");
					        APBD_GetHTMLOptionByArray($mainObj->GetPropertyOptions("status"),$status_selected);
				        ?>
                    </select>
                </div>
            </div>
            <div class="form-group row mt-2">
                <label class="col-form-label col-sm-3 pt-0 " ><?php $this->_e("Extra Action"); ?></label>
                <div class="col-sm">
                    <div class="form-check">
                        <input class="form-check-input" type="hidden" value="N" name="is_remove_lic">
                        <input class="form-check-input" type="checkbox" value="Y" <?php echo APBD_PostValue("is_remove_lic",'N')=="Y"?' checked ':''; ?> name="is_remove_lic" id="is_remove_lic">
                        <label class="form-check-label" for="is_remove_lic">
                            <?php $this->_e("Remove the license info form existing active site/app") ; ?>
                        </label>
                    </div>
                    <div class="form-check">
                        
                        <input class="form-check-input" type="hidden" value="N" name="is_remove_app">
                        <input class="form-check-input has_depend_fld" type="checkbox" <?php echo APBD_PostValue("is_remove_app",'N')=="Y"?' checked ':''; ?> value="Y" name="is_remove_app" id="is_remove_app">
                        <label class="form-check-label" for="is_remove_app">
	                        <?php $this->_e("Remove the plugin or theme form existing active site/app") ; ?>
                        </label>
                        <div class="form-help text-warning fld-is-remove-app fld-is-remove-app-y"><?php $this->_e("Remove only works on WordPress Extensions(Plugin/Theme)");?></div>
                    </div>
                </div>
            </div>
            <div id="rm_type_control" class="form-group row mt-2">
                <label class="col-form-label col-sm-3" for="remove_type"><?php $this->_ee("Remove Type"); ?></label>
                <div class="col-sm">
			        <?php
				        $status_selected= APBD_PostValue("remove_type","L");
				        APBD_GetHTMLRadioByArray("remove_type","remove_type","remove_type",true,["L"=>$this->__("Let me choose domain"),"A"=>$this->__("All Domain")],$status_selected,false);
			        ?>

                </div>
            </div>
        </div>
    </div>
    
</div>
<div class="btn-group-md popup-footer ">
	<div class="clearfix">
		<div class="float-sm-right text-center text-sm-right ">
			<button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> <?php echo $this->__("Next"); ?></button>
			<button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Cancel"); ?></button>
		</div>
		<div class="float-sm-left text-center text-sm-left">
			<?php echo getCustomBackButtion(); ?>
		</div>
	</div>
</div>
<script type="text/javascript">
    function showRemoveType(){
        if($("#is_remove_lic").is(':checked') || $("#is_remove_app").is(':checked')){
            $("#rm_type_control").fadeIn();
        }else{
            $("#rm_type_control").hide();
        }
    }
    jQuery( document ).ready(function( $ ) {
        showRemoveType();
       $("#is_remove_app,#is_remove_lic").on("change",function (e){
           showRemoveType();
       });
    });
</script>
