<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_license $mainObj;
	 */
	$mainObj = apply_filters( $this->getHookActionStr( "license-list-row-data" ), $mainObj );
?>

<div class="clearfix form pb-3">
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title"><?php $this->_e("License Code"); ?></div>
            <div class="apd-view-details mb-2">
				<?php echo $mainObj->purchase_key;	?>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Product"); ?></div>
            <div for="apd-view-details">
				<?php
					if(!empty($mainObj->product_id)) {
						$product = Mapbd_product::FindBy( "id", $mainObj->product_id );
						if ( $product ) {
							echo $product->product_name;
						}
					}
				?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("License"); ?></div>
            <div class="apd-view-details mb-2">
				<?php
					if(!empty($mainObj->license_id)) {
						$liceobj = Mapbd_license_type::FindBy( "id", $mainObj->license_id );
						if ( $liceobj ) {
							echo $liceobj->license_title;
						}
					}
				?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Status"); ?></div>
            <div for="apd-view-details">
				<?php echo $mainObj->getTextByKey("status");	?>
            </div>
        </div>

    </div>

    <div class="row">

        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Created"); ?></div>
            <div class="apd-view-details  mb-2">
				<?php echo APBD_getWPDateTimeWithFormat($mainObj->entry_time);	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Expiry Date"); ?></div>
            <div class="apd-view-details mb-2">
				<?php
					if($mainObj->has_expiry=="Y") {
						echo APBD_getWPDateTimeWithFormat( $mainObj->expiry_time );
					}else{ $this->_e("Never");}?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Support End Date"); ?></div>
            <div class="apd-view-details  mb-2">
				<?php
					if($mainObj->has_support=="Y") {
						?>
                        <span class="<?php echo strtotime($mainObj->support_end_time)>time()?"text-success":"text-danger"; ?>">
                        <?php echo APBD_getWPDateTimeWithFormat($mainObj->support_end_time); ?>
                    </span>
						<?php
					}else{ $this->_e("-");}?>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Max. Domain"); ?></div>
            <div for="apd-view-details">
				<?php echo $mainObj->max_domain;	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" data-toggle="tooltip" title="<?php $this->_e("Verification required if client installed more then this quantity, zero value means, no verification required") ?>"><?php $this->_e("Verification Required"); ?>
                <span ><i class="fa fa-exclamation-circle"></i></span>
            </div>
            <div for="apd-view-details">
				<?php echo $mainObj->verification_required;	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("App Version"); ?></div>
            <div class="apd-view-details mb-2">
				<?php echo !empty($mainObj->current_version)?$mainObj->current_version:$this->__("Not installed yet");	?>
            </div>
        </div>

    </div>
    <div class="row">
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Server IP"); ?></div>
            <div for="apd-view-details">
				<?php echo !empty($mainObj->server_ip)?$mainObj->server_ip:"-";	?>
            </div>
        </div>
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Installed Domain"); ?></div>
            <div for="apd-view-details">
				<?php if(!empty($mainObj->user_domain)){ ?>
                    <a target="_blank" href="<?php echo $mainObj->user_domain; ?>"><?php echo $mainObj->user_domain; ?></a>
				<?php }else{
					echo "-";
				} ?>

            </div>
        </div>
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Extra Param"); ?></div>
            <div for="apd-view-details">
			    <?php if(!empty($mainObj->extra_param)){
			        echo $mainObj->extra_param;
			    }else{
				    echo "-";
			    } ?>

            </div>
        </div>
    </div>
    <div class="row">
       
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("License Param"); ?></div>
            <div for="apd-view-details">
				<?php echo !empty($mainObj->lictype_param)?$mainObj->lictype_param:"-";	?>
            </div>
        </div>
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Other Param"); ?></div>
            <div for="apd-view-details">
	            <?php echo !empty($mainObj->other_param)?$mainObj->other_param:"-";	?>
            </div>
        </div>
    </div>
    <?php do_action( $this->getHookActionStr( "view-license-details-extra" ), $mainObj );?>

</div>
<div class="btn-group-md popup-footer text-right">
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
</div>
