<?php
	/** @var AppsBDBaseModule $this */
?>
    <div class="card apsbd-default-card">
        <div class="card-header pt-0 pb-0 pl-0">
            <div class="row">
                <div class="col">
                    <ul class="app-card-tab nav justify-content nav-tabs" id="settingsTab" role="tablist" >
                        <li class="nav-item ">
                            <a class="nav-link active show"  data-toggle="tab" href="#set_main" >
                                <i class=" <?php echo $this->GetMenuIcon(); ?>"></i>
							    <?php echo $this->GetMenuTitle(); ?>
                            </a>
                        </li>
                        <li class="nav-item ">
                            <a id="banhost" class="nav-link"  data-toggle="tab" href="#set_ban_host" >
                                <i class=" ap ap-ban-host"></i>
			                    <?php echo $this->_e("Ban Host List"); ?>
                            </a>
                        </li>
                        <li class="nav-item ">
                            <a id="api_language_btn" class="nav-link"  data-toggle="tab" href="#api_language" >
                                <i class=" fa fa-commenting"></i>
			                    <?php echo $this->_e("API Message"); ?>
                                <span style="margin-bottom: -34px;" class=" apbd-tab-counter badge badge-danger animated ani-count-3 delay-1s slower flash"><?php $this->_e("New");?></span>
                            </a>
                        </li>
                        <li class="nav-item ">
                            <a id="apbd-license-info" class="nav-link"  data-toggle="tab" href="#show_license_info" >
                                <i class=" ap ap-licence"></i>
			                    <?php echo $this->_e("License Info"); ?>
                            </a>
                        </li>
                    </ul>
                </div>
            </div>


        </div>
    <div class="card-body p-3">
        <div class="tab-content" id="settingsTabContent">

            <div class="tab-pane fade active show" id="set_main" role="tabpanel" aria-labelledby="set_main-tab">
                <form class="apbd-module-form" data-oncomplete="onSaveAPIKey" role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl(""); ?>" method="post" <?php echo $this->isMultipartForm()?' enctype="multipart/form-data" ':''; ?>>
                    <div class="card">
                        <div class="card-body p-3">
                            <div class="row">
                                <div class="col-md-6 ">
                                    <div class="form-group row">
                                        <label for="api_end_point" class="col-sm-4 col-form-label"><?php $this->_e("Enter API End Point") ?></label>
                                        <div class="col-sm-8 mb-2">
                                            <?php $apiendpoint=$this->GetOption("api_end_point") ?>
                                            <input type="text" id="api_end_point" autocomplete="off" value="<?php echo $this->GetOption("api_end_point","licensor");?>" name="api_end_point" class="form-control" data-bv-notempty="true" data-bv-notempty-message="<?php $this->_ee("%s is required","Enter API End Point"); ?>">
                                            <?php if(!empty($apiendpoint)){ ?>
                                            <span class="form-text text-muted"> <i class="animated faa-pulse fa fa-exclamation-triangle"></i> <?php $this->_e("Careful, If you change the %s then your all older version products (app, plugin,theme,etc) won't be valid anymore. You must need to update old version product.",'<span class="text-bold">'.$this->__("API End Point").'</span>');?></span>
                                            <?php } ?>
                                        </div>
                                    </div>
                                 
                                    <div class="form-group row">
                                        <label for="ban_req_limit" class="col-sm-4 col-form-label"><?php $this->_e("Auto Ban Host") ?></label>
                                        <div class="col-sm-8">
                                            <div class="input-group">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text" id="basic-addon2"><?php $this->_e("On") ; ?></span>
                                                </div>
                                                <input type="text" id="ban_req_limit"  value="<?php echo $this->GetOption("ban_req_limit",10);?>" name="ban_req_limit" class="form-control text-center">
                                                <div class="input-group-append">
                                                    <span class="input-group-text" id="basic-addon2"><?php $this->_e("Failed Request") ; ?></span>
                                                </div>
                                            </div>
                                            <small id="passwordHelpBlock" class="form-text text-muted">
				                                <?php $this->_e("if will ban those host which will get failed response on active product event more then this limit.") ; ?> <a id="clkbanhost" href="#banhost"><?php echo $this->_e("Click here") ?></a> <?php echo $this->_e("view current banned host list") ?>
                                            </small>
                                        </div>
                                    </div>
                                    <div class="form-group row mt-2">
                                        <label for="api_end_point" class="col-sm-4 col-form-label"><?php $this->_e("Extra Market Details") ?></label>
                                        <div class="col-sm-8 mb-2">
                                            <textarea id="extra_mkt_dtls"  name="extra_mkt_dtls" class="form-control" placeholder="ex. A=Appsbd,M=MyStore"><?php echo $this->GetOption("extra_mkt_dtls","");?></textarea>
                                            <span class="form-text text-muted"> <?php $this->_e("You can add extra market list, like A=Appsbd,X=xyz,");?></span>
                                        </div>

                                    </div>
                                </div>
                                <div class="col-md-6 ">
                                    <div class="card app-card-default">
                                        <div class="card-header "><?php $this->_e("Your API End Point (URL) link will be") ; ?></div>
                                        <div class="card-body p-3">
                                            <div> <?php echo $this->GetAPIUrl("").'<span class="api-end-point-ct">'.$this->GetOption("api_end_point","licensor").'</span>/';?></div>
                                            <a href="#applicdoc" id="app-doc-viewr" class="btn btn-sm mt-2 btn-info"><i class="fa fa-external-link mr-1"></i> <?php $this->_e("View Details API Documentation") ; ?></a>
                                        </div>
                                    </div>
                                    <div class="card app-card-default mt-3">
                                        <div class="card-header d-flex justify-content-between aligncenter">
                                            <?php $this->_e("Allow Test Domains") ;
				                                        APBD_GetHTMLSwitchButtonInline("allow_test_domain","allow_test_domain","N","Y",$this->GetOption("allow_test_domain"));
			                                        ?>
                                                </div>
                                       
                                        <div class="card-body p-3">
                                            <p class="text-muted">
                                                <?php $this->_e("If you allow this then these domains will be license without any restriction. Just need a valid license key.") ; ?>
                                            </p>
                                           <ul class="d-flex flex-wrap test-dm-list m-0 p-0">
                                               <li>localhost </li>
                                               <li>*.dev </li>
                                               <li>*.test </li>
                                               <li>*.local </li>
                                               <li>local.*</li>
                                               <li>*.staging </li>
                                               <li>staging.*</li>
                                               <li>*.example </li>
                                               <li>*.invalid </li>
                                               <li>*.dev.css (DesktopServer) </li>
                                               <li>*.myftpupload.com (GoDaddy) </li>
                                               <li>*.cloudwaysapps.com (Cloudways) </li>
                                               <li>*.wpsandbox.pro (WPSandbox) </li>
                                               <li>*.ngrok.io (tunneling) </li>
                                           </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-footer">
                            <button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Save") ; ?></button>
                        </div>
                    </div>
                  
                    
                </form>
            </div>
            <div class="tab-pane fade" id="set_ban_host" role="tabpanel" aria-labelledby="set_ban_host-tab">
            <?php $this->LoadView("apbdbanhost/main"); ?>
            </div>
            <div class="tab-pane fade " id="api_language" role="tabpanel" aria-labelledby="api_language_btn">
                <div class="alert alert-warning">
                    <i class="animated faa-ring fa fa-exclamation-triangle"></i> <?php $this->_e("Keep the (%s) count same into your string, otherwise it may occurs error, it might be cause for license deactivation") ; ?>
                </div>
                <div class="form-row row-cols-md-3">
		            <?php
			            $msgs=APBDLicenseSettings::GetAPIMessages();
			            foreach ( $msgs as $key=>$msg ) {
				            ?>
                            <div class="form-group col">
                                <div class="input-group input-group-sm">
                                    <textarea class="form-control max-height-md-75" id="<?php echo $key; ?>" name="<?php echo $key; ?>"><?php echo $msg; ?></textarea>
                                    <div class="input-group-append">
                                        <button class="btn btn-success msg-update-btn " data-target="#<?php echo $key; ?>" type="button" id="button-addon2"><?php $this->_e("Update") ; ?></button>
                                    </div>
                                </div>
                            </div>
				            <?php
			            }
		            ?>
                </div>
            </div>
            <div class="tab-pane fade " id="show_license_info" role="tabpanel" aria-labelledby="show_license_info-tab">
		        <?php
			        $licenseInfo=null;
			        $licenseInfo = apply_filters( 'elite-licenser/license-info',$licenseInfo);
                ?>
                <div class="card">
                    <div class="card-body p-0">
                        <table class="table m-0">
                            <tr>
                                <th><?php $this->_e("License Status") ; ?></th>
                                <th>:</th>
                                <td><?php if ( $licenseInfo->is_valid ) : ?>
                                        <span class="el-license-valid"><?php $this->_e("Valid") ; ?></span>
				                    <?php else : ?>
                                        <span class="el-license-valid"><?php $this->_e("Invalid") ; ?></span>
				                    <?php endif; ?></td>
                            </tr>
                            <tr>
                                <th><?php $this->_e("License Type") ; ?></th>
                                <th>:</th>
                                <td><?php echo $licenseInfo->license_title; ?></td>
                            </tr>
                            <tr>
                                <th><?php echo $this->_e('Product Limit'); ?></th>
                                <th>:</th>
                                <td><?php echo $licenseInfo->product_count=="U"?"Unlimited":$licenseInfo->product_count; ?></td>
                            </tr>
                            <tr>
                                <th><?php $this->_e('License Expired on'); ?></th>
                                <th>:</th>
                                <td><?php
				                        $expd=trim(strtolower($licenseInfo->expire_date));
				                        if(in_array($expd,['no expiry'])){
					                        echo $licenseInfo->expire_date;
				                        }else{
				                             echo APBD_getWPDateWithFormat( $licenseInfo->expire_date );
                                            if ( strtotime( 'ADD 30 DAYS', strtotime( $licenseInfo->expire_date ) ) < time() ) {
                                                if ( ! empty( $licenseInfo->expire_renew_link ) ) {
                                                    ?>
                                                    <a target="_blank" class="el-blue-btn" href="<?php echo $licenseInfo->expire_renew_link; ?>"><?php $this->_e( "Renew" ); ?></a>
                                                    <?php
                                                }
                                            }
				                        }
			                        ?></td>
                            </tr>
                            <tr>
                                <th><?php $this->_e('Support Expired on'); ?></th>
                                <th>:</th>
                                <td><?php
				                        $supd=trim(strtolower($licenseInfo->support_end));
				                        if(in_array($supd,['unlimited','no support'])){
					                        echo $licenseInfo->support_end;
				                        }else{
					                        if(strtotime( $licenseInfo->support_end )  < time()){
						                        echo '<strong class="text-danger">'.APBD_getWPDateWithFormat($licenseInfo->support_end).'</strong>';
					                        }else {
						                        echo APBD_getWPDateWithFormat($licenseInfo->support_end);
					                        }
					                        
					                        if(!empty($licenseInfo->support_renew_link)){
						                        ?>
                                                <a target="_blank" class="el-blue-btn" href="<?php echo $licenseInfo->support_renew_link; ?>"><?php $this->_e("Renew") ; ?></a>
						                        <?php
					                        }
				                        }
			                        ?></td>
                            </tr>
                            <tr>
                                <th><?php echo $this->_e('Your License Key') ?></th>
                                <th>:</th>
                                <td><?php echo esc_attr( $licenseInfo->license_key); ?></td>
                            </tr>
                            <?php if(empty($licenseInfo->no_remove_button)) {?>
                            <tr>
                                <td colspan="3" class="">
                                    <a class="btn btn-sm btn-danger" href="<?php echo esc_url(admin_url( 'admin-post.php?action=APBLIC_el_deactivate_license' )."") ?>"> <i class="fa fa-trash-o"></i> <?php $this->_e("Deactivate License") ; ?></a>
                                </td>
                            </tr>
                            <?php } ?>
                        </table>
                    </div>
                </div>
                
            </div>
        </div>
        
        
      
    </div>
   
</div>

<script type="text/javascript">
   jQuery( document ).ready(function( $ ) {
       $("#api_end_point").on("keyup", function (e) {
           $(".api-end-point-ct").text($(this).val());
       });
       $("#clkbanhost").on("click", function (e) {
           e.preventDefault();
           $("#banhost").click();
       });
       $("#app-doc-viewr").click(function (e) {
           e.preventDefault();
           $("#applicdoc").click();
       });
       $("body").on("click", ".msg-update-btn", function (e) {
           e.preventDefault();
           var btnObj = $(this);
           var inputObj = $(btnObj.data("target"));
           var htmlBeforeLoading = "";
           var data = {name: inputObj.attr("name"), val: inputObj.val()};
           APPSBDAPPJS.core.CallMyAjax("<?php echo $this->GetActionUrl( "update-api-msg" ) ?>", data, function () {
                   htmlBeforeLoading = btnObj.html();
                   btnObj.html('<i class="fas fa fa-spinner fa-spin"></i>');
                   inputObj.prop("disabled", true);
               },
               function (rdata) {
                   APPSBDAPPJS.notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.isSticky, rdata.title, rdata.icon);
               }, true,
               function (jqXHR, textStatu) {
                   btnObj.html(htmlBeforeLoading);
                   inputObj.prop("disabled", false);
               });
       });
   });
</script>