<?php
	/** @var EnvatoIntegrator $this */
?>
<div class="row">
	<div class="col p-0">
		<form class="apbd-module-form" data-oncomplete="onSaveAPIKey" role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl("save-api"); ?>" method="post" <?php echo $this->isMultipartForm()?' enctype="multipart/form-data" ':''; ?>>
			<div class="card ml-3" >
				<h5 class="card-header">
					<i class="fa fa-link"></i> <?php $this->_e("API Status"); ?>
				</h5>
				<div class="card-body p-3 min-height-135">
					<div class="form-group">
						<label class="col-form-label" for="APIKey"><?php $this->_e("Envato API Key (Personal Token)"); ?></label>
						<div class="input-group">
							<input type="text" value="<?php echo $this->GetOption("APIKey"); ?>" name="APIKey" class="form-control" id="APIKey" aria-describedby="APIKey" placeholder="<?php $this->_e("Envato API Key") ?>">
							<div class="input-group-append">
								<button class="btn btn-primary text-white" type="submit" id="submit-button"><?php $this->_e("Save") ?></button>
							</div>
						</div>
						<small id="APIKeyHelp" class="form-text text-muted"><?php $this->_e("Please generate a personal API key, %s to know details",'<a class="popupformWR " href="'.$this->GetActionUrl("view-details").'">'.$this->__("Click Here").'</a>') ; ?></small>
					</div>
				</div>
			</div>
			
		</form>
		
		
		
	</div>
	<div class="col">
		<div class="card ">
			<h5 class="card-header">
				<i class="fa fa-link"></i> <?php $this->_e("API Status"); ?>
			</h5>
			<div id="envatoUserInfo" class="card-body p-3 min-height-130">
				<?php echo $EnvatoUserInfo;?>
			</div>
		</div>
	</div>
</div>
<hr>
<div class="row mt-3">
	
	<div class="col">
		<div class="card ">
			<h5 class="card-header"><i class="fa fa-link"></i> <?php $this->_e("License type link with %s",'<em class="text-success">Envato license type</em>'); ?></h5>
			<div class="card-body p-3">
				<form class="apbd-module-form" role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl(""); ?>" method="post" <?php echo $this->isMultipartForm()?' enctype="multipart/form-data" ':''; ?>>
					<?php
						$licenseTypes=Mapbd_license_type::FindAllByKeyValue("status","A","id","license_title");
					?>
					<div class="form-group ">
						<label class="col-form-label" for="exampleFormControlSelect1">Envato, Regular License</label>
						<select class="custom-select custom-select-sm lic-type-input" name="envatoLR" id="envatoLE" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_e("%s is required","Envato, Regular License");?>">
							<?php
								APBD_GetHTMLOption("","Select");
								APBD_GetHTMLOptionByArray($licenseTypes,$this->GetOption("envatoLR","")); ?>
						</select>
					</div>
					<div class="form-group">
						<label class="col-form-label" for="exampleFormControlSelect1">Envato, Extended License</label>
						<select class="custom-select custom-select-sm lic-type-input" name="envatoLE" id="envatoLE" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_e("%s is required","Envato, Extended License");?>">
							<?php
								APBD_GetHTMLOption("","Select");
								APBD_GetHTMLOptionByArray($licenseTypes,$this->GetOption("envatoLE",""));
							?>
						</select>
					</div>
					<div class="form-group text-right">
					<button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Save"); ?></button>
					</div>
				</form>
				
				
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card ">
			<h5 class="card-header">
				<i class="fa fa-link"></i>
				<?php $this->_e("Product link with %s",'<em class="text-success">Envato product</em>'); ?>
				<a href="<?php echo  $this->GetActionUrl("add-link");?>"  class="add-new-link popupformWR btn btn-sm btn-success pull-right"><?php $this->_e("Add New Link"); ?></a>
			</h5>
			<div id="linkedProductCard" class="card-body pos-relative">
                <div class="div-loader">
                    <div class="text-center msg">
                        <img class="max-height-50" src="<?php echo plugins_url("images/lighboxloader.svg",$this->pluginFile); ?>" alt="...">
                        <br>
                        <h4> <?php $this->_e("Loading") ?> </h4>
                    </div>
                </div>
				<div class="pr-3 apbd-bg-1">
					<table class="table table-sm m-0">
						<thead class="thead-dark">
						<tr>
							<th class="text-center" width="5%;" scope="col">#</th>
                        <th  width="35%;" scope="col"><?php $this->_e("App Product") ?></th>
							<th width="5%" scope="col">&nbsp;</th>
							<th width="35%"  scope="col"><?php $this->_e("Envato Product") ; ?></th>
							<th width="10%" class="text-center" scope="col"><?php $this->_e("Delete"); ?></th>
						</tr>
						</thead>
					</table>
				</div>
				<div class="overflow-auto ht-171">
					<table class="table table-sm m-0">
						<tbody id="linked-product-container">
						<?php echo $this->getLinkedProductHtml(); ?>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<script type="application/javascript">
   
    function onSaveAPIKey(rdata){
        if(rdata.status) {
            $("#envatoUserInfo").html(rdata.data);
        }
        notification.ShowGritterMsg(rdata.msg,rdata.status,rdata.isSticky,rdata.title,rdata.icon);
    }
    function ReloadLinkProduct(){

        $.ajax({
            url: "<?php echo $this->GetActionUrl("get-linked-product"); ?>",
            dataType: 'html',
            type:"GET",
            beforeSend:function(){
                $("#linkedProductCard .div-loader").show();
            },
            success: function (rhtml) {
                $("#linked-product-container").html(rhtml);
                APPSBDAPPJS.Initialize();
            },
            complete:function(){
                $("#linkedProductCard .div-loader").hide();
            }
          
        });
    }
    function linkedDelete(rdata,element){
        if (typeof(swal) == "function") {
            swal(rdata.status ? "Success" : "Failed", rdata.msg, rdata.status ? "success" : "error");
        } else {
            notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.is_sticky, rdata.title, rdata.icon);
        }
        if (rdata.status) {
            ReloadLinkProduct();
        }
    }
    function apbd_reloadLicesneType(){
        jQuery.ajax({
            url: "<?php echo $this->GetActionUrl("get-license-type"); ?>",
            dataType: 'json',
            type:"GET",
            beforeSend:function(){},
            success: function (rdata) {
                var options_html="";
               try {
                   jQuery.each(rdata, function (index, title) {
                       options_html += '<option value="' + index + '">' + title + '</option>';
                   });
                   jQuery(".lic-type-input").each(function () {
                       var v=jQuery(this).val();
                       jQuery(this).html(options_html);
                       jQuery(this).val(v);
                   });
               }catch(e){}
            },
            complete:function(){}

        });
    }
    jQuery( document ).ready(function( $ ) {
        APPSBDAPPJS.core.AddOnCloseLightboxWithEvent("<?php echo $this->GetReloadEvent(); ?>",ReloadLinkProduct);
        APPSBDAPPJS.core.AddOnCloseLightboxWithEvent("APBDLicenseType",apbd_reloadLicesneType);
    });
</script>

