<?php
	/** @var EnvatoIntegrator $this */
	/** @var  $fastInfo */
?>
<div class="row">
	<div class="col-7 p-0">
		
        <div class="card ml-3" >
            <h5 class="card-header">
                <?php $this->_e("Generate %s fulfillment parameter",'<i class="ap ap-fastspring"></i>'); ?>
            </h5>
            <div class="fastspring-api-container card-body p-3 min-height-135">
                <div class="form-group">
                    <label class="col-form-label" for="APIKey"><?php $this->_e("Choose your API key and Product"); ?></label>
                    <div class="input-group input-group-sm">
                        <select class="custom-select custom-select-sm" name="api_key" id="api_key">
                            <option value="" selected><?php $this->_e("Select API Key") ; ?></option>
                            <?php foreach ($fastInfo->apikeys as $akey){
                                ?>
                                <option data-apikey="true" value="<?php echo $akey->api_key; ?>"><?php echo $akey->title.'('.$akey->api_key.')'; ?></option>
                                <?php
                            } ?>
                        </select>
                        <select class="custom-select custom-select-sm" name="product_id_license" id="product_id_license">
                            <option value="" selected><?php $this->_e("Select Product") ; ?></option>
	                        <?php foreach ($fastInfo->products as $key=>$product_title){
		                        ?>
                                <option data-apikey="true" value="<?php echo $key; ?>"><?php echo $product_title; ?></option>
		                        <?php
	                        } ?>
                        </select>
                    </div>
                </div>
                <div class="row mt-3 mb-3 apbd-divider"></div>
                <div class="card-body">
                    <div class="card">
                        <div class="card-body  border-info p-2 text-bold">
	                        <?php $url= APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("").APBDLicenseSettings::GetModuleOption("api_end_point","licensor").'/fastspring/license/add';
	                              $url2="";
                                if(strpos($url,"https://") !==false){
	                                $url2=$url;
	                                $url=str_replace('https://','http://',$url);
                            } ?>
				            <?php $this->_e("Host") ; ?> :
                            <span class="text-info">
	                            <?php echo $url; ?>
                            </span>
                            <?php if(!empty($url2)){?>
                                <br> OR <br>
                            <span class="text-info">
                                    <?php   echo $url2; ?>
                                </span>
                            <?php } ?>
                        </div>
                    </div>
                    <div class="card mt-2">
                        <div class="card-header  bg-secondary text-white p-2 text-bold"><?php $this->_e("Custom Parameters") ; ?></div>
                        <div class="card-body p-0">
                            <table class="table table-sm m-0">
                                <thead class="thead-light ">
                                <tr>
                                    <th class=""><?php $this->_e("Property") ; ?></th>
                                    <th class=""><?php $this->_e("parameter name") ; ?></th>
                                   
                                </tr>
                                </thead>
                                <tbody>
                                <tr>
                                    <th colspan="3" class="text-center text-info ">
		                                <?php $this->_e("These properties need to be add as custom field and put the value exactly same as here in %s ",'<i class="ap ap-fastspring"></i>'); ?>
                                        <i class="fa fa-caret-down"></i>
                                    </th>
                                </tr>
                                <tr class="bg-light">
                                    <th class="bg-light"><?php $this->_e("Property") ; ?></th>
                                    <th class="bg-light"><?php $this->_e("Value") ; ?></th>
                                  
                                </tr>
                                <tr>
                                    <th>api_key</th>
                                    <td id="api-key-container">-</td>
                                    
                                </tr>
                                <tr>
                                    <th>product_id</th>
                                    <td id="product_id_container">-</td>
                                   
                                </tr>
                                <tr>
                                    <th>license_id</th>
                                    <td id="license_type_container"></td>
                                   
                                </tr>
                                <tr>
                                    <th>market</th>
                                    <td>F</td>
                                    
                                </tr>
                               
                                <tr>
                                    <th>return_license_only</th>
                                    <td>1</td>
                                  
                                </tr>
                               
                                </tbody>
                            </table>
                        </div>
                    </div>

                </div>
            </div>
        </div>
		
		
	</div>
	<div class="col-5">
        <form class="apbd-module-form"  role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl(""); ?>" method="post">

        <div class="card mb-3 border-info ">
            <h5 class="card-header bg-info text-white">
                <i class="ap ap-fastspring"></i> <?php $this->_e("Webhook") ; ?>
            </h5>
            <div id="envatoUserInfo" class="card-body p-3 min-height-130">
	            <?php $url= APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("").APBDLicenseSettings::GetModuleOption("api_end_point","licensor").'/fastspring/web-hook';
		            $url2="";
		            if(strpos($url,"https://") !==false){
			            $url2=$url;
			            $url=str_replace('https://','http://',$url);
		            } ?>
                <div class="card mb-3">
                    <div class="card-body  border-info p-2 text-bold">
	            <?php $this->_e("Webhook Link") ; ?> :
                <div class="text-info">
	                            <?php echo $url; ?>
                            </div>
	            <?php if(!empty($url2)){?>
                    <br> OR <br>
                    <div class="text-info">
                                    <?php   echo $url2; ?>
                                </div>
	            <?php } ?>
                    </div>
                </div>
                <div class="form-group">
                    <label for="web_hook_secret" class="col-form-label"><?php $this->_e("HMAC SHA256 Secret") ?></label>
                  
                    <input type="text" id="web_hook_secret" autocomplete="off" value="<?php echo $this->GetOption("web_hook_secret","");?>" name="web_hook_secret" class="form-control">
                    <span class="form-text text-muted"><?php $this->_e("Enter HMAC SHA256 Secret which you entered into");?> <i class="ap ap-fastspring"></i></span>

                </div>
                
                
            </div>
            <div class="card-footer">
                <button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Save") ; ?></button>
            </div>
        </form>
        </div>
		<div class="card ">
			<h5 class="card-header">
				<i class="ap ap-fastspring"></i> <?php $this->_e("Descriptions") ; ?>
			</h5>
			<div id="envatoUserInfo" class="card-body p-3">
                <h6 class="card-title">Watch the video of FastSpring Integration</h6>
                <a href="https://www.youtube.com/watch?v=VzBl50Nynj0" class="btn btn-sm btn-danger popupformIF"><i class="fa fa-youtube-play"></i> Click here to watch video</a>
           </div>
		</div>
	</div>
</div>

    <div class=" p-3 text-bold text-warning" >
        <?php $this->_e("You can also get full API description in documentaion, click the Documentation button for more details") ; ?>
    </div>


<script type="application/javascript">
   function SetFastParam(){
       var apiKey= jQuery(".fastspring-api-container  #api_key").val();
       var prolicense= jQuery(".fastspring-api-container  #product_id_license").val();
       jQuery(".fastspring-api-container  #api-key-container").html(apiKey);
       if(prolicense.length>0){
           var productar=prolicense.split("-");
           try{
               jQuery(".fastspring-api-container  #product_id_container").html(productar[0]);
               jQuery(".fastspring-api-container  #license_type_container").html(productar[1]);
           }catch (e) {}
       }
   }
    jQuery( document ).ready(function( $ ) {
        
        //APPSBDAPPJS.core.AddOnCloseLightboxWithEvent("APBDLicenseType",apbd_reloadLicesneType);
        jQuery(".fastspring-api-container  #api_key,.fastspring-api-container  #product_id_license").on("change",SetFastParam);
        SetFastParam();
    });
</script>

