<?php
	/** @var EnvatoIntegrator $this
	 * @var $paddle_products []
	 */
	$linkedProduct=apply_filters('elite-licenser/paddle-linked-product',[])

?>
<div class="clearfix form pb-3">
    <div class="form-group col-sm">
        <label class="col-form-label" for="paddle_product_id"><?php $this->_e( "Choose Paddle Product" ) ?></label>
        <select class="form-control " name="paddle_product_id" id="paddle_product_id">
            <option value=""><?php $this->_e( "Select" ) ?></option>
			<?php
				if ( ! empty( $paddle_products->products ) ) {
					?>
                    <optgroup label="<?php $this->_e( "Products" ); ?>">
						<?php
							foreach ( $paddle_products->products as $paddle_product ) {
								$attrs=[];
							    if(!empty($linkedProduct[$paddle_product->paddle_id]) ){
								    $attrs=['disabled'=>"disabled"];
								    $paddle_product->name.=' ['.$this->__("Linked").']';
							    }
							    
								APBD_GetHTMLOption( $paddle_product->paddle_id, $paddle_product->name, APBD_PostValue( "paddle_product_id" ) ,$attrs);
							}
						?>
                    </optgroup>
					<?php
				}
				if ( ! empty( $paddle_products->subscriptions ) ) {
					?>
                    <optgroup label="<?php $this->_e( "Subscriptions" ); ?>">
						<?php
							foreach ( $paddle_products->subscriptions as $paddle_product ) {
								$attrs=[];
								if(!empty($linkedProduct[$paddle_product->paddle_id]) ){
									$attrs=['disabled'=>"disabled"];
									$paddle_product->name.=' ['.$this->__("Linked").']';
								}
								APBD_GetHTMLOption( $paddle_product->paddle_id, $paddle_product->name, APBD_PostValue( "paddle_product_id" ) ,$attrs);
							}
						?>
                    </optgroup>
					<?php
				}
			
			?>
        </select>
        <span class="form-text text-muted"><?php $this->_e("If you can find your product here then press") ; ?> <a
                    href="<?php echo $this->GetActionUrl('add-link',["rfproduct"=>"Y"]); ?>" class="popupformWR"><?php $this->_e("Click Here") ; ?></a> to refresh the product</span>
    </div>
    <div class="form-group col-sm">
        <label class="col-form-label" for="el_product_id"><?php $this->_e( "Choose Elite Product" ) ?></label>
        <select class="form-control" name="el_product_id" id="el_product_id">
            <option value=""><?php $this->_e( "Select" ) ?></option>
			<?php
				$products = Mapbd_product::FindAllByKeyValue( "status", "A", "id", "product_name" );
				$license_types=Mapbd_license_type::FindAllByKeyValue('status','A','id','license_title');
				foreach ( $products as $key => $product ) {
					$licenses=Mapbd_product_license::FindAllBy("product_id",$key);
					if(!empty($licenses)) {
						?>
                        <optgroup label="<?php echo $product ?>">
							<?php
								foreach ($licenses as $license) {
									
									APBD_GetHTMLOption( $license->product_id."|".$license->license_id, $product.'-'.APBD_getTextByKey($license->license_id,$license_types), APBD_PostValue( "el_product_id" ) );
								}
							?>
                        </optgroup>
						<?php
						
					}
				}
			
			?>
        </select>
    </div>
</div>
<div class="btn-group-md popup-footer text-right">
    <button type="submit" class="btn btn-sm btn-success"><i
                class="fa fa-save"></i> <?php echo ! empty( $isUpdateMode ) ? $this->__( "Update" ) : $this->__( "Save" ); ?>
    </button>
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i
                class="fa fa-times"></i> <?php $this->_e( "Cancel" ); ?></button>
</div>
<script type="application/javascript">

</script>