<?php
	/** @var EnvatoIntegrator $this */
	/** @var TYPE_NAME $paddleInfo */
?>
<div class="row">
    <div class="col-7">
        <div class="card apbd-ctn-inner-tab">
            <div class="card-header p-3 ">
                <ul class="nav nav-pills nav-fill">
                    <li class="nav-item">
                        <a id="paddle-ff-tab" class="nav-link active" data-toggle="tab" href="#paddle-ff-settings"><?php $this->_e("Product Webhook") ; ?></a>
                    </li>
                    <li class="nav-item ">
                        <a id="paddle-api-tab" class="nav-link" data-toggle="tab" href="#paddle-api-based-settings">API Based</a>
                    </li>
                </ul>
            </div>
            <div class="card-body p-3">
                <div class="tab-content">
                    <div class="tab-pane active" id="paddle-ff-settings" role="tabpanel" aria-labelledby="paddle-ff-tab">
                        <div class="card mb-3">
                            <div class="card-body p-3">
                                <p>
		                            <?php $this->_e("If you use the Product Webhook method, then it is not necessary to use the API Based method. The benefit of using the Product Webhook method is that it will include the license key with the paddle order details. On the other hand, API based method doesn't add the license to the order details but the customer will receive an email for the license key.") ; ?>
                                </p>
                                <p>
		                            <?php $this->_e("Note: If you're using Paddle with WooCommerce, you should avoid these options. We have a WooCommerce Addon for Elite Licenses that you may use to handle licensing.") ; ?>
                                </p>
                            </div>
                        </div>
                       
                        <div class="card" >
                            <h5 class="card-header">
								<?php $this->_e("Generate %s fulfillment parameter",'<i class="ap ap-paddle"></i>'); ?>
                            </h5>
                            <div class="paddle-api-container card-body p-3 min-height-135">
                                <div class="form-group">
                                    <label class="col-form-label" for="APIKey"><?php $this->_e("Choose your API key and Product"); ?></label>
                                    <div class="input-group input-group-sm">
                                        <select class="custom-select custom-select-sm" name="api_key" id="api_key">
                                            <option value="" selected><?php $this->_e("Select API Key") ; ?></option>
											<?php foreach ($paddleInfo->apikeys as $akey){
												?>
                                                <option data-apikey="true" value="<?php echo $akey->api_key; ?>"><?php echo $akey->title.'('.$akey->api_key.')'; ?></option>
												<?php
											} ?>
                                        </select>
                                        <select class="custom-select custom-select-sm" name="product_id_license" id="product_id_license">
                                            <option value="" selected><?php $this->_e("Select Product") ; ?></option>
											<?php foreach ($paddleInfo->products as $key=>$product_title){
												?>
                                                <option data-apikey="true" value="<?php echo $key; ?>"><?php echo $product_title; ?></option>
												<?php
											} ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="row mt-3 mb-3 apbd-divider"></div>
                                <div class="card-body">
                                    <div class="card">
                                        <div class="card-body  border-info p-2 text-bold">
											<?php $url= APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("").APBDLicenseSettings::GetModuleOption("api_end_point","licensor").'/paddle/license/add';
												$url2="";
												if(strpos($url,"https://") !==false){
													$url2=$url;
													$url=str_replace('https://','http://',$url);
												} ?>
											<?php $this->_e("Host") ; ?> :
                                            <span class="text-info">
	                            <?php echo $url; ?>
                            </span>
											<?php if(!empty($url2)){?>
                                                <br> OR <br>
                                                <span class="text-info">
                                    <?php   echo $url2; ?>
                                </span>
											<?php } ?>
                                        </div>
                                    </div>
                                    <div class="card mt-2">
                                        <div class="card-header  bg-secondary text-white p-2 text-bold"><?php $this->_e("Custom Parameters") ; ?></div>
                                        <div class="card-body p-0">
                                            <table class="table table-sm m-0">
                                                <thead class="thead-light ">
                                                <tr>
                                                    <th class=""><?php $this->_e("Property") ; ?></th>
                                                    <th class="" colspan="2"><?php $this->_e("Value") ; ?></th>

                                                </tr>
                                                </thead>
                                                <tbody>
                                                <tr>
                                                    <th>client_name</th>
                                                    <td >{customer_name}</td>
                                                    <td >-You can select from dropdown or put <b>{customer_name}</b> as static value</td>

                                                </tr>
                                                <tr>
                                                    <th>client_email</th>
                                                    <td >{customer_email}</td>
                                                    <td >-You can select from dropdown or put <b>{customer_email}</b> as static value</td>
                                                </tr>
                                                <tr>
                                                    <th>checkout_hash</th>
                                                    <td >{checkout_hash}</td>
                                                    <td >-You can select from dropdown or put as <b>{checkout_hash}</b> static value</td>
                                                </tr>
                                                <tr>
                                                    <th colspan="3" class="text-center text-info ">
														<?php $this->_e("These properties need to be add as custom field and put the value exactly same as below in %s ",'<i class="ap ap-paddle"></i>'); ?>
                                                        <i class="fa fa-caret-down"></i>
                                                    </th>
                                                </tr>
                                                <tr class="bg-light">
                                                    <th class="bg-light"><?php $this->_e("Property") ; ?></th>
                                                    <th colspan="2" class="bg-light"><?php $this->_e("Value") ; ?></th>

                                                </tr>

                                                <tr>
                                                    <th>api_key</th>
                                                    <td colspan="2" id="api-key-container">-</td>

                                                </tr>
                                                <tr>
                                                    <th>product_id</th>
                                                    <td colspan="2" id="product_id_container">-</td>

                                                </tr>
                                                <tr>
                                                    <th>license_id</th>
                                                    <td colspan="2" id="license_type_container"></td>

                                                </tr>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                    
                    
                    <div class="tab-pane" id="paddle-api-based-settings" role="tabpanel" aria-labelledby="paddle-api-tab">
                   <?php
                        $this->LoadView("api_based");
                   ?>
                      
                    </div>

                </div>

            </div>
        </div>

    </div>
    <div class="col-5">
        <form class="apbd-module-form"  role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl(""); ?>" method="post">

            <div class="card mb-3 border-info ">
                <h5 class="card-header bg-info text-white">
                    <i class="ap ap-paddle"></i> <?php $this->_e("Settings") ; ?>
                </h5>
                <div  class="card-body p-3">

                    <div class="form-group ">
                        <label for="web_hook_secret" class="col-form-label"><?php $this->_e("Request Verification Type") ?></label>
                        <div>  <?php
								APBD_GetHTMLRadioByArray( "Auth Type", "paddle_auth_type", "paddle_auth_type", true,["IP"=>$this->__("IP Based"),"pb"=>$this->__("Public Key Based")],$this->GetOption("paddle_auth_type","ip"),false,true,"has_depend_fld");
							?>
                        </div>
                    </div>



                    <div class="form-group fld-paddle-auth-type fld-paddle-auth-type-pb">
                        <label for="paddle_pub_key" class="col-form-label"><?php $this->_e("Public Key") ?></label>
                        <textarea type="text" id="paddle_pub_key" autocomplete="off" name="paddle_pub_key" placeholder="-----BEGIN PUBLIC KEY-----" class="form-control min-height-130 text-12"><?php echo $this->GetOption("paddle_pub_key","");?></textarea>
                        <span class="form-text text-warning">
                            <a href="https://vendors.paddle.com/public-key">Click here</a> to get your public key.
                        </span>
                    </div>

                    <div class="form-group">
                        <label for="web_hook_secret" class="col-form-label"><?php $this->_e("Subscription Update Settings") ?></label>
                        <div>
							<?php
								APBD_GetHTMLRadioByArray( "Support Expire Date", "paddle_sus", "paddle_sus", true,["E"=>$this->__("Update Expire Date Only"),"B"=>$this->__("Update Expire date and also update support date")],$this->GetOption("paddle_sus","B"),false);
							?>
                        </div>
                    </div>

                </div>
                <div class="card-footer">
                    <button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Save") ; ?></button>
                </div>
            </div>
        </form>
      
        <form class="apbd-module-form"  role="form" id="<?php echo $this->GetMainFormId();?>" action="<?php echo $this->GetActionUrl(""); ?>" method="post">

            <div class="card mb-3 border-info ">
                <h5 class="card-header bg-info text-white">
                    <i class="ap ap-paddle"></i> <?php $this->_e("Webhook") ; ?>
                </h5>
                <div class="card-body p-3">
					<?php $url= APBDLicenseSettings::GetModuleInstance()->GetAPIUrl("").APBDLicenseSettings::GetModuleOption("api_end_point","licensor").'/paddle/web-hook';
						$url2="";
						if(strpos($url,"https://") !==false){
							$url2=$url;
							$url=str_replace('https://','http://',$url);
						} ?>
                    <div class="card">
                        <div class="card-body  border-info p-2 text-bold">
							<?php $this->_e("Webhook Link") ; ?> :
                            <div class="text-info"><?php echo $url; ?></div>
							<?php if(!empty($url2)){?>
                                <br> OR <br>
                                <div class="text-info"><?php   echo $url2; ?></div>
							<?php } ?>
                        </div>
                    </div>
                </div>
                <div class="card-footer">
                    <button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Save") ; ?></button>
                </div>
            </div>
        </form>
      
        <div class="card ">
            <h5 class="card-header">
			    <?php $this->_e("Full Setup Documentation") ; ?>

            </h5>
            <div id="envatoUserInfo" class="card-body p-3">
                <h6 class="card-title">
                    <a target="_blank" href="https://appsbd.com/epaddledoc" class="text-info">Click here</a>
                    get Paddle Integration documentation
                </h6>

            </div>
        </div>

    </div>
  
</div>



