<?php
/** @var APBDLicenseList $this
 *  @var Mapbd_license $mainObj;
 */

//ALTER TABLE `wp`.`wp_apbd_license` ADD COLUMN `tet` int(1) UNSIGNED NOT NULL DEFAULT 0 AFTER `status`;
Mapbd_license::DBColumnAddOrModify( "tet", "int", "1", "0", "UNSIGNED NOT NULL", "status", "test", "" );
?>

<div class="clearfix form pb-3">
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title"><?php $this->_e("License Code"); ?></div>
            <div class="apd-view-details mb-2">
			    <?php echo $mainObj->purchase_key;	?>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Product"); ?></div>
            <div for="apd-view-details">
			    <?php
			    if(!empty($mainObj->product_id)) {
				    $product = Mapbd_product::FindBy( "id", $mainObj->product_id );
				    if ( $product ) {
					    echo $product->product_name;
				    }
			    }
			    ?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("License"); ?></div>
            <div class="apd-view-details mb-2">
			    <?php
			    if(!empty($mainObj->license_id)) {
				    $liceobj = Mapbd_license_type::FindBy( "id", $mainObj->license_id );
				    if ( $liceobj ) {
					    echo $liceobj->license_title;
				    }
			    }
			    ?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Status"); ?></div>
            <div for="apd-view-details">
			    <?php echo $mainObj->getTextByKey("status");	?>
            </div>
        </div>

    </div>

    <div class="row">

        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Created"); ?></div>
            <div class="apd-view-details  mb-2">
			    <?php echo APBD_getWPDateTimeWithFormat($mainObj->entry_time);	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Expiry Date"); ?></div>
            <div class="apd-view-details mb-2">
	            <?php
                if($mainObj->has_expiry=="Y") {
	                echo APBD_getWPDateTimeWithFormat( $mainObj->expiry_time );
                }else{ $this->_e("Never");}?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Support End Date"); ?></div>
            <div class="apd-view-details  mb-2">
				<?php
				if($mainObj->has_support=="Y") {
                echo APBD_getWPDateTimeWithFormat($mainObj->entry_time);
				}else{ $this->_e("-");}?>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Max. Domain"); ?></div>
            <div for="apd-view-details">
			    <?php echo esc_html($mainObj->max_domain);	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" data-toggle="tooltip" title="<?php $this->_e("Verification required if client installed more then this quantity, zero value means, no verification required") ?>"><?php $this->_e("Verification Required"); ?>
                <span ><i class="fa fa-exclamation-circle"></i></span>
            </div>
            <div for="apd-view-details">
			    <?php echo esc_html($mainObj->verification_required);	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("App Version"); ?></div>
            <div class="apd-view-details mb-2">
	            <?php echo !empty($mainObj->current_version)?$mainObj->current_version:$this->__("Not installed yet");	?>
            </div>
        </div>

    </div>
    <div class="row">
        <div class="col-sm-4">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Server IP"); ?></div>
            <div for="apd-view-details">
				<?php echo !empty($mainObj->server_ip)?$mainObj->server_ip:"-";	?>
            </div>
        </div>
        <div class="col-sm">
            <div class="apd-view-title" for="product_id"><?php $this->_e("Installed Domain"); ?></div>
            <div for="apd-view-details">
	            <?php echo !empty($mainObj->user_domain)?$mainObj->user_domain:"-";	?>
            </div>
        </div>
    </div>
    
</div>
<div class="btn-group-md popup-footer text-right">
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
</div>
